#ifndef __COMMONDEFS
#define __COMMONDEFS

/* Service type definition */

#ifndef ONCE_ONLY
#define ONCE_ONLY	0x01
#define TIMED		0x02
#define MONITORED	0x04
#define COMMAND		0x08
#define DIM_DELETE	0x10
#define MONIT_ONLY	0x20
#define UPDATE 		0x40
#define TIMED_ONLY	0x80
#define MAX_TYPE_DEF    0x80
#define STAMPED       0x1000
#endif

#ifndef OSK
#	ifdef _OSK
#		define OSK
#	endif
#endif


#ifdef __VMS
#define VMS
#endif

#ifndef _DIM_PROTO
#ifndef OSK		/* Temorary hack */
#	if defined(__cplusplus) /* || (__STDC__ == 1) || defined(_ANSI_EXT) || defined(ultrix) */
#		define	_DIM_PROTO(func,param)	func param
#	else
#		define _DIM_PROTO(func,param)	func ()
#	endif
#else
#	define _DIM_PROTO(func,param)	func ()
#endif
#ifdef WIN32
#ifdef DIMLIB
#	define _DIM_PROTOE(func,param) __declspec(dllexport) _DIM_PROTO(func,param)
#	define DllExp __declspec(dllexport)
#else
#	define _DIM_PROTOE(func,param) __declspec(dllimport) _DIM_PROTO(func,param)
#	define DllExp __declspec(dllimport)
#endif
#else
#	define _DIM_PROTOE(func,param) _DIM_PROTO(func,param)
#	define DllExp
#endif
#endif

#if defined (hpux) || defined (__osf__) || defined(_AIX)  || defined(WIN32)
#ifndef NOTHREADS
#define NOTHREADS
#endif
#endif

#ifndef VMS
#ifndef WIN32
#ifdef NOTHREADS
#ifndef DIMLIB
#ifndef sleep
#define sleep(t) dtq_sleep(t)
#endif
#endif
#endif
#endif
#endif

#ifdef VMS
#include <ssdef.h>
#define DISABLE_AST     long int ast_enable = sys$setast(0);
#define ENABLE_AST      if (ast_enable == SS$_WASSET) sys$setast(1);
#define dim_enable()    sys$setast(1);
#endif

#ifdef unix
#include <signal.h>

#define DISABLE_AST     sigset_t set, oset; sigemptyset(&set);\
						sigaddset(&set,SIGIO);\
						sigaddset(&set,SIGALRM);\
						sigprocmask(SIG_BLOCK,&set,&oset);\
						DIM_LOCK
#define ENABLE_AST      DIM_UNLOCK sigprocmask(SIG_SETMASK,&oset,0);

#ifdef VxWorks
#define DIM_LOCK taskLock();
#define DIM_UNLOCK taskUnlock();
#else

#ifndef NOTHREADS
#include <pthread.h>

_DIM_PROTOE( void dim_lock,		() );
_DIM_PROTOE( void dim_unlock,	() );

#define DIM_LOCK 	dim_lock();
#define DIM_UNLOCK	dim_unlock();

#else
#define DIM_LOCK
#define DIM_UNLOCK
#endif
#endif
#endif
#ifdef OSK
#define INC_LEVEL               1
#define DEC_LEVEL               (-1)
#define DISABLE_AST     sigmask(INC_LEVEL);
#define ENABLE_AST      sigmask(DEC_LEVEL);
#endif


_DIM_PROTOE( int dtq_sleep,	(int secs) );
_DIM_PROTOE( void dtq_start_timer,      (int secs, void(*rout)(void*), void *tag) );
_DIM_PROTOE( int dtq_stop_timer,		(void *tag) );
_DIM_PROTOE( void dim_init,				() );
_DIM_PROTOE( void dim_no_threads,		() );
_DIM_PROTOE( void dna_set_test_write,	(int conn_id, int time) );
_DIM_PROTOE( void dna_rem_test_write,	(int conn_id) );
_DIM_PROTOE( int dim_set_dns_node,		(char *node) );
_DIM_PROTOE( int dim_get_dns_node,		(char *node) );
_DIM_PROTOE( void dic_set_debug_on,		() );
_DIM_PROTOE( void dic_set_debug_off,	() );
_DIM_PROTOE( void dim_print_date_time,		() );
_DIM_PROTOE( void dim_set_write_timeout,		(int secs) );
_DIM_PROTOE( int dim_get_write_timeout,		() );
_DIM_PROTOE( void dim_usleep,	(unsigned int t) );
_DIM_PROTOE( int dim_wait,		(void) );

#ifdef WIN32
#define getpid _getpid
_DIM_PROTOE( void dim_pause,		() );
_DIM_PROTOE( void dim_wake_up,	() );
_DIM_PROTOE( void dim_lock,		() );
_DIM_PROTOE( void dim_unlock,	() );
_DIM_PROTOE( void dim_sleep,	(unsigned int t) );
_DIM_PROTOE( void dim_win_usleep,	(unsigned int t) );
#define sleep(t)	dim_sleep(t);
#define usleep(t)	dim_win_usleep(t);
#define pause() 	dim_pause();
#define wake_up()	dim_wake_up();
#define DIM_LOCK 	dim_lock();
#define DIM_UNLOCK	dim_unlock();
#define DISABLE_AST	DIM_LOCK
#define ENABLE_AST  DIM_UNLOCK
#endif

#endif                         









