package dim.test;

import dim.*;
import java.util.Date;

/**
 * This class serves both as a complete test of the Dim package, as well as a show case for the capabilities of DIM.
 * This class is still under construction.
 * @author M.Jonker Cern
 * @version v1.2
 */
public class TestServer
{

  public static void main(String[] args)
  {
	DimCommand cid = new DimCommand("TestCommand","I")
	{
		public void commandHandler()
		{
			System.out.println("Received "+getInt());
		}
	};
				
	int i = 0;
	DimService sid1 = new DimService("TEST_IT_INT",i);
	DimService cid1 = new DimService("TEST_IT_STR","hello hello");
	
	int myArr[] = {0,1,2,3,4,5};
	DimService aa = new DimService("TEST_IT_ARRAY",myArr);
	
	DimService testMix = new DimService("TEST_MIX");
	testMix.setInt(123);
	testMix.setString("hello",20);
	testMix.setDouble(3.5);
	testMix.setIntArray(new int[] {2,3,4});
	testMix.updateService();

	DimServer.start("TestJDim");
	while(true)
	{
		DimTimer.sleep(10);
		sid1.setQuality(i);
		sid1.setTimestamp(new Date());
		sid1.updateService(++i);
		int myArr1[] = {0,1,2,3,4,5,6,7,8};
		aa.updateService(myArr1);
		testMix.setInt(456);
		testMix.setString("hello world");
		testMix.setDouble(6.5);
		testMix.setIntArray(new int[] {6,7,8,9,10});
		testMix.updateService();
	}
  }
}
