#include <dim.h>
#include <dic.h>
#include <dis.h>

#ifdef VMS
#	include <cvtdef.h>
#endif

#ifdef WIN32
#define unix
#endif

static int Dic_padding = 1;
static int Dis_padding = 1;

void dic_disable_padding()
{
	Dic_padding = 0;
}

void dis_disable_padding()
{
	Dis_padding = 0;
}

int copy_swap_buffer_out(format, format_data, buff_out, buff_in, size)
int format;
register int size;
register FORMAT_STR *format_data;
register void *buff_out, *buff_in;
{
	register int num, old_par_num, curr_size = 0, curr_out = 0;
	int i, res;
#ifdef vms
	unsigned int input_code;
#endif
	char *ptrc = (char *)buff_out;
	
	if(!format_data->par_bytes) {
		if(buff_in != buff_out)
			memcpy( buff_out, buff_in, size );
		return(size);
	}
	for( ; format_data->par_bytes; format_data++) 
	{
		old_par_num = format_data->par_num;
		if((curr_size+(format_data->par_num * format_data->par_bytes))
		   > size)
		{
			format_data->par_num = (size - curr_size)/format_data->par_bytes;
			(format_data+1)->par_bytes = 0;
		}
		switch(format_data->flags & 0x3) {
			case NOSWAP :
				if(!(num = format_data->par_num))
					format_data->par_num = num = size - curr_size;
				memcpy( buff_out, buff_in, num);
				inc_pter( buff_in, num);
if(Dis_padding)
{
#ifdef unix
				if((format_data + 1)->par_bytes > SIZEOF_SHORT)
				{
				if(res = (curr_size+num) % SIZEOF_LONG)
				{
					res = SIZEOF_LONG - res;
					inc_pter( buff_in, res);
					curr_size += res;
				}
				}
				else if((format_data + 1)->par_bytes == SIZEOF_SHORT)
				if(res = (curr_size+num) % SIZEOF_SHORT) 
				{
					res = SIZEOF_SHORT - res;
					inc_pter( buff_in, res);
					curr_size += res;
				}
#endif
}
				inc_pter( buff_out, num);
				curr_out += num;
				break;
			case SWAPS :
				if(!(num = format_data->par_num))
				{
					num = size - curr_size;
					format_data->par_num = num/SIZEOF_SHORT;
				} 
				else 
				{
					num *= SIZEOF_SHORT;
				}
				memcpy( buff_out, buff_in, num);
				inc_pter( buff_in, num);
if(Dis_padding)
{
#ifdef unix
				if((format_data + 1)->par_bytes > SIZEOF_SHORT)
				{
				if(res = (curr_size+num) % SIZEOF_LONG)
				{
					res = SIZEOF_LONG - res;
					inc_pter( buff_in, res);
					curr_size += res;
				}
				}
#endif
}
				inc_pter( buff_out, num);
				curr_out += num;
				break;
			case SWAPL :
				if(!(num = format_data->par_num))
				{
					num = size - curr_size;
					format_data->par_num = num/SIZEOF_LONG;
				} 
				else 
					num *= SIZEOF_LONG;
				memcpy( buff_out, buff_in, num);
				inc_pter( buff_in, num);
				inc_pter( buff_out, num);
				curr_out += num;
				break;
			case SWAPD :
				if(!(num = format_data->par_num))
				{
					num = size - curr_size;
					format_data->par_num = num/SIZEOF_DOUBLE;
				} 
				else
					num *= SIZEOF_DOUBLE;
if(Dis_padding)
{
#ifdef unix
#ifndef aix
#ifndef linux
#ifndef LYNXOS
				if(res = (curr_size + num)%SIZEOF_DOUBLE)
				{
					res = SIZEOF_DOUBLE - res;
					inc_pter( buff_in, res);
					curr_size += res;
				}
#endif
#endif
#endif
#endif
}
				memcpy( buff_out, buff_in, num );
				inc_pter( buff_in, num);
				inc_pter( buff_out, num);
				curr_out += num;
				break;
		}
		curr_size += num;
#ifdef vms
		if(	(format_data->flags & IT_IS_FLOAT) && ((format & 0xF0) == IEEE_FLOAT) )
		{
			switch(format_data->flags & 0x3)
			{
				case SWAPL :
					num = format_data->par_num;
					(int *)buff_out -= num;
					for( i = 0; i < num; i++) 
					{
						cvt$convert_float((void *)buff_out, CVT$K_VAX_F, 
										  (void *)buff_out, CVT$K_IEEE_S,
										  0 );
						((int *)buff_out)++;
					}
					break;
				case SWAPD :
#ifdef __alpha
					input_code = CVT$K_VAX_G;
#else
					input_code = CVT$K_VAX_D;
#endif
					num = format_data->par_num;
					(double *)buff_out -= num;
					for( i = 0; i < num; i++ )
					{
						cvt$convert_float((void *)buff_out, input_code,
										  (void *)buff_out, CVT$K_IEEE_T,
										  0 );
						((double *)buff_out)++;
					}
					break;
			}
		}
#endif
		format_data->par_num = old_par_num;
	}
	return(curr_out);
}

int copy_swap_buffer_in(format_data, buff_out, buff_in, size)
register int size;
register FORMAT_STR *format_data;
register void *buff_out, *buff_in;
{
	register int num;
#ifdef unix
	int res;
#endif
	int i, old_par_num;
	int curr_size = 0, full_size = 0;
	register int curr_fill = 0, curr_data = 0;
#ifdef vms
	unsigned int input_code, output_code;
#endif

	if(!format_data->par_bytes)
	{
		if(buff_in != buff_out)
			memcpy( buff_out, buff_in, size );
		return(size);
	}
	for( ; format_data->par_bytes; format_data++)
	{
		full_size += curr_fill;
		curr_fill = curr_data = 0;
		old_par_num = format_data->par_num;
		if((curr_size+(format_data->par_num * format_data->par_bytes))
		    > size)
		{
			format_data->par_num = (size - curr_size)/format_data->par_bytes;
			(format_data+1)->par_bytes = 0;
		}
		switch(format_data->flags & 0x3)
		{
			case NOSWAP :
				if(!(num = (format_data->par_num * format_data->par_bytes)))
					format_data->par_num = num = size - curr_size;
				if(num > (size - curr_size))
					num = size - curr_size;
				if(buff_in != buff_out)
					memcpy( buff_out, buff_in, num );
				inc_pter( buff_in, num);
				inc_pter( buff_out, num);
if(Dic_padding)
{
#ifdef unix
#ifndef aix			    
#ifndef linux
#ifndef LYNXOS
				/* On UNIX but AIX, if the next element is a double, 
				   align on a double */
				if((format_data + 1)->par_bytes == SIZEOF_DOUBLE)
				{
					if(res = num % SIZEOF_DOUBLE)
					{
						res = SIZEOF_DOUBLE - res;
						inc_pter( buff_out, res) ;
						curr_fill += res;
					}
				}
				else 				 
#endif
#endif
#endif
				if((format_data + 1)->par_bytes > SIZEOF_SHORT)
				{
				/* else align on an int */
				if(res = (full_size+num) % SIZEOF_LONG)
				{
					res = SIZEOF_LONG - res;
					inc_pter( buff_out, res);
					curr_fill += res;
				}
				}
				else
				if((format_data + 1)->par_bytes == SIZEOF_SHORT)
				{
				/* else align on a short */
				if(res = (full_size+num) % SIZEOF_SHORT)
				{
					res = SIZEOF_SHORT - res;
					inc_pter( buff_out, res);
					curr_fill += res;
				}
				}
#endif
}
				num = num / format_data->par_bytes;
				break;
			case SWAPS :
				if(!(num = format_data->par_num))
					format_data->par_num = num = (size - curr_size)/SIZEOF_SHORT;
				/*
if(Dic_padding)
{
#ifdef unix
				res = ((num*SIZEOF_SHORT) % SIZEOF_LONG);
#endif
}
*/
				_swaps_buffer( (short *)buff_out, (short *)buff_in, num) ;
				inc_pter( buff_in, SIZEOF_SHORT * num);
				inc_pter( buff_out, SIZEOF_SHORT * num);
if(Dic_padding)
{
#ifdef unix
				/* In case there was an odd number of shorts align on int boudaries for UNIX */
				res = ((full_size+(num*SIZEOF_SHORT)) % SIZEOF_LONG);
				if((format_data + 1)->par_bytes > SIZEOF_SHORT)
				{
				if(res)
				{
					res = SIZEOF_LONG - res;
					inc_pter( buff_out, res);
					curr_fill += res;
				}
				}
#endif
}
				break;
			case SWAPL :
				if(!(num = format_data->par_num))
					format_data->par_num = num = (size - curr_size)/SIZEOF_LONG;
				_swapl_buffer( (int *)buff_out, (int *)buff_in, num);
				inc_pter( buff_in, SIZEOF_LONG * num);
				inc_pter( buff_out, SIZEOF_LONG * num);
				break;
			case SWAPD :
				if(!(num = format_data->par_num))
					format_data->par_num = num = (size - curr_size)/SIZEOF_DOUBLE;
if(Dic_padding)
{
#ifdef unix
#ifndef aix
#ifndef linux
#ifndef LYNXOS
				/* On all UNIX machines but AIX, doubles are aligned on double boundaries */
				if(res = (full_size % SIZEOF_DOUBLE))
				{
					res = SIZEOF_DOUBLE - res;
					inc_pter( buff_out, res);
					curr_fill += res;
				}
#endif
#endif
#endif
#endif
}
				_swapd_buffer( (double *)buff_out, (double *)buff_in, num);
				inc_pter( buff_in, SIZEOF_DOUBLE * num);
				inc_pter( buff_out, SIZEOF_DOUBLE * num);
				break;
		}
		curr_data = num * format_data->par_bytes;
		curr_size += curr_data;
		full_size += curr_data;
#ifdef vms
		if(format_data->flags & 0xF0)
		{
			/* Floating point conversion on VMS... */
			switch(format_data->par_bytes) {
				case SIZEOF_FLOAT :
					if((format_data->flags & 0xF0) == IEEE_FLOAT)
					{
						num = format_data->par_num;
						(int *)buff_out -= num;
						for( i = 0; i<num; i++)
						{
							cvt$convert_float((void *)buff_out, CVT$K_IEEE_S,
										  (void *)buff_out, CVT$K_VAX_F,
										  0 );
							((int *)buff_out)++;
						}
					}
					break;
				case SIZEOF_DOUBLE :
#ifdef __alpha
					output_code = CVT$K_VAX_G;
#else
					output_code = CVT$K_VAX_D;
#endif
					switch(format_data->flags & 0xF0)
					{
						case VAX_FLOAT:
							input_code = CVT$K_VAX_D;
							break;	
						case AXP_FLOAT:
							input_code = CVT$K_VAX_G;
							break;	
						case IEEE_FLOAT:
							input_code = CVT$K_IEEE_T;
							break;	
					}							
					num = format_data->par_num;
					(double *)buff_out -= num;
					for( i = 0; i<num; i++)
					{
						cvt$convert_float((void *)buff_out, input_code,
										  (void *)buff_out, output_code,
										  0 );
						((double *)buff_out)++;
					}
					break;
			}
		}
#endif
		format_data->par_num = old_par_num;
	}
	return(full_size);
}
















