#define DIMLIB
#include <dic.hxx>

char *DimClient::dimDnsNode = 0;

extern "C" {
static void user_routine(void *tagp, void *bufp, int *size)
{
	DimInfo **tag = (DimInfo **)tagp;
	char *buf = (char *)bufp;
	DimInfo *t = *tag;

	if(!t->itsDataSize)
	{
		t->itsData = new char[*size];
		t->itsDataSize = *size;
	}
	else if(t->itsDataSize < *size)
	{
		delete (char *)(t->itsData);
		t->itsData = new char[*size];
		t->itsDataSize = *size;
	}
	memcpy(t->itsData, buf, *size);
	t->itsSize = *size;
	if(t->itsHandler)
	{
		t->itsHandler->itsService = t;
		DimCore::inCallback = 1;
		t->itsHandler->infoHandler();
		DimCore::inCallback = 0;
	}
	else
	{
		DimCore::inCallback = 1;
		t->infoHandler();
		DimCore::inCallback = 0;
	}
}
}

void DimInfo::doIt()
{
	dim_init();
	DISABLE_AST
	itsId = dic_info_service(itsName,itsType,itsTime, 0, 0,
		user_routine, (int)this, 
		itsNolinkBuf, itsNolinkSize);
	ENABLE_AST
}

int DimInfo::getQuality()
{
	return dic_get_quality(itsId);
}

int DimInfo::getTimestamp()
{
	int ret;

	ret = dic_get_timestamp(itsId, &secs, &milisecs);
	return(secs);
}

int DimInfo::getTimestampMillisecs()
{
	return(milisecs);
}


char *DimInfo::getFormat()
{
	char *def;

	if(itsFormat)
	{
		return itsFormat;
	}
	def = dic_get_format(itsId);

	itsFormat = new char[strlen(def)+1];
	strcpy(itsFormat, def);
	return itsFormat;
}

void DimInfo::timerHandler()
{
	itsId = dic_info_service(itsName,itsType,itsTime, 0, 0,
		user_routine, (int)this, 
		itsNolinkBuf, itsNolinkSize);
}

void DimInfo::subscribe(char *name, int time, void *nolink, int nolinksize,
	DimInfoHandler *handler)
{
	itsId = 0;
	itsFormat = 0;
	itsHandler = handler;
	itsName = new char[strlen(name)+1];
	strcpy(itsName,name);
	itsDataSize = 0;
	itsSize = 0;
	itsNolinkBuf = new char[nolinksize];
	itsNolinkSize = nolinksize;
	memcpy(itsNolinkBuf, nolink, nolinksize);
	if(!time)
	{
		itsType = MONITORED;
		itsTime = 0;
	}	
	else if(time > 0)
	{
		itsType = MONITORED;
		itsTime = time;
	}
	else
	{
		itsType = ONCE_ONLY;
		itsTime = 30;
	}
	doIt();
}


DimInfo::~DimInfo()
{
	dic_release_service(itsId);
	delete (char *)itsNolinkBuf;
	delete (char *)itsData;
	delete itsName;
	if(itsFormat)
		delete itsFormat;
}

void *DimInfo::getData()
{
	if(!this->itsSize)
		return itsNolinkBuf;
	return this->itsData;
}

void DimStampedInfo::doIt()
{
	dim_init();
	DISABLE_AST
	itsId = dic_info_service_stamped(itsName,itsType,itsTime, 0, 0,
		user_routine, (int)this, 
		itsNolinkBuf, itsNolinkSize);
	ENABLE_AST
}

void DimStampedInfo::subscribe(char *name, int time, void *nolink, int nolinksize,
	DimInfoHandler *handler)
{
	itsId = 0;
	itsFormat = 0;
	itsHandler = handler;
	itsName = new char[strlen(name)+1];
	strcpy(itsName,name);
	itsDataSize = 0;
	itsNolinkBuf = new char[nolinksize];
	itsNolinkSize = nolinksize;
	memcpy(itsNolinkBuf, nolink, nolinksize);
	if(!time)
	{
		itsType = MONITORED;
		itsTime = 0;
	}	
	else if(time > 0)
	{
		itsType = MONITORED;
		itsTime = time;
	}
	else
	{
		itsType = ONCE_ONLY;
		itsTime = 30;
	}
	doIt();
}

DimStampedInfo::~DimStampedInfo()
{
}

void DimUpdatedInfo::doIt()
{
	dim_init();
	DISABLE_AST
	itsId = dic_info_service_stamped(itsName,itsType,itsTime, 0, 0,
		user_routine, (int)this, 
		itsNolinkBuf, itsNolinkSize);
	ENABLE_AST
}

void DimUpdatedInfo::subscribe(char *name, int time, void *nolink, int nolinksize,
	DimInfoHandler *handler)
{
	itsId = 0;
	itsFormat = 0;
	itsHandler = handler;
	itsName = new char[strlen(name)+1];
	strcpy(itsName,name);
	itsDataSize = 0;
	itsNolinkBuf = new char[nolinksize];
	itsNolinkSize = nolinksize;
	memcpy(itsNolinkBuf, nolink, nolinksize);
	if(!time)
	{
		itsType = MONIT_ONLY;
		itsTime = 0;
	}	
	else if(time > 0)
	{
		itsType = UPDATE;
		itsTime = time;
	}
	doIt();
}

DimUpdatedInfo::~DimUpdatedInfo()
{
}

extern "C" {
static void data_user_routine(void *tagp, void *bufp, int *size)
{
	DimCurrentInfo **tag = (DimCurrentInfo **)tagp;
	char *buf = (char *)bufp;
	DimCurrentInfo *t = *tag;

	if(!t->itsDataSize)
	{
		t->itsData = new char[*size];
		t->itsDataSize = *size;
	}
	else if(t->itsDataSize < *size)
	{
		delete (char *)(t->itsData);
		t->itsData = new char[*size];
		t->itsDataSize = *size;
	}
	memcpy(t->itsData, buf, *size);
	t->itsSize = *size;
	t->wakeUp = 1;
#ifdef __VMS
	sys$wake(0,0);
#endif
#ifdef WIN32
	wake_up();
#endif
}
}

void DimCurrentInfo::subscribe(char *name, int time, void *nolink, int nolinksize)
{

	int timeout;

	if(!time)
		timeout = 10;
	else
		timeout = time;
	itsName = new char[strlen(name)+1];
	strcpy(itsName,name);
	itsDataSize = 0;
	itsNolinkBuf = new char[nolinksize];
	itsNolinkSize = nolinksize;
	memcpy(itsNolinkBuf, nolink, nolinksize);
	wakeUp = 0;
	dic_info_service(itsName,ONCE_ONLY,timeout, 0, 0,
		data_user_routine, (int)this, 
		itsNolinkBuf, itsNolinkSize);
}

DimCurrentInfo::~DimCurrentInfo()
{
	delete (char *)itsNolinkBuf;

	if(itsDataSize)
		delete (char *)itsData;
	delete itsName;
}

void *DimCurrentInfo::getData()
{
	while(!wakeUp)
	{
#ifdef __VMS
		sys$hiber();
#else
		dim_wait();
#endif
	}
	return this->itsData;
}

extern "C" {
static void cmnd_done(void *tagp, int *result)
{
	DimCmnd **tag = (DimCmnd **)tagp;
	DimCmnd *t = *tag;

	t->result = *result;
	t->wakeUp = 1;
#ifdef __VMS
	sys$wake(0,0);
#endif
#ifdef WIN32
	wake_up();
#endif
}
}

int DimCmnd::send(char *name, void *data, int datasize) 
{
	if(DimCore::inCallback) 
	{
		dic_cmnd_service(name, data, datasize);
		return(1);
	}
	else
	{
		wakeUp = 0;
		dic_cmnd_callback(name, data, datasize, 
			cmnd_done, (int)this);
		while(!wakeUp)
		{
#ifdef __VMS
			sys$hiber();
#else
			dim_wait();
#endif
		}
		return(result);
	}
}

void DimCmnd::sendNB(char *name, void *data, int datasize) 
{
	dic_cmnd_service(name, data, datasize);
}

extern "C" {
static void rpc_user_routine(void *tagp, void *bufp, int *sizep)
{
	DimRpcInfo **tag = (DimRpcInfo **)tagp;
	char *buf = (char *)bufp;
	int size = *sizep;
	DimRpcInfo *t = *tag;
	int quality;

	quality = dic_get_quality(0);
	if(quality == -1)
	{
		buf = (char *)t->itsNolinkBuf;
		size = t->itsNolinkSize;
	}
	if(!t->itsDataSize)
	{
		t->itsData = new char[size];
		t->itsDataSize = size;
	}
	else if(t->itsDataSize < size)
	{
		delete (char *)(t->itsData);
		t->itsData = new char[size];
		t->itsDataSize = size;
	}
	memcpy(t->itsData, buf, size);
	t->itsSize = size;
	t->wakeUp = 1;
	if(t->itsWaiting)
	{
		if(t->itsInit)
			t->itsHandler->rpcInfoHandler();
		t->itsWaiting = 0;
	}
#ifdef __VMS
	sys$wake(0,0);
#endif
#ifdef WIN32
	wake_up();
#endif
}
}

void DimRpcInfo::subscribe(char *name, void *data, int size,
	void *nolink, int nolinksize, int timeout)
{

	itsId = 0;
	itsInit = 0;
	itsWaiting = 0;
	itsName = new char[strlen(name)+1];
	strcpy(itsName,name);
	itsHandler = this;
	itsDataSize = 0;
	itsData = 0;
	itsDataOutSize = 0;
	itsDataOut = 0;
	itsNolinkBuf = new char[nolinksize];
	itsNolinkSize = nolinksize;
	memcpy(itsNolinkBuf, nolink, nolinksize);
	itsNameOut = new char[strlen(name)+1+10];
	strcpy(itsNameOut,name);
	strcat(itsNameOut,(char *)"/RpcIn");
	itsNameIn = new char[strlen(name)+1+10];
	strcpy(itsNameIn,name);
	strcat(itsNameIn,(char *)"/RpcOut");
	itsTimeout = timeout;
	dim_init();
	{
		if(!itsId)
		{
			itsId = dic_info_service_stamped(itsNameIn,MONIT_ONLY,itsTimeout, 
				0, 0,
				rpc_user_routine, (int)itsHandler, 
				itsNolinkBuf, itsNolinkSize);
			dim_usleep(200000);
			itsInit = 1;
		}
	}
	if(size)
	{
		doIt(data, size);
	}
}
	
void DimRpcInfo::doIt(void *data, int size)
{
	int ret;

	wakeUp = 0;
	if(!itsDataOut)
	{
		itsDataOut = new char[size];
		itsDataOutSize = size;
	}
	else if(itsDataOutSize < size)
	{
		delete (char *)itsDataOut;
		itsDataOut = new char[size];
		itsDataOutSize = size;
	}
	memcpy(itsDataOut, data, size);
	itsWaiting = 1;
	ret = DimClient::sendCommand(itsNameOut, itsDataOut, itsDataOutSize); 
	if(!ret)
	{
		rpc_user_routine((int *)&itsHandler, itsNolinkBuf, &itsNolinkSize);
	}
}

void *DimRpcInfo::getData()
{
	while(!wakeUp)
	{
#ifdef __VMS
		sys$hiber();
#else
		dim_wait();
#endif
	}
	return this->itsData;
}

DimRpcInfo::~DimRpcInfo() 
{
	if(itsId)
		dic_release_service(itsId);
	delete (char *)itsNolinkBuf;
	if(itsDataSize)
		delete (char *)itsData;
	if(itsDataOutSize)
		delete (char *)itsDataOut;
	delete itsName;
	delete itsNameIn;
	delete itsNameOut;
}

DimBrowser::DimBrowser()
{
	int i;
	for(i = 0; i<4; i++)
	{
		itsData[i] = 0;
		itsData[i] = 0;
	}
	currIndex = -1;
	none = 0;
}

DimBrowser::~DimBrowser()
{
	int i;
	for(i = 0; i<4; i++)
	{
		if(itsData[i])
			delete itsData[i];
	}
}

int DimBrowser::getServices(const char * serviceName) 
{
	char *str;
	DimRpcInfo rpc((char *)"DIS_DNS/SERVICE_INFO",(char *)"\0");
	rpc.setData((char *)serviceName);
	str = rpc.getString();	
	if(itsData[0])
		delete itsData[0];
	itsData[0] = new TokenString(str,(char *)"|\n"); 
	currIndex = 0;
	if(!itsData[0]->getNTokens())
		return(0);
	return(itsData[0]->getNTokens((char *)"\n") + 1); 
}

int DimBrowser::getServers() 
{
	char *str;
	DimCurrentInfo srv((char *)"DIS_DNS/SERVER_LIST",(char *)"\0");
	str = srv.getString();	
	if(itsData[1])
		delete itsData[1];
	itsData[1] = new TokenString(str,(char *)"|@\n"); 
	currIndex = 1;
	if(!str[0])
		return(0);
	return(itsData[1]->getNTokens((char *)"|") +1); 
}
	
int DimBrowser::getServerServices(const char *serverName) 
{
	char *str;
	char *name = new char[strlen(serverName) + 20];
	strcpy(name,(char *)serverName);
	strcat(name,(char *)"/SERVICE_LIST");
	DimCurrentInfo srv(name,(char *)"\0");
	delete name;
	str = srv.getString();	
	if(itsData[2])
		delete itsData[2];
	itsData[2] = new TokenString(str,(char *)"|\n"); 
	currIndex = 2;
	if(!itsData[2]->getNTokens())
		return(0);
	return(itsData[2]->getNTokens((char *)"\n") + 1); 
}

int DimBrowser::getServerClients(const char *serverName) 
{
	char *str;
	char *name = new char[strlen(serverName) + 20];
	strcpy(name,(char *)serverName);
	strcat(name,(char *)"/CLIENT_LIST");
	DimCurrentInfo srv(name,(char *)"\0");
	delete name;
	str = srv.getString();	
	if(itsData[3])
		delete itsData[3];
	itsData[3] = new TokenString(str,(char *)"|@\n"); 
	currIndex = 3;
	return(itsData[3]->getNTokens((char *)"@") ); 
}
	
int DimBrowser::getNextService(char *&service, char *&format)
{
	int ret, type;

	service = format = &none;
	ret = itsData[0]->getToken(currToken);
	if(!ret) return 0;
	service = currToken;
	ret = itsData[0]->getToken(currToken);
	if(!itsData[0]->cmpToken((char *)"|"))
		return 0;
	ret = itsData[0]->getToken(currToken);
	if(!itsData[0]->cmpToken((char *)"|"))
	{
		format = currToken;
		ret = itsData[0]->getToken(currToken);
		if(!itsData[0]->cmpToken((char *)"|"))      
			return 0;
	}
	ret = itsData[0]->getToken(currToken);
	type = DimSERVICE;
	if(!itsData[0]->cmpToken((char *)"\n"))
	{
		if(itsData[0]->cmpToken((char *)"CMD"))
			type = DimCOMMAND;
		if(itsData[0]->cmpToken((char *)"RPC"))
			type = DimRPC;
		ret = itsData[0]->getToken(currToken);
		if(!itsData[0]->cmpToken((char *)"\n"))
			return 0;
	}
	return type;
}
	
int DimBrowser::getNextServer(char *&server, char *&node)
{
	int ret;

	server = node = &none;
	ret = itsData[1]->getToken(currToken);
	if(!ret) return 0;
	server = currToken;
	ret = itsData[1]->getToken(currToken);
	if(!itsData[1]->cmpToken((char *)"@"))
		return 0;
	while(1)
	{
		ret = itsData[1]->getToken(currToken);
		node = currToken;
		itsData[1]->pushToken();
		ret = itsData[1]->getToken(currToken);
		if(itsData[1]->cmpToken((char *)"@"))
		{
			strcat(server,"@");
			strcat(server,node);
		}
		else
			break;
	}
	if(!itsData[1]->cmpToken((char *)"|"))
		itsData[1]->popToken();
	return 1;
}
	
int DimBrowser::getNextServerService(char *&service, char *&format)
{
	int ret, type;

	service = format = &none;
	ret = itsData[2]->getToken(currToken);
	if(!ret) return 0;
	service = currToken;
	ret = itsData[2]->getToken(currToken);
	if(!itsData[2]->cmpToken((char *)"|"))
		return 0;
	ret = itsData[2]->getToken(currToken);
	if(!itsData[2]->cmpToken((char *)"|"))
	{
		format = currToken;
		ret = itsData[2]->getToken(currToken);
		if(!itsData[2]->cmpToken((char *)"|"))
			return 0;
	}
	ret = itsData[2]->getToken(currToken);
	type = DimSERVICE;
	if(!itsData[2]->cmpToken((char *)"\n"))
	{
		if(itsData[2]->cmpToken((char *)"CMD"))
			type = DimCOMMAND;
		if(itsData[2]->cmpToken((char *)"RPC"))
			type = DimRPC;
		ret = itsData[2]->getToken(currToken);
		if(!itsData[2]->cmpToken((char *)"\n"))
			return 0;
	}
	return type;
}
	
int DimBrowser::getNextServerClient(char *&client, char *&node)
{
	int ret;

	client = node = &none;
	ret = itsData[3]->getToken(currToken);
	if(!ret) return 0;
	client = currToken;
	ret = itsData[3]->getToken(currToken);
	if(!itsData[3]->cmpToken((char *)"@"))
		return 0;
	ret = itsData[3]->getToken(currToken);
	node = currToken;
	itsData[3]->pushToken();
	ret = itsData[3]->getToken(currToken);
	if(!itsData[3]->cmpToken((char *)"|"))
		itsData[3]->popToken();
	return 1;
}

