#define DIMLIB
#include <dis.hxx>

DimClientExitHandler *DimServer::itsClientExit = 0;
DimExitHandler *DimServer::itsExit = 0;
char *DimServer::itsName = 0;
char *DimServer::clientName = 0;
char *DimServer::dimDnsNode = 0;
int DimServer::autoStart = 1;

extern "C" {
static void user_routine( void *tagp, void **buf, int *size, int *first_time)
{
	DimService **tag = (DimService **)tagp;
	DimService *t = *tag;

	if( t->itsServiceHandler ) {
		t->itsServiceHandler->itsService = t;
		DimCore::inCallback = 2;
		t->itsServiceHandler->serviceHandler();
		DimCore::inCallback = 0;
	}
	else
	{
		DimCore::inCallback = 2;
		t->serviceHandler();
		DimCore::inCallback = 0;
	}
	if( t->itsType == DisSTRING)
			t->itsSize = strlen((char *)t->itsData)+1;
	*buf = t->itsData;
	*size = t->itsSize;
}
}

void DimService::declareIt(char *name, char *format, DimServiceHandler *handler)
{
	itsName = new char[strlen(name)+1];
	itsDataSize = 0;
	strcpy( itsName, name);
	if(handler)
		itsServiceHandler = handler;
	else
		itsServiceHandler = 0;
	itsId = dis_add_service( name, format, NULL, 0, 
			user_routine, (int)this);

	DimServer::start();
}

void DimService::storeIt(void *data, int size)
{

	if(!itsDataSize)
	{
		itsData = new char[size];
		itsDataSize = size;
	}
	else if(itsDataSize < size)
	{
		delete (char *)itsData;
		itsData = new char[size];
		itsDataSize = size;
	}
	memcpy(itsData, data, size);
	itsSize = size;
}

extern "C" {
static void command_routine( void *tagp, void *buf, int *size)
{
	DimCommand **tag = (DimCommand **)tagp;
	DimCommand *t = *tag;

	t->itsData = buf;
	t->itsSize = *size;
	if( t->itsCommandHandler ) {
		t->itsCommandHandler->itsCommand = t;
		DimCore::inCallback = 2;
		t->itsCommandHandler->commandHandler();
		DimCore::inCallback = 0;
	}
	else
	{
		DimCore::inCallback = 2;
		t->commandHandler();
		DimCore::inCallback = 0;
	}
	t->itsData = 0;
	t->itsSize = 0;
}
}

void DimCommand::declareIt(char *name, char *format, DimCommandHandler *handler)
{
	itsName = new char[strlen(name)+1];
	strcpy( itsName, name);
	itsFormat = new char[strlen(format)+1];
	strcpy( itsFormat, format);
	currCmnd = 0;
	if(handler)
		itsCommandHandler = handler;
	else
		itsCommandHandler = 0;
	itsId = dis_add_cmnd( name, format, command_routine, 
			(int)this);
	DimServer::start();
}

extern "C" {
static void rpcin_routine( void *tagp, void *buf, int *size)
{
	DimRpc **tag = (DimRpc **)tagp;
	DimRpc *t = *tag;
	int id[2];

	t->itsDataIn = buf;
	t->itsSizeIn = *size;
	DimCore::inCallback = 2;
	t->rpcHandler();
	DimCore::inCallback = 0;
	t->itsDataIn = 0;
	t->itsSizeIn = 0;
	id[0] = dis_get_conn_id();
	id[1] = 0;
	dis_selective_update_service(t->itsIdOut, id);
}
}

extern "C" {
static void rpcout_routine( void *tagp, void **buf, int *size, int *firt_time)
{
	DimRpc **tag = (DimRpc **)tagp;
	DimRpc *t = *tag;

	*buf = t->itsDataOut;
	*size = t->itsSizeOut;
}
}

void DimRpc::declareIt(char *name, char *formatin, char *formatout)
{
	itsName = new char[strlen(name)+1];
	strcpy( itsName, name);
	itsNameIn = new char[strlen(name)+1+10];
	strcpy( itsNameIn, name);
	strcat(itsNameIn,(char *)"/RpcIn");
	itsNameOut = new char[strlen(name)+1+10];
	strcpy( itsNameOut, name);
	strcat(itsNameOut,(char *)"/RpcOut");
	itsDataOut = new char[1];
	itsDataOutSize = itsSizeOut = 1;
	
	itsIdIn = dis_add_cmnd( itsNameIn, formatin, 
		rpcin_routine, (int)this);
	itsIdOut = dis_add_service( itsNameOut, formatout, 0,0, 
		rpcout_routine, (int)this);
	DimServer::start();
}

void DimRpc::storeIt(void *data, int size)
{

	if(!itsDataOutSize)
	{
		itsDataOut = new char[size];
		itsDataOutSize = size;
	}
	else if(itsDataOutSize < size)
	{
		delete (char *)itsDataOut;
		itsDataOut = new char[size];
		itsDataOutSize = size;
	}
	memcpy(itsDataOut, data, size);
	itsSizeOut = size;
}
