#!/bin/bash

if [ ! ${AFFAIR_MONITOR} ]; then
    if [ ! ${AFFAIR} ]; then
	echo " AFFAIR_MONITOR nor AFFAIR is declared. exit ";
 	exit 1
    fi
fi

make clean;
 source monitorPars.sh;

if [ ! -d log ]; then
    mkdir log
    chmod a+w log;
    chmod a+w log/.;
fi	

if [ ${DATE_SITE} ]; then
# this is  in mode where the dim and smi libraries are from DATE code
# Both the Monitor and Collectors will use these libraries
#  do installation for collectors 
#
    if [ ${AFFAIR} ]; then
	source setup1.sh;
	source setup2.sh;
	make sysmon;
	make datemonObj;
	make datemonBin;
    fi
else
# mode where dim and smi are local, i.e .standalone
    make dimcode;
    make smi;
    if [ ${AFFAIR} ]; then
	make sysmonStandAlone;
	make myCollectorStandAlone;
    fi
fi


# install Monitor if it is a monitoring station (determined by
# the existence of AFFAIR_MONITOR variable

if [ ${AFFAIR_MONITOR} ]; then
	# check if log,backup  and rrd directories exist, and create them if not	
	if [ ! -d backup ]; then
                mkdir backup
	fi
	if [ ! -d rrd ]; then
	        mkdir rrd
	fi
	if [ ! -d rootfiles ]; then
                mkdir rootfiles
	fi
	if [ ! -d plots ]; then
                mkdir plots;
	fi

	if [ ! -d config ]; then
	    if [ -d config.example ]; then
		echo " there is no previous version of config directory. Will assume example config directory ";
		mv config.example config;
	    fi
	else
	    if [ -d config.example ]; then
		echo " Will move old config files to config.old.";
		mv config config.old;		    
		mv config.example config;
		cp config.old/computerlist.conf config/computerlist.conf;
	    fi
	fi


	chmod a+w plots;
	chmod a+w plots/.;
	chmod a+w plots/*;
	chmod a+w config/.;
	chmod a+w config/*;
	chmod a+w log;
	chmod a+w log/.;
	chmod a+w log/*;

	make RRD;
	cd src/root; make;
	cd ${AFFAIR_MONITOR};
fi





