// booloperation.cxx: implementation of the BoolOperation class.
//
//                                                B. Franek
//                                           26 February 2000
//////////////////////////////////////////////////////////////////////

#include "booloperation.hxx"

#include "stdlib.h"
#include "string.h"
#include "name.hxx"
#include "boolitem.hxx"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
BoolOperation::BoolOperation()
{
	return;  
}

BoolOperation::BoolOperation(const int idNum,const char operation,
			const char operand1,const int num1,
			const char operand2,const int num2)  
{
//	cout << "BoolOperation constructor called" << endl;
//	cout << idNum << " " << operand1 << "" << num1 << endl;

	_idNum = idNum;
	_operation = operation;
	if ( operation == '-' ) {
		_operand1 = operand1; _num1 = num1;
	}
	else if ( operation == '+' || operation == '.' ) {
		_operand1 = operand1; _num1 = num1;
		_operand2 = operand2; _num2 = num2;
	}
	else {
		cout << " Error  Illegal operation in BoolOperation" << endl;
		exit(2);
	}
		
	return;
}
//---------------------------------------------------------------------
BoolOperation::BoolOperation(const int idNum,const char operation,
			BoolItem* pOperand1, BoolItem* pOperand2)  
{
//	cout << "BoolOperation constructor called" << endl;

	_idNum = idNum;
	_operation = operation;
	if ( operation == '-' ) {
		_pOperand1 = pOperand1; _pOperand2 = 0;
	}
	else if ( operation == '+' || operation == '.' ) {
		_pOperand1 = pOperand1; _pOperand2 = pOperand2;
	}
	else {
		cout << " Error  Illegal operation in BoolOperation" << endl;
		exit(2);
	}
		
	return;
}

BoolOperation::BoolOperation(const BoolOperation& source)
{
	_operation = source._operation;

	_operand1 = source._operand1; _num1 = source._num1;
	_operand2 = source._operand2; _num2 = source._num2;
	_pOperand1 = source._pOperand1; _pOperand2 = source._pOperand2; 
 

	return;
}

int BoolOperation::idNum() const
{
	return _idNum;
}

char BoolOperation::type() const
{
	return 'X';
}

BoolOperation::~BoolOperation()
{
    return;
}

//----------------------------------------------------------------------
void BoolOperation::out(const Name offset) const
{
//	cout << "BoolOperation::out called" << endl; 

	char* ptn=offset.getString(); cout << ptn ;

	if ( _operation == '-' ) {
//		cout << _operation << _operand1 << _num1 << endl;
		cout << "X" << _idNum << " = ";	
		cout << _operation << _pOperand1->type() << _pOperand1->idNum() << endl;
	}
	else {
//		cout << _operand1 << _num1 
//			<< " " << _operation << " " << _operand2 << _num2 << endl;
		cout << "X" << _idNum << " = "
			 << _pOperand1->type() << _pOperand1->idNum() 
		 	<< " " << _operation << " "
			<< _pOperand2->type() << _pOperand2->idNum() << endl;
	}
	return;
}
//----------------------------------------------------------------------
void BoolOperation::outFull(const Name offset) const
{
//	cout << "BoolOperation::out called" << endl;
//	out(offset);
    Name tmpOffset = offset;
	if (_pOperand1->type() == 'X') {_pOperand1->outFull(tmpOffset);}
	if (_pOperand2 != 0 && _pOperand2->type()=='X') {_pOperand2->outFull(tmpOffset);}

	char* ptn=tmpOffset.getString(); cout << ptn ;

	if ( _operation == '-' ) {
		cout << "X" << _idNum << " = ";	
		cout << _operation << _pOperand1->type() << _pOperand1->idNum() << endl;
	}
	else {
		cout << "X" << _idNum << " = "
			 << _pOperand1->type() << _pOperand1->idNum() 
		 	<< " " << _operation << " "
			<< _pOperand2->type() << _pOperand2->idNum() << endl;
	}
	return;
}

//------------------------------------------  BF April 2000  --------
void BoolOperation::outSobj(ofstream& sobj) const
{
	if (_pOperand1->type() == 'X') {_pOperand1->outSobj(sobj);}
	if (_pOperand2 != 0 && _pOperand2->type()=='X') {_pOperand2->outSobj(sobj);}

	if ( _operation == '-' ) {
		sobj << "X" << _idNum << " = ";	
		sobj << _operation << _pOperand1->type() << _pOperand1->idNum() << endl;
	}
	else {
/*		sobj << "X" << _idNum << " = "
			 << _pOperand1->type() << _pOperand1->idNum() 
		 	<< " " << _operation << " "
			<< _pOperand2->type() << _pOperand2->idNum() << endl;*/
		if (_operation=='+') {sobj << "or    " ;}
		else                 {sobj << "and   ";}
			int idnum1 = _pOperand1->idNum();
			int idnum2 = _pOperand2->idNum();
			char zeros1[3]; char zeros2[3];
			if      (idnum1 <   10)                    {strcpy(zeros1,"00");}
			else if (idnum1 >=  10 && idnum1 <  100)   {strcpy(zeros1,"0"); }
			else if (idnum1 >= 100 && idnum1 < 1000) {strcpy(zeros1,"\0");}
			else {
				cout << "***Fatal internal error BoolOperation::outSobj" << endl;
				exit(2);
			}
			if      (idnum2 <   10)                    {strcpy(zeros2,"00");}
			else if (idnum2 >=  10 && idnum2 <  100)   {strcpy(zeros2,"0"); }
			else if (idnum2 >= 100 && idnum2 < 1000) {strcpy(zeros2,"\0");}
			else {
				cout << "***Fatal internal error BoolOperation::outSobj" << endl;
				exit(2);
			}
				 
        
			sobj << _pOperand1->type() << zeros1 <<  idnum1
			 << "  "   << _pOperand2->type() << zeros2 <<  idnum2 << endl;
	}
	return;
}