// condition.cxx: implementation of the Condition class.
//
//                                                B. Franek
//                                               8 October 1999
// Copyright Information:
//      Copyright (C) 1999/2000 CCLRC. All Rights Reserved.
//////////////////////////////////////////////////////////////////////
#include "stdlib.h"
#include "stdio.h"
#include "assert.h"
#include "string.h"
#include "smlline.hxx"
#include "smllinevector.hxx"
#include "utilities.hxx"
#include "smpcond.hxx"
#include "boolitem.hxx"
#include "booloperation.hxx"
#include "stack.hxx"
#include "stackitem.hxx"

#include "condition.hxx"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
Condition::Condition()
{
	_sobjHeader = "not defined";
	_numBoolOperations = 0;
	return;
}
//-------------------------------------------------------------------------------
int Condition::initialise(SMLlineVector* pSMLcode,
					 const int ist, const int jst,  
					 int& inext, int& jnext)
{

	Stack stack(1000);

	int numOfLines = pSMLcode->length(); 
	
	SMLline line; char* pLine;


	char* ptn;

	Name tempNm = " "; Name temp;

//	cout << endl << "going to parse contition" << endl;

// "("  ")"  "not" "and" "or"  "name"  "do"  "then"
	int numSimpCond = 0; SmpCond* pSmpCond;
	char item,item1;
	item1 = ' ';

	int istt = ist;
	int jstt = jst;
	int iprint = 1;

	for (; ; ) {
		line = (*pSMLcode)[istt];
//		if (iprint != 0) {cout << line << endl;}
		pLine = line.getString();
		ptn = &pLine[jstt];
//		cout << " Next search in : |" << ptn << "|" << endl;

		int flag = getNextItem(pSMLcode,istt,jstt,inext,jnext,item,pSmpCond);

		if (flag==2) {break;}
//		cout << endl << " ----> Item : " << item << endl;

		if (item == '(' || item == '-' || item == 'T') {
			if (item == 'T') {
				stack.push(pSmpCond);
			}
			else {
				stack.push(item);
			}
		}
		else if ( item == ')' || item == '.' || item == '+' || item == 'E') {
			//   ) . + or E
			int flag1 = handleStack(stack,item);

			if (flag1 == 1) 
			{}
			else if (flag1 == 2)
			{
				return 1;
			}
			else if (!flag1)
			{
				cout << " Parsing of condition fails " << endl;
				cout << line << endl;
				return 0;
			}
			else 
			{
				cout << " Unknown flag from handleStack...call expert" << endl;
				return 0;				}
			}
		else {
			cout << "Error parsing condition. Unexpected item found :"
				<< item << endl;
			cout << line << endl;
			return 0;
		}
		if (istt == inext ) {iprint = 0;}
		else {iprint = 1;}
		jstt = jnext; istt = inext;
	}
	return 1;
}
//-------------------------------------------------------------------------------
int Condition::handleStack(Stack& stack,const char item)
{

//  This is called when item is either ) . + or E
// item1 is either X or T


	Name offset = " "; Name tempNm = " ";
//    cout << endl << "handleStack" << endl;
	char item1,item2;
	BoolItem* point1, *point3;
	StackItem stackItem1,stackItem2,stackItem3;

		for (;;) {
//			stack.out(offset);
			stack.getFromStack(1,stackItem1);
			item1=stackItem1.item();
			point1=stackItem1.pointer();

			if (item1 != 'X' && item1 != 'T') { 
				cout << "Error:   item1 should be T or X. It is " << item1 << endl;
				cout << "    Contact expert" << endl;
				return 0;
			}

			if (!stack.getFromStack(2,stackItem2)) {
//				cout << " item2  not there" << endl;
				if ( item == '.' || item == '+' ) {
					stack.push(item);
//					stack.out(offset);cout << "handleStack...end" << endl;
					return 1;
				}
				else if ( item == 'E' ) { return 2;}
				else {
					cout << "Error: Expecting and  or  do/then and found : " << item << endl;
					return 0;
				}
				return 2;
			}
					
			item2 = stackItem2.item();
//			cout << " item2 " << item2 << endl;

			if (  (item == '.' && (item2 == '(' || item2 == '+')) ||
				(item == '+' && item2 == '(') ) {
				stack.push(item);
//				stack.out(offset);cout << "handleStack...end" << endl;
				return 1;
			}

			if ( item2 == '(' ) {
				if ( item != ')' ) {
					cout << "Error  expecting ) and found " << item << endl;
					return 0;
				}
				stack.deleteItem2FromStack();
//				stack.out(offset);
//				cout << "handleStack...end" << endl;
				return 1;
			}

			if ( item2 == '-' ) {
				stack.deleteTopStack(2);
				if (item1 == 'T') {
					SmpCond* pSmpCond = (SmpCond*)point1;
					pSmpCond->negate();
					stack.push(point1);
				}
				else { 
					_numBoolOperations++;
					BoolOperation* pBoolOp = 
						new BoolOperation(_numBoolOperations,'-',point1,0);
//					cout << "New operation "; Name tmp = " "; pBoolOp->out(tmp); 
					stack.push(pBoolOp);
					_pExecutor = pBoolOp;
				}
				continue;
			}

			if (item=='.' || item=='+' || item=='E' || item==')') {
				if (!stack.getFromStack(3,stackItem3)) {
					cout << "Error :  Item3 is not there...call expert" << endl;
					return 0;
				}
				point3 =stackItem3.pointer();
				stack.deleteTopStack(3);
				_numBoolOperations++;
				BoolOperation* pBoolOp = 
					new BoolOperation(_numBoolOperations,item2,point3,point1);
//				cout << "New operation "; Name tmp = " "; pBoolOp->out(tmp);
				assert (!pBoolOp == 0);
				stack.push(pBoolOp);
				_pExecutor = pBoolOp;
				continue;
			}

			cout << "Error : Brackets probably do not balance" << endl;
			return 0;
		}

}
//----------------------------------------------------------------------------
int Condition::getNextItem(SMLlineVector* pSMLcode,const int ist,const int jst,
					   int& inext, int& jnext, char& item, SmpCond*& pSmpCond)
{

	pSmpCond = 0;

	int inbl,jnbl,iprev,jprev; 
	item = firstNonBlank(pSMLcode,ist,jst,inbl,jnbl,inext,jnext,iprev,jprev);
	if (item == '\0' || item == '#' || item == '!' ) {
		inext = -1; jnext = 0;
		return 2;
	}

	Name temp; int idel,jdel;
	item = getNextToken(pSMLcode,inbl,jnbl," ()",temp,idel,jdel,inext,jnext);

	if ((item == '\0' || item == '#' || item == '!' )&&
		temp=="\0") {
		return 2;
	}

	if ((item == '(' || item == ')')&&temp=="\0") {
		return 1;
	}
	
	inext = idel; jnext = jdel;

	temp.upCase(); temp.trim();
	if (temp == "NOT" ) {
		item='-';
		return 1;
	}
	else if (temp == "AND" ) {
		item='.';
		return 1;
	}
	else if (temp == "OR" ) {
		item='+';
		return 1;
	}
	else if (temp == "DO" || temp == "THEN" ) {
		item ='E';
		return 1;
	}
	else {
//		cout << " found simple cond" << endl;
		Name tempNm = " "; int idNum = 	_smpConditions.length()+1;
		pSmpCond = new SmpCond();
		_smpConditions.addRegardless(tempNm,pSmpCond);
		pSmpCond->initialise(idNum,pSMLcode,inbl,jnbl,inext,jnext);
		item = 'T';
		return 1;
	}
}



Condition::~Condition()
{
	return;
}

void Condition::translate()
{
	return;
}

void Condition::out(const Name offset) const
{

	Name offset1 = offset;
	offset1 += "  ";
	void* ptnvoid; SmpCond* pSmpCond;
	char* ptn = offset.getString();
	cout << ptn << " Condition " << endl;

	int noOfSmpCond = _smpConditions.length();
	cout << ptn << " No of simple conditions " << noOfSmpCond << endl;

	for ( int iu=0; iu<noOfSmpCond; iu++ ) {  
		ptnvoid = _smpConditions.gimePointer(iu);
		pSmpCond = (SmpCond*)ptnvoid;
	  
		pSmpCond->out(offset1);
	}

	cout << ptn <<endl;
	cout << ptn << " No of boolean operations " << _numBoolOperations << endl;
	
	if (_numBoolOperations > 0) {_pExecutor->outFull(offset1);}

	return;
}
//-----------------------------------------  BF April 2000  -----------
void Condition::outSobj(ofstream& sobj) const
{
	sobj << _sobjHeader.getString() << endl;

	int nsmp = _smpConditions.length();

	char line[80];
	sprintf(line,"%5d%5d",nsmp,_numBoolOperations);
	sobj << line << endl;

//	sobj << "    " << nsmp << "    " << _numBoolOperations << endl;

	for ( int is=0; is<nsmp; is++) {
		void* ptnvoid = _smpConditions.gimePointer(is) ;
		SmpCond* pSmpCond;
		pSmpCond = (SmpCond*)ptnvoid;
		pSmpCond->outSobj(sobj);
	}

	if (_numBoolOperations>0) {
		_pExecutor->outSobj(sobj);
	}

	return;
}
//---------------------------------------------  BF  April 2000  -------
void Condition::getHeader(SMLlineVector* pSMLcode,const int ist,const int jstin,
					   int iend, int jend)
{
	Name temp = "\0";
	SMLline line;
	char* pLine;
	//	Name condString = " ";
	Name condString = "\0";
	char save;
	char* ptn; 	int aloneDO;

	int j;
	int nend;

	if (iend >= 0) {
		nend = iend;
	}
	else {
		nend = pSMLcode->length()-1;
	}

	int jst = jstin;
	line = (*pSMLcode)[ist];
	pLine = line.getString();
	if (pLine[jst-1] == ' ') {jst = jstin-1;}


	for (int i=ist; i<=nend; i++) {
		line = (*pSMLcode)[i];
		pLine = line.getString();
		if (i==ist) {j=jst;}
		else {j=0;}

		ptn = &pLine[j];

		if (i==iend) {
			save = pLine[jend]; pLine[jend] = '\0';
		}

		process_line_forTrans(ptn);
		condString += ptn;
		if ( i==iend) {
			aloneDO = 0;
			if (!strcmp(ptn," DO")) {aloneDO =1;}
//			cout << "dbg|" << ptn << "|" << endl;
//			cout << aloneDO << endl;

		}
	}


	char* str = condString.getString();
	strTrim(str);
	int ln = strlen(str);

	if ( str[ln-1]=='O') {
		ln=ln-2;
		str[ln] = '\0';
		if (aloneDO == 0) {
			if (str[ln-1]==' ') {ln=ln-1;str[ln]='\0';}
		}
	}
	if ( str[ln-1]=='N') {str[ln-4] = '\0'; ln=ln-4;}


    ln = strlen(str);

	if (ln <= 79) { 
		_sobjHeader = str; _sobjHeader.trim(); return;
	}



	save = str[37]; str[37]='\0';
	_sobjHeader = str; str[37]=save;

	_sobjHeader += "......";

	_sobjHeader += &str[ln-36]; _sobjHeader.trim();
	return;
}


