// condition.hxx: interface for the Condition class.
//
//                                                  B. Franek
//                                                 8 October 1999
// Copyright Information:
//      Copyright (C) 1999/2000 CCLRC. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////
#ifndef CONDITION_HH
#define CONDITION_HH

#include "name.hxx"
#include "registrar.hxx"
class SMLlineVector;
class Stack;
class SmpCond;
class BoolOperation;


class Condition  
{
public:
	Condition();

	int initialise(SMLlineVector* pSMLcode,
			const int ist, const int jst,  
			int& iend, int& jend);

	void getHeader(SMLlineVector* pSMLcode,const int ist,const int jst,
					   int iend, int jend);


	virtual ~Condition();

	virtual void translate();

	void out(const Name) const;

	void outSobj(ofstream& sobj) const;


protected :

	int handleStack(Stack& stack,const char item);

	int getNextItem(SMLlineVector* pSMLcode,const int ist,const int jst,
					   int& iend, int& jend, char& item, SmpCond*&);

	Name _sobjHeader;

	Registrar _smpConditions;
//	Registrar _boolOperations;
	int _numBoolOperations;
	BoolOperation* _pExecutor;

};

#endif 
