// doins.cxx: implementation of the DoIns class.
//
//                                                B. Franek
//                                           30 September 1999
//////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "smlunit.hxx"
#include "smlline.hxx"
#include "name.hxx"
#include "utilities.hxx"
#include "doins.hxx"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

DoIns::DoIns()  
{
   _name = "do";
//   cout << "Do constructor called" << endl;
   return;
}

DoIns::~DoIns()
{
    delete _pSMLcode;
}
//-----------------------------------------------------------------------
void DoIns::translate() {

    Name token; int idel,jdel; int inext,jnext;
	int ist,jst;
	char del = getNextToken(_pSMLcode,0,0," ",token,idel,jdel,inext,jnext);
	token.upCase(); token.trim();
	if ( token == "DO"){}
	else { cout << " Keyword do not found" << endl; exit(2);}
    ist = inext; jst = jnext;

	del = getNextToken(_pSMLcode,ist,jst," (",_actionNm,idel,jdel,inext,jnext);
	_actionNm.upCase(); 
	if ( !check_name(_actionNm) ) {
		cout << _actionNm << " is not a name" << endl;
		exit(2);
	}

	if ( del == '(' ) {
		ist = idel, jst = jdel;
		if ( !_parameters.initFromSMLcode( 0, _pSMLcode, ist,jst,inext,jnext)) {
			cout << " Parameter parsing failed " << endl;
			exit(2);
        }
	}
	ist = inext; jst = jnext;
    del = getNextToken(_pSMLcode,ist,jst," ",_objectNm,idel,jdel,inext,jnext);
    _objectNm.upCase();
	if ( !check_name(_objectNm) ) {
		cout << _objectNm << " is not a name" << endl;
		exit(2);
	}
}

void DoIns::out(const Name offset) const
{

	SMLUnit::out(offset); 
	char* ptn=offset.getString(); cout << ptn ;
	cout << "Action : "<< _actionNm << "  Object : " << _objectNm << endl;
	_parameters.out(offset);

  return;
}
//----------------------------------  BF April 2000  ------------------
void DoIns::outSobj(int&,int,ofstream& sobj,Registrar&) const
{
	sobj << "do" << endl;

	sobj << _actionNm.getString() << endl;

	int numpar = _parameters.numOfEntries();

	sobj << "    " << numpar << endl;

	for (int ip=0; ip<numpar; ip++) {
		Name name,value; char type[10];
		_parameters.get(ip,name,value,type);
		sobj << name.getString() << endl;
		sobj << value.getString() << endl;
	}

	sobj << _objectNm.getString() << endl;

	return;
}