// ifins.cxx: implementation of the IfIns class.
//
//                                                B. Franek
//                                           30 September 1999
//////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <assert.h>
#include "smlline.hxx"
#include "ifins.hxx"
#include "ifunit.hxx"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IfIns::IfIns()  
{
   _name = "if";
   return;
}

IfIns::~IfIns()
{
    delete _pSMLcode;
}
//-----------------------------------------------------------------------------
void IfIns::translate() {

	int newUnit = 0;
	Name unitType = "\0";
	SMLUnit *pUnit;

	bool insLine;
	Name insType = "\0";
	int ifLevel = 0;
	int elseEncountered = 0;
	int endifEncountered = 0;

	int numOfLines = _pSMLcode->length();
	SMLline line; 

	for (int i = 0; i<numOfLines; i++) {   //***** Beg of collection loop
		line = (*_pSMLcode)[i];
		
		insLine = line.instructionLine(insType);
//cout << insLine << " " << insType << " " << ifLevel << endl;

		if (ifLevel == 0) {
			if (endifEncountered) {
				if (line.commentLine()) {continue;}
				else {
					cout << "**Error***  some crap is following 'if' instruction" << endl;
					line.out();
					exit(2);
				}
			}
			else {
				if (insLine && insType == "if") {
					ifLevel++;
					newUnit = 1;
					pUnit = new IfUnit();
				}
				else {
					cout << "*** Internal error***  Expecting 'if' and found:" << endl;
					line.out();
					exit(2);
				}
			}
		}
		else if (ifLevel == 1) {
			if (insLine) {
				if (insType == "elseif" || insType == "else") {
					if (insType == "else") {
						if (elseEncountered) {
							cout << "***Error***  second occurence of 'else'" << endl;
							line.out();
							exit(2);
						}
						else {elseEncountered = 1;}
					}
					newUnit = 1;
					pUnit = new IfUnit();
				}
				if (insType == "if") {ifLevel++;}
				if (insType == "endif") {ifLevel--; endifEncountered = 1; continue;}
			}
		}
		else if (ifLevel > 1) {
			if (insLine && insType == "if")    {ifLevel++;}
			if (insLine && insType == "endif") {ifLevel--;}
		}
		else {
			cout << "This can never happen"<< endl; exit(2);
		}

		if (newUnit) {
			newUnit = 0;
			assert(pUnit != 0);
			unitType = insType;
			_internalSMLUnits.addRegardless(unitType,pUnit);
		}
		pUnit->acceptLine(line);
	}         //****** end of collection loop

	if (ifLevel != 0) {
		cout << "***Error*** if nesting or internal error" << endl;
		line = (*_pSMLcode)[0];
		line.out();
		exit(2);
	}
	if (_internalSMLUnits.length() > 1 && elseEncountered == 0) {
		cout << "***Error***   'else' is missing in if instruction" << endl; 
		line = (*_pSMLcode)[0];
		line.out();
		exit(2);
	}

	translateUnits();		
}
//------------------------------------------  BF  April 2000  --------
void IfIns::outSobj(int& id, int level, ofstream& sobj, Registrar& insLists) const
{
	sobj << "if" << endl;

	int nunits = _internalSMLUnits.length();

	sobj << "  " << nunits << endl;

	for (int i=0; i < nunits; i++) {
		void* ptnvoid = _internalSMLUnits.gimePointer(i) ;
		IfUnit* pIfUnit;
		pIfUnit = (IfUnit*)ptnvoid;
		Name label = "\0"; InsList* pInsList;
		id++;
		pIfUnit->outSobj(id,level+1,sobj,label,pInsList);
		insLists.add(label,pInsList);
	}

	return;
}
