// ifUnit.cxx: implementation of the IfUnit class.
//
//                                                B. Franek
//                                             4 October 1999
//////////////////////////////////////////////////////////////////////
#include <assert.h>
#include <stdio.h>
#include "smlline.hxx"
#include "ifunit.hxx"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IfUnit::IfUnit() : SMLUnit("ifunit",10) 
{
   _name = "ifunit";
   return;
}

IfUnit::~IfUnit()
{
    delete _pSMLcode;
}

void IfUnit::translate() {

//	cout << " Translating " << _id << _name << endl;
//    _pSMLcode->out();

	SMLUnit *pUnit; Name tempName;

	int numOfLines = _pSMLcode->length();

	int collectingHead = 1;
	int collectingInsList = 0;

	_pHeadBlock = new IfUnitHeadBlock();
	pUnit = _pHeadBlock; tempName =" ";
	_internalSMLUnits.addRegardless(tempName,pUnit);

	SMLline line; char* pLine;

	InsList* pInsList;
	Name instype;
	bool insLine;
	int ifLevel = 0;

	for (int i = 0; i<numOfLines; i++) {   //***** Beg of collection loop
		line = (*_pSMLcode)[i];
		pLine = line.getString();
//          cout << pLine  << endl;

		if ( !line.commentLine() ) {
			insLine = line.instructionLine(instype);
//			  cout << i << "  " << insLine << instype << endl;
			  
			if ( insLine && collectingHead == 1 && i>0) {
				collectingInsList = 1;
				collectingHead = 0;
				pInsList = new InsList();
				assert (pInsList != 0);
				pUnit = pInsList; tempName = "InsList";
				_pInsList=pInsList;
				_internalSMLUnits.addRegardless(tempName,pUnit);
			}
		}
		  
		if (collectingHead ==1) {_pHeadBlock->acceptLine(line);}
		if (collectingInsList == 1 ) {pInsList->acceptLine(line);}
	}                              //****** end of collection loop


	translateUnits();
	_pCondition = _pHeadBlock->pCondition();
	
}
//---------------------------------  BF  April 2000  -------------------
void IfUnit::outSobj(int id, int level, ofstream& sobj, Name& label, InsList*& pInsList) const
{
	if(_pCondition) {_pCondition->outSobj(sobj);}
	else {
		sobj << "else" << endl;
		sobj << "    0" << "    0" << endl;
	}

//	sobj << "  " << id << "  " << level << endl;

	char tempch[80];

	sprintf(tempch,"%3d%3d",id,level); label = tempch;
	sobj << tempch << endl;

	pInsList = _pInsList;
	return;
}