//-----------------------------------------------------------------------
//                         IfUnitHeadBlock  Class
//                                                 B. Franek
//                                                 4-April-2000
//-----------------------------------------------------------------------
//
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "ifunitheadblock.hxx"
#include "smlunit.hxx"
#include "smlline.hxx"
#include "name.hxx"
#include "utilities.hxx"

//--------------------------- Constructors -------------------------------

IfUnitHeadBlock::IfUnitHeadBlock ( ) 
	: SMLUnit("ifunit head block",2) {
	return;
}

IfUnitHeadBlock::~IfUnitHeadBlock() {
    delete _pSMLcode;
}

  
void IfUnitHeadBlock::translate() {

/*	_pSMLcode->out();
	SMLline line; char* pLine;*/

	_else = 0;

    Name token; int idel,jdel; int inext,jnext;
	int ist,jst;
	char del = getNextToken(_pSMLcode,0,0," (",token,idel,jdel,inext,jnext);
	token.upCase(); token.trim();
	if ( token == "IF" ) {ist=idel; jst=jdel;}
	else if (token == "ELSE") {
		if (inext < 0) {_else = 1; return;}
		int idel1,jdel1,inext1,jnext1;
		del = getNextToken(_pSMLcode,inext,jnext," (",token,idel1,jdel1,inext1,jnext1);
		token.upCase(); token.trim();
		if (token == "IF") {ist=idel1; jst=jdel1;}
		else {cout << " Syntax error " << endl; exit(2);}
	}
	else { cout << " if, if else , or else not found" << endl; exit(2);}
    


	if (!_condition.initialise(_pSMLcode,ist, jst, inext, jnext)) {
		cout << " Parsing of condition failed" << endl;
		exit(2);
	}

	_condition.getHeader(_pSMLcode,ist,jst,inext,jnext);
	
    return;
}

void IfUnitHeadBlock::out(const Name offset) const
{

	SMLUnit::out(offset); 
	char* ptn=offset.getString(); cout << ptn << endl;

	if (_else==0){
		_condition.out(offset);
	}
	else {
		cout << ptn << " ELSE" << endl;
	}
	return;
}
//------------------------------------------  BF  April 2000 -------
Condition* IfUnitHeadBlock::pCondition()
{
	if (_else==1) {return 0;}
	return &_condition;
}
