//-----------------------------------------------------------------------
//                         IsOfClassObject  Class
//                                                 B. Franek
//                                                 24 April 2000
//-----------------------------------------------------------------------
//
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include "smlunit.hxx"
#include "utilities.hxx"
#include "isofclassobject.hxx"
#include "attributeblock.hxx"
#include "smlline.hxx"

//--------------------------- Constructors -------------------------------

IsOfClassObject::IsOfClassObject
( const Name& name, int assoc) 
: SMLUnit("Object",5) {
	_name = name;
	_associated = assoc;

	_isOfClass = "UNKNOWN";

//	cout << endl << "Object  " << _name << endl;
}
//----------------------------------------------------------------------
IsOfClassObject::~IsOfClassObject() {
    delete _pSMLcode;
}
//-----------------------------------------------------------------------
  
void IsOfClassObject::translate() {

//	cout << " Translating " << _id << _name << endl;
//    _pSMLcode->out();
	SMLline line; char* pLine;

	line = (*_pSMLcode)[0];
	pLine = line.getString();
	char* ptn = getNextToken(pLine,":", _isOfClass);
	ptn = getNextToken(ptn+1," ",_isOfClass);
	ptn = getNextToken(ptn+1," ",_isOfClass);
	ptn = getNextToken(ptn+1," /#!",_isOfClass);
	_isOfClass.upCase(); _isOfClass.trim();
	if (!check_name(_isOfClass)) {
		cout << " ***Error***  " << _isOfClass 
			<< "  is not a name" << endl;
		line.out();
		exit(2);
	}

	SMLUnit *pUnit; Name tempName;

	int numOfLines = _pSMLcode->length();

	_pAttributeBlock = new AttributeBlock();
	assert (_pAttributeBlock != 0);
	pUnit = _pAttributeBlock; tempName ="attribute block";
	_internalSMLUnits.addRegardless(tempName,pUnit);

	for (int i = 0; i<numOfLines; i++) { 
		line = (*_pSMLcode)[i];
		_pAttributeBlock->acceptLine(line);		  
	 }                       

//     cout << " Object : " << _name << " collecting finished" << endl;
 
	translateUnits();
	
	return;
}
//---------------------------------------------  BF April 2000  ------------------
void IsOfClassObject::outSobj(ofstream& sobj) const
{
	sobj << "*OBJECT" << endl;

	char* pStr = _name.getString();
	sobj << pStr << endl;

	int n1,n2,n3;

	n1 = 1;

	n2 = _pAttributeBlock->_attributes.length();
	n3 = _associated;

	char line[80];
	sprintf(line,"%5d%5d%5d",n1,n2,n3);
//	sobj << "    " << n1 << "    " << n2 << "    " << n3 << endl;
    sobj << line << endl;


	sobj << _isOfClass.getString() << endl;

	for (int i=0; i<n2; i++) {
		sobj << _pAttributeBlock->_attributes[i].getString() << endl;
	}

	sobj << "*END_OBJECT" << endl; 

	return;
}
//-----------------------------------------------------------------------------
