//-----------------------------------------------------------------------
//                         ParameterBlock  Class
//                                                 B. Franek
//                                                 26 March 1999
//-----------------------------------------------------------------------
//
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "parameterblock.hxx"
#include "smlunit.hxx"
#include "smlline.hxx"
#include "name.hxx"
#include "utilities.hxx"

//--------------------------- Constructors -------------------------------

ParameterBlock::ParameterBlock ( ) 
	: SMLUnit("parameter block",2) {
	return;
}

ParameterBlock::~ParameterBlock() {
    delete _pSMLcode;
}

  
void ParameterBlock::translate() 
{
	int numOfLines = _pSMLcode->length(); 
	if (numOfLines <= 0) {return;}

	Name token; int idel,jdel; int inext,jnext;
	int ist,jst;
	char del = getNextToken(_pSMLcode,0,0,":",token,idel,jdel,inext,jnext);
	token.upCase(); token.trim();
	if ( token == "PARAMETERS"){}
	else { cout << " Keyword Parameters not found" << endl; exit(2);}
    ist = inext; jst = jnext;

	if ( !_parameters.initFromSMLcode( 1, _pSMLcode, ist,jst,inext,jnext)) {
		cout << " Parameter parsing failed " << endl;
		exit(2);
	}

	return;
}

void ParameterBlock::out(const Name offset) const
{

	SMLUnit::out(offset); 
	char* ptn=offset.getString(); cout << ptn << endl;
	_parameters.out(offset);

}
//-----------------------------------------------------------------------
Parms* ParameterBlock::pParameters()
{
	return &_parameters;
}
//------------------------------------------  BF  April 2000  ---------	 
int ParameterBlock::numOfParameters() const
{
	return _parameters.numOfEntries();
}
//------------------------------------------  BF April  2000  ----------
void ParameterBlock::getPar(int inx, Name& name, Name& value, char* type) const
{
	_parameters.get(inx,name,value,type);
	return;
}

