#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "name.hxx"
#include "utilities.hxx"
//---------------------------------------------------------------------
//                                                   B. Franek
//                                                   17-March-1999
//---------------------------------------------------------------------

void processCommandLine( int argc, char* argv[],
                        int& dbg, Name& inputFile, Name& outputFile) {

#ifndef WIN32
	int c;
	extern char *optarg;
	extern int optind, optopt;

	dbg = 0;

	while ((c = getopt(argc, argv, ":d")) != -1 ) {
		switch (c) {
		case 'd':
			dbg = 1;
			break;
		case ':':
			cout << " option " << optopt 
			<< " requires an argument\n" ;
			break;
		case '?':
			cout << " unknown option " << optopt << endl;
			break;
		}
	}

	if ( optind >= argc ) {
		cout << " Input file is missing " << endl;
		exit(2);
	}
	inputFile = argv[optind];
	optind++;
	if ( optind >= argc ) {
		outputFile = "\0";
	}
	else {
		outputFile = argv[optind];
	}
//--------------------------------------------------------------
	char* pStr = inputFile.getString();
	char* ptnf;
	Name reducedName;

	if (outputFile == "\0") { // Output file is absent 
		if (ptnf = strstr(pStr,".smi")) {  // contains .smi 
			if (!strcmp(ptnf,".smi")) { // it is at the end 
				*ptnf ='\0';
			}
			reducedName = pStr; 
		}
		else {
			reducedName = inputFile;
		}
		inputFile = reducedName;
		inputFile += ".smi";
		outputFile = reducedName;
		outputFile += ".sobj";
	}
    return;
#else
	dbg = 0;
	inputFile = argv[1]; outputFile = argv[2];
	return;
#endif
}
