// setins.cxx: implementation of the SetIns class.
//
//                                                B. Franek
//                                           30 September 1999
//////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "smlunit.hxx"
#include "smlline.hxx"
#include "name.hxx"
#include "utilities.hxx"
#include "setins.hxx"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SetIns::SetIns()  
{
   _name = "set";
   return;
}

SetIns::~SetIns()
{
    delete _pSMLcode;
}

void SetIns::translate() {
	Name parName; Name value; Name temp; Name objName;
	char TAB = '\t';

	char type[10];
	int ierr;


	int numOfLines = _pSMLcode->length();
	SMLline line;

//	SMLUnit::out(" ");


    Name token; int idel,jdel; int inext,jnext;
	int ist,jst;
	char del = getNextToken(_pSMLcode,0,0," ",token,idel,jdel,inext,jnext);
	token.upCase(); token.trim();
	if ( token == "SET"){}
	else { cout << " Keyword do not found" << endl; exit(2);}
    ist = inext; jst = jnext;


	del = getNextToken(_pSMLcode,ist,jst,"=",_objectParamNm,idel,jdel,inext,jnext);
	_objectParamNm.upCase(); 
	if ( !check_name(_objectParamNm) ) {
		cout << _objectParamNm << " is not a name" << endl;
		exit(2);
	}

	ist = inext; jst = jnext;
	del = getValue(_pSMLcode,ist,jst,"&",value,type,ierr,
				idel,jdel,inext,jnext);

	if (!strcmp(type,"UNKNOWN")) {
		_insType = 3;
		del = getNextToken(_pSMLcode,ist,jst,".<",_otherObjectNm,idel,jdel,inext,jnext);
		_otherObjectNm.upCase(); 
		if ( !check_name(_otherObjectNm) ) {
			cout << _otherObjectNm << " is not a name" << endl;
			exit(2);
		}

		ist = inext; jst = jnext;
		del = getNextToken(_pSMLcode,ist,jst,">",_otherParamNm,idel,jdel,inext,jnext);
		_otherParamNm.upCase(); 
		if ( !check_name(_otherParamNm) ) {
			cout << _otherParamNm << " is not a name" << endl;
			exit(2);
		}

	}
	else if (!strcmp(type,"NAME")) {
		_insType = 2;
		_actionParamNm = value;
		_actionParamNm.upCase(); 
		if ( !check_name(_actionParamNm) ) {
			cout << _actionParamNm << " is not a name" << endl;
			exit(2);
		}

	}
	else {_insType = 1; _value = value;}

   return;

}

//--------------------------------------------------------------------------
void SetIns::out(const Name offset) const
{

	SMLUnit::out(offset); 
	char* ptn=offset.getString(); cout << ptn ;
	cout << " Set instruction type " <<_insType << endl;
	cout << ptn;
	cout << "Parameter : " << _objectParamNm << endl;

	if (_insType == 1) {
		cout << ptn;
		cout << " set to value = " << _value << endl;
	}
	else if (_insType == 2 ) {
		cout << ptn;
		cout << "set to value of action parameter : " << _actionParamNm << endl;
	}
	else {
		cout << ptn;
		cout << " set to parameter " << _otherParamNm 
		<< " of object " << _otherObjectNm << endl;
	}

  return;
}
//------------------------------------------  BF April  2000  -----------
void SetIns::outSobj(int&,int,ofstream& sobj,Registrar&) const
{
	sobj << "set" << endl;

	sobj << "    " << _insType << endl;

	if (_insType == 1) {
		sobj << _objectParamNm.getString() << endl;
		sobj << _value.getString() << endl;
	}
	else if (_insType == 2) {
		sobj << _objectParamNm.getString() << endl;
		sobj << _actionParamNm.getString() << endl;
	}
	else if (_insType == 3) {
		sobj << _objectParamNm.getString() << endl;
		sobj << _otherObjectNm.getString() << endl;
		sobj << _otherParamNm.getString() << endl;
	}
	else {}

	return;
}