// smlunit.cxx: implementation of the SMLUnit class.
//
//                                                B. Franek
//                                               2 July 1999
//////////////////////////////////////////////////////////////////////

#include "smlunit.hxx"
#include "assert.h"
#include "string.h"
#include "parms.hxx"
#include "smlline.hxx"
#include "utilities.hxx"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SMLUnit::SMLUnit(char* id, int buf, Name name)
{
	_id = id;
	_name = name;
    _pSMLcode = new SMLlineVector(buf);
     assert(_pSMLcode != 0); 
//	 cout << "SMLUnit constructor called" << endl;
}

SMLUnit::~SMLUnit()
{
    delete _pSMLcode;
}

int SMLUnit::acceptLine( const SMLline& line )
{
    *_pSMLcode += line;
//	cout << "acceptLine _id :" << _id << " _name : " << _name << endl;
//	cout << line << endl;
	return 0;
}

void SMLUnit::out(const Name offSet) const
{
	Name nextOffset;
	nextOffset = offSet;

	nextOffset += "  |";


    char* ptn = offSet.getString();

    void* ptnvoid; SMLUnit* pUnit;
	int numOfUnits = _internalSMLUnits.length();
	cout << ptn 
		<< "----------------------------------------------"<< endl 
		<< ptn << 
		" SMLUnit : " << _id << " " << _name << "  No of internal units : " << numOfUnits << endl;
	
	ptn = offSet.getString();
	if ( numOfUnits == 0 ) {
    	_pSMLcode->out(ptn);
	}
	else {
		for ( int i=0; i<numOfUnits; i++ ) {
			cout << ptn << "  " << i+1 << endl;
			ptnvoid = _internalSMLUnits.gimePointer(i);
            pUnit = (SMLUnit*)ptnvoid;
	        pUnit->out(nextOffset);
		}
	}
}
//------------------------------------------------- BF April 2000 -----------------
//void SMLUnit::outSobj(ofstream& sobj) const
//{
//	return;
//}
//------------------------------------------------- BF April 1999 -------------
void SMLUnit::translateUnits() {
	
     int numOfUnits = _internalSMLUnits.length();
    // cout << "Num of units : " << numOfUnits << endl;

     void* ptnvoid; SMLUnit* pUnit;

     for ( int iu=0; iu<numOfUnits; iu++ ) {  //Translation loop
        ptnvoid = _internalSMLUnits.gimePointer(iu);
        pUnit = (SMLUnit*)ptnvoid;
//       cout << " Going to translate :" << endl;
//		pUnit->outCodeOnly(" ");
//cout << " Translating " << pUnit->unitId() << pUnit->unitName() << endl;
	    pUnit->translate();

	 }   // end of translation loop
}

//----------------------------------------------------------------

Name SMLUnit::unitId() const
{
	return _id;
}

//----------------------------------------------------------------

Name SMLUnit::unitName() const
{
	return _name;
}

//-----------------------------------------------------------------

void SMLUnit::outCodeOnly(const Name offSet) const
{

	Name nextOffset;
	nextOffset = offSet;

	nextOffset += "  |";


    char* ptn = offSet.getString();

	int numOfUnits = _internalSMLUnits.length();
	cout << ptn 
		<< "----------------------------------------------"<< endl 
		<< ptn << 
		" SMLUnit : " << _id << " " << _name << "  No of internal units : " << numOfUnits << endl;
	
	ptn = offSet.getString();
	_pSMLcode->out(ptn);
}

//---------------------------------------------------------------
int SMLUnit::nextChar(const int iline, const int ch,
				int nextLine, int nextCh) const
{
	int numOfLines = _pSMLcode->length();
	if ( iline <0 || iline >= numOfLines ) return 0;

	SMLline line = (*_pSMLcode)[iline];
	char* pLine = line.getString();
	int lineLength = strlen(pLine);

	if ( ch < 0 || ch >= lineLength ) {return 0;}

	nextCh = ch +1;

	if ( nextCh < lineLength ) {nextLine = iline; return 1;}

	nextCh = 0;

	for ( int i=iline+1; i < numOfLines; i++) {
		line = (*_pSMLcode)[i];
		pLine = line.getString();
		lineLength = strlen(pLine);
		if ( lineLength > 0 ) {nextLine = i; return 1;}
	}
	return 0;
}

/*int SMLUnit::prevChar(const int line, const int ch, 
				int prevLine, int prevCh) const
{
	return 0;
}*/
