// smlunit.hxx: interface for the SMLUnit class.
//
//                                                  B. Franek
//                                                 2 July 1999
//
//////////////////////////////////////////////////////////////////////

#ifndef SMLUNIT_HH
#define SMLUNIT_HH

#include <fstream.h>
#include "name.hxx"
#include "registrar.hxx"
#include "smllinevector.hxx"
#include "condition.hxx"
class Parms;

class SMLUnit  
{
public:
	SMLUnit(char* id, int buf, Name name="\0");

	virtual ~SMLUnit();

	virtual int acceptLine( const SMLline& line);

    virtual void translate() = 0;

	virtual void out(const Name offset) const;

//	virtual void outSobj(ofstream& sobj) const;

	Name unitId() const;

	Name unitName() const;

	void outCodeOnly(const Name offset) const;

	int nextChar(const int line, const int ch,
				int nextLine, int nextCh) const;

/*	int prevChar(const int line, const int ch, 
				int prevLine, int prevCh) const;*/

protected :

	void translateUnits();



	Name _id;  Name _name;

	SMLlineVector* _pSMLcode;

    Registrar _internalSMLUnits;
};

#endif
