// smpcond.cxx: implementation of the SmpCond class.
//
//                                                B. Franek
//                                               21 February 2000
//////////////////////////////////////////////////////////////////////
#include "stdlib.h"
#include "assert.h"
#include "string.h"
#include "smlline.hxx"
#include "smllinevector.hxx"
#include "utilities.hxx"

#include "smpcond.hxx"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
SmpCond::SmpCond()
{
	return;
}

SmpCond::~SmpCond()
{
	return;
}

int SmpCond::initialise(const int idNum, SMLlineVector* pSMLcode,
			const int ist, const int jst,  
//			int& iend, int& jend, int& inext, int& jnext)
			int& inext, int& jnext)
{

	_idNum = idNum;
	Name parName; Name value;
	char* ptnDel;

	int numOfLines = pSMLcode->length(); 
	
	SMLline line; char* pLine;


	char* ptn;

	Name temp;

//	cout << endl << "going to parse Simple condition" << endl;

	int i = ist;
	line = (*pSMLcode)[i];
//	cout << line << endl;
	pLine = line.getString();
	ptn = &pLine[jst];
	
  
	int ibeg,jbeg;
	int idel,jdel;

//	cout << "ist,jst" << " " << ist << "," << jst << endl;
	char del = getNextToken(pSMLcode,ist,jst,". ",
					_objectName,idel,jdel,inext,jnext);
//	cout << "idel,jdel" << " " << idel << "," << jdel << endl;
	_objectName.upCase(); _objectName.trim();
	if (!check_name(_objectName)) {
		cout << " Object name is not a name " << _objectName << endl;
		exit(2);
	}
	if (del == '.') {
		Name part2 = "\0";
		char del = getNextToken(pSMLcode,inext,jnext," ",
					part2,idel,jdel,inext,jnext);
//		cout << part2 << endl;
		part2.upCase();
		if (!check_name(part2)) {
			cout << part2 << "  is not a name" << endl;
			exit(2);
		}
		_objectName += "."; _objectName += part2;
	}
//	cout << " Object name " << _objectName << endl;
	ibeg = inext; jbeg = jnext;
	del = getNextToken(pSMLcode,ibeg,jbeg," {",temp,idel,jdel,inext,jnext);
	temp.upCase(); ptnDel = &del;

	if (temp == "IN_STATE") { _inState = 1;}
	else if (temp == "NOT_IN_STATE") { _inState = 0;}
	else {
		cout << " Error   looking for in_state or not_in_state " 
			<<temp << endl;
		cout << line << endl;
		exit(2);
	}
//	cout << _inState << endl;
	ibeg = inext; jbeg = jnext;

	if ( *ptnDel == ' ' ) {
		del = getNextToken(pSMLcode,ibeg,jbeg," )",temp,idel,jdel,inext,jnext);
		temp.upCase(); temp.trim(); ptnDel = &del;

		if(!check_name(temp)) {
			cout << " State name is not a name " << temp << endl;
			exit(2);
		}
		_states += temp;

//		iend = idel; jend = jdel; 
		if (del == ')') {inext = idel; jnext = jdel;}
		return 1;
	}

	
//	if (!getStates(pSMLcode,ibeg,jbeg,iend, jend,inext,jnext)) {
	if (!getStates(pSMLcode,ibeg,jbeg,inext,jnext)) {

		cout << " Parsing simple condition failed " << endl;
		exit(2);
	}


	return 1;

}
//-----------------------------------------------------------------------
int SmpCond::idNum() const
{
	return _idNum;
}

char SmpCond::type() const
{
	return 'T';
}
//-----------------------------------------------------------------------
void SmpCond::negate()
{
	if (_inState == 1) {_inState = 0; return;}
	if (_inState == 0) {_inState = 1; return;}
}
//-----------------------------------------------------------------------
int SmpCond::getStates(SMLlineVector* pSMLcode,
			const int ist, const int jst,
//			int& iend, int& jend,
			int& inext, int& jnext) 
{
	Name temp;

//	cout << endl << "collecting states" << endl;

	char del; int ibeg,jbeg,idel,jdel;
	ibeg = ist; jbeg = jst;

	for (;;) {
		del = getNextToken(pSMLcode,ibeg,jbeg,",}",temp,idel,jdel,inext,jnext);
		if (temp == "\0") {break;}
		temp.upCase();
		if(!check_name(temp)) {
			cout << " State name is not a name " << temp << endl;
			exit(2);
		}
		_states += temp;
//		if (del == '}') { iend = idel; jend = jdel; return 1;}
		if (del == '}') { return 1;}

		if (inext <0) {break;}
		ibeg=inext;jbeg=jnext;
	}


    cout << " matching } not found" << endl;
	return 0;
}
//----------------------------------------------------------------------------
void SmpCond::out(const Name offset) const
{
	Name offset1 = offset; offset1 += "          ";
	char temp[20];
	if ( _inState == 1 ) {strcpy(temp," in_state ");}
	else {strcpy(temp," not_in_state ");}
	char* ptn = offset.getString();
	cout << ptn  << _idNum << " " << _objectName << temp << " ";
	_states.out(offset1); 
	return;
}
void SmpCond::outFull(const Name offset) const
{ out(offset); return;}

//---------------------------------------------  BF April 2000  ------
void SmpCond::outSobj(ofstream& sobj) const
{
	sobj << _objectName.getString() << endl;

	if (_inState) { sobj << "in_state" << endl;}
	else          { sobj << "not_in_state" << endl;}

	int ns = _states.length();

	sobj << "    " << ns << endl;

	for (int is=0; is<ns; is++) {
		sobj << (_states[is]).getString() << endl;
	}

	return;
}
