// smpcond.hxx: interface for the SmpCond class.
//
//                                                  B. Franek
//                                                21 February 2000
//
//////////////////////////////////////////////////////////////////////
#ifndef SMPCOND_HH
#define SMPCOND_HH

#include <fstream.h>
#include "name.hxx"
#include "namevector.hxx"
class SMLlineVector;
#include "boolitem.hxx"

class SmpCond : public BoolItem 
{
public:
	SmpCond();

	virtual ~SmpCond();

	int initialise(const int idNum, SMLlineVector* pSMLcode,
			const int ist, const int jst,  
//			int& iend, int& jend, int& inext, int& jnext);
			int& inext, int& jnext);

	int idNum() const;

	char type() const;

	void negate();

	void out(const Name) const;

	void outFull(const Name) const;

	void outSobj(ofstream& sobj) const;

protected :

	int getStates(SMLlineVector* pSMLcode,
			const int ist, const int jst,  
			int& inext, int& jnext);
	
	int _idNum;

	Name _objectName;

	int _inState;

	NameVector _states;
};

#endif 
