// termins.cxx: implementation of the TermIns class.
//
//                                                B. Franek
//                                           30 September 1999
//////////////////////////////////////////////////////////////////////

#include "termins.hxx"

#include "stdlib.h"
#include "smlline.hxx"
#include "utilities.hxx"
#include "name.hxx"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TermIns::TermIns()  
{
   _name = "terminate_action";
   _endState = "\0";
   return;
}

TermIns::~TermIns()
{
    delete _pSMLcode;
}

void TermIns::translate() {

	Name parName; Name temp; Name actName;
	char TAB = '\t';
	int ierr; 
	char* ptnDel; char* ptemp;


	int numOfLines = _pSMLcode->length();
	SMLline line; char* pLine;


	line = (*_pSMLcode)[0];
//	cout << line << endl;
//	if (line.commentLine()) {continue;}
	pLine = line.getString();
	ptnDel = getName(pLine,"/",temp,ierr);

	ptemp = temp.getString();
	if(my_strcasecmp(ptemp,"terminate_action") || ierr != 0 ){
		cout << " Error   expecting terminate_action .." << endl;
		cout << line << endl; 
		exit(2);
	}

	ptnDel = getName(ptnDel+1,"=",temp,ierr);

	ptemp = temp.getString();
	if(my_strcasecmp(ptemp,"state") || ierr != 0 ){
		cout << " Error   expecting state .." << endl;
		cout << line << endl; 
		exit(2);
	}

	ptnDel = getName(ptnDel+1,"=",temp,ierr);

	if(ierr != 0 ){
		cout << " Error  parsing terminate_action instruction .." << endl;
		cout << line << endl; 
		exit(2);
	}


	_endState = temp;
   return;
}

void TermIns::out(const Name offset) const
{

	SMLUnit::out(offset); 
	char* ptn=offset.getString(); cout << ptn 
							<< "End state " << _endState << endl;
}
//-------------------------------------  BF April 2000  ---------------
void TermIns::outSobj(int& dum1,int dum2, ofstream& sobj, Registrar&) const
{
	sobj << "terminate" << endl;

	sobj << _endState.getString() << endl;

	return;

}