// when.cxx: implementation of the When class.
//
//                                                B. Franek
//                                               23 September 1999
//////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "when.hxx"
#include "smlline.hxx"
#include "utilities.hxx"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

When::When() : SMLUnit("when",3) 
{
  
}

When::~When()
{
    delete _pSMLcode;
}
//----------------------------------------------------------------------
void When::translate() {

    Name token; int idel,jdel; int inext,jnext;
	int ist,jst;
	char del = getNextToken(_pSMLcode,0,0," (",token,idel,jdel,inext,jnext);
	token.upCase(); token.trim();
	if ( token == "WHEN"){}
	else { cout << " When not found" << endl; exit(2);}
    ist = idel; jst = jdel;

	int ibegcond = ist; int jbegcond = jst;
	if (!_condition.initialise(_pSMLcode,ist, jst, inext, jnext)) {
		cout << " Parsing of condition failed" << endl;
		exit(2);
	}
	int iendcond = inext; int jendcond = jnext;

	ist = inext; jst = jnext;
	del = getNextToken(_pSMLcode,ist,jst," ",_actionName,idel,jdel,inext,jnext);

	if (inext != -1 ) {
		cout << " Unknown code following a valid when condition"
			<< endl;
		exit(2);
	}

/*	cout << "dbg" << endl;
		cout << ibegcond << endl;
			cout << jbegcond << endl;
				cout << iendcond << endl;
					cout << jendcond << endl;
	_pSMLcode->out();*/
	
	_condition.getHeader(_pSMLcode,ibegcond,jbegcond,iendcond,jendcond);
			
	return;
}
//---------------------------------------------------------------------
void When::out(const Name offset) const
{
	SMLUnit::out(offset); 
	char* ptn=offset.getString(); cout << ptn << endl;
	_condition.out(offset);
	cout << ptn << endl << ptn << " Action : " << _actionName << endl;
}
//------------------------------------------- BF April 2000 -----------
void When::outSobj(ofstream& sobj) const
{
	sobj << "*WHEN" << endl;

	_condition.outSobj(sobj);


	sobj << "do" << endl;
	sobj << _actionName.getString() << endl;
	sobj << "    0" << endl;
	sobj << "&THIS_OBJECT" << endl;

	return;
}


