//
//  manager.cc  -->  manager  the prototype data flow proxy process
//
//  usage:    manager <domain_name> <crate_mask> [parameter_file]
//
//  Since we currently need to modify it, we include the generated main() 
//  routine completely below.  The modification is actually in the 
//  declaration of the globl pointer to the OdfManager.
//  Hopefully this can be avoided in the furture 
//  if we get a really smart idea.?

#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <signal.h>

typedef int bool;
#define false 0
#define true 1 
#include <smirtl.hh>

char*      TheProxyName = "DATAFLOW" ;
char*      TheDomainName ;
char*      TheObjectName ;
/*
extern "C" {
  void dim_init_threads() ;
	   } ;
*/
bool       newCommand = false ;

void handleSignals(void) 
{
  newCommand = true ;
}


void handleCommands(void) 
{
   char command[133] ;
  int npars ;
  npars = 0 ;
  smi_get_action(command,&npars) ;
  cout <<TheObjectName
		<<"Received command " << command 
		<<" from Run Control "
		<< "\n";
  cout.flush();
  // The following if clause is a hack to allow testing of 
  // error handling etc. in simulation mode.
  /*
  if (getenv("ORCDEBUGERROR") != NULL )
    {
      FILE  *errorFile = fopen(getenv("ORCDEBUGERROR"),"r") ;
      if ( errorFile == NULL ) 
	{
	  cout 
	    << "Failed to open action error file " 
	    << getenv("ORCDEBUGERROR")
	    << endl ;
	}
      else
	{
	  char line[100],action[100],state[100] ;
	  while (0 != fgets(line,80,errorFile) )
	    {
	      sscanf(line,"%s %s",action,state) ;
	      if ( !strcmp(action,command) )
		{
		  theManager->setState(state) ;
		  fclose(errorFile) ;
		  return ;
		}
	    }
	  fclose(errorFile) ;
	}
    }

  
  theManager->dispatch(command,npars) ;
  */
  smi_terminate_action("READY");
  }

 main(int argc, char** argv)
{
    char full_name[256] ;
    int realFlag ;


    // argv[1] contains the SMI domain name within which 
    // this obect lives. The full_name is then contructed 
    // as   <domain_name>::<object name> 
    //  argv[2] is the list of crates required - will be sent from the creator
    /*
     if (argc <2) 
       { 
         cout << "manager: At least 2 arguments required :  domain_name crate_mask [realFlag] " << endl ;
         exit(0) ;
       }
    */
     sprintf(full_name,"%s::%s",argv[1],TheProxyName);
     TheDomainName = new char[strlen(argv[1])+1] ;
     strcpy(TheDomainName,argv[1]) ;
     TheObjectName = new char[strlen(full_name)+1] ;
     strcpy(TheObjectName,full_name) ;

     /*
     unsigned crates = 0xffffffff ;
     if (argc >= 3)  { 
       sscanf(argv[2],"%x",&crates) ;
     }
     realFlag = 1 ;
     if (argc == 4) {
       sscanf(argv[3],"%d",&realFlag) ;
     }
     
     cout 
       << TheObjectName 
       << " started for odf_platform "
       << getenv("ODF_PLATFORM") 
       << " crate mask "
       << hex << crates << dec
       << endl ;
     */
     cout 
       << TheObjectName 
       << " started \n";
     cout.flush();
     // Before we talk to any sockets etc.
     // Find out whether we are already a process group leader (started
     // from the teminal) or not.  If not then become one.
     // [ This is now fixed in Dim v3.1 ]
     //    cout << " set process group " << endl ;
     //     setpgrp() ;


     // We also need to make sure that we have SIGIO and SIGALRM unblocked
     // This ma sometimes be the case is this process was forked from 
     // another
     
     sigset_t set, oset; 
     sigemptyset(&set);     sigaddset(&set,SIGIO);
     sigaddset(&set,SIGALRM);
     sigprocmask(SIG_UNBLOCK,&set,&oset);
     

     // Now we connect to the dataflow platform and ask for the 
     // new partition to be created
     //  Note: We are atually making and OdfController here.

     // The following calls would naturally go into the 
    // manager construtor, but we put them here to keep 
    // a clean separation between the stubs which should 
    // and should not be edited by the User 
    //  NOTE:  WE HAVE NOT ACHEIVED THIS ADMIRABLE GOAL AS YET

     dim_init_threads() ;
    smi_attach(full_name, (void (*)(...))handleSignals) ;
    smi_volatile();
    smi_set_par("DF_CORR_CRATE_MASK","0",STRING);
    smi_set_state("STARTINGUP") ;

    dtq_sleep(2);
    /*
    OstErrLog myErrLogger(1) ;
    myErrLogger.addContext("domain", "ORC") ;
    myErrLogger.addContext("name", "ODF") ;
    myErrLogger.addContext("component", argv[1]) ;
    myErrLogger.setDumpToScreen(true) ;
    myErrLogger.init() ;

    theManager = new OrcOdfController(crates,realFlag) ;
    */
    while(1)
      { 
	pause();
	if(newCommand)
	  {
	    handleCommands() ;
	    newCommand=false ;
	  }
      }
    

} 










