      integer function cond_transl(condition,
     &                             max_smpconds,n_smpconds,smpconds,
     &                max_instructions,num_instructions,instructions)
* The condition string is going to be destroyed
*
      implicit none
      character*(*) condition             ! Complete condition string uppercased
!                                         ! and multiple blanks removed

      integer n_smpconds,max_smpconds     ! Number and max number of simple
!                                         ! conditions returned

      character*(*) smpconds(max_smpconds) ! array of simple conditions


      integer max_instructions,num_instructions
      character*(*) instructions(max_instructions)


      integer nc_cond      ! length of the condition string

      integer ln_smpcond  ! length of the simple condition string

      integer nc,ic

      integer ipom,istart
      integer ipom1,ipom2

      integer beg_smpcond,end_smpcond


      integer i
      character*4 S,S1,S2,S3
      integer priS,priS1,priS2,priS3
      character*4 item
      integer item_pt,ns
*****************************************************************************
      character*4 operation
      character*1 operand1_id
      character*1 operand2_id    ! Either T or X
      integer operand1_num,operand2_num


      nc_cond = len(condition)
      ln_smpcond = len(smpconds(1))

! This is the form I would expect to receive it, i.e in one string with 
! multiple  blanks removed and everything in UPPER CASE.

      call replace(condition,condition(1:nc_cond),' IN_STATE '
     &             ,' in_state ',nc_cond)

      call replace(condition,condition(1:nc_cond),' NOT_IN_STATE '
     &             ,' not_in_state ',nc_cond)

      call replace(condition,condition(1:nc_cond),' AND '
     &             ,' and ',nc_cond)

      call replace(condition,condition(1:nc_cond),' AND('
     &             ,' and(',nc_cond)

      call replace(condition,condition(1:nc_cond),')AND '
     &             ,')and ',nc_cond)

      call replace(condition,condition(1:nc_cond),')AND('
     &             ,')and(',nc_cond)


      call replace(condition,condition(1:nc_cond),' OR '
     &             ,' or ',nc_cond)

      call replace(condition,condition(1:nc_cond),')OR '
     &             ,')or ',nc_cond)

      call replace(condition,condition(1:nc_cond),' OR('
     &             ,' or(',nc_cond)

      call replace(condition,condition(1:nc_cond),')OR('
     &             ,')or(',nc_cond)

      call replace(condition,condition(1:nc_cond),' NOT '
     &             ,' not ',nc_cond)

      call replace(condition,condition(1:nc_cond),'(NOT '
     &             ,'(not ',nc_cond)

      call replace(condition,condition(1:nc_cond),' NOT('
     &             ,' not(',nc_cond)

      call replace(condition,condition(1:nc_cond),'(NOT('
     &             ,'(not(',nc_cond)

      call squeeze(condition,condition(1:nc_cond),nc_cond)


*BEG*****************  Find and replace all the simple conditions *************

      n_smpconds = 0
      istart = 0

      do while (.true.)
        ipom1 = index(condition(istart+1:nc_cond),'in_state')
        ipom2 = index(condition(istart+1:nc_cond),'not_in_state')
        if(ipom1 .eq. 0 .and. ipom2 .eq. 0) go to 200

        if (ipom1 .eq. 0) then
            ipom = ipom2
        else
           if ( ipom2 .eq. 0 ) then
                ipom = ipom1
           else
                if( ipom1 .lt. ipom2 ) then
                    ipom = ipom1
                else
                    ipom = ipom2
                endif
           endif
        endif

        ipom = ipom + istart

        n_smpconds = n_smpconds + 1
        if( n_smpconds .gt. max_smpconds) then
          write(6,*) ' Too many simple conditions'
          cond_transl = 2    
          return
        endif

* search for opening bracket or 'or' or 'and'
        do ic = ipom-1,1,-1
          if(condition(ic:ic) .eq. '(') then
            beg_smpcond = ic+1
            go to 111
          elseif (condition(ic:ic+1) .eq. 'or') then
            beg_smpcond = ic+2
            go to 111
          elseif (condition(ic:ic+2) .eq. 'and') then
            beg_smpcond = ic+3
            go to 111
          endif
        enddo
        cond_transl = 4     ! no opening bracket in a simple condition
        return

  111   continue

* search for closing bracket or 'or' or 'and'

        do ic = ipom+8,nc_cond,+1
          if(condition(ic:ic) .eq. ')') then
             end_smpcond = ic-1
             go to 112
          elseif(condition(ic:ic+1) .eq. 'or') then
             end_smpcond = ic-1
             go to 112
          elseif(condition(ic:ic+2) .eq. 'and') then
             end_smpcond = ic-1
             go to 112
          endif
        enddo
        cond_transl = 6     ! no closing bracket in a simple condition
        return

  112   continue
        if( (end_smpcond-beg_smpcond+1) .gt. ln_smpcond) then
           write(6,*) ' Simple condition is too long '
           cond_transl = 8
           return
        endif
        smpconds(n_smpconds) = condition(beg_smpcond:end_smpcond)

* Now replace the simple condition in the condition string by T'n',where
* n is the simple condition number. E.g.  4th simple condition will be T0004

        write(condition(beg_smpcond:beg_smpcond+3),'(''T'',i3.3)')
     &                                                n_smpconds               
        condition(beg_smpcond+4:) = condition(end_smpcond+1:nc_cond)
        nc_cond = nc_cond - (end_smpcond-beg_smpcond+1) + 4

* seart=ch for the next one
        istart = beg_smpcond
      enddo

  200 continue
*END***************** Find and replace all the simple conditions   *************


      do ipom = 1,n_smpconds
        write(80,'(i3,1x,a)') ipom,smpconds(ipom)(1:70)
      enddo

        write(80,*) ' '

      ipom = 0
      do while (.true.)
        if((ipom+50) .gt. nc_cond) then
           nc = nc_cond - ipom
        else
           nc = 50
        endif
        write(80,'(1x,a)') condition(ipom+1:ipom+nc)
        if(nc .ne. 50) go to 300
        ipom=ipom+50
      enddo

  300 continue
c beg============== Translate it now into instructions =======================



      condition(nc_cond+1:nc_cond+1) = ';'
      item_pt = 0

      do while (.true.)
         call get_next_item(condition,item,priS,item_pt)
         if(item .eq. ';  ') go to 400
         write(80,'(1x,a,2x,i5)') item,priS
      enddo

  400 continue

      ns = 0
      item_pt = 0

      i = 1
      S = '@'
      priS = 0

      do while (.true.)
        if( S .eq. 'and' .or. S .eq. 'or' 
     &     .or. S .eq. ')' .or. S .eq. ';') then
          go to 999
        else
          call put_on_stack(S,priS,ns)
          call get_next_item(condition,S,priS,item_pt)
          go to 1000    !end of the loop
        endif
  999   continue
        if(i .gt. max_instructions) then
           write(6,*) ' condition is too long'
           cond_transl = 10
           return
        endif
        call get_from_stack(2,S2,priS2,ns)          
        if( priS .gt. priS2 ) then
          call put_on_stack(S,priS,ns)
          call get_next_item(condition,S,priS,item_pt)
          go to 1000    !end of the loop
        endif
        if( S2 .eq. '@' ) go to 1001
        if( S2 .eq. '(' ) then
          call delete_S2_from_stack(ns)
          call get_next_item(condition,S,priS,item_pt)
          go to 1000
        endif
        if( S2 .eq. 'and' .or. S2 .eq. 'or' ) then
          call get_from_stack(1,S1,priS1,ns)
          call get_from_stack(3,S3,priS3,ns)
          write(item,'(''X'',i3.3)') i
          write(80,'(1x,a,'' = '',3a5)') item,S3,S2,S1
          if( S2 .eq. 'and' ) operation = 'and '
          if( S2 .eq. 'or' ) operation = 'or  '
          if(index(S3,'X') .ne. 0) operand1_id = 'X'
          if(index(S3,'T') .ne. 0) operand1_id = 'T'
          if(index(S1,'X') .ne. 0) operand2_id = 'X'
          if(index(S1,'T') .ne. 0) operand2_id = 'T'
          read(S3(2:4),'(i3)') operand1_num 
          read(S1(2:4),'(i3)') operand2_num 
          write(instructions(i),'(a,2x,a,i3.3,2x,a,i3.3)')
     &    operation,operand1_id,operand1_num
     &                 ,operand2_id,operand2_num
          call delete_top_stack(3,ns)
          call put_on_stack(item,-1,ns)
          i=i+1
          go to 999
        endif
        if( S2 .eq. 'not' ) then
          call get_from_stack(1,S1,priS1,ns)
          write(item,'(''X'',i3.3)') i
          write(80,'(1x,a,'' = '',2a4)') item,S2,S1
          operation = 'not'
          if(index(S1,'X') .ne. 0) operand1_id = 'X'
          if(index(S1,'T') .ne. 0) operand1_id = 'T'
          read(S1(2:4),'(i3)') operand1_num 
          operand2_id = ' '
          operand2_num = 0
          write(instructions(i),'(a,2x,a,i3.3,2x,a,i3.3)')
     &    operation,operand1_id,operand1_num
     &                 ,operand2_id,operand2_num
          call delete_top_stack(2,ns)
          call put_on_stack(item,-1,ns)
          i=i+1
          go to 999
        endif
        write(6,*) ' something is wrong'
        call exit(2)
 1000 continue
      enddo
 1001 continue

      num_instructions = i - 1

      cond_transl = 1      
      return
      end
