!      character*80 parameters
!      integer line_number
!      integer max_par,npar
!      parameter (max_par=3)
!      character*10 par_name(max_par),parv(max_par),par_type(max_par)
!      integer nq,i,lv,lnm,lt
!
!
!    1 continue
!      read(5,'(q,a)') nq,parameters(1:nq)
!   
!      call get_parameters(parameters(1:nq),line_number
!     &                          ,max_par,npar
!     &                          ,par_type,par_name,parv)
!
!      write(6,*) ' npar = ',npar
!
!      do i=1,npar
!         call str$trim(par_type(i),par_type(i),lt)
!         call str$trim(par_name(i),par_name(i),lnm)
!         call str$trim(parv(i),parv(i),lv)
!        write(6,*) '<',par_type(i)(1:lt),
!     &             '>  <',par_name(i)(1:lnm),'>  <',parv(i)(1:lv),'>'
!      enddo
!
!      go to 1
!      end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine get_parameters(parameters,line_number
     &                          ,max_par,npar
     &                          ,par_type,par_name,parv)

!----------------------------------------------------------------------
! It will handle the new format i.e.
!
!                 PAR1=VAL1,PAR2,PAR3=VAL3
!
!  The values can be surounded by doublequotes
!                                                  Author : B. Franek
!                                                  Date : 10-June-1997
!----------------------------------------------------------------------
      implicit none

      integer line_number

      integer max_par,npar
      character*(*) par_type(1),par_name(1),parv(1)

!---------
      character*(*) parameters     ! The parameter string with lnf's taken out
      integer ln_parameters


      character*80 token
      integer get_token1,status,pdel
      integer ist,nc_token
      integer ibeg,pequ
!---------------------------------------------------------------------

      npar = 0
      ln_parameters = len(parameters)

      ist = 1
      
      do while (.true.) 
        status = get_token1
     &       (parameters(ist:ln_parameters),',',token,pdel)
        if (  status .ne. 1 ) then
            write(6,'('' Error  Line :'',i5)') line_number
            write(6,'('' Processing parameters '')')
            call exit(2)
        endif
        call str_trim(token,nc_token)
*        write(80,'('' token :'',a)') token(1:nc_token) 

        npar = npar + 1
        if (npar .gt. max_par) then
           write(6,'('' Error  Line :'',i5)') line_number
           write(6,'('' Processing parameters '')')
           call exit(2)
        endif

        if ( token(1:3) .eq. 'INT' ) then
            par_type(npar) = 'INT'
            ibeg = 5
        elseif ( token(1:5) .eq. 'FLOAT' ) then
            par_type(npar) = 'FLOAT'
            ibeg = 7
        else
            par_type(npar) ='STRING'
            ibeg = 1
        endif


        status = get_token1
     &        (token(ibeg:nc_token),'=',par_name(npar),pequ)
        if ( status .ne. 1) then
           write(6,'('' Error:  Problems with processing parameters'')')
           call exit(2)
        endif


        if (pequ .eq. 0) then    ! parameter does not have a default val
           parv(npar) = ' '
        else
           status = get_token1
     &           (token(ibeg+pequ:nc_token),'=',parv(npar),pequ)
        endif

        if (pdel .eq. 0) return
        ist = ist + pdel
      enddo

      end
!      character*80 string
!      integer linenum,nextpos
!      character*32 par_name
!
!      linenum = 1
!    1 continue
!      read(5,'(q,a)') nq,string(1:nq)
!      
!
!      call get_parname(string(1:nq),linenum,par_name,nextpos)
!
!      write(6,*) '<',par_name,'>',nextpos
!      go to 1
!      end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine get_parname(string,linenum,par_name,nextpos)
!
!    The subroutine assumes, that the string starts as name=...   or name,
!    Nextpos is the position in the string of the = or ,
      implicit none

      character*(*) string
      integer ln_string

      integer linenum,nextpos
      character*(*) par_name
      integer ln_par_name

      integer i,n

      ln_string = len(string)
      ln_par_name = len(par_name)

      par_name = ' '

      n = 0
      do i = 1,ln_string
         if ( string(i:i) .eq. '=' .or. string(i:i) .eq. ',') then
            nextpos = i
            return
         endif
         n = n + 1
         if ( n .gt. ln_par_name ) then
            write(6,'('' Error :  Line :'',i5)') linenum
            write
     &        (6,'(''  illegal parameter format (name too long)'')')
            call exit(2)
         endif
         par_name(n:n) = string(i:i)
      enddo

      nextpos = ln_string + 1
      return

      end
!      character*80 string
!      integer linenum,nextpos
!      character*32 par_val
!
!      linenum = 1
!    1 continue
!      read(5,'(q,a)') nq,string(1:nq)
!      
!
!      call get_parval(string(1:nq),linenum,par_val,nextpos)
!
!      write(6,*) '<',par_val,'>',nextpos
!      go to 1
!      end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine get_parval(string,linenum,par_val,nextpos)
      implicit none
!
! The subroutine assumes that it starts with first character of a value
! i.e a "

      character*(*) string
      integer ln_string

      integer linenum,nextpos
      character*(*) par_val
      integer ln_par_val

      integer i,n

      ln_string = len(string)
      ln_par_val = len(par_val)

      par_val = ' '

      n = 1
      par_val(1:1) = '"'

! looking for the end string
!
      do i = 2,ln_string
         n = n + 1
         if ( n .gt. ln_par_val ) then
            write(6,'('' Error :  Line :'',i5)') linenum
            write
     &      (6,'(''  illegal old parameter format (value too long)'')')
            call exit(2)
         endif
         par_val(n:n) = string(i:i)
         if ( string(i:i) .eq. '"') then
            if ( i .eq. ln_string) then
               nextpos = ln_string + 1
               return
            else
               if(string(i+1:i+1) .eq. ',') then
                 nextpos = i + 1
                 return
               else
                 write(6,'('' Error :  Line :'',i5)') linenum
                 write
     &          (6,'(''  illegal old parameter format (missing ")'')')
                call exit(2)
               endif
            endif
         endif               
      enddo

      write(6,'('' Error :  Line :'',i5)') linenum
      write
     & (6,'(''  illegal parameter format (missing matching ")'')')
      call exit(2)


      end
!      character*80 string
!      integer linenum,nextpos
!      character*32 par_valname
!
!      linenum = 1
!    1 continue
!      read(5,'(q,a)') nq,string(1:nq)
!      
!
!      call get_parvalname
!     &     (string(1:nq),linenum,par_valname,nextpos)
!
!      write(6,*) '<',par_valname,'>',nextpos
!      go to 1
!      end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine get_parvalname
     &           (string,linenum,par_valname,nextpos)
!
! The subroutine starts with the first character of value name
      implicit none

      character*(*) string
      integer ln_string

      integer linenum,nextpos
      character*(*) par_valname
      integer ln_par_valname

      integer i,n

      ln_string = len(string)
      ln_par_valname = len(par_valname)

!                 PAR1=VAL1,PAR2,PAR3=VAL3


      par_valname = ' '

      n = 0
      do i = 1,ln_string
         if ( string(i:i) .eq. ',') then
            nextpos = i
            return
         endif

         n = n + 1
         if ( n .gt. ln_par_valname ) then
            write(6,'('' Error :  Line :'',i5)') linenum
            write
     &  (6,'(''  illegal parameter format (valuename too long)'')')
            call exit(2)
         endif
         par_valname(n:n) = string(i:i)
      enddo

      nextpos = ln_string+1

      return
      end
