!      character*80 parameters
!      integer line_number
!      integer max_par,npar
!      parameter (max_par=3)
!      character*10 par_name(max_par),parv(max_par)
!      integer nq,i,lv,lnm
!
!    1 continue
!      read(5,'(q,a)') nq,parameters(1:nq)
!   
!      call get_parameters_olddo(parameters(1:nq),line_number
!     &                          ,max_par,npar
!     &                          ,par_name,parv)
!
!      write(6,*) ' npar = ',npar
!
!      do i=1,npar
!         call str$trim(par_name(i),par_name(i),lnm)
!         call str$trim(parv(i),parv(i),lv)
!        write(6,*) '<',par_name(i)(1:lnm),'>  <',parv(i)(1:lv),'>'
!      enddo
!
!      go to 1
!      end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine get_parameters_olddo(parameters,line_number
     &                          ,max_par,npar
     &                          ,par_name,parv)

!----------------------------------------------------------------------
! This subroutine has to be kept to be backward compatible.
! It parses the old parameter format in do instructions:
!
!   "/par1="valname,"/par2=value",....
!
!                                                  Author : B. Franek
!                                                  Date : 10-June-1997
!----------------------------------------------------------------------
      implicit none

      integer line_number

      integer max_par,npar
      character*(*) par_name(1),parv(1)

!---------
      character*(*) parameters     ! The parameter string with lnf's taken out
      integer ln_parameters


      integer i,nextpos      
!---------------------------------------------------------------------

      npar = 0
      ln_parameters = len(parameters)

      if ( (parameters(1:1) .ne. '"') .or. 
     &     (parameters(2:2) .ne. '/') ) then
            write(6,'('' Error :  Line :'',i5)') line_number
            write(6,'(''  extraction of parameters fails'')')
            call exit(2)
      endif         

       npar = 0

       i = 0
    1  continue
       i = i + 1
       if( i .gt. ln_parameters ) go to 200       
       npar = npar + 1      
       if ( npar .gt. max_par) then
           write(6,'('' Error :  Line :'',i5)') line_number
           write(6,'(''  too many parameters'')')
           call exit(2)
       endif
       call get_parname_olddo
     &      (parameters(i:ln_parameters),line_number
     &      ,par_name(npar),nextpos)
! nextpos points to = after the name
       i = i + nextpos    ! This should point to the character after =
       if ( parameters(i:i) .eq. '"' ) then
          call get_parvalname_olddo
     &      (parameters(i:ln_parameters),line_number
     &      ,parv(npar),nextpos)
       else
          call get_parval_olddo
     &      (parameters(i:ln_parameters),line_number
     &      ,parv(npar),nextpos)
       endif
       i = i + nextpos    ! should point to the character after ,
       if ( i .gt. ln_parameters) go to 200
       i = i -1
       go to 1

  200 continue
      end
!      character*80 string
!      integer linenum,nextpos
!      character*32 par_name
!
!      linenum = 1
!    1 continue
!      read(5,'(q,a)') nq,string(1:nq)
!      
!
!      call get_parname_olddo(string(1:nq),linenum,par_name,nextpos)
!
!      write(6,*) '<',par_name,'>',nextpos
!      go to 1
!      end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine get_parname_olddo(string,linenum,par_name,nextpos)
!
!    The subroutine assumes, that the string starts as "/name=...
!    Nextpos is the position in the string of the =
      implicit none

      character*(*) string
      integer ln_string

      integer linenum,nextpos
      character*(*) par_name
      integer ln_par_name

      integer i,n

      ln_string = len(string)
      ln_par_name = len(par_name)

      if (string(1:1) .ne. '"' .or. string(2:2) .ne. '/') then
         write(6,'('' Error :  Line :'',i5)') linenum
         write
     &    (6,'(''  illegal old parameter format (" or / missing)'')')
         call exit(2)
      endif

! Now look for =
      par_name = ' '

      n = 0
      do i = 3,ln_string
         if ( string(i:i) .eq. '=') go to 2
         if ( string(i:i) .eq. '"') then
            write(6,'('' Error :  Line :'',i5)') linenum
            write
     &        (6,'(''  illegal old parameter format (missing =)'')')
            call exit(2)
         endif
         n = n + 1
         if ( n .gt. ln_par_name ) then
            write(6,'('' Error :  Line :'',i5)') linenum
            write
     &        (6,'(''  illegal old parameter format (name too long)'')')
            call exit(2)
         endif
         par_name(n:n) = string(i:i)
      enddo

      write(6,'('' Error :  Line :'',i5)') linenum
      write
     & (6,'(''  illegal old parameter format (missing =)'')')
      call exit(2)


    2 continue
      nextpos = i
      end
!      character*80 string
!      integer linenum,nextpos
!      character*32 par_val
!
!      linenum = 1
!    1 continue
!      read(5,'(q,a)') nq,string(1:nq)
!      
!
!      call get_parval_olddo(string(1:nq),linenum,par_val,nextpos)
!
!      write(6,*) '<',par_val,'>',nextpos
!      go to 1
!      end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine get_parval_olddo(string,linenum,par_val,nextpos)
!
!   Old format of parameter string:  "/par1name="logname,"/par2name=val2",
!    The subroutine assumes, that the string starts as  val2",
!    Nextpos is the position in the string after the value of the ,

      implicit none
      character*(*) string
      integer ln_string

      integer linenum,nextpos
      character*(*) par_val
      integer ln_par_val

      integer i,n

      ln_string = len(string)
      ln_par_val = len(par_val)

!   Old format of parameter string:  "/par1name="logname,"/par2name=val2",

      par_val = ' '

      n = 0
      do i = 1,ln_string
         if ( string(i:i) .eq. '"') go to 2
         n = n + 1
         if ( n .gt. ln_par_val ) then
            write(6,'('' Error :  Line :'',i5)') linenum
            write
     &      (6,'(''  illegal old parameter format (value too long)'')')
            call exit(2)
         endif
         par_val(n:n) = string(i:i)
      enddo

      write(6,'('' Error :  Line :'',i5)') linenum
      write
     & (6,'(''  illegal old parameter format (missing ")'')')
      call exit(2)


    2 continue
      nextpos = i + 1

! Values should have beggining and end "'s
      n = n + 2
      if ( n .gt. ln_par_val ) then
         write(6,'('' Error :  Line :'',i5)') linenum
         write
     &     (6,'(''  illegal old parameter format (value too long)'')')
         call exit(2)
      endif

      par_val = '"'//par_val(1:n-2)//'"'
      return
      end
!      character*80 string
!      integer linenum,nextpos
!      character*32 par_valname
!
!      linenum = 1
!    1 continue
!      read(5,'(q,a)') nq,string(1:nq)
!      
!
!      call get_parvalname_olddo
!     &     (string(1:nq),linenum,par_valname,nextpos)
!
!      write(6,*) '<',par_valname,'>',nextpos
!      go to 1
!      end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine get_parvalname_olddo
     &           (string,linenum,par_valname,nextpos)
!
!   Old format of parameter string:  "/par1name="valname,"/par2name=val2",
!    The subroutine assumes, that the string starts as  "valname,
!    Nextpos is the position in the string after the value of the ,

      implicit none
      character*(*) string
      integer ln_string

      integer linenum,nextpos
      character*(*) par_valname
      integer ln_par_valname

      integer i,n

      ln_string = len(string)
      ln_par_valname = len(par_valname)

!   Old format of parameter string:  "/par1name="valname,"/par2name=val2",

      if ( string(1:1) .ne. '"' ) then
          write(6,'('' Error :  Line :'',i5)') linenum
          write
     &      (6,'(''  illegal old parameter format (missing ")'')')
          call exit(2)
      endif

      par_valname = ' '

      n = 0
      do i = 2,ln_string
         if ( string(i:i) .eq. ',') then
            nextpos = i
            go to 2
         endif

         n = n + 1
         if ( n .gt. ln_par_valname ) then
            write(6,'('' Error :  Line :'',i5)') linenum
            write
     &  (6,'(''  illegal old parameter format (valuename too long)'')')
            call exit(2)
         endif
         par_valname(n:n) = string(i:i)
      enddo

      nextpos = ln_string+1

    2 continue

      return
      end
