      subroutine proc_action_line(n_lines,lines,nc,line_num,il
     &                           ,action_name,max_par,npar
     &                           ,par_type,par_name,par_default
     &                           ,last_il)

!----------------------------------------------------------------------
! Expectin the 'action line(s)' starting at line lines(il)
!
! Format of action line (lines) is:
!
! action : name (p1,p2=defaulp,p3)
!
! It can span several lines. 
! The action name must be contained within the first line
! The opening bracket for parameters must be on the same line as 
! the action name.
! The closing bracket must be the last meaningfull character on the last line
!
!                                                  Author : B. Franek
!                                                  Date : 18-May-1997
!----------------------------------------------------------------------
      implicit none

      integer n_lines,nc(1),line_num(1)
      character*133 lines(1)
      integer il

      character*(*) action_name

      integer max_par,npar
      character*(*) par_type(1),par_name(1),par_default(1)

      integer ipar,lnpar

      integer max_ln_parameters
      parameter (max_ln_parameters = 2000)
!---------
      character*2000 parameters     ! The parameter string with lnf's taken out

      integer ist

      integer last_il
      integer last_pos

      character*133 line
      integer lnline

!---------------------------------------------------------------------
      line = lines(il)(1:nc(il))
      last_il = il
      call squeeze(line,line,lnline)

      if(index(line(1:7),'ACTION:') .eq. 0) then
         write(6,'('' Error :  Line :'',i5)') line_num(il)
         write(6,'( '' Expecting  ACTION  and found '',a)') line(1:7)
         call exit(2)
      endif

!---- check if the action has parameters
!---- the opening bracket for parameters must be on the first line

      if (index(line(1:lnline),'(') .eq. 0) then
!----  no parameters
         npar = 0
         if( (lnline-7) .gt. len(action_name)) then
             write(6,'('' Error :  Line :'',i5)') line_num(il)
             write(6,'(''  action name is too long'')')
             call exit(2)
         endif
         read(line(8:lnline),'(a)') action_name
         return
      endif

!--------------------- the action has parameters ---------------------
!--- extract action name
      ist = index(line(1:lnline),'(')
!--- action name must not span 2 lines
      if( (ist-8) .gt. len(action_name)) then
          write(6,'('' Error :  Line :'',i5)') line_num(il)
          write(6,'(''  action name is too long'')')
          call exit(2)
      endif
      read(line(8:ist-1),'(a)') action_name
!---

!---  extract the parameter string

      ist = index(lines(il)(1:nc(il)),'(')
      call get_paramstring(n_lines,lines,nc,line_num,il,ist,
     &                          parameters,last_il,last_pos)

      call str_trim(parameters,lnpar)

!---  extract parameters
      call get_parameters(parameters(1:lnpar),line_num(il)
     &                          ,max_par,npar
     &                          ,par_type,par_name,par_default)

      do ipar = 1,npar
         call str_trim(par_default(ipar),lnpar)
         if ( lnpar .le. 0 ) par_default(ipar) = '&nodefault'
      enddo

      return
      end
