      integer function process_condition(condition,
     &           max_cndlines,num_cndlines,cndlines)
      implicit none

      character*(*) condition
      integer max_cndlines,num_cndlines
      character*(*) cndlines(max_cndlines)

      integer nc_cndline
      
      integer max_smpconds,n_smpconds
      parameter (max_smpconds = 100)
      character*800 smpconds(max_smpconds)
      integer max_instructions,num_instructions
      parameter (max_instructions = 100)      
      character*20 instructions(max_instructions)

      integer i,nc
      integer  status,cond_transl,smpcond_transl
      character*32 object_nm
      character*12 in_state
      integer max_states,n_states
      parameter (max_states = 20)
      character*32 states(max_states)
      integer istate


      nc_cndline = len(cndlines(1))

      status = cond_transl(condition,
     &                max_smpconds,n_smpconds,smpconds,
     &                max_instructions,num_instructions,instructions)


      if(status .ne. 1) then
         write(6,'(''  Error:  Translation of a condition fails'')')
         process_condition = status
         return
      endif        


      num_cndlines = 1
      cndlines(1) = ' '
      write(cndlines(1),'(2i5)') n_smpconds,num_instructions

      do i = 1,n_smpconds
        call str_trim(smpconds(i),nc)
        status = smpcond_transl(smpconds(i)(1:nc),
     &              object_nm,in_state,max_states,n_states,states)


        if( (num_cndlines+3+n_states)  .gt. max_cndlines) then
           write(6,
     &     '('' Error : not enough space to save the condition'')')
           process_condition = 2
           return
        endif

        num_cndlines = num_cndlines + 1
        cndlines(num_cndlines) = object_nm 

        num_cndlines = num_cndlines + 1
        cndlines(num_cndlines) = in_state

        num_cndlines = num_cndlines + 1
        write(cndlines(num_cndlines),'(i5)') n_states

        do istate = 1,n_states
           num_cndlines = num_cndlines + 1
           cndlines(num_cndlines) = states(istate)
        enddo
      enddo

      if( num_instructions .gt. 0) then

         do i = 1,num_instructions
           num_cndlines = num_cndlines + 1
           if( num_cndlines  .gt. max_cndlines) then
              write(6,
     &        '('' Error : not enough space to save the condition'')')
              process_condition = 2
              return
           endif

           cndlines(num_cndlines) = ' '
           call str_trim(instructions(i),nc)
           write(cndlines(num_cndlines),'(a)') instructions(i)(1:nc)
         enddo      
      endif

      process_condition = 1

      return
      end
