       integer function smpcond_transl(smpcond,
     &              object_nm,in_state,max_states,n_states,states)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
!
!                                                        Author : B. Franek
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

       implicit none

       character*(*) smpcond
       integer nc_smpcond

       character*12 in_state
       integer ln_in_state

       character*(*) object_nm
       integer nc_object_nm

       integer max_states,n_states
       character*(*) states(max_states)
       integer nc_state

       integer ibeg,iend
       integer status,get_element

       integer skip     ! skips in_state   or  not_in_state   string
!  smpcond is a simple condition whose format is:
!  OOOin_stateSSS    or  notOOOin_stateSSS   or  OOOnot_in_stateSSS  where
!  OOO is an object name and SSS is a list state surounded by {}. If only
!  one state is present, {} can be ommited

       nc_smpcond = len(smpcond)
       nc_object_nm = len(object_nm)
       nc_state = len(states(1))

       if (nc_smpcond .lt. 3) then
          write(6,*) ' Simple condition is shorter then 3 characters'
          write(6,*) '<',smpcond(1:nc_smpcond),'>'
          smpcond_transl = 2
          return
       endif

!  OOOin_stateSSS    or  notOOOin_stateSSS   or  OOOnot_in_stateSSS  where

       if( smpcond(1:3) .eq. 'not') then
          in_state = 'not_in_state'
          ibeg = 4
          iend = index(smpcond,'not_in_state')
          if( iend .ne. 0) then
              write(6,*) ' Simple condition : <',
     &                   smpcond(1:nc_smpcond),'>'
              write(6,*) ' has two not''s'
              call exit(2)
          endif
          iend = index(smpcond,'in_state')
          skip = 9
       else
!  OOOin_stateSSS    or  notOOOin_stateSSS   or  OOOnot_in_stateSSS  where
          ibeg = 1
          iend = index(smpcond,'not_in_state')
          if ( iend .eq. 0 ) then
             in_state = 'in_state'
             iend = index(smpcond,'in_state')
             skip = 9
          else
             in_state = 'not_in_state'
             skip = 13
          endif
       endif

       if ( iend .eq. 0 ) then
          write(6,*) 
     &    ' Simple condition does not contain the string ''in_state'''
          smpcond_transl = 4
          return
       endif

       iend = iend - 1

       if( (iend-ibeg+1) .gt. nc_object_nm ) then
          write(6,*)
     &    ' Simple condition has an object name that is too large'
          smpcond_transl = 6
          return
       endif

       object_nm = smpcond(ibeg:iend) 

       ibeg = iend + skip

       if(smpcond(ibeg:ibeg) .ne. '{') then

          if( (nc_smpcond-ibeg+1) .gt. nc_state) then
             write(6,*)
     &       ' Simple condition has a state name that is too large'
             smpcond_transl = 8
             return
          endif

          n_states = 1
          states(1) = smpcond(ibeg:nc_smpcond)
          smpcond_transl = 1
          return
       endif

*  Multiple states

       ibeg = ibeg + 1

       if( smpcond(nc_smpcond:nc_smpcond) .ne. '}') then
         write(6,*) ' Can not find closing } in simple condition'
         smpcond_transl = 10
       endif

       iend = nc_smpcond - 1

       n_states = 0

       do while (.true.)
          status = get_element(states(n_states+1),n_states,',',
     &                        smpcond(ibeg:iend))
          if( status .eq. 1 ) then
             n_states = n_states + 1

             if( n_states .ge. max_states ) then
                write(6,*) ' Too many states in simple condition'
                smpcond_transl = 12
                return
             endif

          elseif (status .eq. 2) then
             smpcond_transl = 1
             return
          else          
             write(6,*) 
     &       ' Extraction of state names in simple condition fails'
             smpcond_transl = 14
             return
          endif

       enddo

       end
