      subroutine translator
     &    (input_str,output_str,dbg,scratch1_str,scratch2_str)
      implicit none

      byte input_str(1),output_str(1),scratch1_str(1),scratch2_str(1)
      integer dbg
      character*256 input,output,scratch1,scratch2
      integer ln_input,ln_output,ln_scratch1,ln_scratch2

      character*133 line
      integer nc_line

      integer linenum

*  Signals that beginning of 'blok' i.e Object or Class was found and the
*  lines are being collected. 1 means object, 2 means class
      integer blk_being_processed

      integer n_blk_lines,max_n_blk_lines
      parameter (max_n_blk_lines = 6000)

      character*133  blk_lines(max_n_blk_lines)
      integer nc(max_n_blk_lines) 
      integer line_num(max_n_blk_lines)
*----------------------------------------------------------------------------

      character*32 object_nm
      integer ln_object_nm
      integer class_member    ! 1 indicates, that the object belongs to a class
*---------------------------------------------------------------------------

      character*32 class_name
      integer ln_class_name
*---------------------------------------------------------------------------

      integer mx_atributes,n_atributes
      parameter (mx_atributes = 10)

      character*32 atributes(mx_atributes)

      integer associated     ! 1 indicates that the object is associated

      integer get_line
      character*80 debug1,debug2

      logical exists
*------------------------------------------------------------------------------
*------------------------------------------------------------------------------

      debug1 = 'smiTrans.dbg1'
      debug2 = 'smiTrans.dbg2'

      call ctoforstr(input_str,input,ln_input)
      call ctoforstr(output_str,output,ln_output)
      call ctoforstr(scratch1_str,scratch1,ln_scratch1)
      call ctoforstr(scratch2_str,scratch2,ln_scratch2)

      inquire ( file = input(1:ln_input), exist=exists)
      if ( .not.exists ) then
         write(6,'('' **** File '',a,'' does not exist'')')
     &                     input(1:ln_input)
         call exit(2)         
      endif

      open(unit=1,file=input(1:ln_input),status='old')
      open(unit=2,file=output(1:ln_output),status='new'
     &     ,carriagecontrol='list')

      if ( dbg .ne. 0 ) then 
         open(unit=80,file=debug1,status='new'
     &     ,carriagecontrol='list')

         open(unit=88,file=debug2,status='new'
     &     ,carriagecontrol='list')
      else
         open(unit=80,file=scratch1(1:ln_scratch1),status='new')
         open(unit=88,file=scratch2(1:ln_scratch2),status='new')
      endif


      linenum = 0

      blk_being_processed = 0
      n_blk_lines = 0


      do while (.true.)
*---------------------------------------------------------------------------
*  Read and preprocess the line, ie remove empty lines and lines starting
*  with !
*  If line contains !, consider only the part before
        if(get_line(linenum,line,nc_line) .ne. 1) go to 500
*
        if(nc_line .ne. 0 ) then
          write(88,'(1x,i5,'':'',a)') linenum,line(1:nc_line)
          if(index(line(1:7),'OBJECT') .ne. 0
     &       .or. index(line(1:6),'CLASS') .ne. 0) then         ! New block

             if ( blk_being_processed .ne. 0) then

                if ( blk_being_processed .eq. 1) then
                   call process_object
     &                 (object_nm(1:ln_object_nm),
     &                  n_atributes,atributes,associated,
     &                  class_member,class_name(1:ln_class_name),
     &                  n_blk_lines,blk_lines,nc,line_num)
                else
                   call process_class
     &                 (class_name(1:ln_class_name),
     &                  n_atributes,atributes,associated,
     &                  n_blk_lines,blk_lines,nc,line_num)
                endif

                n_blk_lines = 0
                blk_being_processed = 0
             endif


             if(index(line(1:6),'CLASS') .ne. 0) then        ! Class definition
                blk_being_processed = 2
                call proc_class_line
     &                  (linenum,line(1:nc_line),class_name,
     &                   mx_atributes,n_atributes,atributes,associated)

                call str_trim(class_name,ln_class_name)
             else                                             ! Object
                blk_being_processed = 1
                call proc_object_line
     &                 (linenum,line(1:nc_line),object_nm,
     &                  mx_atributes,n_atributes,atributes,associated,
     &                  class_member,class_name)

                call str_trim(object_nm,ln_object_nm)
                call str_trim(class_name,ln_class_name)
             endif

          else
*-------------------- 
             if( blk_being_processed .eq. 0) then
                write(6,'(///'' Error  Line : '',i5)') linenum
                write(6,*) ' Looking for Class or Object'
                call exit(2)
             endif
             n_blk_lines = n_blk_lines + 1
             if(n_blk_lines .gt. max_n_blk_lines) then
                write(6,
     &         '(///'' Error  Line : '',i5//'' Object : |'',a,''|'')')
     &          linenum,
     &          object_nm(1:ln_object_nm)
                write(6,'(''  Object is too big '')')
               call exit(2)
             endif
             blk_lines(n_blk_lines) = line
             nc(n_blk_lines) = nc_line
             line_num(n_blk_lines) = linenum
          endif


        endif
      enddo

  500 continue

      if ( blk_being_processed .eq. 1) then
         call process_object
     &          (object_nm(1:ln_object_nm),
     &           n_atributes,atributes,associated,
     &           class_member,class_name(1:ln_class_name),
     &           n_blk_lines,blk_lines,nc,line_num)
      endif

      if ( blk_being_processed .eq. 2) then
         call process_class
     &          (class_name(1:ln_class_name),
     &           n_atributes,atributes,associated,
     &           n_blk_lines,blk_lines,nc,line_num)
      endif
 
      return
      end
       subroutine ctoforstr(cstr,forstr,ln_forstr)
       byte cstr(1)
       character*(*) forstr
       integer ln_forstr
       byte cpom
       character*1 fpom
       equivalence (cpom,fpom)
       
       ln_forstr = 0
       
       do while (.not.cstr(ln_forstr+1) .eq. 0)
          ln_forstr = ln_forstr + 1
          cpom = cstr(ln_forstr)
          forstr(ln_forstr:ln_forstr) = fpom 
       enddo
       
       return
       end
