#include <Mrm/MrmAppl.h>                /* Motif Toolkit and MRM */
#include <Xm/Xm.h>
#include "dui_colors.h"

#define MAX_NAME 		132
#define MAX_OBJECTS		512
#define MAX_STATES		50
#define MAX_ACTIONS		50
#define MAX_OBJECT_NAME	32
#define MAX_SUBOBJECTS	50
#define MAX_BUFFER		1024
#define MAX_ATTRS		10
#define MAX_FILE_NAME   256

typedef struct {
	char param[MAX_OBJECT_NAME+1];
	char value_str[MAX_NAME];
	int value_int;
	double value_float;
	int size;
	int type;
} PAR_TYPE;

typedef struct {
    int n_actions;
	char actions[MAX_ACTIONS][MAX_OBJECT_NAME+1];
	PAR_TYPE *params[MAX_ACTIONS];
} ACTION_LIST;

typedef struct {
	int state;
	char action[MAX_BUFFER];
}BUSY;

typedef struct {
	char attributes[MAX_ATTRS][MAX_OBJECT_NAME];
}ATTR_LIST;

typedef struct {
	char file_ident[MAX_FILE_NAME];
	char file_name[MAX_FILE_NAME];
}FILE_TYP;

typedef struct {
	char obj[MAX_NAME];
	char cmd[MAX_NAME];
}CMD_TYP;

typedef struct {
	char name[MAX_OBJECT_NAME];
	char state[MAX_OBJECT_NAME];
	char name_alias[MAX_OBJECT_NAME];
	int created;
	int connecting;
	int visible;
	int statechange_id;
	ACTION_LIST actions;
	PAR_TYPE *params;
	ATTR_LIST *attrs;
	int index_x;
	int index_y;
	Widget obj_id;
	Widget name_id;
	Widget state_id;
	Widget action_id;
	Widget menu_id;
	Widget action_ids[MAX_ACTIONS];
}OBJ;

typedef struct {
	char state[MAX_OBJECT_NAME];
	int color;
}STATE_COL;

STATE_COL State_colors[512];

/* VUIT routines for the user to call */
void s_error();

/* Motif Global variables */
Display         *display;			/* Display variable */
XtAppContext    app_context;		/* application context */
Widget			toplevel_widget;	/* Root widget ID of application */
MrmHierarchy	s_MrmHierarchy;		/* MRM database hierarchy ID */

