//----------------------   M a i n   P r o g r a m  --------------------------
//                         SMI Preprocessor         
//
//                                                Author : Boda Franek
//                                                Date : 20 December 1997
//---------------------------------------------------------------------------
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include "codeblock.hh"
#include "name.hh"

void cpreproc(const Name&, const Name&, Name&);
//-----------------------------------------------------------------------------

int main(int argc, char* argv[]) {

  int c;
  extern char *optarg;
  extern int optind, optopt;

  Name inputFile,preprocFile,cPreprocOpts;
  Name outputFile;

//-------------------------- Process the command line ----------------------

        cPreprocOpts = "\0";

        while ((c = getopt(argc, argv, ":p:")) != -1 ) {
		switch (c) {
		case 'p':
			cPreprocOpts = optarg;
                        break;
		case ':':
			printf(" option  %c requires an argument\n",optopt);
			break;
		case '?':
			printf(" unknown option  %c \n",optopt);
			break;
		}
        }
        if ( optind >= argc ) {
           cout << " Input file is missing " << endl; cout.flush();
           exit(2);
        }
        inputFile = argv[optind];
        optind++;
        if ( optind >= argc ) {
           cout << " Output file is missing " << endl; cout.flush();
           exit(2);
        }
        outputFile = argv[optind];
//--------------------------------------------------------------------------

// First do C Preprocessor step
  cpreproc(cPreprocOpts,inputFile,preprocFile);

  CodeBlock* pprevBlock = new CodeBlock(preprocFile);
  CodeBlock* pnextBlock = new CodeBlock();
  int pass(0);
  
  for (;;) {
//      cout << endl << endl;
//      cout << " Pass :" << pass << endl << endl;
//      pprevBlock->out();

//      if (pass == 1) { pprevBlock->outToFile("work:pass0.pre_smi");}
      
      if (pprevBlock->anyIncludes()) {
          pprevBlock->makeNextBlock(*pnextBlock);
          delete pprevBlock;
          pprevBlock = pnextBlock;
          pnextBlock = new CodeBlock();
          pass++;
      }
      else { break;}
  }

  

  
//  pprevBlock->outToFile("work:partitions.pre_gener");

   pprevBlock->generPass(*pnextBlock);   

   delete pprevBlock;
   pprevBlock = pnextBlock;
   pnextBlock = new CodeBlock();
   pprevBlock->objectSetPass(*pnextBlock);

  
   delete pprevBlock;
   pprevBlock = pnextBlock;
   pnextBlock = new CodeBlock();
   pprevBlock->macroPass(*pnextBlock);


   pnextBlock->outToFile(outputFile); 
  
#ifndef __VMS
   if ( preprocFile == inputFile ) {}
   else { 
      Name delcom;
      delcom = "rm ";
      delcom += preprocFile;
      system(&delcom[0]);
   }
#endif

   exit(0);


}
