#include <iostream.h>
#include <assert.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
//#include "smirtl_core.hh"
#define SMILIB
#include "smirtl.hh"
#include "../smixx_version.h"

static int Version_number = SMIXX_VERSION;

void SmiProxy::commandHandler()
{
	DimCommand *cmnd;

	cmnd = getCommand();
	if(itsCommand)
		delete itsCommand;
	itsCommand = new char[cmnd->getSize()];
	strcpy(itsCommand, cmnd->getString());
	if(cmndTokens)
		delete cmndTokens;
	cmndTokens = new TokenString(itsCommand);
	storeCmndPar();
	smiCommandHandler();
}

void SmiProxy::publish_it()
{
	char *aux;

	capitalize(itsDomain);
	capitalize(itsName);

	itsFullName = new char[strlen(itsDomain)+strlen(itsName)+3];
	strcpy(itsFullName,itsDomain);
	strcat(itsFullName,"::");
	strcat(itsFullName,itsName);
	aux = new char[strlen(itsDomain)+strlen(itsName)+5+32];
	strcpy(aux,"EP/");
	strcat(aux,itsDomain);
	strcat(aux,"/");
	strcat(aux,itsName);

	if(!itsState)
		itsState=new char[8];
	if(!itsShortState)
		itsShortState=new char[128];
	strcpy(itsState,"$DEAD");
	strcpy(itsShortState,"$DEAD");
	itsDimState = new DimService(aux,itsState);
	strcat(aux,"/CMD");
	itsDimCmnd = new DimCommand(aux,"C",this);
	strcpy(aux,"EP/");
	strcat(aux,itsDomain);
	strcat(aux,"/");
	strcat(aux,itsName);
	strcat(aux,"/SMI_VERSION_NUMBER");
	itsDimVersion = new DimService(aux,Version_number);
	DimServer::start(itsFullName);
}

void SmiProxy::attach(char *domain)
{
	itsDomain = new char[strlen(domain)+1];
	strcpy(itsDomain,domain);
	publish_it();
//	smi_attach(itsFullName, (void (*) (...))handle_smi_command);
}

void SmiProxy::attach(char *domain, char *name)
{
	itsDomain = new char[strlen(domain)+1];
	strcpy(itsDomain,domain);
	itsName = new char[strlen(name)+1];
	strcpy(itsName,name);
	publish_it();
//	smi_attach(itsFullName, (void (*) (...))handle_smi_command);
}

void SmiProxy::setVolatile()
{
//	smi_volatile();
	DimServer::addClientExitHandler(this);
}

int SmiProxy::setState(char *state)
{
	
//	return smi_set_state(state);
	formState(state);
	itsDimState->updateService(itsState);
	return(1);
}
	
char *SmiProxy::getState()
{
//	if(!itsState)
//		itsState=new char[256];
//	smi_get_state(itsState,256);
	return itsShortState;
}

int SmiProxy::setParameter(char *parName, int parValue)
{
//	return smi_set_par(parName, &parValue, SMI_INTEGER);
	return addPar(parName, &parValue, SMI_INTEGER);

}
	
int SmiProxy::setParameter(char *parName, double parValue)
{
//	return smi_set_par(parName, &parValue, SMI_FLOAT);
	return addPar(parName, &parValue, SMI_FLOAT);
}
	
int SmiProxy::setParameter(char *parName, char *parValue)
{
//	return smi_set_par(parName, parValue, SMI_STRING);
	return addPar(parName, &parValue, SMI_STRING);
}

int SmiProxy::getParameterInt(char *parName)
{
	int value;
	char *data;

	data = getCmndPar(parName, SMI_INTEGER);
	if(data)
	{
		if(strchr(data,'x'))
			sscanf(data,"%x",&value);
		else
			sscanf(data,"%d",&value);
		return value;
	}
//	if(smi_get_par_value(parName, &value))
//		return value;
//	else
		return -1;
}

double SmiProxy::getParameterFloat(char *parName)
{
	double value;
	char *data;

	data = getCmndPar(parName, SMI_FLOAT);
	if(data)
	{
		sscanf(data,"%lf",&value);
		return value;
	}
//	if(smi_get_par_value(parName, &value))
//		return value;
//	else
		return -1;
}
	
char *SmiProxy::getParameterString(char *parName)
{
//	if(!itsParValue)
//		itsParValue=new char[256];
//	itsParValue[0] = '\0';
//	smi_get_par_value(parName, itsParValue);
//	return itsParValue;
	char *data;

	data = getCmndPar(parName, SMI_STRING);
	if(data)
	{
		if(data[0] == '"')
		{
			if(data[strlen(data)-1] == '"')
				data[strlen(data)-1] = '\0';
			return data+1;
		}
		return data;
	}
	return 0;
}

int SmiProxy::testAction(char *action)
{
//	return smi_test_action(action);

	return (!strcmp(itsAction,action));
}

char *SmiProxy::getAction()
{
//	int npars;

//	if(!itsAction)
//		itsAction=new char[256];
//	itsAction[0] = '\0';
//	smi_get_action(itsAction,&npars);
	return itsAction;
}

void SmiProxy::capitalize(char *str)
{
	while(*str)
	{
		*str = toupper(*str);
		str++;
	}
}
/*
int SmiProxy::findPar(char *name)
{
	ParInfo *parptr;
	char *parname;

	parptr = (ParInfo *)itsParList.getHead();
	while(parptr)
	{
		parname = parptr->getName();
		if(!strcmp(parname, name))
		{
			return parptr;
			break;
		}
		parptr = (ParInfo *)itsParList.getNext();
	}
	return 0;
}
*/
int SmiProxy::addPar(char *name, void *value, int type)
{
	ParInfo *parptr;
	int found = 0;
	char *parname;
	int ret = 1;

	parptr = (ParInfo *)itsParList.getHead();
	while(parptr)
	{
		parname = parptr->getName();
		if(!strcmp(parname, name))
		{
			found = 1;
			break;
		}
		parptr = (ParInfo *)itsParList.getNext();
	}
	if(!found)
	{
		parptr = new ParInfo(name, type);
		itsParList.add(parptr);
	}
	ret = parptr->setInfo(value, type);
	return(ret);
}

int SmiProxy::getStateLen(char *state)
{
	ParInfo *parptr;
	char *parname;
	int len = 0;

	len = strlen(state);
	parptr = (ParInfo *)itsParList.getHead();
	while(parptr)
	{
		parname = parptr->getName();
		len += 1 + strlen(parname) +3+1;  /* /par_name(X)= */
		len += parptr->getDataSize();
		parptr = (ParInfo *)itsParList.getNext();
	}
	len += 1;
	return len;	
}

void SmiProxy::formState(char *state)
{
	int len;
	ParInfo *parptr;
//	char *parname;

	len = getStateLen(state);
	delete itsState;
	itsState = new char[len];

	strcpy(itsShortState, state);	
	strcpy(itsState,state);
	parptr = (ParInfo *)itsParList.getHead();
	while(parptr)
	{
		strcat(itsState,"/");
		strcat(itsState, parptr->getName());
		strcat(itsState, parptr->getTypeStr());
		strcat(itsState,"=");
		strcat(itsState, parptr->getData());
		parptr = (ParInfo *)itsParList.getNext();
	}
}

int SmiProxy::getType(char *str)
{
    int type;

    switch(*str)
    {
        case 'S':
            type = SMI_STRING;
            break;
        case 'I':
            type = SMI_INTEGER;
            break;
        case 'F':
            type = SMI_FLOAT;
            break;
    }
    return(type);
}

int SmiProxy::storeCmndPar()
{
	char *token, *parname;
	ParInfo *parptr;
	int type;
	int ret = 1;

	while(parptr = (ParInfo *)itsCmndParList.removeHead())
		delete parptr;
	cmndTokens->getToken(token);
	if(itsAction)
		delete itsAction;
	itsAction = new char [strlen(token)+1];
	strcpy(itsAction,token);
	while(cmndTokens->getToken(token))
	{
		if(cmndTokens->cmpToken("/"))
		{
			cmndTokens->getToken(parname);
			cmndTokens->pushToken();
			cmndTokens->getToken(token);
			if(cmndTokens->cmpToken("("))
			{
				cmndTokens->getToken(token);
				type = getType(token);
				cmndTokens->getToken(token);
			}
			else
			{
				cmndTokens->popToken();
				type = SMI_STRING;
            }
			parptr = new ParInfo(parname, type);
			itsCmndParList.add(parptr);

			cmndTokens->getToken(token);
			if(cmndTokens->cmpToken("="))
			{
				cmndTokens->getToken(token);
				ret = parptr->setStrInfo(token, type);
			}
		}
	}

	currCmndPar = (ParInfo *)0;
	return(ret);
}

char *SmiProxy::getCmndPar(char *name, int type)
{
	ParInfo *parptr;
	char *parname;
	int found = 0;

	if(currCmndPar)
	{
		parname = currCmndPar->getName();
		if(!strcmp(parname, name))
		{
			if(currCmndPar->getType() == type)
				return currCmndPar->getData();
		}
		return 0;
	}
	parptr = (ParInfo *)itsCmndParList.getHead();
	while(parptr)
	{
		parname = parptr->getName();
		if(!strcmp(parname, name))
		{
			if(parptr->getType() == type)
				return parptr->getData();
		}
		parptr = (ParInfo *)itsCmndParList.getNext();
	}
	return 0;
}

int SmiProxy::getParameterType(char *name)
{
	ParInfo *parptr;
	char *parname;
	int found = 0;

	if(currCmndPar)
	{
		parname = currCmndPar->getName();
		if(!strcmp(parname, name))
		{
			return currCmndPar->getType();
		}
		return -1;
	}
	parptr = (ParInfo *)itsCmndParList.getHead();
	while(parptr)
	{
		parname = parptr->getName();
		if(!strcmp(parname, name))
		{
			return parptr->getType();
		}
		parptr = (ParInfo *)itsCmndParList.getNext();
	}
	return -1;
}

char *SmiProxy::getNextParameter()
{

	if(!currCmndPar)
		currCmndPar = (ParInfo *)itsCmndParList.getHead();
	else
		currCmndPar = (ParInfo *)itsCmndParList.getNext();
	if(currCmndPar)
	{
		return currCmndPar->getName();
	}
	return 0;
}

