#define MAX_NAME 		132
#define MAX_OBJECTS		512
#define MAX_BUFFER		1024

#include <dic.h>
#include <dis.h>

#include "parameters.h"

typedef struct {
	int state;
	char action[MAX_BUFFER];
}BUSY;

char Domain_name[80];

char Object[MAXNAMESIZE];

static int Get_obj_busy = -1;
static int Get_obj_state = 0;
static char No_link_str[8] = "DEAD";
static int No_link_busy = 0;
static int No_link = -1;
static char No_link_char = -1;

get_obj_name(obj_name, serv_name, ep)
char *obj_name, *serv_name;
int ep;
{

	char obj[MAXNAMESIZE];
	char *ptr_domain, *ptr_obj, obj_type[10];

	strcpy(obj,obj_name);
	if(ptr_obj = (char *)strstr(obj,"::"))
	{
		*ptr_obj = '\0';
		ptr_obj +=2;
		ptr_domain = obj;
	}
	else
	{
/*
		get_domain_name(Domain_name);
*/
		ptr_domain = Domain_name;
		ptr_obj = obj;
	}
	strcpy(Object,ptr_obj);
	if(ep)
		sprintf(serv_name,"EP/%s/%s", ptr_domain, ptr_obj);
	else
		sprintf(serv_name,"SMIU/%s/%s", ptr_domain, ptr_obj);
	strcpy(Domain_name,ptr_domain);
}
	
void get_state_rout(tag)
int *tag;
{
	if(*tag)
	{
		Get_obj_state = 1;
	}
	if((!Get_obj_busy) && (Get_obj_state))
	{
		sys$wake(0,0);
	}
}
                     
int smiu_get_object_state_wait(obj, state, state_len)
char *obj;
char *state;
int state_len;
{
	char serv_name[MAX_NAME];
	int index, state_id, busy_id;
	void get_state_rout();

	get_obj_name(obj,serv_name,1);
	Get_obj_state = 0;
	Get_obj_busy = -1;
	state_id = dic_info_service(serv_name, MONITORED, 0, state, state_len, 
		get_state_rout, 1, No_link_str, 5);
	strcat(serv_name,"/BUSY");
	busy_id = dic_info_service(serv_name, MONITORED, 0, &Get_obj_busy, 4, 
		get_state_rout, 0, &No_link_busy, 4);
	sys$hiber();
	dic_release_service(state_id);
	dic_release_service(busy_id);
	if(!strcmp(state,No_link_str))
		return(0);
	return(1);
}
                     
static BUSY Get_obj_state_busy = {-1};

void get_state_busy_rout(tag)
int *tag;
{
	if(*tag)
	{
		Get_obj_state = 1;
	}
	if((Get_obj_state_busy.state != -1) && (Get_obj_state))
	{
		sys$wake(0,0);
	}
}
                     
int smiu_get_object_state_busy(obj, state, state_len, action)
char *obj;
char *state;
int state_len;
char *action;
{
	char serv_name[MAX_NAME];
	int index, state_id, busy_id;
	void get_state_rout();

	get_obj_name(obj,serv_name,1);

	Get_obj_state = 0;
	Get_obj_state_busy.state = -1;
	state_id = dic_info_service(serv_name, MONITORED, 0, state, state_len, 
		get_state_busy_rout, 1, No_link_str, 5);
	strcat(serv_name,"/BUSY");
	busy_id = dic_info_service(serv_name, MONITORED, 0, &Get_obj_state_busy, 
		4+MAX_BUFFER, get_state_busy_rout, 0, &No_link_busy, 4);
	sys$hiber();
	dic_release_service(state_id);
	dic_release_service(busy_id);
	if(Get_obj_state_busy.state == 1)
		strcpy(action,Get_obj_state_busy.action);
	else
		action[0] = '\0';
	if(!strcmp(state,No_link_str))
		return(0);
	return(1);
}

int smiu_get_object_state(obj, user_rout, par)
char *obj;
void (*user_rout)();
int par;
{
	char serv_name[MAX_NAME];
	int index, state_id, busy_id;
	void get_state_rout();

	get_obj_name(obj,serv_name,1);
	state_id = dic_info_service(serv_name, MONITORED, 0, 0, 0, 
		user_rout, par, "No link", 8);
}
                     
int smiu_get_object_busy(obj, user_rout, par)
char *obj;
void (*user_rout)();
int par;
{
	char serv_name[MAX_NAME];
	int index, state_id, busy_id;
	void get_state_rout();

	get_obj_name(obj,serv_name,1);
	strcat(serv_name,"/BUSY");
	state_id = dic_info_service(serv_name, MONITORED, 0, 0, 0, 
		user_rout, par, &No_link, 4);
}
         
int smiu_get_object_action_list(obj, user_rout, par)
char *obj;
void (*user_rout)();
int par;
{
	char serv_name[MAX_NAME];
	int index, action_id, action_par_id;
	void get_state_rout();

	get_obj_name(obj,serv_name,1);
	strcat(serv_name,"/ACTIONS&PARS");
	action_par_id = dic_info_service(serv_name, MONITORED, 0,
		Objects[obj_index].actions_pars, MAX_ACTIONS * (MAX_NAME + 1), 
		update_obj_actions_pars, obj_index, &No_link_char, 1);
	strcat(serv_name,"/ACTIONS");
	action_id = dic_info_service(serv_name, MONITORED, 0,
		0,0,
		update_obj_actions, obj_index, &no_link_int, 4);
	state_id = dic_info_service(serv_name, MONITORED, 0, state, state_len, 
		get_state_rout, 1, No_link_str, 5);
	strcat(serv_name,"/BUSY");
	busy_id = dic_info_service(serv_name, MONITORED, 0, &Get_obj_busy, 4, 
		get_state_rout, 0, &No_link_busy, 4);
	sys$hiber();
	dic_release_service(state_id);
	dic_release_service(busy_id);
	if(!strcmp(state,No_link_str))
		return(0);
	return(1);
}

int smiu_send_command(obj, cmnd)
char *obj, *cmnd;
{
	char serv_name[MAX_NAME];
			
	get_obj_name(obj,serv_name,0);
	strcat(serv_name,"/CMD");
	printf("Sending %s to %s\n",cmnd,serv_name);
	dic_cmnd_service(serv_name, cmnd, strlen(cmnd)+1);
}

int ep_send_command(obj, cmnd)
char *obj, *cmnd;
{
	char serv_name[MAX_NAME];
			
	get_obj_name(obj,serv_name,1);
	strcat(serv_name,"/CMD");
	printf("Sending %s to %s\n",cmnd,serv_name);
	dic_cmnd_service(serv_name, cmnd, strlen(cmnd)+1);
}

