//-------------------------- Condition Class ----------------------------------
#include <iostream.h>
#include <stdio.h>
#include <assert.h>

#include "condition.hh"
//
//                                                              B. Franek
//                                                             12-Aug-1996
//-----------------------------------------------------------------------------

Condition::Condition (char lines[][MAXRECL], int *no_lines){
//-------------------------------------------------------------------------
// Input :
// lines[0] ....... the first line of the condition
// Output :
// no_lines ....... number of lines in the condition
//----------------------------------------------------------------------------

   int il;

   il = 0;
//   cout << "Condition: \n";
//   cout << lines[il] << "\n";
//   cout << lines[il+1] << "\n";

   strcpy(_condition,lines[il]);

//   cout << "Condition is |" << _condition << "|\n";

   il++;
   sscanf(lines[il],"%d %d",&_noOfSmpCond,&_noOfCondIns);
   assert (_noOfSmpCond >= 0);
   assert (_noOfSmpCond < _maxSmpCond); 

   assert (_noOfCondIns >= 0);
   assert (_noOfCondIns < _maxCondIns); 

   il++;

   if ( _noOfSmpCond > 0 ) {
      for (int ismp=0; ismp < _noOfSmpCond; ismp++) {
         int no_smpcond_lines;
//         cout << lines[il] << "\n";
         _pSmpCond[ismp] = new SmpCond(&lines[il],&no_smpcond_lines);
         il = il + no_smpcond_lines;
      }
   }


   char condIns[MAXRECL];  
   char oper[4];   


   if ( _noOfCondIns > 0 ) {
      for (int icins=0; icins < _noOfCondIns; icins++) {
         strcpy(_condIns[icins],lines[il]);
//         sscanf(lines[il],"%s",_condIns[icins]);
         strcpy(condIns,_condIns[icins]);
         condIns[16] = '\0';
//         cout << condIns << "\n";
         decode_instruction(condIns, 
         oper, &_type1[icins], &_num1[icins], &_type2[icins], &_num2[icins]);
         strcpy(_oper[icins],oper);
//         cout << _oper[icins] << _type1[icins] << _num1[icins]
//              << _type2[icins] << _num2[icins] << " \n";
         il++;
      }
   }


  *no_lines = il;

/* The following is just a test of simple condition function
   if ( _noOfSmpCond > 0 ) {
      for (int ismp=0; ismp < _noOfSmpCond; ismp++) {
         enum { maxLen = 241 };
         char condString[maxLen];
         _pSmpCond[ismp]->whatAreYou(maxLen,condString);
//         cout << condString << "\n";
      }
   }
*/

  return ;
}  


void Condition::whatAreYou(int maxStrLen, char* condString) {
//   cout << " Condition::whatAreYou   not implemented yet \n";
   strcpy(condString,_condition);
   return ;
}

//---------------------------- evaluate -----------------------------------
int Condition::evaluate() {
//
   int flag;
   int ismp;
   int icins;
   int smpflags[_maxSmpCond];     
   int X[_maxCondIns];
//
   if ( _noOfSmpCond == 0 ) { 
#ifdef DEBUG
        cout << "    ELSE \n";
	    cout.flush();
#endif
        flag = 1;     // else evaluates always to true
        goto Fin;        
   }  
//
   for ( ismp = 0; ismp < _noOfSmpCond; ismp++) {
#ifdef DEBUG
         cout << "    T" << ismp+1 << ": ";
 	     cout.flush();
#endif
         smpflags[ismp] = _pSmpCond[ismp]->evaluate();
         if (smpflags[ismp] == -1 ) { 
             flag = -1;
             goto Fin;
         }
   }
//
   if ( _noOfSmpCond == 1 ) {
      flag = smpflags[0];
      goto Fin;
   }


   int oprd1,oprd2;

#ifdef DEBUG
   cout << " \n";
   cout.flush();
#endif

   for ( icins=0; icins < _noOfCondIns; icins++) {
#ifdef DEBUG
        cout << "    " << _condIns[icins];
	    cout.flush();
#endif
        if (_type1[icins] == 'T') {
            oprd1 = smpflags[_num1[icins]-1];
        }
        else {
            oprd1 = X[_num1[icins]-1];
        }
        if (_type2[icins] == 'T') {
            oprd2 = smpflags[_num2[icins]-1];
        }
        else if (_type2[icins] == 'X') {
            oprd2 = X[_num2[icins]-1];
        }
        else { oprd2 = 0; }
//
        if ( !strcmp(_oper[icins],"and") ) {
           if ( oprd1 && oprd2 ) { X[icins] = 1;} else { X[icins] = 0;}
        }        
        else if ( !strcmp(_oper[icins],"or ") ) {
           if ( oprd1 || oprd2 ) { X[icins] = 1;} else { X[icins] = 0;}
        }        
        else if ( !strcmp(_oper[icins],"not") ) {
           if ( oprd1 ) { X[icins] = 0;} else { X[icins] = 1;}
        }        
        else {
           cout << "\n  screwed operation\n ";
	       cout.flush();
           exit(1);
        }
#ifdef DEBUG
   cout << "  =  X(" << icins+1 << ")= " << X[icins] << "\n";
   cout.flush();
#endif
   }

   flag = X[_noOfCondIns-1];
   goto Fin;
//
//
   Fin:

   if ( flag == 0 ) {
#ifdef DEBUG
        cout << "    Condition evaluates to FALSE \n";
	    cout.flush();
#endif
   }
   else if ( flag == 1 ) {
#ifdef DEBUG
        cout << "    Condition evaluates to TRUE \n";
	    cout.flush();
#endif
   }
   else if ( flag == -1 ) {
#ifdef DEBUG
        cout << "    Condition can not be evaluated \n";
	    cout.flush();
#endif
   }
   else {
        cout << "    Flag returned by Condition has illegal value :" << flag
             << "\n";
        exit(1);
   }

#ifdef DEBUG
   cout << "\n";
   cout.flush();
#endif

   return flag;
}


//------------------------------  isPresent  ---------------------------------
//
bool Condition::isPresent( const char *objName) const {
//
   for ( int ismp = 0; ismp < _noOfSmpCond; ismp++) {
         if ( _pSmpCond[ismp]->isPresent(objName) ) { return 1; }
   }
//
   return 0;
}



//--------------------------   decode_instruction   ------------------------
void Condition::decode_instruction
     (char* instruction, 
      char* operation, char* type1, int *num1, char *type2, int *num2) {
//
//  Typical instruction looks like:
//
//0123456789012345..... cols
//and   T005  X056
//not   X003
char line[81];     // internal instruction

char operand1[5];  // T005
char operand2[5];  // X056

char operand1_num[4]; // 005
char operand2_num[4]; // 056

int instruction_len;
instruction_len = strlen(instruction);

if ( instruction_len  < 10 || instruction_len  > 80 ) {
     cout << " Condition instruction has illegal length :" 
          << "0123456789012345 \n"
          << instruction_len
          << " \n";
	 cout.flush();
     exit(1);
}
 
strcpy(line,instruction);


line[3]  = '\0';
strcpy(operation,line);

line[10] = '\0';
strcpy(operand1,&line[6]);

*type1 = operand1[0];
if( *type1 != 'T' &&  *type1 != 'X' ) {
    cout << " Condition instruction has illegal format :\n"
         << "0123456789012345 \n"
         << instruction << " \n";
	cout.flush();
    exit(1);
}
strcpy(operand1_num,&operand1[1]);
sscanf(operand1_num,"%d",num1);


if ( !strcmp(operation,"and") || !strcmp(operation,"or ") ) {
     if ( instruction_len < 16 ) {
         cout << " Condition instruction has illegal format :\n"
              << "0123456789012345 \n"
              << instruction << " \n";
 	     cout.flush();
         exit(1);
     }
     line[16] = '\0';
     strcpy(operand2,&line[12]);
     *type2 = operand2[0];
     if( *type2 != 'T' &&  *type2 != 'X' ) {
         cout << " Condition instruction has illegal format :\n"
              << "0123456789012345 \n"
              << instruction << " \n";
	     cout.flush();
         exit(1);
     }
     strcpy(operand2_num,&operand2[1]);
     sscanf(operand2_num,"%d",num2);
}
else if ( !strcmp(operation,"not") ) {
     *type2 = ' ';
     *num2 = 0;
}
else {
     cout << " Condition instruction has illegal format :\n"
          << "0123456789012345 \n"
          << instruction << " \n";
	    cout.flush();
     exit(1);
}

return;
}


//--------------------------  objectSet   ------------------------
void Condition::objectSet(Set_Name *pobjSet) {
//
   char objnm[MAXOBJECTNAME];

   if ( !pobjSet->isEmpty() ) {
        cout << " objectSet   is not empty\n";
	    cout.flush();
        exit(1);
   }

   for ( int ismp = 0; ismp < _noOfSmpCond; ismp++) {
         _pSmpCond[ismp]->objName(objnm,MAXOBJECTNAME);
         pobjSet->add(objnm);
   }
//


}


//--------------------------  addto_objectSet   ------------------------
void Condition::addto_objectSet(Set_Name *pobjSet) {
//
   char objnm[MAXOBJECTNAME];

   for ( int ismp = 0; ismp < _noOfSmpCond; ismp++) {
         _pSmpCond[ismp]->objName(objnm,MAXOBJECTNAME);
         pobjSet->add(objnm);
   }
//


}


/*
//-----  Test main for decode_instruction-------------------
void main() {
char instruction[17];

char oper[4];

char typ1;
char typ2;

int num1;
int num2;


strcpy(instruction,"or    T002  X056");

cout << instruction << "\n";

decode_instruction (instruction, oper, &typ1, &num1, &typ2, &num2);

cout << " Operation : |" << oper << "| \n";

cout << " First  operand :  Type : |" << typ1 << "|  number : " << num1 << " \n";

cout << " Second operand :  Type : |" << typ2 << "|  number : " << num2 << " \n";

exit(1);

}
*/
