//-------------------------  Condition  Class  ---------------------------------
#ifndef CONDITION_HH
#define CONDITION_HH

#include "parameters.hh"
#include "utilities.hh"
#include "smpcond.hh"
#include "set_name.hh"
class  SmpCond;
//                                                         B. Franek
//                                                         09-Aug-1996
//----------------------------------------------------------------------------
class Condition {
public :
  Condition( char lines[][MAXRECL], int *no_lines);
//-------------------------------------------------------------------------
// Input :
// lines[0] ....... the first line of the condition
// Output :
// no_lines ....... number of lines in the condition
//----------------------------------------------------------------------------
  void whatAreYou(int maxStrLen, char* condString);
  int evaluate();     // 0-false;  1-true;  -1 - an object in transition;
//
  bool isPresent( const char *objName) const;  // check whether the object is present
//
  void objectSet(Set_Name *pobjSet); // 
//
  void addto_objectSet(Set_Name *pobjSet); // 
//
private :
   void decode_instruction
     (char* instruction, 
      char* operation, char* type1, int *num1, char *type2, int *num2);


   char _condition[MAXRECL];            // Truncated condition


   int _noOfSmpCond;    // Number of simple conditions
   int _noOfCondIns;    // Number of condition instructions

   enum { _maxSmpCond = 100 };
   SmpCond *_pSmpCond[_maxSmpCond];  // Pointers to simple conditions

   enum { _maxCondIns = 100 };
   char _condIns[_maxCondIns+1][MAXRECL];  // Condition Instruction lines

//  per instruction:
   char _oper[_maxCondIns+1][4];   // 1-and   2-or  3-not

   char _type1[_maxCondIns+1];  // Type of the 1-st operand ( T or X )
   int  _num1[_maxCondIns+1];   // index of the first operand

   char _type2[_maxCondIns+1];  // Type of the 2-nd operand ( T or X )
   int  _num2[_maxCondIns+1];   // index of the second operand
};

#endif

