//-----------------------------  IfIns  Class ------- if instruction -------
#include <iostream.h>
#include <stdio.h>
#include <assert.h>

#include "parameters.hh"
#include "utilities.hh"
//---------------------- Externals ----------------------
#include "objectregistrar.hh"
   extern ObjectRegistrar allSMIObjects;
#include "ifhandler.hh"
   extern IfHandler ifHandler;
//-------------------------------------------------------
#include "ifins.hh"
#include "condition.hh"
//
//                                                        B. Franek
//                                                       15-Apr-1996
//---------------------------------------------------------------------------
//
//------------------------------ IfIns -------------------------------------

 IfIns::IfIns
 ( char lines[][MAXRECL],int lev,InsList* *pAllBlocks,int *no_lines
 , char* objName, Action* pact){
//-------------------------------------------------------------------------
// Input :
// lines[0] ....... the first line after the 'if'
// lev    ....... the block level
// pAllBlocks ..... array of pointers of all the blocks belonging to the action
// Output :
// no_lines ....... number of lines in 'if' (not counting the first 'if')
//----------------------------------------------------------------------------

   strcpy(_objName,objName);

    _pParentAction = pact;

//   cout << " If belongs to object : " << _objName << "\n";

   _level = lev;
   _numCond = 0;
   _isuspended = 0;
   _suspend_flag = 0;

   int il;

   il = 0;
   sscanf(lines[il]," %d",&_numCond);
//   cout << "No. of conditions : " << _numCond << "\n";

   for (int icond=0; icond<_numCond; icond++) {

     int numCondlines;

     il++;
     Condition *tempcnd;     
     tempcnd = new Condition(&lines[il],&numCondlines);
     il = il + numCondlines;

     int ref_blockno,ref_level;

     sscanf(lines[il],"%d %d",&ref_blockno,&ref_level);
//     cout << "Execute block : " << ref_blockno << 
//             " level : " << ref_level << "\n";

     InsList *tempblk;
     tempblk = pAllBlocks[ref_blockno];
  
     char condition[MAXRECL];
     tempcnd->whatAreYou(MAXRECL,condition);
//     cout << "Addind condition : " << condition << "\n";
     _pCondition[icond] = tempcnd;
     _pblocks[icond] = tempblk; 
//     cout << icond << "  " << _pblocks[icond] << "\n";

   }


   _pCondition[0]->objectSet(&_tobeLocked);

   for ( int iicond = 1; iicond < _numCond; iicond++ ) {
         _pCondition[iicond]->addto_objectSet(&_tobeLocked);
   }

//   _tobeLocked.out();


  *no_lines = il + 1;
  return ;
}
//


//------------------------------ whatAreYou ---------------------------------
void IfIns::whatAreYou(){
char condition[MAXRECL];
cout << "\n";
indent(_level*2+5);
_pCondition[0]->whatAreYou(MAXRECL,condition);
cout  << "if " << condition << " then"  << "\n";
_pblocks[0]->listInstructions();
//cout << "_pblocks[0] " << _pblocks[0] << "\n";
for (int i=1; i<_numCond; i++) {
_pCondition[i]->whatAreYou(MAXRECL,condition);
  indent(_level*2+5);
  if (!strcmp(condition,"else")) {
    cout << "else" << "\n";
  }
  else {
    cout << "else if " << condition << " then"  << "\n";
  }
  _pblocks[i]->listInstructions();
}
indent(_level*2+5);
cout << "end if" << "\n" << "\n";
cout.flush();
}

//----------------------------------- execute --------------------------------
int IfIns::execute(char* pstate){
//
   int trueBlock;
   int returnStat, i;

   returnStat = 0;
#ifdef DEBUG
   cout  << "  ---------------  IF instruction(" << this << ")-----------\n";
   cout  << "  NoOfCond : " << _numCond << "\n";
#endif

   if ( _suspend_flag == 0 ) {               //--------- _suspend_flag == 0
#ifdef DEBUG
        cout << "  To be locked : ";
        _tobeLocked.out();
        cout << "\n";
#endif
        lockObjects();
        if ( !_tobeLocked.isEmpty() ) {
#ifdef DEBUG
             indent(_level);
             cout << "  If suspended...waiting for objects to be locked\n";
#endif
             _suspend_flag = 1;
             ifHandler.addSet(_objName,&_tobeLocked);
             return 2;
        } 
//
        trueBlock = findTrueBlock() ;
        if ( trueBlock < 0 ) {
             returnStat = 0;
             goto EndIf;
        }
//
        returnStat = _pblocks[trueBlock]->execute(pstate);
        if (returnStat == 2 ) { 
            _suspend_flag = 2;
            _isuspended = trueBlock;
             return 2; 
        }
        else if ( returnStat == 0 || returnStat == 1 ) { goto EndIf;}
        else { cout << "IfIns...return from execute is illegal\n";exit(1);}    
   }
//
   else if ( _suspend_flag == 1 ) {            //--------- _suspend_flag == 1
//
        if ( !_tobeLocked.isEmpty() ) {
            cout << " To be locked set not empty\n";
            exit(1);
        }
//
        trueBlock = findTrueBlock() ;
        if ( trueBlock < 0 ) {
             returnStat = 0;
             goto EndIf;
        }
//
        returnStat = _pblocks[trueBlock]->execute(pstate);
        if (returnStat == 2 ) { 
            _suspend_flag = 2;
            _isuspended = trueBlock;
             return 2; 
        }
        else if ( returnStat == 0 || returnStat == 1 ) { goto EndIf;}
        else { cout << "IfIns...return from execute is illegal\n";exit(1);}    
   }
//
   else if ( _suspend_flag == 2 ) {            //--------- _suspend_flag == 2
//
        returnStat = _pblocks[_isuspended]->execute(pstate);
        if (returnStat == 2 ) { 
             return 2; 
        }
        else if ( returnStat == 0 || returnStat == 1 ) { goto EndIf;}
        else { cout << "IfIns...return from execute is illegal\n";exit(1);}    
   }
//
   else {
        cout << " IfIns.... suspend flag has illegal value : " 
             << _suspend_flag << "\n";
        exit(1);
   }



   EndIf:
   _isuspended = 0;
   _suspend_flag = 0;

   unlockObjects();
//
#ifdef DEBUG
   indent(_level);
   cout  << "  -------------  END-OF-IF instruction(" 
         << this << ")---------------------\n\n";
#endif
//   if (returnStat != 0) {
//   cout << " State :" << pstate << "\n" << "\n";
//   }
//

   return returnStat;
}

//--------------------------  lockObjects  ------------------------------------
//
void IfIns::lockObjects() {
//
   char obj[MAXOBJECTNAME];
   SMIObject *pSMIObj;
//
   int numel = _tobeLocked.numOfEntries();
//
   for ( int iel = 0; iel < numel; iel++ ) {
         _tobeLocked.element(iel, obj, MAXOBJECTNAME);
         pSMIObj = allSMIObjects.gimePointer(obj);           
         int lockFlg = pSMIObj->lock(_objName);
         if ( lockFlg ) { 
             if ( _tobeLocked.remove(obj) ) {
                  iel = iel -1;
                  numel = numel -1;
             }
         }
   }
//
   return;
}

//-----------------------------  unlockObjects  -------------------------------
//
void IfIns::unlockObjects() {
//
   if( !_tobeLocked.isEmpty() ){
       cout << " Object set not empty at end if \n";
       exit(1);
   }

   _pCondition[0]->objectSet(&_tobeLocked);

   for ( int iicond = 1; iicond < _numCond; iicond++ ) {
         _pCondition[iicond]->addto_objectSet(&_tobeLocked);
   }

   char obj[MAXOBJECTNAME];
   SMIObject* pSMIobj;
   int numel = _tobeLocked.numOfEntries();
   for ( int iel = 0; iel < numel; iel++ ) {
        _tobeLocked.element(iel, obj, MAXOBJECTNAME);
        pSMIobj = allSMIObjects.gimePointer(obj);           
        pSMIobj->unlock();
   }
//
   return;
}
//
//----------------------------  findTrueBlock --------------------------
//
int IfIns::findTrueBlock() {
//
   int block;
//
   block = -1;
//
   for ( int icond=0; icond < _numCond; icond++ ) {
         int  cond_flag = _pCondition[icond]->evaluate();
         if ( cond_flag == -1 ) {
              cout << 
              " Ifins  procedural error  some objects are transiting\n";
                exit(1);
         }
         else if ( cond_flag == 1 ) {    
              block = icond;
              break;
         }
   }
//
   if ( block < 0 && _numCond > 1 ) {
        cout << " IfIns... no condition is true \n";
        exit(1);
   }

   return block;

}
