//----------------------   INITIATOR  --------------------------
#include "parameters.hh"
#include <fstream.h>
#include <assert.h>
#include "utilities.hh"
#include "smiobject.hh"
#include "smiclass.hh"
#include "objectregistrar.hh"
#include "smiclassregistrar.hh"
#include "namevector.hh"
extern ObjectRegistrar allSMIObjects;

void createAlloc
     (const Name& externDomain, const SMIClassRegistrar* const pAllClasses,
      int& numOfObjects);

//  Will read all the records from the SOBJ file searching for objects or
//  SMI classes. For each of these it collects all the records in lines and 
//  calls the SMIObject creator.
//
//                                                   20-August-1996
//                                                    B.Franek
//-----------------------------------------------------------------------------
typedef char OBJLINE[MAXRECL];

void initiator(ifstream *pSOBJFile) {


   char line[MAXRECL]; Name lineNm;

// -----Instantiate Registrar of SMI Objects and Classes -------------


   SMIClassRegistrar *pAllClasses;
   pAllClasses = new SMIClassRegistrar;
// -------------------------------------------------------------------


   int numOfObjects(0);
   int numOfClasses(0);

   int smiClass;

   int expected;   // when =1 it means that *OBJECT or *CLASS record is expected
   expected = 1;


  for (;;) {

     NameVector* pObjectCode = new NameVector(20);
     assert(pObjectCode != 0);
          
     for (;;) {
        pSOBJFile->getline(line,MAXRECL);
        lineNm = line; (*pObjectCode)+= lineNm;

        if (pSOBJFile->eof() ) {
           pSOBJFile->close();
           if ( expected == 1 ) {
              goto EndOfFile;
           }
           else {
              cout << " This is unexpected and therefore an error \n";
              cout.flush();
              exit(0);
           }
        }
        else if (pSOBJFile->bad()) {
           cout << "Error reading file\n";
           cout.flush();
           exit(0);
        }

        else if (!strcmp(line,"*OBJECT") ) {
           if ( expected == 1 ) {
              smiClass = 0;
              expected = 0;
           }
           else {
              cout << " *OBJECT expected, read: \n  |"
                   << line << "| \n";
              cout.flush();
              exit(0);
           }
        }        

        else if (!strcmp(line,"*CLASS") ) {
           if ( expected == 1 ) {
              smiClass = 1;
              expected = 0;
           }
           else {
              cout << " *OBJECT expected, read: \n  |"
                   << line << "| \n";
              cout.flush();
              exit(0);
           }
        }        

        else if (!strcmp(line,"*END_OBJECT") ) {
           if ( expected == 1 ) {
              cout << " *OBJECT expected, read: \n  |"
                   << line << "| \n";
              cout.flush();
              exit(0);
           }
//         ------------- SMI Object lines collected....instantiate! ----------


           int no_lines = pObjectCode->length();
	   
	   char* pCode = new char[no_lines*MAXRECL];
           OBJLINE* lines = (OBJLINE*) pCode;   
          
	   for (int il=0;il<no_lines;il++) {
	      lineNm = (*pObjectCode)[il];
	      strcpy(lines[il],&lineNm[0]);
	   }
	   
           SMIObject *pSMIObj;

#ifdef DEBUG
           cout << "\n";
           cout.flush();
#endif
           pSMIObj = new SMIObject(pAllClasses,&lines[0]);
           assert (pSMIObj != 0 );
           delete [] pCode; delete pObjectCode;
           numOfObjects++;

           Name externDomain = pSMIObj->externDomain();
           if ( externDomain == "\0" ){}
           else { createAlloc(externDomain,pAllClasses,numOfObjects);}

           expected = 1;
	   break;
//         -----------------------------------------------------------------
        }

        else if (!strcmp(line,"*END_CLASS") ) {
           if ( expected == 1 ) {
              cout << " *OBJECT expected, read: \n  |"
                   << line << "| \n";
              cout.flush();
              exit(0);
           }
//         ------------- SMI Class lines collected....instantiate! ----------

           int no_lines = pObjectCode->length();
	   
	   char* pCode = new char[no_lines*MAXRECL];
           OBJLINE* lines = (OBJLINE*) pCode;   
     
	   for (int il=0;il<no_lines;il++) {
	      lineNm = (*pObjectCode)[il];
	      strcpy(lines[il],&lineNm[0]);
	   }


           SMIClass *pSMICla;
#ifdef DEBUG
           cout << "\n";
           cout.flush();
#endif
           pSMICla = new SMIClass(pAllClasses,&lines[0]);
           assert (pSMICla != 0 );
           delete [] pCode; delete pObjectCode;

           numOfClasses++;
           expected = 1;
           break;
//         -----------------------------------------------------------------
        }
        else  {
        }
     }
  }   // object loop
//---------------------- Everything is read in ---------------------------


  EndOfFile:

  cout << "End of file \n  \n"
       << " Number of SMI Objects instantiated : " << numOfObjects << " \n"
       << " Number of SMI Classes instantiated : " << numOfClasses << " \n";
  cout.flush();


  return;

}
void createAlloc(const Name& externDomain, 
      const SMIClassRegistrar* const pAllClasses,
      int& numOfObjects) {

   static  char lines[5][MAXRECL] = { "*OBJECT",
                                     "object name",
                                     "1    0    1",
                                     "&ALLOCATION_OBJECT",
                                     "*END_OBJECT" };

   SMIClass *temp = pAllClasses->gimePointer("&ALLOCATION_OBJECT");
   if ( temp == 0 ) {return;}   // This class does not exists...old sobj


   Name allocObject = externDomain;
   allocObject += "::&ALLOC";

   SMIObject *ptnr = allSMIObjects.gimePointer(allocObject);

   if (ptnr) { return; }  // already exists

   allocObject.whatAreYou(lines[1],MAXRECL);

   SMIObject *pSMIObj = new SMIObject(pAllClasses,&lines[0]);
   assert ( pSMIObj != 0 );
   numOfObjects++;

}
