//------------------------- InsList Class ------------------------------------
#include <iostream.h>
#include <stdio.h>
#include <assert.h>
#include "utilities.hh"
#include "inslist.hh"
#include "doins.hh"
#include "termins.hh"
#include "ifins.hh"
#include "setins.hh"
//                                                             B. Franek
//                                                             April 1996
//-----------------------------------------------------------------------------
//
InsList::InsList
    (int blknum, int lev, char* objName, 
     SMIObject *pobj, State* pstat, Action* pact){
  strcpy(_objName,objName);
  _pParentObject = pobj;
  _block_id = blknum;
  _level = lev;
  _numIns = 0;
  _isuspended = 0;
  for(int i=0;i<MAXINS;i++){
    _pIns[i] = 0;
    };
  _pParentAction = pact;
  _pParentState = pstat;
}

void InsList::initialise( char lines[][MAXRECL], InsList* *pblocks, 
                          int *no_lines){

  int curr_block, curr_level;   // block number and level of the block
                                // which is being processed

  sscanf(lines[1],"%d %d",&curr_block,&curr_level);
//  cout << " Block :  " << curr_block << " level " << curr_level << "\n";


  for (int il=2;;il++){
//    cout << lines[il] << "\n";
    if (!strcmp(lines[il],"*END_ACTION")) {
       *no_lines = il;
       break;
    }
    else if (!strcmp(lines[il],"*BLOCK")) {
       *no_lines = il;
       break;
    }

    else if (!strcmp(lines[il],"do")) {             //-------- do instruction
      int no_dolines;

      DoIns *pDoIns;
      pDoIns = new DoIns
            (&lines[il],curr_level,&no_dolines,_pParentObject,_pParentAction);

      assert( _numIns < MAXINS );
      _pIns[_numIns] = pDoIns;
      _numIns++;
      il = il + no_dolines - 1;
    }

    else if (!strcmp(lines[il],"terminate")) {      //-------- terminate instr.
//      cout << "terminate encountered\n";
      il++;
      int no_termlines;

      TermIns *pTermIns;

      pTermIns = new TermIns(&lines[il],curr_level,
                 _pParentObject,_pParentState,_pParentAction,no_termlines);
      assert( _numIns < MAXINS );
      _pIns[_numIns] = pTermIns;
      _numIns++;

      il = il + no_termlines - 1;
    }

    else if (!strcmp(lines[il],"if")) {             //-------- if instruction
//      cout << "if encountered\n";
      il++;
      int no_iflines;

      IfIns *pIfIns;
      pIfIns = new IfIns
          (&lines[il],curr_level,pblocks,&no_iflines,_objName,_pParentAction);

      assert( _numIns < MAXINS );
      _pIns[_numIns] = pIfIns;
      _numIns++;

      il = il + no_iflines - 1;
    }
    else if (!strcmp(lines[il],"set")) {             //-------- set instruction
      int no_setlines;

      SetIns *pSetIns;
      pSetIns = new SetIns
            (&lines[il],curr_level,no_setlines,_pParentObject,_pParentAction);

      assert( _numIns < MAXINS );
      _pIns[_numIns] = pSetIns;
      _numIns++;
      il = il + no_setlines - 1;
    }
    else {
      cout << " InsList::InsList  :funny line encountered \n"
           << "|" << lines[il] << "|\n";
      cout.flush();
      exit(1);
    }      
  }
//------------------------------------------------------------------------


  return;
}


void InsList::listInstructions(){
//cout << " Num of instructions : " << _numIns << "\n";
if (_numIns == 0 ) {return;}
for( int i=0; i<_numIns; i++) {
   _pIns[i]->whatAreYou();
   };
}


int InsList::execute(char* pstate){
int temp;
#ifdef DEBUG
indent(_level);

cout << "  ---Block " << _block_id << " starting execution "  
<< "at " << _isuspended << "(" << _numIns << ")"  << "\n";
cout.flush();
#endif

for( int i=_isuspended; i<_numIns; i++) {
#ifdef DEBUG
   indent(_level);
   cout << i << ":";
   cout.flush();
#endif
   temp = _pIns[i]->execute(pstate);
   if (temp == 2) { 
     _isuspended = i; 
#ifdef DEBUG
     indent(_level);
     cout << "  ---Block " << _block_id << " execution" << 
          " suspended at " << i << " instruction \n";

     cout.flush();
#endif
     return temp;
}
   if (temp != 0) { break; }
};
#ifdef DEBUG
indent(_level);
cout << "  ---Block "  << _block_id << " end of execution " << "\n";
cout.flush();
#endif

_isuspended = 0;
return temp;
}

