#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "name.hh"
#include "state_managerversion.hh"
//---------------------------------------------------------------------
//                                                   B. Franek
//                                                   29 March 1999
//---------------------------------------------------------------------

void processCommandLine( int argc, char* argv[],
                        int& dbg, Name& domain, Name& sobjFile) {

        dbg = 0;
	int input_error = 0;
	domain = "\0"; sobjFile = "\0";
        char temp[3];

	for(int i=1; i<argc && !input_error; i++)
	{       
                temp[0] = argv[i][0]; temp[1] = argv[i][1]; temp[2] = '\0';
		if(!strcmp("-v",temp)){
			cout << State_ManagerVersion << endl;
			exit(0);
		}
		else if (!strcmp("-d",temp)){
			dbg = 1;
		}
		else if(temp[0] == '-') {
			cout << "Unknown option requested " << argv[i] << endl;
			input_error =1;
		} 
		else {
			if (domain == "\0") {
                            domain = argv[i]; domain.upCase();
                        }
			else if (sobjFile == "\0") {
                            sobjFile = argv[i];
                        }
			else {
				input_error = 1;
			}
		}
	}

	if (domain == "\0" || sobjFile == "\0") input_error =1;

	if(input_error) {
		cout << endl << "\tusage: " 
			<< argv[0] << " [-v] [-d] domain-name  sobj-file-name" << endl;
		exit(1);
        }

	char* pStr = sobjFile.getString();
	char* ptnf;

        if ( ptnf = strstr(pStr,".sobj")) {  // contains .sobj 
			if (!strcmp(ptnf,".sobj")) { // it is at the end 
				return;
			}
	}
        sobjFile += ".sobj";
        return;
}
