//----------------------   M a i n   P r o g r a m  --------------------------
#include "parameters.hh"
#include "utilities.hh"
//----------------------  Globals -------------------------------
#include "objectregistrar.hh"
   ObjectRegistrar allSMIObjects;
#include "queue_name.hh"
   Queue_Name executableObjectQ;
#include "ifhandler.hh"
   IfHandler ifHandler;
   Name smiDomain;
   Name allocator("\0");
//---------------------------------------------------------------
#include <fstream.h>
#include <ctype.h>
#include "smiobject.hh"
#include "state_managerversion.hh"

void logicEngine();
//ObjectRegistrar *initiator(ifstream *p);
void initiator(ifstream *p);
void processCommandLine(int argc, char* argv[],int& dbg,Name& ,Name&);
  

//-----------------------------------------------------------------------------

int main(int argc, char* argv[]) {

  Name inputFile; int dbg;
  processCommandLine(argc,argv,dbg,smiDomain,inputFile);
  
  if ( smiDomain.length() > (MAXNAMESIZE-1) ) {
     cout << " The domain name is too long " << endl;
     cout.flush();
     abort();
  }

  cout << "\n\n";
  cout << " ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
  cout << " +                                                              +\n";
  cout << " +                                                              +\n";
  cout << " +               SMI++   S T A T E   M A N A G E R              +\n";
  cout << " +                                                              +\n";
  cout << State_ManagerVersion << endl;
  cout << " +                                                              +\n";
  cout << " +                                                              +\n";
  cout << " +                                                              +\n";
  cout << " +  Any problems please report to :                             +\n";
  cout << " +                                                              +\n";
  cout << " +    Boda Franek                 |  Tel: ++ 44 1235 445643     +\n";
  cout << " +    2-46, Building R1           |                             +\n";
  cout << " +    Rutherford Appleton lab.    |  Fax: ++ 44 1235 446733     +\n";
  cout << " +    Chilton, Didcot             |                             +\n";
  cout << " +    Oxon OX11 0XQ               |  email: B.Franek@rl.ac.uk   +\n";
  cout << " +    England                     |                             +\n";
  cout << " ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
  cout << "\n\n";

  cout << "               SMI Domain : " << smiDomain << "\n \n";

//---------------------  Open the input SOBJ file -----------------------
  char* pStr = inputFile.getString();
  cout << " Input file : |" << inputFile << "| \n \n \n \n"; 

  ifstream input_file(pStr);

  if (input_file.bad()) {
    cout << "Could not open file\n";
    exit(0);
  }
//------------------------------------------------------------------


   print_msg("SMI++ Initiator starting");

   initiator(&input_file);  

   cout << "\n";
   print_msg("SMI++ Initiator Finished");


// ****************************
/*
   cout << "\n \n  The following objects are registered : \n \n";

  int numOfObjects;
  numOfObjects = allSMIObjects.numOfObjects();

  for (int io=0; io < numOfObjects; io++) {
     char object_nm[MAXNAMESIZE];
     SMIObject *pSMIObj;
     allSMIObjects.gimeName(io,object_nm);
     cout << object_nm << "\n";
     pSMIObj = allSMIObjects.gimePointer(object_nm);
     pSMIObj->whatAreYou();
  }
*/
//************************************************************************

   cout << " \n \n \n              Logic Engine starting execution \n \n";

   logicEngine();


   exit(1);


}
