#include "parameters.hh"
#ifdef __VMS
#	include <descrip.h>
#endif
#include "utilities.hh"

void print_date_time()
{
#ifdef __VMS
    char s[24];
    $DESCRIPTOR(msg,s);

    lib$date_time(&msg);
    s[23] = 0;
    cout << s ;
#else
    time_t t;
	char *s;

    t = time((time_t *)0);
    s = ctime(&t);
	*(char *)strchr(s,'\n') = '\0';
    cout << s ;
#endif
}

void print_msg(char *msg) {
   print_date_time();
   cout << ": " << msg << "\n";
   cout.flush();
}


void print_obj(char *obj_name){
     print_date_time();
     cout << " : " << obj_name;
}


void print_obj(Name& obj_name){
     print_date_time();
     cout << " : " << obj_name;
}


void indent(int blanks){
  for (int ii=0; ii<=blanks; ii++) {  cout << " ";}
  cout.flush();

}


int strElement
   (char* deststr, int mxsize, int elm_num, char* delimiter,char* src_string) {
   char* reso, *resn, *res;
   int len;

//   cout << "\n Input string : |" << src_string << "| \n";
//   cout << " delimiter :|" << delimiter << "| \n";
//   cout << " element num :" << elm_num << " \n";

   reso = src_string;

   for (int i=0; i<=elm_num; i++) {
      res = reso;
      resn = strchr(reso,delimiter[0]);

      if ( resn == NULL ) {
         len = strlen(reso);
         if ( i < elm_num ) {
            return 0;
         }
      }
      else {
         len = strlen(reso) - strlen(resn);
      }

//      cout <<  len << " |" << res << "|\n";      
      reso = resn +1;
   }

   
   assert ((len+1)<= mxsize ) ;

   strncpy(deststr,res,len);
   strcpy(deststr+len,"\0");
   return 1;
 }
//
//
int subobjectState
   (char* subobject, char* state, int elm_num, char* state_string) {
   char subobject_string[2*(MAXNAMESIZE-1)+2];  //   'subobj'.'state'NULL

//   cout << "\n State string : |" << state_string << "| \n";
//   cout << " element num :" << elm_num << " \n";

   if (strElement(subobject_string,2*(MAXNAMESIZE-1)+2,elm_num,
                  ",",state_string)) {
//      cout << " Subobject string :|" << subobject_string << "|\n";
      if ( strlen(subobject_string) == 0 ) {
         cerr << " State string has illegal format \n" << state_string << "\n";
         assert ( 1==0 ); 
      }
      if ( strElement(subobject,MAXNAMESIZE,0,".",subobject_string) ) {
//         cout << " Subobject :|" << subobject << "|\n";
         if ( strlen(subobject) == 0 ) {
            cerr << " State string has illegal format \n" << state_string << "\n";
            assert ( 1==0 ); 
         }
         if ( strElement(state,MAXNAMESIZE,1,".",subobject_string) ) {
//            cout << " State :|" << state << "|\n";
            if ( strlen(subobject_string) == 0 ) {
               cerr << " State string has illegal format \n" << state_string << "\n";
               assert ( 1==0 ); 
            }
            return 1;
         }
         else {
         cerr << " State string has illegal format \n" << state_string << "\n";
         assert ( 1==0 ); 
         }
      }
      else {
      cerr << " State string has illegal format \n" << state_string << "\n";
      assert ( 1==0 ); 
      }
   }
   else {
      return 0;
   }
   return 0;
 }


bool check_name(const Name& name) {
    char charset[] = "_abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
    char ch;

    ch = name[0];

    if ( strchr(charset,ch) ) {
       return 1;
    }
    else {
       return 0;
    }
}

bool check_int(const Name& name) {
     int tempi;
     char ch;

     if ( sscanf(&name[0],"%d %c",&tempi,&ch) == 1) { return 1; }     
     return 0;
}

bool check_float(const Name& name) {
     int tempf;
     char ch;

     if ( sscanf(&name[0],"%e %c",&tempf,&ch) == 1) { return 1; }     
     return 0;
}

bool check_string(const Name& name) {

     if ( name[0] == '\"' ) { return 1; }//anything beginning with " is string
     return 0;          
}
