//------------------------  Class   D o I n s  -----------------------------
#include <iostream.h>
#include <stdio.h>
#include <assert.h>
#include "utilities.hh"
//-------------------- Externals -----------------
#include "objectregistrar.hh"
   extern ObjectRegistrar allSMIObjects;
   extern  Name smiDomain;
//-------------------------------------------------
#include "doins.hh"
#include "smiobject.hh"
#include "parms.hh"
//                                                      Date : 5-May-1996
//                                                     Author: Boda Franek
//---------------------------- DoIns -------------------------------------
//
DoIns::DoIns
( char lines[][MAXRECL], int lev, int *no_lines, 
  SMIObject *pobj, Action* pact){
   char tempstr[MAXRECL];
   int lin;
   level = lev;

   _pParentObject = pobj;

   _pParentAction = pact;
//    cout << " do init _pParentAction : " << _pParentAction << "\n";

   sscanf(lines[1],"%s",tempstr);
   _actionNm = tempstr;

   int npara;
   sscanf(lines[2],"%d",&_numOfPara);
   assert ( _numOfPara < MAXPARA );

   lin = 3;

   Name paraNm, paraVal;

   if ( _numOfPara > 0) {
      for(int ipar=0; ipar<_numOfPara; ipar++) {
         sscanf(lines[lin],"%s",tempstr);
         paraNm = tempstr;
         lin++;
         sscanf(lines[lin],"%s",tempstr);
         if ( !strcmp(tempstr,"&SMIDOMAIN") ) {
            paraVal = "\"";
            paraVal += smiDomain;
            paraVal += "\"";
         }
         else {
            paraVal = tempstr;
         }
         lin++;
         _doInsParameters.add(paraNm,paraVal);
      }
   }

   sscanf(lines[lin],"%s",tempstr);
   _objectNm = tempstr;
   *no_lines = lin + 1;
   return;
}



//---------------------------- whatAreYou ---------------------------------

void DoIns::whatAreYou(){
   indent(2*level+5);

// Format: do RO_SETUP ("/RO_FILE="SMI_LES_RO_FILE) LES

   cout << "do " << _actionNm ;

   if (_numOfPara > 0 ) {
      cout << " (";
      for (int ip=0; ip<_numOfPara; ip++) {
//         cout << _para[ip] << _value[ip];
//         if ( ip<(_numOfPara-1) ){cout << ",";}
      }
      cout << ")";
   }

   cout << "  " << _objectNm  << "\n";
}


//----------------------------  execute  ---------------------------------------
//
//
int DoIns::execute(char* pendState){
//
//
#ifdef DEBUG
   cout  << "  do " << _actionNm << "  " << _objectNm << "\n";
   cout.flush();
#endif


   Name actionString = _actionNm;  
   Parms outPars;
//
   if (_numOfPara > 0) {
      Name name,val;
      char type[7];

      outPars = _doInsParameters;  // copy do instruction pars to outgoing pars
      Parms* pCurPars = _pParentAction->pCurrentParameters();

//    cout << " Do parameters :" << endl;         outPars.out();
//    cout << " Incomming parameters :" << endl;  pCurPars->out();

      outPars.replaceNameValues( *pCurPars );

//    cout << " Do parameters after action names replacement:" << endl; outPars.out();

      int npom =
          outPars.replaceNameValues( *_pParentObject->pObjectParameters() );

//    cout << " Do parameters after object names replacement:" << endl; outPars.out();

      if (npom == 0) {
         cout << " Not all the names replaced...fatal error" << endl;
         cout.flush();
         abort();
      }

      outPars.guessTypes(); 

//    cout << " Do parameters after guessing value types:" << endl; outPars.out();

      if( !outPars.allHaveValues() ) {
         cout << " Not all parameters have values...fatal error"<< endl;
         cout.flush();
         abort();
      }
      Name tempParString;
      outPars.buildParmString(tempParString) ;

      actionString += tempParString;

//    cout << " Parameter string : " << tempParString << endl;
      cout.flush();
   }
//---------------------------------------------------------------------------

//   cout << " Action string : " << actionString << endl;
//   cout.flush();


   SMIObject *pSMIObj = allSMIObjects.gimePointer(_objectNm);
   pSMIObj->queueAction(actionString);


   strcpy(pendState,"not changed");
   return 0;         // do instruction allways finishes
}


//-------------------------  executeHp  ---------------------------------------
//
//
void DoIns::executeHp(){

    _pParentObject->queueHpAction(_actionNm);

return ;
}

