//----------------------  Class  IfHandler  ---------------------------------
//
//                                                      Author: Boda Franek
//                                                      Date : 14 April 1996
//----------------------------------------------------------------------------
#include "ifhandler.hh"
#include <iostream.h>
#include <string.h>
#include <assert.h>
#include "smiobject.hh"
#include "parameters.hh"
//---------------------------- Externals ----------
#include "objectregistrar.hh"
   extern ObjectRegistrar allSMIObjects;
//-------------------------------------------------
//
//----------------------------- IfHandler ---------------------------------
IfHandler::IfHandler() {
    _numOfObjects = 0;
    return;
}
//
//
//-----------------------------  isEmpty  ---------------------------------
bool IfHandler::isEmpty() {
   if ( _numOfObjects > 0 ) { return 1;}
   return 0;
}
//
//
//-----------------------------  addSet  ------------------------------------
void IfHandler::addSet(char* objName, Set_Name* pTobeLocked) {
//
   _objNames[_numOfObjects] = objName;
   _pTobeLocked[_numOfObjects] = pTobeLocked;   
   _numOfObjects++;
//
   if ( _numOfObjects >= 100 ) {
        cout << " Too many Ifs waiting\n";
        cout.flush();
        exit(1);
   }
}
//
//
//----------------------------  objectLocked  -----------------------------
void IfHandler::objectLocked(char* locked, char* requester) {
//
//
   Name objRequester;

   objRequester = requester;

   for ( int i = 0; i < _numOfObjects; i++ ) {
         if ( objRequester == _objNames[i] ) {
             if ( _pTobeLocked[i]->remove(locked) ) {
#ifdef DEBUF
                  cout << " To be locked: ";
                  _pTobeLocked[i]->out();
                  cout << "\n";
                  cout.flush();
#endif
                  return;
             }
             else {
                  cout << " Locked object not found in the list\n";
                  cout.flush();
                  exit(1);
             }
         }
   }
//
   cout << " Requesting object not found in ifhandler list\n";
   cout.flush();
   exit(1);
}
//
//
//------------------------------  execute  ---------------------------------
//
void IfHandler::execute() {
//
   char objname[MAXOBJECTNAME];
   int iex,i;
//
   iex = -1;
//
   for ( i = 0; i < _numOfObjects; i++ ) {
        if ( _pTobeLocked[i]->isEmpty() ) {
             _objNames[i].whatAreYou(objname,MAXOBJECTNAME);
             SMIObject *pSMIObj;
             pSMIObj = allSMIObjects.gimePointer(objname);
             pSMIObj->resume();
             iex = i;
             break;
        }
   }
//
   if ( iex == -1 ) { return; }
//
   _numOfObjects = _numOfObjects - 1;
   if( _numOfObjects == 0 ) { return; }
   if( iex == _numOfObjects ) { return; }
   for ( i = iex; i < _numOfObjects; i++ ) {
        _objNames[i] = _objNames[i+1];
        _pTobeLocked[i] = _pTobeLocked[i+1];
   } 
}
//
//
//------------------------------  out  --------------------------------------
// 
void IfHandler::out() {
//
//
   for ( int i = 0; i < _numOfObjects; i++ ) {
        _objNames[i].out();
   }
}
