//----------------------------- IfIns  Class ---------------------------------
#ifndef IFINS_HH
#define IFINS_HH

#include "parameters.hh"
#include "instruction.hh"

#include "inslist.hh"
#include "condition.hh"
#include "set_name.hh"
class Condition;
class Action;
//
//                                                               15-April-1996
//                                                               B. Franek
//-----------------------------------------------------------------------------

class IfIns : public Instruction{
public :
  IfIns( char lines[][MAXRECL],int lev,InsList* *pAllBlocks
       ,int *no_lines,char*, Action*);
  void whatAreYou();
  int execute(char* pstate);   // 0-normal,  1-terminated action, 2-suspended
private:
//
  void lockObjects();
  void unlockObjects();
  int findTrueBlock();
//
  int _level;
  int _numCond;
  Action* _pParentAction;
  InsList *_pblocks[100];  
  Condition *_pCondition[100];
  int _isuspended;    // block at which it was suspended
  int _suspend_flag;  // non zero means that 'if' was suspended
//                      1 - suspended because the condition could not be eval
//                      2 - suspended because a block was suspended

  Set_Name _tobeLocked;


  char _objName[MAXOBJECTNAME];    // Name of the object to which 
//                                        the If instruction belongs
};

#endif
