//--------------------------  ObjectRegistrar Class  -----------------------------------
#include <assert.h>
#include <string.h>
#include "parameters.hh"
#include "name.hh"
#include "smiobject.hh"
#include "objectregistrar.hh"
//                                                         21-August-1996
//                                                          B. Franek
//---------------------------------------------------------------------------
//
//--------------------------- Registrar --------------------------------------
ObjectRegistrar::ObjectRegistrar(){

   _num = 0;  _size = 0;

}

//
//--------------------------- Registrar --------------------------------------
ObjectRegistrar::~ObjectRegistrar(){
//
   if ( _size > 0 ) {
      delete [] _pbase;
   }
}

//--------------------------- registerObject ----------------------------------
int ObjectRegistrar::registerObject( SMIObject * const pSmiObj) {
   SMIObject** pbasenew;


    if( _num >= _size ) {
       pbasenew = new SMIObject* [_size+10];
       assert (!pbasenew == 0);
       if ( _size > 0 ) {
          for ( int i=0; i<_size; i++) {
              pbasenew[i] = _pbase[i];
          }
          delete [] _pbase;
       }
       _pbase = pbasenew;
       _size = _size + 10;
    }
    _pbase[_num] = pSmiObj;
    _num++;

    return 1;
}

//---------------------------- gimePointer ------------------------------------
SMIObject *ObjectRegistrar::gimePointer(const Name& objname) const {
   Name temp_name;
   SMIObject* pObj;
//   cout << " Looking for : " << objname << endl;
//   cout.flush();

   if ( _num == 0 ) { 
      cout << " no objects registered " << endl;
      cout.flush();
      abort();
   }

   for (int io = 0; io < _num; io++) {
      pObj = _pbase[io];
//      cout << " io " << io << " _pbase[io] " << _pbase[io] << endl;
//      cout.flush();
      temp_name = pObj->name();
//      cout << temp_name << endl;
//      cout.flush();
      if ( objname == temp_name ) {return _pbase[io];}
   }   

   return 0;
}

SMIObject *ObjectRegistrar::gimePointer(const char* objname) const {
   Name temp_name;

   temp_name = objname;

   SMIObject* crap=gimePointer(temp_name);
   return crap;
}


SMIObject *ObjectRegistrar::gimePointer(const int inx) const {

   if ( inx >= _num || inx < 0) { 
      cout << " illegal index : " << inx << endl;
      cout.flush();
      abort();
   }


   return _pbase[inx];
}
//--------------------------- numOfObjects ------------------------------------
int ObjectRegistrar::numOfObjects() const {
   return _num;
}

//--------------------------- gimeName ----------------------------------------
int ObjectRegistrar::gimeName(const int inx, char* objname) const {
   int iassoc, numSubobj;

   if ( inx >= _num || inx < 0) { 
      cout << " illegal index : " << inx << endl;
      cout.flush();
      abort();
   }

   iassoc = _pbase[inx]->name(objname,&numSubobj);

   return 1;
}

