//---------------------- Scheduler   Class ---------------------------
#ifndef SCHEDULER_HH
#define SCHEDULER_HH
#include <fstream.h>
#include "parameters.hh"
#include "objectregistrar.hh"
#include "smiclass.hh"

#include "commhandler.hh"
#include "queue_twonames.hh"

//                                                          8-November-1996
//                                                            B. Franek
//--------------------------------------------------------------------------


class Scheduler {
public :
  Scheduler
  ( CommHandler *pCommHandler,
    Queue_TwoNames *pStateQ, Queue_TwoNames *pExternalActionQ );

  void initialise();

  void execute();
private :

  int guardianOK(const Name& objectstring, Name& actionstring);

  CommHandler *_pCommHandler;
  Queue_TwoNames *_pStateQ;
  Queue_TwoNames *_pExternalActionQ;

  void handleWhens(char *objName);   // name of the object that triggered
//                                   // this call by reaching a state 
};
#endif
