//------------------------  Class   S e t I n s  -----------------------------
#include <iostream.h>
#include <stdio.h>
#include <assert.h>
#include "utilities.hh"
//-------------------- Externals -----------------
#include "objectregistrar.hh"
   extern ObjectRegistrar allSMIObjects;
   extern  Name smiDomain;
//-------------------------------------------------
#include "setins.hh"
#include "smiobject.hh"
#include "parms.hh"
//                                                      Date : 14-Jun-1998
//                                                     Author: Boda Franek
//---------------------------- SetIns -------------------------------------
//

SetIns::SetIns
       ( char lines[][MAXRECL], const int lev, int& no_lines,
         SMIObject *pobj, Action* pact){

   _level = lev;

   _pParentObject = pobj;

   _pParentAction = pact;

   sscanf(lines[1],"%d",&_insType);

   Parms *pObjParms = _pParentObject->pObjectParameters();


   char tempstr[MAXRECL];

   if ( _insType == 1 ) {
       //  set Par = val
       strcpy(tempstr,lines[2]);
       _objectParamNm = tempstr;
       strcpy(tempstr,lines[3]);
       _value = tempstr;
//     check for type correctness
       Name value; char type[7];
       if( pObjParms->get(_objectParamNm,value,type) == 0 ){
          cout << " Set instruction: Param " << _objectParamNm << 
                " is not declared" << endl;
          cout.flush();
          abort();
       }
       if      ( !strcmp(type,"STRING") && check_string(_value) ){}
       else if ( !strcmp(type,"INT")    && check_int(_value)    ){}      
       else if ( !strcmp(type,"FLOAT")  && check_float(_value)  ){}
       else {
          cout << " Set instruction: Param " << _objectParamNm 
               << " is illegal type" <<  endl;
          cout.flush();
          abort();
       }
       no_lines =4;
       return;
     }



     else if ( _insType == 2 ) {
//     Set OBJPAR = ACTIONPAR
       strcpy(tempstr,lines[2]);
       _objectParamNm = tempstr;
       strcpy(tempstr,lines[3]);
       _actionParamNm = tempstr;
//     check for type correctness
       Name valueo,valuea;
       char typeo[7],typea[7];
       if( pObjParms->get(_objectParamNm,valueo,typeo) == 0 ){
           cout << " Set instruction:Object Param " << _objectParamNm <<
                " is not declared" << endl;
          cout.flush();
          abort();
       }

       Parms* pActParms = _pParentAction->pDeclaredParms();

       if( pActParms->get(_actionParamNm,valuea,typea) == 0 ){
           cout << " Set instruction: Action Param " << _actionParamNm <<
                " is not declared" << endl;
          cout.flush();
          abort();
       }
       if ( strcmp(typeo,typea) ) {
          cout << " Set instruction: Action Param " << _actionParamNm 
               << " has incompatible type with Object Param " 
               << _objectParamNm << endl;
          cout.flush();
          abort();
       }       
       no_lines =4;
       return;
     }

     else if ( _insType == 3 ) {
//     Set OBJPAR = OBJNAME<OBJPAR>
       strcpy(tempstr,lines[2]);
       _objectParamNm = tempstr;
       strcpy(tempstr,lines[3]);
       _otherObjectNm = tempstr;
       strcpy(tempstr,lines[4]);
       _otherParamNm = tempstr;
       Name valueo;
       char typeo[7];
       if( pObjParms->get(_objectParamNm,valueo,typeo) == 0 ){
           cout << " Set instruction:Object Param " << _objectParamNm <<
                " is not declared" << endl;
          cout.flush();
          abort();
       }
// It is imposible to check anything about the other object or for type 
// correctness because the other object does need to be initialised 
// at this stage yet.
       no_lines =5;
       return;
     }

    else { 
       cout << " Set instruction type " << _insType << 
               " not yet implemented" << endl;
       cout.flush();
       abort();
     }
}






//---------------------------- whatAreYou ---------------------------------

void SetIns::whatAreYou(){
}


//----------------------------  execute  ---------------------------------------
//
//
int SetIns::execute(char* pendState){
//
//
   Parms *pObjParms = _pParentObject->pObjectParameters();

   int dbg = 1;
   if ( dbg > 0 ) {
       cout << "  " << endl;
       cout << " --------------------------------------------------" << endl;
       cout << " Executing Set instruction Type: " << _insType << endl;
       cout << " Object parameters before : " << endl;
       pObjParms->out();

       if ( _insType == 1 ) {
          cout << " Param  " << _objectParamNm << " set to " << _value << endl;
       }
       else if (_insType == 2 ) {
          cout << " Param  " << _objectParamNm << " set to incomming parm " 
               << _actionParamNm << endl;
       }
       else if (_insType == 3 ) {
          cout << " Param  " << _objectParamNm << " set to parameter "
               << _otherParamNm << " of object " << _otherObjectNm << endl;
       }
   }

   if (_insType == 1 ) {
      if( pObjParms->set( _objectParamNm, _value) != 1 ) {
         cout << " Set instruction :  Parameter :" << _objectParamNm 
              << " not set " << endl; 
//            1...updated   2...not found  
         cout.flush();
         abort();
      }
   }

   else if (_insType == 2 ) {
      Name namea,valuea;
      char typea[7];

      Parms* pCurParms = _pParentAction->pCurrentParameters();

       if( pCurParms->get(_actionParamNm,valuea,typea) == 0 ){
           cout << " Set instruction: Action Param " << _actionParamNm <<
                " is not present" << endl;
          cout.flush();
          abort();
       }
       if ( pObjParms->set(_objectParamNm,valuea) != 1) {}
   }



   else if (_insType == 3 ) {
       SMIObject *pSMIObj = allSMIObjects.gimePointer(_otherObjectNm);
       Parms *pOtherObjectParms = pSMIObj->pObjectParameters();
       Name value;
       char type[7];
       if ( pOtherObjectParms->get(_otherParamNm,value,type) == 0 ) {
          cout << " Executing Set instr. Object " << _otherObjectNm
               << " does not have parameter " << _otherParamNm << endl;
          cout.flush();
          abort();
       }
       Name typeNm = type;
       if ( pObjParms->set(_objectParamNm,value,typeNm) != 1) {
          cout << " Set instruction failed because the parameter " 
               << _otherParamNm << endl
               << " of object " << _otherObjectNm 
               << " either does not exists or has incompatible type" << endl;
          cout.flush();
          abort();
       }      
   }

   else {
        cout << " Internal error, unknown type " << _insType << endl;
        cout.flush();
        abort();
   }

   if ( dbg > 0 ) {
       cout << " Object parameters after : " << endl;
       pObjParms->out();
       cout << " --------------------------------------------------" << endl;
   }

   return 0;         // set instruction allways finishes
}


