//--------------------------  SMIObject Class  -----------------------------------
//#define FAST_SMI
#include <iostream.h>
#include <stdio.h>
#include <assert.h>
#include "utilities.hh"
//----------- Externals ------------------
#include "queue_name.hh"
   extern Queue_Name executableObjectQ;
#include "objectregistrar.hh"
   extern ObjectRegistrar allSMIObjects;
#include "ifhandler.hh"
   extern IfHandler ifHandler;
//---------------------------------------
#include "smiclass.hh"
#include "smiobject.hh"
#include "commhandler.hh"
//                                                         19-August-1996
//                                                          B. Franek
//---------------------------------------------------------------------------
//
typedef char OBJLINE[MAXRECL];

SMIObject::SMIObject
 ( const SMIClassRegistrar* const pAllClasses,
    char lines[][MAXRECL]){


    _lock = 0;

//  0th line is:*OBJECT

   char objnm_temp[MAXRECL];
   strcpy(objnm_temp,lines[1]);
   _objectName = objnm_temp;

#ifdef DEBUG
   cout << " Object : " << _objectName << " \n";
   cout.flush();
#endif
   allSMIObjects.registerObject(this);

   _numOfStates = 0;

   sscanf(lines[2],"%d %d %d",&_classFlag,&_numOfAtributes,&_associated);
   assert ( _numOfAtributes < MAXATRIBUTES );

   int lin;
   lin = 3;

   if ( _classFlag != 0 ) {
      sscanf(lines[3],"%s",_className);
      lin = 4;
   }

   if ( _numOfAtributes > 0 ) {
      for ( int ia=0; ia<_numOfAtributes; ia++) {
         _atribute[ia] = lines[lin];     // Read in the atributes
         lin++;
      }
   }

   if ( _classFlag != 0 ) {   //---- The object belongs to a class
      SMIClass *ptnr;
//      char clines[MAXCLASSLINES][MAXRECL];
	  OBJLINE *clines;
	  clines = new char[MAXCLASSLINES][MAXRECL];
      ptnr = pAllClasses->gimePointer(_className);

//      cout << "Object belongs to class : " << _className << "\n";

      int nl;
      nl = ptnr->numOfLines();

      for (int il=0; il<nl; il++) {  //---- Get the lines from the class
         ptnr->gimeLine(il,clines[il]);
//         cout << clines[il] << "\n";
      }
//  line 0 is *CLASS;  line 1 is the 'class name'; line 2 is num of attributes;
      int numOfClassAtributes;
      sscanf(clines[2],"%d",&numOfClassAtributes);

//      cout << "The class has " << numOfClassAtributes << " atributes \n";

      int icl;
      icl = 3;
      int ipom = 0;
      if ( numOfClassAtributes != 0 ) {  //--- Add the class atributes to object
         for ( int ica=0; ica<numOfClassAtributes; ica++) {
            _atribute[_numOfAtributes+ica] = clines[icl];
            if(_atribute[_numOfAtributes+ica] == "ASSOCIATED" ){ipom=1;}
            icl++;
//            cout << _atribute[_numOfAtributes+ica] << "\n";
         }
         _numOfAtributes = _numOfAtributes + numOfClassAtributes;
      }            
      if ( ipom == 1 ) { _associated = 1;}    // class atribute is stronger
      bodyLog(&clines[icl]);
   }
   else {   //---- The object does not belong to a class
      bodyLog(&lines[lin]);
   }

   print_obj(_objectName);

   if ( _objectParameters.numOfEntries() != 0 ) {
      cout << " Params : " << _objectParameters.numOfEntries();
   }

   cout <<  endl;
   cout.flush();

   return;
}

void SMIObject::bodyLog( char lines[][MAXRECL]) {
//---
// This processes the object following the atributes
// These are obtained either from the object or from the class
//---

  _numOfSubobjects = 0;

  int lin = 0;

// If the object has any parameters, they should be here
   if ( !strcmp(lines[lin],"*PARAMETERS" ) ){
       lin++;
       char tempStr[MAXRECL];
       Name parName,parVal,nodef="&nodefault";
       char parType[MAXRECL];
       for (;;) {
          if ( !strcmp(lines[lin],"*END_PARAMETERS") ) { lin++; break; }
          strcpy(parType,lines[lin]);
          lin++;
          strcpy(tempStr,lines[lin]);
          parName = tempStr;
          lin++;
          strcpy(tempStr,lines[lin]);
          parVal = tempStr;
          lin++;
          if ( parVal == nodef ) { _objectParameters.add(parName,parType); }
          else            { _objectParameters.add(parName,parVal,parType); }
       }
   }


  int dead_state_declared = 0;
  int initial_state_declared = 0;

  for ( ;; lin++) {
     if (!strcmp(lines[lin],"*END_OBJECT")) {break;}

     else if (!strcmp(lines[lin],"*END_CLASS")) {break;}

     else if (!strcmp(lines[lin],"*END_SUBOBJECT")) {

         if ( dead_state_declared == 0 ) {
            _pState[_numOfStates] = 
               new State("DEAD",this);
             assert ( _pState[_numOfStates] != 0 );
            _numOfStates++;
            assert( _numOfStates < MAXSTATES );
         }

         if ( initial_state_declared == 0 ) {
            _pState[_numOfStates] = 
               new State("&INITIAL",this);
             assert ( _pState[_numOfStates] != 0 );
            _numOfStates++;
            assert( _numOfStates < MAXSTATES );
         }

         _numOfSubobjStates[_numOfSubobjects-1] = _numOfStates
                                              - _stateIndex[_numOfSubobjects-1];
          continue;
     }

     else if (!strcmp(lines[lin],"*SUBOBJECT")) {
        lin++ ;
        dead_state_declared = 0; initial_state_declared = 0;
        _subobject[_numOfSubobjects] = lines[lin];
        _stateIndex[_numOfSubobjects] = _numOfStates;
        assert ( _numOfSubobjects < MAXSUBOBJECTS );
#ifdef DEBUG
        cout << " subobobject : " << _subobject[_numOfSubobjects] << " \n";
        cout.flush();
#endif
        _numOfSubobjects++;
     }

     else if (!strcmp(lines[lin],"*STATE")) {
        int st_lines;  //  and the number of state lines
        _pState[_numOfStates] = 
               new State(&lines[lin],this, &st_lines);
        assert ( _pState[_numOfStates] != 0 );
        if ( _pState[_numOfStates]->deadState() ) {dead_state_declared = 1;}
        if ( _pState[_numOfStates]->initialState() ) {initial_state_declared = 1;}
        _numOfStates++;
        assert( _numOfStates < MAXSTATES );

//        cout << " No of state lines : " << st_lines << "\n";
        lin = lin + st_lines - 1;
     }
     else { 
        cout << "Strange sequence " << lines[lin] << " encountered\n";
	    cout.flush();
	 }

  }


  return;
}


void SMIObject::whatAreYou() {

   cout << "\n \n" << " Object : " << _objectName ;

   if (_numOfAtributes > 0 ) {
      for ( int ia=0; ia<_numOfAtributes; ia++) {
         cout << "/" << _atribute[ia];
      }
   }

     cout << "\n";

//   cout << " Number of states : " << _numOfStates << "\n";

   if (_numOfSubobjects > 1 ) {
      for (int isub=0; isub<_numOfSubobjects; isub++) {
          cout << "\n";
          cout << " subobject : " << _subobject[isub] << "\n";
          cout << _stateIndex[isub] << _numOfSubobjStates[isub] << "\n";
          for (int ist1=0; ist1 < _numOfSubobjStates[isub]; ist1++) {
              _pState[_stateIndex[isub]+ist1]->whatAreYou();
          }          
      }
   }          
   else {
      for (int ist=0; ist<_numOfStates; ist++){
//      cout << _pState[ist] << "  " << _pState[ist]->stateName() << "\n";
         _pState[ist]->whatAreYou();
      }
   }
   cout.flush();
  return;
}

//**************************  startUP  *************************************
// Logical objects will determine their initial state. That is either the state
// that is marked /initial or the first state. They will then inject this state
// on the stateQ and will wait for it to come back.
//
// Associated objects will also startup in initial state which is either
// declared /initial_state or it will be called &INITIAL

void SMIObject::startUp( Queue_TwoNames* pStateQ, CommHandler *pCommHandler){

   _pStateQ = pStateQ;
   _pCommHandler = pCommHandler;
//
//---  First determine what is the object's initial state
//
   if ( _associated == 0 ) {                          //---  Logical object
//------ Determine if there is the initial state declared
      _currStateInx = 0;
      for ( int is=0; is<_numOfStates; is++) {
         if ( _pState[is]->initialState() ) {
            _currStateInx = is;
            break;
         }
      }  
#ifdef DEBUG
      print_obj(_objectName);
      cout  << " starting up in state :" 
            << _pState[_currStateInx]->stateName() << "\n";
      cout.flush();
#endif
//---  add to the State Q
      TwoNames  stateInfo;
      stateInfo.set(_objectName,_pState[_currStateInx]->stateName());
      pStateQ->add(stateInfo);
      strcpy(_internalState,"WaitSetState");
   }
   else                    {                            //---  Associated object
      for ( int isub=0; isub<_numOfSubobjects; isub++) {
         _currStateInxes[isub] = stateInxInitialState(isub);
         if ( _currStateInxes[isub] == -1 ) {
            print_obj(_objectName);
            cout << " Initial state does not exists " << endl; cout.flush();
            abort();
         }
      }
//
      if ( _numOfSubobjects == 1 ) {
          _currStateInx = _currStateInxes[0];
      }

      Name curr_state = currentState();
//
//#ifdef DEBUG
      print_obj(_objectName);
      cout << " starting up in state :" << curr_state << "\n";
      cout.flush();
//#endif
      strcpy(_internalState,"WaitSetState");
   }
}


//*****************************  setState  *********************************

void SMIObject::setState( const Name& statestr) {
#ifndef FAST_SMI
   print_obj(_objectName);
   cout << " in_state : " << statestr << "\n";
   cout.flush();
#endif


   if ( _objectName.exists("::&ALLOC") ) { setStateAlloc(statestr); return; }

   Name stateNm,paramStr;
   split(statestr,stateNm,paramStr); 

   if ( stateNm == "$DEAD" ) {}
   else {
      if ( _associated != 0 ) { // Only external objects
//                                 carry param string
         if( _objectParameters.setFromParmString(paramStr) != 1 ) {
            cout << " Parameter string " << paramStr << endl
                 << " incompatible with the object parameters " << endl;
            cout.flush();
            abort();
         }
      }
   }

//
   if (_associated == 0) {        //---------------------------- logical object
//                                For logical object, the set State call is 
//                                caused by the object previously injecting
//                                its state onto the state queue and setting its
//                                internal state to "WaitSetState"          
      if ( strcmp(_internalState,"WaitSetState") ) {
         cout << " Object not in the correct internal state";
         cout.flush();
         exit(1);
      }
      strcpy(_internalState,"Idle");
      if ( _pState[_currStateInx]->stateName() == stateNm) {}
      else {
         cout << " Logic failure...the current state is supposed to be :"
              << _pState[_currStateInx]->stateName() << "/n";
         cout.flush();
         exit(1);
      }
   }                               //--------------------
//
   else {                          //---------------------- associated object
//                                   for these objects setState is the conseq.
//                                   of either an action having been sent to
//                                   the remote proxy or it is a spontaneous
//                                   change of state.
//
      if ( stateNm == "$DEAD" ) {  //--- $DEAD state (same string regardless
//                                       the number of subobjects)
//                                       indicating that the conection was lost
         for ( int isub=0; isub<_numOfSubobjects; isub++) {
            _currStateInxes[isub] = stateInxDeadState(isub);
            if ( _currStateInxes[isub] == -1 ) {
               print_obj(_objectName);
               cout << " Dead state does not exists " << endl; cout.flush();
               abort();
            }
         }
//
         if ( _numOfSubobjects == 1 ) {
             _currStateInx = _currStateInxes[0];
         }

      }                                //----- end $DEAD state

      else {                           //------ normal state
         setCurrStateInxes( stateNm ) ;
      }                                //---------- end normal state

#ifdef DEBUG
      Name curr_state = currentState();
      cout << " Current state after setState " << curr_state << "\n";
      cout.flush();
#endif


   }


// Having accepted setState, the only possible internal state is "Idle"
// unless it was locked associated object
   if ( strcmp(_internalState,"Locked") ) {
        strcpy(_internalState,"Idle");
   }
   else {
      cout << " ********************* warning ****************" << endl;
      print_obj(_objectName);
      cout << " is locked ! " << endl;
   }
//
// If either of the actions queues has actions, make it executable
   if ( !_hpActionQ.isEmpty() || !_actionQ.isEmpty() ) {
        executableObjectQ.add(_objectName);
   }

   return;
}
//-------------------------------  execute  ----------------------------------

void SMIObject::execute() {

//
// Are there any actions queued?
//
   if (_hpActionQ.isEmpty()  && _actionQ.isEmpty() ) {
#ifdef DEBUG
      print_obj(_objectName);
      cout << " no actions queued \n";        
      cout.flush();
#endif
      return;
   }
//
// First check if in a correct internal state  i.e. "Idle"
   if ( strcmp(_internalState,"Idle") ) {
#ifdef DEBUG
      print_obj(_objectName);
      cout << " is in internal state : " << _internalState << "\n";
      cout.flush();
#endif
      return;  // The action is left on the queue so it will be executed
//                sometimes in the future
   }
//---- Object is Idle and there are actions queued
   Name actionstr;
//
   if( !_hpActionQ.isEmpty() ) {    // Hight priority actions present
      actionstr = _hpActionQ.remove();

      print_obj(_objectName);
      cout << " executing High priority action : " << actionstr << "\n";
      cout.flush();

   }
   else  { 
      actionstr = _actionQ.remove();

      print_obj(_objectName);
      cout << " executing action : " << actionstr << "\n";
      cout.flush();

   }
//--------------
   if ( actionstr.exists("&lock/")) {
        _lock++;
        strcpy(_internalState,"Locked");
        Name clientObject;
        actionstr.element(1,'/',clientObject);        

//        print_obj(_objectName);
//        cout << " locked by  " << clientObject << "\n";
//        cout.flush();

        char temp[MAXNAMESIZE];
        clientObject.whatAreYou(temp,MAXNAMESIZE);
        char objnm_temp[MAXRECL];
        _objectName.whatAreYou(objnm_temp, MAXRECL);
        ifHandler.objectLocked(objnm_temp,temp);
        return;
   }
//
   _currentActionString = actionstr;
//
//------------
   int flag,ist;
   char newState[MAXNAMESIZE];

   if ( _associated == 0 ){             // Logical object
        _pCommHandler->publishBusy(this,actionstr.getString());
        executeState();
        return;
   }
   else {                               // Associated object
         if ( _numOfSubobjects <= 1 ) {
              flag = _pState[_currStateInx]->
                         execute_assoc( _currentActionString, _pCommHandler);
         }
         else {
                for (int iis = 0; iis < _numOfSubobjects; iis++ ) {
                         flag = _pState[_currStateInxes[iis]]->
                         execute_assoc( _currentActionString, _pCommHandler);
                         if ( flag == 1) { break; }
                }
         }
         if ( flag == -1 ) {
              _pCommHandler->invalidAction(this);
              print_obj(_objectName);
              cout << " can not execute the action in the current state \n";
              cout.flush();
// Make the object executable again if there actions queued
              if ( !_hpActionQ.isEmpty() || !_actionQ.isEmpty() ) {
                   executableObjectQ.add(_objectName);
              }
              return;
         }
         strcpy(_internalState,"WaitSetState"); // valid action was successfully
//                                                 dispatched
#ifdef DEBUG
         print_obj(_objectName);
         cout << " sends action to the remote object \n";
         cout.flush();
#endif
   }

 return;

}
//
//
//-------------------------------------------------------------------------
//
void SMIObject::resume() {

//   print_obj(_objectName);
// cout << " resuming action " << _currentActionString << "\n";
//   cout.flush();
//
   if ( strcmp(_internalState,"Suspended") ) {
       cout << " the object is not in Suspended internal state\n";
       cout.flush();
       abort();
   }
//
   executeState();
   return;   
}


//**************************** executeWhens *********************************

void SMIObject::executeWhens(char * objName_newState) {

// This makes sence only for Logical objects
//
   if (_associated != 0) { return;}
//
//  check if in a correct internal state  
   if ( strcmp(_internalState,"Idle") && strcmp(_internalState,"Locked")) {
//      cout << "  Whens for object : " << _objectName <<
//              " ...is not in a stable state to execute whens \n";
      return;  
   }
//---- Object is either Idle or Locked

//   cout << "  Whens for object : " << _objectName <<
//           "  in state : " << _pState[_currStateInx]->stateName() << "\n";
   _pState[_currStateInx]->executeWhens(objName_newState);
   return;
}


//*****************************  queueAction *******************************

void SMIObject::queueAction ( Name& actionstr ) {

   print_obj(_objectName);
   cout  << " queuing action :" << actionstr << "\n";
   cout.flush();

   _actionQ.add(actionstr);
//   _actionQ.out();

   executableObjectQ.add(_objectName);

 return;

}


void SMIObject::queueAction ( char* actionstr ) {
   Name temp;
   temp = actionstr;
   queueAction(temp);
} 

//*****************************  queueHpAction *******************************

void SMIObject::queueHpAction ( Name& action_nm ) {
   print_obj(_objectName);
   cout  << " queuing high priority action :" << action_nm << "\n";
   cout.flush();
   _hpActionQ.add(action_nm);

   executableObjectQ.add(_objectName);

   return;
}

void SMIObject::queueHpAction ( char* action_nm ) {
   Name temp;
   temp = action_nm;
   queueHpAction(temp);
   return;
}


//*****************************  lock   *******************************

int SMIObject::lock ( char* objname ) {
#ifdef DEBUG
   cout << "  Object : " << _objectName;
   cout.flush();
#endif
   if ( _hpActionQ.isEmpty() && _actionQ.isEmpty() ) {   // action queues empty

        if ( !strcmp(_internalState,"Idle")  || 
             !strcmp(_internalState,"Locked")) {
             _lock++;
             strcpy(_internalState,"Locked");

//             print_obj(_objectName);
//             cout << " locked by " << objname << "\n";
//             cout.flush();

             return 1;
        }
   }

   char lockAction[MAXOBJECTNAME+6];
   strcpy(lockAction,"&lock/");
   strcat(lockAction,objname);
    _actionQ.add(lockAction);
    executableObjectQ.add(_objectName);

//    print_obj(_objectName);
//    cout << " lock queued by " << objname << "\n";
//    cout.flush();

    return 0;
}


//*****************************  unlock   *******************************

void SMIObject::unlock ( ) {

   if ( strcmp(_internalState,"Locked") ) {
      print_obj(_objectName);
      cout << " is not locked\n";
      cout.flush();
      exit(1);
   }

   _lock = _lock - 1;

   if ( _lock == 0 ) {
        strcpy(_internalState,"Idle");
   }

   executableObjectQ.add(_objectName);

//   print_obj(_objectName);
//   cout << " unlocking, Internal state after:" << _internalState << endl;
   cout.flush();

   return ;

}

//*****************************   name   ***********************************

int SMIObject::name ( char* obj_nm, int *numSubobj ) {

   _objectName.whatAreYou(obj_nm,MAXRECL);
   *numSubobj = _numOfSubobjects;

   return(_associated);

}

Name SMIObject::name () const {
return _objectName;
}
//------------------------  numSubobj() --------------
  int SMIObject::numSubobj() const {
     return _numOfSubobjects;
  }
//------------------------ associated() --------------  B. Franek  4-Feb-1999 -
  bool SMIObject::associated() const {
     return _associated;
  }
//************************************************************************
Name SMIObject::externDomain () const {

  Name domain = "\0", tempName;

  tempName = _objectName;

  char* ptnr = strstr(&tempName[0],"::");

  if (ptnr) {
     *ptnr = '\0';
     domain = &tempName[0];
  }
  return domain;
}

//---------------------------- subobjectName ------ B.Franek  4-Feb-1999 ---
  Name SMIObject::subobjectName(const int index) const {
     return _subobject[index];
  }
//*****************************  subobjectName  ****************************

void SMIObject::subobjectName ( int index, char* name ) {

   _subobject[index].whatAreYou(name,MAXNAMESIZE);

   return;

}
//-------------------------------------------------------------------------

Name SMIObject::currentState() const {
   if ( _numOfSubobjects <= 1 ) {
      return _pState[_currStateInx]->stateName(); 
   }

   Name temp = "\0";

   for ( int isub=0; isub < _numOfSubobjects; isub++ ) {
      if ( isub > 0 ) { temp += ","; }
      temp += _subobject[isub];
      temp += ".";
      temp += _pState[_currStateInxes[isub]]->stateName();
   }

   return temp;
}

//*****************************  currentState  ****************************

void SMIObject::currentState ( int index, State** pState ) {

    if (_numOfSubobjects <= 1) {
      *pState = _pState[_currStateInx];
    }
   else {
        *pState = _pState[_currStateInxes[index]];
    }

   return;

}

State* SMIObject::pCurrentState( const int index ) const {

    if (_numOfSubobjects <= 1) {
      return _pState[_currStateInx];
    }
   else {
        return _pState[_currStateInxes[index]];
    }

}
//*****************************  currentState  ****************************

int SMIObject::currentState ( char *subobjnm, char *statenm ) {

//  check if in a correct internal state  
   if ( strcmp(_internalState,"Idle") && strcmp(_internalState,"Locked")) {
      return -1;   // The object is busy  
   }


    if (_numOfSubobjects <= 1) {
          _pState[_currStateInx]->stateName().whatAreYou(statenm,256);
    }
   else {
         for ( int isub = 0; isub < _numOfSubobjects; isub++) {
             if ( _subobject[isub] == subobjnm  ) {
               _pState[_currStateInxes[isub]]->stateName().
                    whatAreYou(statenm,256);  
                  return 1;
             }
         }
         cout << " Subobject : " << subobjnm << " not found \n";
         cout.flush();
         exit(1);
    }

   return 1;

}


//
//
//---------------------------  executeState  --------------------------------
void SMIObject::executeState() {
//
        int flag,ist;
        char newState[MAXNAMESIZE];
//
        flag = _pState[_currStateInx]->
                   execute(_currentActionString, newState);
//           flag is either -1..action not found
//                           1..action terminated
//                           2..action suspended
//             cout << " flag : " << flag << "  newState : |" 
//                                      << newState << "| \n";  
//--------------
        switch (flag) {                             
        case 1 :                                     //--- action terminated
             print_obj(_objectName);
             cout << " action " << _currentActionString 
                  << " terminated in state " << newState << endl; cout.flush();
//           first find out which state it is
             _currStateInx = stateInx(newState);
//             cout << " _currStateInx = " << _currStateInx << " \n";
             if ( _currStateInx == -1 ) {    
                print_obj(_objectName);
                cout << " Action terminated with state :|" << newState << "| \n"
                     << " The object however does not have such state \n";
                cout.flush();
                abort();
             }
// add the state change (can be the same state) to the state q
//             cout << " StateQ before : \n";
//             _pStateQ->out();
             { char objnm_temp[MAXRECL];
             _objectName.whatAreYou(objnm_temp, MAXRECL);
             _pStateQ->add(objnm_temp,newState);}
#ifdef DEBUG
              print_obj(_objectName);
              cout << " end state " << newState << " ->StateQ \n";
              cout.flush();
#endif
//             cout << " \n StateQ after : \n";
//             _pStateQ->out();
// and wait for it
             strcpy(_internalState,"WaitSetState");
             break;
        case 2 :                                       //----- suspended
//             print_obj(_objectName);
//             cout << " action " << _currentActionString 
//                  << " suspended " << endl; cout.flush();
             strcpy(_internalState,"Suspended");
             break;
        case -1 :                                      //------- action not exists
              _pCommHandler->invalidAction(this);
              print_obj(_objectName);
              cout << " can not execute the action in the current state \n";
              cout.flush();
// Make it executable again if there actions queued
              if ( !_hpActionQ.isEmpty() || !_actionQ.isEmpty() ) {
                   executableObjectQ.add(_objectName);
              }
              return;
              break;
        default :
             print_obj(_objectName);
             cout << " flag = " << flag << "  this is an ilegal value \n";
             cout.flush();
             exit(1);
             break;
        }
//
        return;
}

//------------------------ parmString -----------  B.Franek   4-Feb-1999 ---
   Name SMIObject::parmString() const {
      Name tempName;
      _objectParameters.buildParmString(tempName);
      return tempName;
   }

void SMIObject::parmString(Name& str) const {

     _objectParameters.buildParmString(str);
}

void SMIObject::parmString(char* str, int mxsize) const {
    Name tempName;

    parmString(tempName);
    tempName.whatAreYou(str,mxsize);
}

Parms* SMIObject::pObjectParameters() {
    return &_objectParameters;
}

void SMIObject::split
           ( const Name& statestr, Name& stateNm, Name& paramStr) const {
    Name ststr = statestr;

    char* ptnr = strstr(&ststr[0],"/");

    if ( ptnr ) {  // state string contains /   -> it has parms
       *ptnr = '\0';
       stateNm = ststr;
       *ptnr = '/';
       paramStr = ptnr;
    }
    else {
       stateNm = statestr;
       paramStr = "\0";
    }

    return;
} 

//---------------------------------------------------  BF 14-Oct-1998 ---------

  int SMIObject::stateInx( const int isub, const Name& state ) const {

     if ( isub >= _numOfSubobjects ) {
        cout << " Illegal subobobject index " << endl; cout.flush(); abort();
     }

     for ( int ist=0; ist < _numOfSubobjStates[isub]; ist++ ) {
        if ( _pState[_stateIndex[isub]+ist]->stateName() == state ) {
           return _stateIndex[isub]+ist;
        }
     }
     return -1;
  }

//----------------------------------------------------------------------------
  int SMIObject::stateInx( const Name& stname) const {

     int inx = -1;
     for ( int i=0; i < _numOfStates; i++ ) {
        if ( stname == _pState[i]->stateName() ) { inx = i; break; }
     }

     return inx;
  } 


  int SMIObject::stateInx( const char stname[]) const {
     Name temp = stname;

     int inx = stateInx(temp);

     return inx;
  }

//---------------------------------------------------------------------------
  State* SMIObject::pTaggedState (const Name& tagname) const {
     for ( int i=0; i < _numOfStates; i++ ) {
        if ( tagname == _pState[i]->tagName() ) { return _pState[i]; }
     }

     return 0;
  }
//---------------------------------------------------------------------------

  int SMIObject::stateInxDeadState() const {

     for ( int i=0; i<_numOfStates; i++ ) {
        if ( _pState[i]->deadState() ) { return i; }
     }

     return -1;
  }
//-----------------------------------------------------BF 11-Oct-1998-------

  int SMIObject::stateInxDeadState(const int isub) const {

     if ( isub >= _numOfSubobjects ) {
        cout << " Illegal subobobject index " << endl; cout.flush(); abort();
     }

     for ( int ist=0; ist < _numOfSubobjStates[isub]; ist++ ) {
        if ( _pState[_stateIndex[isub]+ist]->deadState() ) {
           return _stateIndex[isub]+ist;
        }
     }
     return -1;
  }
//-----------------------------------------------------BF 11-Oct-1998-------

  int SMIObject::stateInxInitialState(const int isub) const {

     if ( isub >= _numOfSubobjects ) {
        cout << " Illegal subobobject index " << endl; cout.flush(); abort();
     }

     for ( int ist=0; ist < _numOfSubobjStates[isub]; ist++ ) {
        if ( _pState[_stateIndex[isub]+ist]->initialState() ) {
           return _stateIndex[isub]+ist;
        }
     }
     return -1;
  }

//-------------------------------------------------------------------------

  int SMIObject::stateInxTaggedState() const {
     Name tagname("&VARIABLE");

     for ( int i=0; i < _numOfStates; i++ ) {
        if ( tagname == _pState[i]->tagName() ) { return i; }
     }

     return -1;
  }

//-------------------------------------------------------------------------

  void SMIObject::setStateAlloc( const Name& statestr ) {
     Name stateNm,paramStr;

     split(statestr,stateNm,paramStr);

     if ( stateNm == "$DEAD" ) {
        _currStateInx = stateInxDeadState();
        if (_currStateInx < 0 ) {
           cout << " Dead state has to be declared " << endl; cout.flush();
           abort();
        }
     }
     else {
        if ( stateNm == "NOT_ALLOCATED" ) {
           _currStateInx = stateInx(stateNm);
        }
        else {
           _currStateInx = stateInxTaggedState();
           _pState[_currStateInx]->changeName(stateNm);
        }
     }

//   Having accepted setState, the only possible internal state is "Idle"
//
     strcpy(_internalState,"Idle");
//
//   If either of the actions queues has actions, make it executable
     if ( !_hpActionQ.isEmpty() || !_actionQ.isEmpty() ) {
        executableObjectQ.add(_objectName);
     }

  }

//--------------------------------------------------------  BF 14-Oct-1998 --

   void SMIObject::setCurrStateInxes( const Name& stateNm ) {

      if ( _numOfSubobjects <= 1 ) {
         _currStateInxes[0] = stateInx(stateNm);
         _currStateInx = _currStateInxes[0];
         if ( _currStateInx < 0 ) {
            print_obj(_objectName);
            cout << " does not have state " << stateNm << " declared" << endl;
            cout.flush();
            abort();
         }
         return;  
      }
      else {
         int elm = 0;
         Name subObjelement;  //  subobjname.state
         Name subobjname, state;

         while ( stateNm.element(elm,',',subObjelement) ) {
            elm++;
            if ( !subObjelement.element(0,'.',subobjname) ||
                 !subObjelement.element(1,'.',state)         ) {
               cout << " State string " << stateNm 
                    << " has illegal format" << endl; cout.flush(); abort();
            }

            int subFound = 0;
            for (int sub=0; sub < _numOfSubobjects; sub++) {
                if ( subobjname == _subobject[sub] ) {
                   _currStateInxes[sub] = stateInx(sub,state);
                   if (_currStateInxes[sub] < 0 ) {
                      cout << " subobject " << subobjname 
                           << " does not have state " << state << endl; 
                      cout.flush();
                      abort();
                   }
                   subFound = 1; break;
                }
            }

            if ( subFound == 0 ) {
               cout << " subobject " << subobjname 
                    << " does not exists " << endl;  cout.flush();
               abort();
            }
         }
         return;
      }
   }

//--------------------------------------------------------------------------
