//------------------------  SmpCond  Class ------------------------------------
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include "name.hh"
#include "smpcond.hh"
#include "assert.h"
//----------------- Externals --------------------
#include "objectregistrar.hh"
   extern ObjectRegistrar allSMIObjects;
   extern  Name smiDomain;
//------------------------------------------------
//                                                         B. Franek
//                                                         01-Aug-1996
//----------------------------------------------------------------------------


SmpCond::SmpCond ( char lines[][MAXRECL], int *no_lines) {
//-------------------------------------------------------------------------
// Input :
// lines[0] ....... the first line of the simple condition
// Output :
// no_lines ....... number of lines in the simple condition
//----------------------------------------------------------------------------
   int il;

   il = 0;

// Line 0 is the object name

   sscanf(lines[il],"%s",_objectStr);

//***********************************
   char *ptnr;

   if ( ptnr = strchr(_objectStr,'.') ) {   
       *ptnr =  '\0';
        ptnr++;
        strcpy(_objectName,_objectStr);
        strcpy(_subobjectName,ptnr);
        strcat(_objectStr,".");
        strcat(_objectStr,_subobjectName);
   }
   else {
        strcpy(_objectName,_objectStr);
        strcpy(_subobjectName," ");
   }
//**********************************

   il++;
// Line 1 is either  'in_state'   or  'not_in_state'

   if (!strcmp(lines[il],"in_state")) {
      _inState = 1;
   }
   else if (!strcmp(lines[il],"not_in_state")) {
      _inState = 0;
   }
   else {
      cout << " Error initialising Simple condition \n";
      cout.flush();
      exit(1);
   }

   il++;
// Line 2 is number of states


   sscanf(lines[il],"%d",&_noOfStates);
   assert ( _noOfStates > 0 );
   assert ( _noOfStates <= _maxStates );
    

   for (int ist=0; ist < _noOfStates; ist++) {
      il++;
      sscanf(lines[il],"%s",_states[ist]);
      if ( !strcmp(_states[ist],"&SMIDOMAIN") ) {
         smiDomain.whatAreYou(_states[ist],MAXNAMESIZE-1);
      }
   }


  *no_lines = il + 1;
  return ;

}


//--------------------------- whatAreYou --------------------------------------
void SmpCond::whatAreYou(int maxLen,char* condString) {
// Input:  maxLen ......Maximal length of the output string
// Output: condString ...output string

  char leftbr[] = "( ";  char rightbr[] = " )";
  char instate[] = " in_state "; char not[] = "not ";
  char leftCurl[] = "{"; char rightCurl[] = "}";
  char coma[] = ",";
// Allow at least for "( not " i.e. 6+1 = 7 characters

  if ( maxLen < 7 ) {
     cout << " SmpCond::whatAreYou| not enough room for the condString \n";
     cout.flush();
     exit(1);
  }

  int len;              // Length of the string (including 'null')
  strcpy(condString,leftbr);
  
  if ( _inState == 0) {
     strcat(condString,not);
  }
     
  len = strlen(condString) + 1;  // strlen does not include the 'null'

  int objnmLen;
  objnmLen = strlen(_objectStr);
  
  if ( maxLen < (len+objnmLen)) {
     cout << " SmpCond::whatAreYou| not enough room for the condString \n";
     cout.flush();
     exit(1);
  }

  strcat(condString,_objectStr);
  len = strlen(condString) + 1;

  if ( maxLen < (len+10)) {
     cout << " SmpCond::whatAreYou| not enough room for the condString \n";
     cout.flush();
     exit(1);
  }
  strcat(condString,instate);
  len = strlen(condString) + 1;

  if ( _noOfStates > 1 ) {
     if ( maxLen < (len + 1)) {
     cout << " SmpCond::whatAreYou| not enough room for the condString \n";
     cout.flush();
     exit(1);
     }
     strcat(condString,leftCurl);
     len = strlen(condString) + 1;
  }

  for (int ist=0; ist < _noOfStates; ist++) {
     int statenmLen;
     statenmLen = strlen(_states[ist]);

     if ( maxLen < (len+statenmLen+1)) {
        cout << " SmpCond::whatAreYou| not enough room for the condString \n";
        cout.flush();
        exit(1);
     }
     strcat(condString,_states[ist]);  
     strcat(condString,coma);
     len = strlen(condString) + 1;
  }

// Now get rid of the last coma

  len = len -1;
  condString[len-1] = '\0';     

  if ( _noOfStates > 1 ) {
     if ( maxLen < (len + 1)) {
     cout << " SmpCond::whatAreYou| not enough room for the condString \n";
     cout.flush();
     exit(1);
     }
     strcat(condString,rightCurl);
     len = strlen(condString) + 1;
  }

  if ( maxLen < (len+2)) {
     cout << " SmpCond::whatAreYou| not enough room for the condString \n";
     cout.flush();
     exit(1);
  }
  strcat(condString,rightbr);
  len = strlen(condString) + 1;
  return;
}


//---------------------------- evaluate ----------------------------------
int SmpCond::evaluate() {
//
  int flag;
  char subobjnm[MAXNAMESIZE];
  char statenm[MAXNAMESIZE];

#ifdef DEBUG
  cout  << _objectStr ;
  cout.flush();
#endif

  SMIObject *pSMIObj;
  pSMIObj = allSMIObjects.gimePointer(_objectName);
  flag = pSMIObj->currentState(_subobjectName,statenm);

  if ( flag < 0 ) {
#ifdef DEBUG
       cout << "  is busy \n";
       cout.flush();
#endif
       return -1;
  }
  else {
#ifdef DEBUG
       cout << " (" << statenm << ")";
       cout.flush();
#endif
  }
//
#ifdef DEBUG
  if ( _inState == 1) { cout << " in_state "; }
  else                { cout << " not_in_state "; }
  cout.flush();
#endif
//
  int found;
  found = 0;
#ifdef DEBUG
  cout << "  {" << _states[0] ;
  cout.flush();
#endif
  if (!strcmp(_states[0],statenm)) { found = 1; }
  for ( int is = 1; is < _noOfStates; is++ ) {
#ifdef DEBUG
        cout << "," << _states[is]; 
        cout.flush();
#endif
        if (!strcmp(_states[is],statenm)) { found = 1; }
  }
#ifdef DEBUG
  cout << "} ";
  cout.flush();
#endif
//
  int retflag;
  if ( _inState == 1 ) {
      if ( found == 0 ) {  retflag = 0; }
      else              {  retflag = 1; }
  }
  else {
      if ( found == 0 ) {  retflag = 1; }
      else              {  retflag = 0; }
  }


#ifdef DEBUG
  if ( retflag == 1 ) { cout << "... TRUE  \n";}
  else                { cout << "... FALSE \n";}
  cout.flush();
#endif
//
  return retflag;
}



//------------------------------  isPresent  ----------------------------------
//
bool SmpCond::isPresent( const char *objName) const {
//
   if ( !strcmp(objName,_objectName) ) { return 1; }
//
   return 0;
}


//------------------------------   objName  ------------------------------------
//
void SmpCond::objName(char *objName, int mxsize) {
//
   if( (strlen(_objectName)+1) > mxsize ) {
      cout << " SmpCond::objName...not enough room for obj name\n";
      cout.flush();
      exit(1);
   }
//
   strcpy(objName,_objectName);

}
