//--------------------------  S t a t e Class  ------------------------------
#include <iostream.h>
#include <assert.h>
#include <stdio.h>
#include "utilities.hh"
#include "state.hh"
#include "smiobject.hh"
#include "parms.hh"
//                                                         19-August-1996
extern Name smiDomain;
extern ObjectRegistrar allSMIObjects;
//                                                          B. Franek
//---------------------------------------------------------------------------
//
State::State( char lines[][MAXRECL],
               SMIObject* pobj,
               int *st_lines){

//
//  It will first instantiate the State object
//  It will then scan the input lines to extract actions. For every action
//  the subroutine process_action is called that will process it and returns
//  the pointer to the 'action' object. This pointer and the action name are
//  then saved in the 'state' object. The routine will return the number of
//  the state lines (st_lines) and the pointer to the 'state' object (pState).
//
// P.s.  0th line of the state is the line following the name of the state
//     

   _objName = pobj->name();

   char name[MAXRECL];
   strcpy(name,lines[1]);

   _stateName = name;

   _stateNametag = name;

   _pParentObject = pobj;

#ifdef DEBUG
   cout << " state : " << _stateName << "\n";
   cout.flush();
#endif

   sscanf(lines[2],"%d",&_numOfAtributes);
   assert ( _numOfAtributes < MAXATRIBUTES );

//   cout << " Atributes :" << _numOfAtributes << "\n";

   int lin;
   lin = 3;

   if ( _numOfAtributes > 0 ) {
      char atrib[MAXRECL];
      for ( int ia=0; ia<_numOfAtributes; ia++) {
         sscanf(lines[lin],"%s",atrib);     // Read in the atributes
         _atribute[ia] = atrib;
         lin++;
      }
   }



   _numWhens = 0;

   _numActions = 0;

   char action_nm[MAXNAMESIZE];

   int no_aclines;


//------------------- Loop over state lines untill *END_STATE found ----------



  for (;;lin++){
//    cout << lin << ": |" << lines[lin] << "|\n";
    if (!strcmp(lines[lin],"*END_STATE")) {
       *st_lines = lin+1;
       break;
    }

    else if (!strcmp(lines[lin],"*ACTION")) {

//--------
       Action *pAct;

       char objnm[256];
       _objName.whatAreYou(objnm,256);
       pAct = new Action
             (&lines[lin],action_nm,&no_aclines,objnm,_pParentObject,this);
// The subroutine returns pointer to the action and number of action lines
// when it encounteres *END_ACTION

//------------- The action pointer and its name is added to the state object
       assert ( _numActions < MAXACTIONS );
       _action[_numActions] = action_nm;
       _pAction[_numActions] = pAct;
       _numActions++ ;

//       cout << " No of action lines : " << no_aclines << "\n";
       lin = lin + no_aclines - 1;
    }

    else if (!strcmp(lines[lin],"*WHEN")) {
       int no_whlines;
       assert ( _numWhens < MAXWHENS );
       _pWhen[_numWhens] = new When(&lines[lin],&no_whlines,_pParentObject);
       _numWhens++;
       lin = lin + no_whlines - 1;
    }

    else {
       cout << "Strange sequence " << lines[lin] << " encountered\n";
       cout.flush();
       exit(1);
    }
  }


  return;
}
//...........................................................................
State::State( const char* const state_name, SMIObject* pobj ) {

   _stateName = state_name;

   _stateNametag = state_name;

   if ( _stateName == "DEAD" ) {
      _numOfAtributes = 1;
      _atribute[0] = "DEAD_STATE";
   }
   else if ( _stateName == "&INITIAL" ) {
      _numOfAtributes = 1;
      _atribute[0] = "INITIAL_STATE";
   }
   else { _numOfAtributes = 0; }

   _numWhens = 0;

   _numActions = 0; 

   _objName = pobj->name();

   _pParentObject = pobj;
}



//********************************  whatAreYou  ***************************

void State::whatAreYou() const {
  cout << "\n";
  cout << " state : " << _stateName ;


   if (_numOfAtributes > 0 ) {
      for ( int ia=0; ia<_numOfAtributes; ia++) {
         cout << "/" << _atribute[ia];
      }
   }

   cout << "\n";
   cout.flush();

   if (_numWhens > 0 ) {
      for ( int iw=0; iw<_numWhens; iw++) {
         _pWhen[iw]->whatAreYou();
      }
   }



   cout << " \n";
//  cout << " No. of actions : " << _numActions << "\n";

  if ( _numActions == 0 ) {return;}

  for (int i=0; i<_numActions; i++) {
//    cout << _pAction[i] << "  " << _action[i] << "\n";
    _pAction[i]->whatAreYou();
  }

  return;
}

//------------------------------- execute  (for Logical objects) ------------

int State::execute( const Name& actionstr, char* pnewState) const {
//
//  cout << " state : " << _stateName << " to execute action |" 
//                              << pname_act << "|\n \n";
//
  Name actionnm;
  actionstr.element(0,'/',actionnm);


  for (int i=0; i<_numActions; i++) {
    if ( _action[i] == actionnm ) {
      int temp = _pAction[i]->execute(pnewState,actionstr);
      if ( temp == 0 ) {  // This means that the last action instruction
//                           is not terminate_action instruction
           _stateName.whatAreYou(pnewState,256);
           return 1;
      }
      return temp;
    }
  }

//  cout << " action not found " << "\n";
  return -1;
}

//-------------------- execute_assoc  (for Associated objects) ------------

int State::execute_assoc
( const Name& actionstr, const CommHandler* const pCommHandler) const {
//
//  cout << " state : " << _stateName << " to execute action |" 
//                              << pname_act << "|\n \n";

// Extract action name
  Name actionnm;
  actionstr.element(0,'/',actionnm);

  if ( !actionExists(actionnm) ) { return -1; }  

  char actionstr_out[256];

  Parms inpars;
  inpars.initFromParmString(actionstr);

  Name remoteDomain = _pParentObject->externDomain();

  if ( remoteDomain == "\0" ) {} // proxy  
  else {  // this is an object in another domain (external)
     Name remAllocObject = remoteDomain;
     remAllocObject += "::";
     remAllocObject += "&ALLOC";
     SMIObject* pRemAllocObject = allSMIObjects.gimePointer(remAllocObject);

     if ( !pRemAllocObject ) {
        cout << " Remote domain " << remoteDomain << 
                " does not have &ALLOC object " << endl;
     }
     else {
        if ( pRemAllocObject->currentState() == "NOT_ALLOCATED" ||
             pRemAllocObject->currentState() == "NOT_THERE" ||
             pRemAllocObject->currentState() == smiDomain ) {}
        else { return -1; }
     } 

     if ( _objName.exists("&ALLOC") ) {  // this is even an allocation object
        inpars.clear();  // For this kind of object I know what the pars should be
        Name pname("ID");
        inpars.add(pname,smiDomain,"STRING");
     }
  }

  Name parmstr,temp;
  inpars.buildParmString(parmstr);
  temp = actionnm;
  temp += parmstr;
  temp.whatAreYou(actionstr_out,256);    

  char objnm[256];
  _objName.whatAreYou(objnm,256);

  pCommHandler->sendCommand(objnm,actionstr_out);
  return 1;

}

//---------------------------------  executeWhens  ---------------------------
//
void State::executeWhens(const char *objName_newState) const {
//
// Are there any whens to be executed?
//
//   cout << "  Number of whens : " << _numWhens << "\n";
   if ( _numWhens == 0 ) { return; }
//
//   cout << "\n Whens for object : " << _objName << "(" << _stateName << ") \n";
//
   for ( int iw = 0; iw < _numWhens; iw++) {
//       cout << "    " << iw << "\n";
       _pWhen[iw]->execute(objName_newState);
   }
}

//--------------------------------  initialState  ---------------------------

bool State::initialState() const {
   for (int ia=0; ia<_numOfAtributes; ia++) {
      if ( _atribute[ia] == "INITIAL_STATE" ) { return 1;}
   }   
   return 0;
}

//--------------------------------  deadState  -----------------------------

bool State::deadState() const {
   for (int ia=0; ia<_numOfAtributes; ia++) {
      if ( _atribute[ia] == "DEAD_STATE" ) { return 1;}
   }   
   return 0;
}

//-------------------------------- name -------------------------------------
Name State::stateName() const {
   return _stateName;
}
//-------------------------------- tagName ---------------------------------
Name State::tagName() const {
    return _stateNametag;
}

void State::changeName( const Name& name ) {
   _stateName = name;
}

//--------------------------- numActions ------   B.Franek   4-Feb-1999 ----
  int State::numActions() const {
     return _numActions;
  }
//---------------------------------  name  -----------------------------------

void State::name ( char *name, int *numActions) const {

        _stateName.whatAreYou(name,256);
	*numActions = _numActions;

	return;

}


//--------------------------------  action  ----------------------------------

void State::action ( const int index, Action** pAction ) const {

        if ( index >= _numActions ) {
            cout << " State::action ... invalid index \n";
            cout.flush();
            exit(1);
        }

        *pAction = _pAction[index];
	return;

}


void State::action ( const int index, char* action ) const {

        _action[index].whatAreYou(action,MAXNAMESIZE);

	return;

}
//----------------------------- actionString ----------------------------------
//   action/par1/par2=555/par3
//
  Name State::actionString( const int index ) const {

     if ( index >= _numActions ) {
         cout << " State::action ... invalid index \n";
         cout.flush();
         exit(1);
     }
//
    Action* pact = _pAction[index];
//
    Name temp;

    pact->actionString(temp);

    return temp;
  }

void State::actionString 
     ( const int index, char* actionstr, const int maxlen) const {
//

     if ( index >= _numActions ) {
         cout << " State::action ... invalid index \n";
         cout.flush();
         exit(1);
     }
//
    Action* pact = _pAction[index];
//
    Name temp;

    pact->actionString(temp);

    temp.whatAreYou(actionstr,maxlen);

    return;
   
}

bool State::actionExists( const Name& actionnm ) const {

  for (int i=0; i<_numActions; i++) {
    if (  _action[i] == actionnm ) {
      return 1;
    }
  }

  return 0;
}
