//---------------------- S t a t e   Class ---------------------------
#ifndef STATE_HH
#define STATE_HH

#include "parameters.hh"
#include "action.hh"
#include "when.hh"
#include "commhandler.hh"
class SMIobject;
class When;
class CommHandler;
class Name;
//                                                 Author: B. Franek
//                                                 Date : May-1996
//----------------------------------------------------------------------------

class State {
public :
  State ( char lines[][MAXRECL],
           SMIObject* pobj,
           int *st_lines);

  State ( const char* const state_name, SMIObject* pobj );

  void whatAreYou() const;
//
  int execute( const Name& actionstr,char* pnewState) const;
//
  int execute_assoc
      ( const Name& actionstr, const CommHandler* const pCommHandler) const;
//                       Special for associated objects 
//                       Return value
//                       is 1(OK) or 
//                       -1...action not found
//
  void executeWhens(const char *objName) const; // Object that just changed its state
//
  bool initialState() const;

  bool deadState() const;

  Name stateName() const;

  int numActions() const;

  Name tagName() const;

  void changeName( const Name& name );

  void name(char* name, int *numActions) const;

  void action( const int index, Action** pAction) const;

  void action( const int index, char* action) const;

  void actionString( const int index, char* actionstr, const int maxsize) const;

  Name actionString( const int index ) const;

  bool actionExists( const Name& actname) const;

private :
  Name _stateName;             // State name

  Name _stateNametag;   //e.g. &VARIABLE

  int _numOfAtributes;
  Name _atribute[MAXATRIBUTES];

  int _numWhens;
  When *_pWhen[MAXWHENS];


  int _numActions;
  Name _action[MAXACTIONS];  // List of actions
  Action *_pAction[MAXACTIONS];        // List of pointers to actions          

  Name _objName;    // Name of the object to which 
//                                        the state belongs
  SMIObject *_pParentObject;
};
#endif
