//----------------------  Class   Name  ---------------------------------
//
//                                                      Author: Boda Franek
//                                                      Date : 28 December 1996
//----------------------------------------------------------------------------
#ifndef NAME_HH
#define NAME_HH
#include <iostream.h>
#include "typedefs.hh"

class Name {
   public :
      Name();

      Name(const char* );

      Name(const Name& );

      Name& operator=(const Name &);

      Name& operator=(const char *);

      Name& operator+= (const Name &);

      Name& operator+= (const char *);

      int length() const;

      char& operator[] (const int elem) const;

      void append(const Name& name);

      void append(const char*);

      bool element(const int num, const char delim, Name& elem) const;

      bool elementSp(const int num, const char delim, Name& elem) const;

      bool exists(const char* str) const; // checks if the string is part of the name
      
      bool exists(const Name& ) const;

      int existsAt(const char* str) const; // returns the index of the first
                                           // char otherwise 0
      char* getString() const; // returns the pointer to the first char
      
      void replace(const Name& oldstr, const Name& newstr); 
                          // will replace all occurences of string oldstr by
                          // newstr

      void squeeze();

      void trim();

      void upCase();
                                        
      friend bool operator == (const Name &, const Name &);
                                                                             
      friend bool operator == (const Name &, const char[]);
 
      friend ostream& operator<<(ostream&, const Name& );

      virtual ~Name();

      void whatAreYou(char* str, const int mxsize) const;

      void out() const;
//
//
   protected :
      int _size;
      char *_ptn;
};

#endif
