//----------------------  Class   SMLline  ---------------------------------
//
//                                                      Author: Boda Franek
//                                                      Date : 15 December 1998
//----------------------------------------------------------------------------
#include <string.h>
#include "smlline.hh"
#include "utilities.hh"

  SMLline::SMLline() {
     _lineNum = 0;
  }

  SMLline::~SMLline() {
  }

  SMLline::SMLline(const int linnum, const Name& name) : Name(name) {
     _lineNum = linnum;
  }

  SMLline& SMLline::operator=(const SMLline& line) {
    Name::operator= (line);
    _lineNum = line._lineNum;
    return *this;
  }


  bool SMLline::commentLine() {
// Line, which is empty, or full of blanks, or the first non-blank character
// is !  or #

     if ( !strtok(_ptn," ") ) { return 1;}  // empty or only blanks

     *(_ptn+strlen(_ptn)) = ' ';

     char* ptn = strchr(_ptn,'!');

     if (ptn) {
        *ptn = '\0';
        if( !strtok(_ptn," ") ) {  *ptn = '!'; return 1;}
        *(_ptn+strlen(_ptn)) = ' ';
        *ptn ='!';
     }
     ptn = strchr(_ptn,'#');

     if (ptn) {
        *ptn = '\0';
        if( !strtok(_ptn," ") ) {  *ptn = '#'; return 1;}
        *(_ptn+strlen(_ptn)) = ' ';
        *ptn ='#';
     }

     return 0;
  }

  bool SMLline::objectLine
               (Name& name, int& smiClass, int& assoc, Name& isOfClass) {

     char* ptn;
     ptn = strstr(_ptn,":");
     if ( !ptn ) {return 0;}

     Name token;
     ptn = getToken(_ptn, ':',token );

     char* pStr = token.getString();

     if      ( !strcasecmp(pStr,"object") ) { smiClass = 0;} 
     else if ( !strcasecmp(pStr,"class") )  { smiClass = 1;} 
     else { return 0;}

     Name aftercol;
     ptn = getToken(ptn,'/',aftercol);
     aftercol.upCase();
     char* paftercolstr = aftercol.getString();

     if ( aftercol.exists("IS_OF_CLASS") ) {
        char* ppp = getToken(paftercolstr,' ',name);
        Name temp;
        ppp = getToken(ppp,' ',temp);
        getToken(ppp,'/',isOfClass);
     } 
     else { name = aftercol; isOfClass = "\0"; }

     assoc = 0;
     for ( ; ptn != 0; ) {
        ptn = getToken(ptn,'/',token);
        pStr = token.getString();
        if ( !strcasecmp(pStr,"associated") ) { assoc = 1; break;}
     }
     return 1;
  }

  bool SMLline::objectSetLine
               (Name& name, Name& isOfClass) {

     char* ptn;
     ptn = strstr(_ptn,":");
     if ( !ptn ) {return 0;}

     Name token;
     ptn = getToken(_ptn, ':',token );

     char* pStr = token.getString();

     if      ( strcasecmp(pStr,"Object_Set") ) { return 0;} 

     Name aftercol;
     ptn = getToken(ptn,'=',aftercol);
     aftercol.upCase();
     char* paftercolstr = aftercol.getString();

     if ( aftercol.exists("IS_OF_CLASS") ) {
        char* ppp = getToken(paftercolstr,' ',name);
        Name temp;
        ppp = getToken(ppp,' ',temp);
        getToken(ppp,'/',isOfClass);
     } 
     else { name = aftercol; isOfClass = "VOID"; }
     return 1;
  }
//------------------------------------------------------------------
  bool SMLline::parametersLine() {

     char* ptn;
     ptn = strstr(_ptn,":");
     if ( !ptn ) {return 0;}

     Name token;
     ptn = getToken(_ptn, ':',token );

     char* pStr = token.getString();

     if      ( strcasecmp(pStr,"Parameters") ) { return 0;} 
     return 1;
  }
//--------------------------------------------------------------
  bool SMLline::stateLine( Name& name ) {

     char* ptn;
     ptn = strstr(_ptn,":");
     if ( !ptn ) {return 0;}

     Name token;
     ptn = getToken(_ptn, ':',token );

     char* pStr = token.getString();

     if      ( strcasecmp(pStr,"State") ) { return 0;} 

     Name aftercol;
     ptn = getToken(ptn,'/',name);
     name.upCase();
     return 1;
  }
//--------------------------------------------------------------
  bool SMLline::actionLine( Name& name ) {

     char* ptn;
     ptn = strstr(_ptn,":");
     if ( !ptn ) {return 0;}

     Name token;
     ptn = getToken(_ptn, ':',token );

     char* pStr = token.getString();

     if      ( strcasecmp(pStr,"Action") ) { return 0;} 

     Name aftercol;
     ptn = getToken(ptn,'/',name);
     name.upCase();
     return 1;
  }


  void SMLline::out() const {
     cout << _lineNum << ":" << _ptn << endl;
  }


  ostream& operator<<(ostream& os, const SMLline& line) {
     os << line._lineNum << ": " << line._ptn ;
     return os;
  }
