/* AffairCollector
 * gathers system data and sends to AffairMonitor
 *
 * Start Date    : 1-8-2001
 * Written by    : tome.anticic@cern.ch
 */


#include "CollectorSYSMON.h"

int startFlag = 0;

////////////////////////////////////////////////////////////////////////////////////////////////
void startCollecting(tag, buf, size)
    int *tag, *size;
    char *buf;
{

    char    **argv;
    int     argc;

    int timeIndex            = 3;
    int disk1Index           = 5;
    int disk2Index           = 6;
    int disk3Index           = 7;
    int diskrw1Index         = 8;
    int diskrw2Index         = 9;
    int ethDeviceIndex       =10;

    // note that argv starts from 1, not zero for actual pars. That's why first par has index 5, and not 4
    argv = string_to_argv(buf, &argc); 

    
    timeDelay = atoi(argv[timeIndex]);    
    printf("Start Collecting. buf is %s \n time is %i srtrin 1=%s 2=%s 3=%s 4=%s \n",buf,timeDelay,argv[1],argv[2],argv[3],argv[4]);
    if (timeDelay <= 0) {
      printf("Warning.timeDelay <= 0 =%i. setting it to 10 sec \n",timeDelay);
      timeDelay = 10; //consistency
    }

    //if not automatic from incoming parline, use the incoming par line values
    if (strcmp(argv[disk1Index],"AUTO")      !=0)   sprintf(sSYSMONPAR.disk1,"%s",argv[disk1Index]);
    if (strcmp(argv[disk2Index],"AUTO")      !=0)   sprintf(sSYSMONPAR.disk2,"%s",argv[disk2Index]);
    if (strcmp(argv[disk3Index],"AUTO")      !=0)   sprintf(sSYSMONPAR.disk3,"%s",argv[disk3Index]);
    if ( strcmp(argv[diskrw1Index],"AUTO")   !=0)   sprintf(sSYSMONPAR.diskRW1,"%s",argv[diskrw1Index]);
    if ( strcmp(argv[diskrw2Index],"AUTO")   !=0)   sprintf(sSYSMONPAR.diskRW2,"%s",argv[diskrw2Index]);
    if ( strcmp(argv[ethDeviceIndex],"AUTO") !=0)   sprintf(sSYSMONPAR.ethdevice,"%s",argv[ethDeviceIndex]);


    sprintf(hostInfo.parameterLine,"%s %s %i DUMMY %s %s %s %s %s %s",hname,hostInfo.monset,timeDelay,
	    sSYSMONPAR.disk1,sSYSMONPAR.disk2,sSYSMONPAR.disk3, sSYSMONPAR.diskRW1,sSYSMONPAR.diskRW2,sSYSMONPAR.ethdevice);

    if (gDebugLevel == 1) printf("orig par line is %s \n",hostInfo.parameterLine);


    // send info to monitor about the parameter line
    dis_update_service(kParameterLine);

    sprintf(gTextString,"Received command from AFFAIR_MONITOR=%s\n",buf);
    writeOutput(gTextString);

    startFlag = 1;    
}



// erh_device is a charcter, and can be 0, 1, 2... (for eth0, eth1...)
void getNetStat(int iter, char *eth_device)
{
   FILE          *devfp;
   static char   line[256];
   unsigned long dummy;
   int           pos;
   char          dummyStr[1028];
   char          tempDev[20];
   char          currentDev[20];
   int           correctDevStatus;

   // copy previously filled array into old
   if ( iter > 0) {
       st_net_dev_old.rx_packets = st_net_dev_new.rx_packets;
       st_net_dev_old.tx_packets = st_net_dev_new.tx_packets;
       st_net_dev_old.rx_bytes   = st_net_dev_new.rx_bytes;
       st_net_dev_old.tx_bytes   = st_net_dev_new.tx_bytes;
       st_net_dev_old.collisions = st_net_dev_new.collisions;
       st_net_dev_old.rx_errors  = st_net_dev_new.rx_errors;
       st_net_dev_old.tx_errors  = st_net_dev_new.tx_errors;
       st_net_dev_old.rx_dropped = st_net_dev_new.rx_dropped;
       st_net_dev_old.tx_dropped = st_net_dev_new.tx_dropped;
   }

   /* Open network device file */   
   if ((devfp = fopen(NET_DEV, "r")) != NULL) {
     correctDevStatus = 0;
     while (fgets(line, 256, devfp) != NULL) {
       pos = strcspn(line, ":");
       
       if (pos < strlen(line)) {
	 if ( strlen(eth_device) == 1) {
	   if (line[pos-1] == *eth_device) correctDevStatus = 1;
	 } else {
	   //	   sscanf(line,"%[.*]:%[^\n]",&currentDev[0],&dummyStr[0]);
	   sscanf(line,"%[^\:]%s",&tempDev[0],&dummyStr[0]);
	   sscanf(tempDev,"%s",&currentDev[0]);
	   printf(" line is %s\n",line);
	   printf(" currentdev is %s dummy is %s eth_device is %s comparison is %i len 1 is %i len 2 %i \n",currentDev,dummyStr,eth_device,strcmp(currentDev,eth_device),strlen(currentDev),strlen(eth_device));
	   if (strcmp(currentDev,eth_device) == 0) correctDevStatus = 1;
	   
	 }
       }
	 //       if (pos < strlen(line) && line[pos-1] == *eth_device) {
       if (correctDevStatus == 1) {
	 if (gDebugLevel == 1) printf(" have correct device! = %s  \n",eth_device);
	 sscanf(line + pos + 1, "%lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu",
		&st_net_dev_new.rx_bytes, &st_net_dev_new.rx_packets,
		&st_net_dev_new.rx_errors, &st_net_dev_new.rx_dropped,
		&dummy, &dummy,
		&dummy, &dummy,
		&st_net_dev_new.tx_bytes, &st_net_dev_new.tx_packets,
		&st_net_dev_new.tx_errors, &st_net_dev_new.tx_dropped,
		&dummy, &st_net_dev_new.collisions,
		&dummy, &dummy);
	 break;
       }
     }
     if (gDebugLevel == 1) printf(" out of loop \n");
     /* Close serial file */
     fclose(devfp);
   }
   
   // fill diff structure
   if ( iter >0) {
       st_net_dev_diff.rx_packets = (double) (   st_net_dev_new.rx_packets    -  st_net_dev_old.rx_packets   )   ;
       st_net_dev_diff.tx_packets = (double) (   st_net_dev_new.tx_packets    -  st_net_dev_old.tx_packets   )   ;
       st_net_dev_diff.rx_bytes   = (double) (   (st_net_dev_new.rx_bytes     -  st_net_dev_old.rx_bytes)/1024.0 )   ; //kilobytes really
       st_net_dev_diff.tx_bytes   = (double) (   (st_net_dev_new.tx_bytes     -  st_net_dev_old.tx_bytes)/1024.0 )   ; //kilobytes really
       st_net_dev_diff.collisions = (double) (   st_net_dev_new.collisions    -  st_net_dev_old.collisions   )   ;
       st_net_dev_diff.rx_errors  = (double) (   st_net_dev_new.rx_errors     -  st_net_dev_old.rx_errors    )   ;
       st_net_dev_diff.tx_errors  = (double) (   st_net_dev_new.tx_errors     -  st_net_dev_old.tx_errors    )   ;
       st_net_dev_diff.rx_dropped = (double) (   st_net_dev_new.rx_dropped    -  st_net_dev_old.rx_dropped   )   ;
       st_net_dev_diff.tx_dropped = (double) (   st_net_dev_new.tx_dropped    -  st_net_dev_old.tx_dropped   )   ;
   }
}


void getCPUStat(int iter)
{
   FILE *statfp;
   static char line[2560];
    unsigned int cc_user, cc_nice, cc_system;
   unsigned long cc_idle;

   double cc_user_all, cc_nice_all, cc_system_all, cc_idle_all,cc_total_all;


   //use new/old structures for cpus to avoid dividing long numbers. will get overruns
   
   if (iter > 0 ) {
       cpu_old.cpu_user = cpu_new.cpu_user;
       cpu_old.cpu_nice = cpu_new.cpu_nice;
       cpu_old.cpu_system = cpu_new.cpu_system;
       cpu_old.cpu_idle = cpu_new.cpu_idle;
   }
   else {
       cpu_new.cpu_user = 0;
       cpu_new.cpu_nice = 0;
       cpu_new.cpu_system = 0;
       cpu_new.cpu_idle = 0;
   }

   /* Open stat file */
   if ((statfp = fopen(STAT, "r")) == NULL) {
      sprintf(gTextString,"Cannot open %s\n", STAT);
      writeOutput(gTextString);
      //      fprintf(stderr,"Collector: Cannot open %s\n", STAT);
      exit(2);
   }

   while (fgets(line, 2560, statfp) != NULL) {
       if (!strncmp(line, "cpu ", 4)) {
	   /*
	    * Read the number of jiffies spent in user, nice, system and idle mode among all proc.
	    * CPU usage is not reduced to one processor to avoid rounding problems.
	    */
	   sscanf(line + 5, "%u %u %u %lu",&cc_user, &cc_nice, &cc_system, &cc_idle);
      
	   cpu_new.cpu_user  = cc_user;
	   cpu_new.cpu_nice  = cc_nice;
	   cpu_new.cpu_system  = cc_system;
	   cpu_new.cpu_idle  = cc_idle;
       }       
   }
   /* Close serial file */
   fclose(statfp);

   // fill diff structure
   if ( iter >0) {
	   cc_user_all = (double) ( cpu_new.cpu_user - cpu_old.cpu_user) ;
	   cc_nice_all = (double) ( cpu_new.cpu_nice - cpu_old.cpu_nice) ;
	   cc_system_all = (double) ( cpu_new.cpu_system - cpu_old.cpu_system) ;
	   cc_idle_all = (double) ( cpu_new.cpu_idle - cpu_old.cpu_idle) ;
	   // normalize the cpu 
	   cc_total_all        =   cc_user_all + cc_nice_all +  cc_system_all + cc_idle_all;
	   cpu_diff.cpu_user   =  (100.0*cc_user_all/cc_total_all);
	   cpu_diff.cpu_nice   =  (100.0*cc_nice_all/cc_total_all);
	   cpu_diff.cpu_system =  (100.0*cc_system_all/cc_total_all);
	   cpu_diff.cpu_idle   =  (100.0*cc_idle_all/cc_total_all);
   }
}




void getFullStat(int iter)
{
   FILE *statfp;
   static char line[2560];
    unsigned int cc_user, cc_nice, cc_system;
   unsigned long cc_idle;
   double cc_user_all, cc_nice_all, cc_system_all, cc_idle_all,cc_total_all;

   unsigned int pswpin, pswpout;

    unsigned int v_tmp[5], v_major, v_index;
    int index_count = 0;

    int i;
    int pos;    
    unsigned int u_tmp[3];


   //use new/old structures for cpus to avoid dividing long numbers. will get overruns
   
   if (iter > 0 ) {
       cpu_old.cpu_user = cpu_new.cpu_user;
       cpu_old.cpu_nice = cpu_new.cpu_nice;
       cpu_old.cpu_system = cpu_new.cpu_system;
       cpu_old.cpu_idle = cpu_new.cpu_idle;

	for ( i =0; i < MAXDISK; i++) {
	    disk_re_wr_old.dk_rblk[i] = disk_re_wr_new.dk_rblk[i];
	    disk_re_wr_old.dk_wblk[i] = disk_re_wr_new.dk_wblk[i];
	}


       pswp_old.pswpin  = pswp_new.pswpin;
       pswp_old.pswpout = pswp_new.pswpout;

   }
   else {
       cpu_new.cpu_user = 0;
       cpu_new.cpu_nice = 0;
       cpu_new.cpu_system = 0;
       cpu_new.cpu_idle = 0;

       pswp_new.pswpin = 0;
       pswp_new.pswpout= 0;
   }

   /* Open stat file */
   if ((statfp = fopen(STAT, "r")) == NULL) {
      sprintf(gTextString,"Cannot open %s\n", STAT);
      writeOutput(gTextString);
      //      fprintf(stderr,"Cannot open %s\n", STAT);
      exit(2);
   }

   while (fgets(line, 2560, statfp) != NULL) {
       if (!strncmp(line, "cpu ", 4)) {
	   /*
	    * Read the number of jiffies spent in user, nice, system and idle mode among all proc.
	    * CPU usage is not reduced to one processor to avoid rounding problems.
	    */
	   sscanf(line + 5, "%u %u %u %lu",&cc_user, &cc_nice, &cc_system, &cc_idle);
      
	   cpu_new.cpu_user  = cc_user;
	   cpu_new.cpu_nice  = cc_nice;
	   cpu_new.cpu_system  = cc_system;
	   cpu_new.cpu_idle  = cc_idle;
       }  
       

       else if (!strncmp(line, "disk_rblk ", 10)) {
	    /* Read number of blocks read from disk */
	    sscanf(line + 10, "%u %u %u %u", &(disk_re_wr_new.dk_rblk[0]), &u_tmp[0], &u_tmp[1], &u_tmp[2]);
	    disk_re_wr_new.dk_rblk[0] += u_tmp[0] + u_tmp[1] + u_tmp[2];
	}
	
	else if (!strncmp(line, "disk_wblk ", 10)) {
	    /* Read number of blocks written to disk */
	    sscanf(line + 10, "%u %u %u %u", &(disk_re_wr_new.dk_wblk[0]), &u_tmp[0], &u_tmp[1], &u_tmp[2]);
	    disk_re_wr_new.dk_wblk[0] += u_tmp[0] + u_tmp[1] + u_tmp[2];
	}


       else if (!strncmp(line, "disk_io: ", 9)) {
	   pos = 9;	    
	   /* Read disks I/O statistics (for 2.4 kernels) */
	   while (pos < strlen(line) - 1) {	/* Beware: a CR is already included in the line */
	       sscanf(line + pos, "(%u,%u):(%u,%u,%u,%u,%u) ",
		      &v_major, &v_index,
		      &v_tmp[0], &v_tmp[1], &v_tmp[2], &v_tmp[3], &v_tmp[4]);
	       if (index_count < MAXDISK) {
		   disk_re_wr_new.dk_rblk[index_count]  = v_tmp[2];
		   disk_re_wr_new.dk_wblk[index_count]  = v_tmp[4];
	       }
	       index_count++;
	       pos += strcspn(line + pos, " ") + 1;		
	   }	    
       }
       
       else if (!strncmp(line, "swap ", 5)) {
	   sscanf(line + 5, "%u %u",
		  &pswpin, &pswpout);
	   
	   pswp_new.pswpin  = pswpin;
	   pswp_new.pswpout  = pswpout;
       }                    
   }
   /* Close serial file */
   fclose(statfp);

   // fill diff structure
   if ( iter >0) {
       cc_user_all = (double) ( cpu_new.cpu_user - cpu_old.cpu_user) ;
       cc_nice_all = (double) ( cpu_new.cpu_nice - cpu_old.cpu_nice) ;
       cc_system_all = (double) ( cpu_new.cpu_system - cpu_old.cpu_system) ;
       cc_idle_all = (double) ( cpu_new.cpu_idle - cpu_old.cpu_idle) ;
       // normalize the cpu 
       cc_total_all = cc_user_all + cc_nice_all +  cc_system_all + cc_idle_all;
       cpu_diff.cpu_user =  (100.0*cc_user_all/cc_total_all);
       cpu_diff.cpu_nice =  (100.0*cc_nice_all/cc_total_all);
       cpu_diff.cpu_system =  (100.0*cc_system_all/cc_total_all);
       cpu_diff.cpu_idle =  (100.0*cc_idle_all/cc_total_all);
       
       
       
       for (i =0; i < MAXDISK;i++) {
	   disk_re_wr_diff.dk_rblk[i] = (double) (disk_re_wr_new.dk_rblk[i] - disk_re_wr_old.dk_rblk[i]);
	   disk_re_wr_diff.dk_wblk[i] =  (double) (disk_re_wr_new.dk_wblk[i] - disk_re_wr_old.dk_wblk[i]);
       }


       pswp_diff.pswpin = (double) ( pswp_new.pswpin - pswp_old.pswpin) ;
       pswp_diff.pswpout = (double) ( pswp_new.pswpout - pswp_old.pswpout) ;

   }
}


void getSwapStat(int iter)
{
   FILE *statfp;
   static char line[2560];
   unsigned int pswpin, pswpout;


   //use new/old structures for cpus to avoid dividing long numbers. will get overruns
   
   if (iter > 0 ) {
       pswp_old.pswpin  = pswp_new.pswpin;
       pswp_old.pswpout = pswp_new.pswpout;
   }
   else {
       pswp_new.pswpin = 0;
       pswp_new.pswpout= 0;
   }

   /* Open stat file */
   if ((statfp = fopen(STAT, "r")) == NULL) {
      sprintf(gTextString,"Cannot open %s\n", STAT);
      writeOutput(gTextString);
      //      fprintf(stderr,"Cannot open %s\n", STAT);
      exit(2);
   }

   while (fgets(line, 2560, statfp) != NULL) {
       if (!strncmp(line, "swap ", 5)) {
	   sscanf(line + 5, "%u %u",
		  &pswpin, &pswpout);
      
	   pswp_new.pswpin  = pswpin;
	   pswp_new.pswpout  = pswpout;
       }       
   }
   /* Close serial file */
   fclose(statfp);

   // fill diff structure
   if ( iter > 0) {
       pswp_diff.pswpin = (double) ( pswp_new.pswpin - pswp_old.pswpin) ;
       pswp_diff.pswpout = (double) ( pswp_new.pswpout - pswp_old.pswpout) ;
   }
}

void getDiskStat(int iter)
{
    
    FILE *statfp;
    static char line[2560];
    unsigned int v_tmp[5], v_major, v_index;
    int index_count = 0;
    int i;
    int pos;    
    unsigned int u_tmp[3];
    
    
    // copy previously filled array into old
    if ( iter > 0) {
	for ( i =0; i < MAXDISK; i++) {
	    disk_re_wr_old.dk_rblk[i] = disk_re_wr_new.dk_rblk[i];
	    disk_re_wr_old.dk_wblk[i] = disk_re_wr_new.dk_wblk[i];
	}
    }
    
    
    /* Open stat file */
    if ((statfp = fopen(STAT, "r")) == NULL) {
      //	fprintf(stderr, "Cannot open %s \n", STAT);
      sprintf(gTextString,"Cannot open %s\n", STAT);
      writeOutput(gTextString);
      exit(2);
    }
    
    while (fgets(line, 2560, statfp) != NULL) {
	if (!strncmp(line, "disk_rblk ", 10)) {
	    /* Read number of blocks read from disk */
	    sscanf(line + 10, "%u %u %u %u", &(disk_re_wr_new.dk_rblk[0]), &u_tmp[0], &u_tmp[1], &u_tmp[2]);
	    disk_re_wr_new.dk_rblk[0] += u_tmp[0] + u_tmp[1] + u_tmp[2];
	}
	
	else if (!strncmp(line, "disk_wblk ", 10)) {
	    /* Read number of blocks written to disk */
	    sscanf(line + 10, "%u %u %u %u", &(disk_re_wr_new.dk_wblk[0]), &u_tmp[0], &u_tmp[1], &u_tmp[2]);
	    disk_re_wr_new.dk_wblk[0] += u_tmp[0] + u_tmp[1] + u_tmp[2];
	}

	else if (!strncmp(line, "disk_io: ", 9)) {
	    pos = 9;	    
	    /* Read disks I/O statistics (for 2.4 kernels) */
	    while (pos < strlen(line) - 1) {	/* Beware: a CR is already included in the line */
		sscanf(line + pos, "(%u,%u):(%u,%u,%u,%u,%u) ",
		       &v_major, &v_index,
		       &v_tmp[0], &v_tmp[1], &v_tmp[2], &v_tmp[3], &v_tmp[4]);
		if (index_count < MAXDISK) {
		    disk_re_wr_new.dk_rblk[index_count]  = v_tmp[2];
		    disk_re_wr_new.dk_wblk[index_count]  = v_tmp[4];
		}
		index_count++;
		pos += strcspn(line + pos, " ") + 1;		
	    }	    
	}
    }
    /* Close serial file */
    fclose(statfp);

   // fill diff structure
   if ( iter >0) {
       for (i =0; i < MAXDISK;i++) {
	   disk_re_wr_diff.dk_rblk[i] = (double) (disk_re_wr_new.dk_rblk[i] - disk_re_wr_old.dk_rblk[i]);
	   disk_re_wr_diff.dk_wblk[i] =  (double) (disk_re_wr_new.dk_wblk[i] - disk_re_wr_old.dk_wblk[i]);
       }
   }
}



void setup(void)
{
    char  strCommand[256];
    FILE *diskfp;
    FILE *statfp;
    FILE *netfp;
    static char lineStat[2560];
    unsigned int v_tmp[5], v_major, v_index;
    
    static char line[256];
    char diskLogFile[256];
    char diskName[128];
    int diskCount = 0;
    int pos; 
    int i;
    int indexCount = 0;
    unsigned long tx_bytes_new;
    unsigned long tx_bytes_old = 0;
    unsigned long dummy;
    int countNetDev=0;
    int countNetDevTotal=0;


    int chars_read;
    char buffer[512];

    
    // find the default disk names
    // only use first 3 partitions 
    //sprintf(strCommand,"%s/support/getDisksUsed.pl %s",affairPath,hname,3);
    sprintf(strCommand,"%s/support/getDisksUsed.pl %s",affairPath,"3");
    //printf("Collecotr sysmon = %s \n",strCommand);
    diskfp = popen(strCommand,"r");
    if(diskfp !=NULL){
	chars_read = fread(buffer,sizeof(char),512,diskfp);
	if (chars_read > 0) sscanf(buffer,"%s %s %s",&sSYSMONPAR.disk1,&sSYSMONPAR.disk2,&sSYSMONPAR.disk3);      
     }
    pclose(diskfp);
        
      if (gDebugLevel == 1) {
	sprintf(gTextString,"default d1=%s d2=%s d3=%s \n",sSYSMONPAR.disk1,sSYSMONPAR.disk2,sSYSMONPAR.disk3);
        writeOutput(gTextString);
      }

    // find the default ethernet device. Define as device in /proc/net/dev with largestpockets transmitted
    // Open network device file 
    if ((netfp = fopen(NET_DEV, "r")) != NULL) {
	while (fgets(line, 256, netfp) != NULL) {
	 pos = strcspn(line, ":");
	 if (pos < strlen(line) ) {	   
		sscanf(line + pos+1, "%lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu",
		      &dummy, &dummy,
		      &dummy, &dummy,
		      &dummy, &dummy,
		      &dummy, &dummy, &dummy,
		      &tx_bytes_new,
		      &dummy, &dummy,
		      &dummy, &dummy,
		      &dummy, &dummy);
		//

		if (gDebugLevel == 1) {
		  sprintf(gTextString,"default eth dev tx_bytes_new=%u tx_bytes_old=%u\n",tx_bytes_new,tx_bytes_old);
		  writeOutput(gTextString);
		}

		countNetDevTotal++;
		if ( (unsigned long) tx_bytes_new >= (unsigned long) tx_bytes_old) { 
		    tx_bytes_old = tx_bytes_new; 
		    sprintf(sSYSMONPAR.ethdevice,"%c",line[pos-1]);

		    if (gDebugLevel == 1) {
		      sprintf(gTextString,"NEW default ethernet device=%s\n",sSYSMONPAR.ethdevice);
		      writeOutput(gTextString);
		    }
		    countNetDev++;
		}
		if (countNetDev==0) sprintf(sSYSMONPAR.ethdevice,"0"); 
		//why the line below???
		if (countNetDevTotal > 1 && strcmp(sSYSMONPAR.ethdevice,"o") == 0 ) sprintf(sSYSMONPAR.ethdevice,"0");
		//		sprintf(gTextString,"collector: default eth dev=%s\n",sSYSMONPAR.ethdevice);
		//  writeOutput(gTextString);
	    }
	}
    }
    fclose(netfp); 

    sprintf(gTextString,"default ethernet device is (has most traffic) = %s\n",sSYSMONPAR.ethdevice);
    writeOutput(gTextString);

   
    //    
    sprintf(sSYSMONPAR.diskRW1,"%s","DUMMY");
    sprintf(sSYSMONPAR.diskRW2,"%s","DUMMY");
   
    /* Open stat file */
    if ((statfp = fopen(STAT, "r")) == NULL) {
	sprintf(gTextString, "Cannot open %s \n", STAT);
	writeOutput(gTextString);
	//	fprintf(stderr, "Collector: Cannot open %s \n", STAT);
	exit(2);
    }
    
    while (fgets(lineStat, 2560, statfp) != NULL) {
	if (!strncmp(lineStat, "disk_io: ", 9)) {
	    pos = 9;	    
	    /* Read disks I/O statistics (for 2.4 kernels) */
	    while (pos < strlen(lineStat) - 1) {	/* Beware: a CR is already included in the line */
		sscanf(lineStat + pos, "(%u,%u):(%u,%u,%u,%u,%u) ",
		       &v_major, &v_index,
		       &v_tmp[0], &v_tmp[1], &v_tmp[2], &v_tmp[3], &v_tmp[4]);
		indexCount++;
		if (indexCount <= MAXDISK) {
		    if (indexCount == 1)  sprintf(sSYSMONPAR.diskRW1,"%s","disk1");
		    if (indexCount == 2)  sprintf(sSYSMONPAR.diskRW2,"%s","disk2");
		}
		pos += strcspn(lineStat + pos, " ") + 1;		
	    }	    
	}
    }
    /* Close serial file */
    fclose(statfp);
    if (indexCount == 0) {
	sprintf(sSYSMONPAR.diskRW1,"%s","disk1");
    }

    for ( i =0; i < MAXDISK; i++) {
	disk_re_wr_new.dk_rblk[i] = 0;
	disk_re_wr_new.dk_wblk[i] = 0;
    }
}


main(argc,argv)
    int argc;
    char **argv;
{
    char aux[256];
    int i;
    char obj[128];
    float tmpValues[3];
    float cpuValues[5];
    int iter=0;

   
    //      printf("Affair.Starting initialization for system monitoring argc = %i  argv[1]=%s argv[2]= %s \n",argc,argv[1],argv[2]);
    gDebugLevel = 0;
    sprintf(gUserHname,"%s","DUMMY");  
    if ( argc == 2 && (strncmp(argv[1],"-V", 2 )  == 0  ||   strcmp(argv[1],"verbose")== 0)) gDebugLevel = 1;
    if ( argc == 3 && (strncmp(argv[2],"-V", 2 )  == 0  ||   strcmp(argv[2],"verbose")== 0)) gDebugLevel = 1;
 

    // to ensure comaptibility with DATE affair processes, format CollectorSYSMON, CollectorSYSMON DATEMON, CollectorSYSMON DATEMON -V, CollectorSYSMON -V
    // should all start the DATEMON monitoring
    sprintf(monitorSet,"%s","DATEMON");  
    if ( argc == 3) {
	sprintf(monitorSet,"%s",argv[1]);  
    } 
    if ((argc == 2 && gDebugLevel == 0) ) {
	sprintf(monitorSet,"%s",argv[1]);  
    }

    if ((argc > 3) ) {
	sprintf(monitorSet,"%s",argv[1]);  
	if ( strncmp(argv[3],"-h", 2 )  == 0 ) sprintf(gUserHname,"%s",argv[4]);
    }


    printf("Affair.monitorSet is %s\n",monitorSet);

    sprintf(hostInfo.monset,"%s",monitorSet);  

    // setup services, initial parameters...
    setupCommon(logOption,&monitorData, sizeof(monitorData));

    //setup up monitor specific stuff
    setup();
    // start the data collector 
    sprintf(aux,"%s_%s_Collector",hname,monitorSet);
    dis_start_serving(aux);
    // send the hostInfo information to the monitoring station, so it can
    // set things up over there
    // need the statusFlag = -1 condition for time being...
    monitorData.statusFlag = -1;
    dis_update_service(kStartCollecting);            
    sprintf(aux,"%s_%s",hname,monitorSet);
    dic_cmnd_service("MonAffair/newHost",&aux,sizeof(aux));
    sprintf(gTextString,"Initialization done. DIM MonAffair/newHost command sent to AFFAIR_MONITOR. Waiting for response \n");
    writeOutput(gTextString);

    // wait for monitor to acknowledge that it sees this node/service
    while(!startFlag) dim_wait();
    sprintf(gTextString,"Received response from AFFAIR_MONITOR. Start collecting performance data \n");
    writeOutput(gTextString);

    dtq_sleep(timeDelay);		

    monitorData.statusFlag = 1;


    ///////////////////////////////////////////////////////////////////////////////////////////////////
    // do an endless loop with provided delay, get current data and send data to monitor in each cycle
    /////////////////////////////////////////////////////////////////////////////////////////////////////
    while(1){	
	getNetStat(iter,sSYSMONPAR.ethdevice);
	getFullStat(iter);

	monitorData.statusFlag  = (double) time(0);    		

	monitorData.du1       = getDiskUsage(sSYSMONPAR.disk1);
	monitorData.du2       = getDiskUsage(sSYSMONPAR.disk2);
	monitorData.du3       = getDiskUsage(sSYSMONPAR.disk3);
	monitorData.df1       = getDiskFree(sSYSMONPAR.disk1);
	monitorData.df2       = getDiskFree(sSYSMONPAR.disk2);
	monitorData.df3       = getDiskFree(sSYSMONPAR.disk3);
	monitorData.d_rblk1   = disk_re_wr_diff.dk_rblk[0]/((double)timeDelay);
	monitorData.d_rblk2   = disk_re_wr_diff.dk_rblk[1]/((double)timeDelay);

	monitorData.d_wblk1   = disk_re_wr_diff.dk_wblk[0]/((double)timeDelay);
	monitorData.d_wblk2   = disk_re_wr_diff.dk_wblk[1]/((double)timeDelay);

	monitorData.userCPU   = cpu_diff.cpu_user;
	monitorData.niceCPU   = cpu_diff.cpu_nice;
	monitorData.systemCPU = cpu_diff.cpu_system;
	monitorData.idleCPU   = cpu_diff.cpu_idle;

	monitorData.in        = st_net_dev_diff.rx_bytes/((double)timeDelay);
	monitorData.out       = st_net_dev_diff.tx_bytes/((double)timeDelay);

	monitorData.swp       = getMemInfo("SwapFree");
	monitorData.mem       = getMemInfo("MemFree");
	monitorData.ls        = getLoginSessions();
	monitorData.pswpin    = pswp_diff.pswpin*kBytePerPage*(0.001)/((double)timeDelay);
	monitorData.pswpout   = pswp_diff.pswpout*kBytePerPage*(0.001)/((double)timeDelay);

	
	/*
	if (MY_MONVALUE_COUNT > 0) {
	  for ( i =0; i < MY_MONVALUE_COUNT; i++) {
	    monitorData.myMonitoredValues[i] = getMyMonitoredValues(i);
	    if (gDebugLevel == 1) printf("myMonitoredValues=%i value = %f  \n",i,monitorData.myMonitoredValues[i]);
	  }
	}
	*/

	// case when have user defined hname, for tesrting purposes
	if (strcmp(gUserHname,"DUMMY")  !=0) {
	  monitorData.userCPU   = monitorData.userCPU * 1.2;
	  monitorData.niceCPU   = monitorData.niceCPU * 0.8;
	  monitorData.systemCPU = monitorData.systemCPU * 1.3;
	  monitorData.idleCPU   = monitorData.idleCPU * 0.7;

	  monitorData.du1       = monitorData.du1*0.9;
	  monitorData.du2       = monitorData.du2*1.1;
	  monitorData.du3       = monitorData.du3*1.2;
	  monitorData.df1       = monitorData.df1*0.9;
	  monitorData.df2       = monitorData.df2*1.1;
	  monitorData.df3       = monitorData.df3*1.2;

	}

	// data sent to monitor
	dis_update_service(kUpdateData);	 
	if (gDebugLevel == 1) {
	  sprintf(gTextString,"new data sent. iteration=%i \n",iter);
	  writeOutput(gTextString);
	}
	iter++;

	// wait for time delay
	dtq_sleep(timeDelay);		

    }
}









