#include <stdio.h>
#include <dic.h>
#include <dis.h>
#include <signal.h>

#include <stdlib.h>
#include <unistd.h>
#include <smirtl.h>

#include "hostInfo.h"
#include "collectorlib.h"
#include "myMonitoredValues.h"


#define MAXSNMPDIGITS 11
// setup logfile
// it can be stdout if logOption ==0, /dev/null if logOption ==1, and in log dir if logoption = 2
const int    logOption    = 0;
const double kBytePerPage = 4.0;

void getNetStat(int iter,char *eth_device);
void getCPUStat(int iter);
void getSwapStat(int iter);
void getDiskStat(int iter);
void getFullStat(int iter);


typedef struct {    
    double statusFlag;  //Affair specific data
    double du1;
    double du2;
    double du3;
    double df1;
    double df2; 
    double df3;
    double d_rblk1;
    double d_rblk2;
    double d_wblk1;
    double d_wblk2;
    double userCPU;  
    double niceCPU;  
    double systemCPU;
    double idleCPU;  
    double in;     
    double out;    
    double swp;      
    double mem;      
    double ls;       
    double pswpin;
    double pswpout;
  //    double myMonitoredValues[MY_MONVALUE_COUNT];
}TMonitorData;
TMonitorData monitorData;

typedef struct {
    int timeDelay;
    char disk1[30];
    char disk2[30];
    char disk3[30];
    char diskRW1[10];
    char diskRW2[10];
    char ethdevice[5];
}TSYSMONPAR;
TSYSMONPAR sSYSMONPAR;
TSYSMONPAR sSYSMONPARTemp;

#define NET_DEV		"/proc/net/dev"
#define STAT		"/proc/stat"
#define MAXDISK          2

struct stats_net_dev {
   unsigned long rx_packets		;
   unsigned long tx_packets		;
   unsigned long rx_bytes		;
   unsigned long tx_bytes		;
   unsigned long collisions		;
   unsigned long rx_errors		;
   unsigned long tx_errors		;
   unsigned long rx_dropped		;
   unsigned long tx_dropped		;
};

struct stats_net_dev_d {
   double rx_packets		;
   double tx_packets		;
   double rx_bytes		;
   double tx_bytes		;
   double collisions		;
   double rx_errors		;
   double tx_errors		;
   double rx_dropped		;
   double tx_dropped		;
};

struct stats_net_dev st_net_dev_new;
struct stats_net_dev st_net_dev_old;
struct stats_net_dev_d st_net_dev_diff;


struct cpu_stats {
    unsigned int  cpu_user;
    unsigned int  cpu_nice;
    unsigned int  cpu_system;
    unsigned long cpu_idle  ;
};

struct cpu_stats_d {
   double  cpu_user;
   double  cpu_nice;
   double  cpu_system;
   double cpu_idle  ;
};

struct cpu_stats cpu_old;
struct cpu_stats cpu_new;
struct cpu_stats_d cpu_diff;



struct disk_re_wr {               
    unsigned int  dk_rblk[MAXDISK] ;
    unsigned int  dk_wblk[MAXDISK] ;
};

struct disk_re_wr_d {               
    double  dk_rblk[MAXDISK] ;
    double  dk_wblk[MAXDISK] ;
};

struct disk_re_wr disk_re_wr_new;
struct disk_re_wr disk_re_wr_old;
struct disk_re_wr_d disk_re_wr_diff;



struct pswp_stats {
    unsigned int  pswpin;
    unsigned int  pswpout;
};

struct pswp_stats_d {
   double  pswpin;
   double  pswpout;
};

struct pswp_stats pswp_old;
struct pswp_stats pswp_new;
struct pswp_stats_d pswp_diff;






