// #include "CollectorSYSMON.h"
#include "MyCollector.h"

int startFlag = 0;

////////////////////////////////////////////////////////////////////////////////////////////////
void startCollecting(tag, buf, size)
    int *tag, *size;
    char *buf;
{

    char    **argv;
    int     argc;
    int     parid;
    int     isParSetByAffairMonitor;

    int timeIndex            = 3;

    argv = string_to_argv(buf, &argc); 
    
    timeDelay = atoi(argv[timeIndex]);    
    printf("Start Collecting. buf is %s \n time is %i srtrin 1=%s 2=%s 3=%s 4=%s \n",buf,timeDelay,argv[1],argv[2],argv[3],argv[4]);
    if (timeDelay <= 0) {
      printf("Warning.timeDelay <= 0 =%i. setting it to 10 sec \n",timeDelay);
      timeDelay = 10; //consistency
    }

    sprintf(hostInfo.parameterLine,"%s %s %i  DUMMY ", hname,hostInfo.monset,timeDelay);

    if (gDebugLevel) {
      printf("MyCollector. monset =%s myparcount =%d \n",hostInfo.monset,MY_PARAMETERS_COUNT);
    }
    if (MY_PARAMETERS_COUNT > 0) {
      for (parid = 0; parid < MY_PARAMETERS_COUNT; parid++) {
	isParSetByAffairMonitor = 1;
	if (strcmp(argv[5+parid],"AUTO") == 0)   isParSetByAffairMonitor = 0;
	if (gDebugLevel) printf("MyCollector. parline is =%s \n   parid =%d par is %s isParSetByAffairMonitor is %d \n",hostInfo.parameterLine,parid,argv[5+parid],isParSetByAffairMonitor);
	
	sprintf(hostInfo.parameterLine,"%s %s",hostInfo.parameterLine,GetMyParameters(parid,argv[5+parid],isParSetByAffairMonitor)  );	
	if (gDebugLevel) printf("MyCollector. updated parline is =%s \n",hostInfo.parameterLine);
	
      }
    }
    // send info to monitor about the parameter line
    dis_update_service(kParameterLine);

    sprintf(gTextString,"Received command from AFFAIR_MONITOR=%s\n",buf);
    writeOutput(gTextString);

    startFlag = 1;    
}




void setup(void)
{
    char  strCommand[256];
    FILE *diskfp;
    FILE *statfp;
    FILE *netfp;
    static char lineStat[2560];
    unsigned int v_tmp[5], v_major, v_index;
    
    static char line[256];
    char diskLogFile[256];
    char diskName[128];
    int diskCount = 0;
    int pos; 
    int i;
    int indexCount = 0;
    unsigned long tx_bytes_new;
    unsigned long tx_bytes_old = 0;
    unsigned long dummy;
    int countNetDev=0;
    int countNetDevTotal=0;


    int chars_read;
    char buffer[512];

}


main(argc,argv)
    int argc;
    char **argv;
{
    char aux[256];
    int i;
    char obj[128];
    float tmpValues[3];
    int iter=0;

   
    //      printf("Affair.Starting initialization for system monitoring argc = %i  argv[1]=%s argv[2]= %s \n",argc,argv[1],argv[2]);
    gDebugLevel = 0;
    sprintf(monitorSet,"%s","DUMMY");  
    sprintf(gUserHname,"%s","DUMMY");  


    for( i = 1; i< argc; i++) {
        if ( strncmp(argv[i],"-monitorSet", 2 ) == 0 ) {
	    sprintf(monitorSet,"%s",argv[i+1]);
        }
        if ( strncmp(argv[i],"-V", 2 ) == 0 ) {
	  gDebugLevel = 1;
        }
        if ( strncmp(argv[i],"-v", 2 ) == 0 ) {
	  gDebugLevel = 1;
        }
        else if ( strncmp(argv[i],"-h", 2 )  == 0 ) {
	  sprintf(gUserHname,"%s",argv[i+1]);
        }
    }
    
    if (strcmp(monitorSet,"DUMMY") == 0)  {
      printf("You did not set a monitoring set. The firmat is ./MyCollecor -m monitorSet \n For debug output, use the -V flag. \n \
      To force a hostname(for testing purposes), use -h hostname.\n");
      return 0;
    }

    printf("Affair.monitorSet is %s size is %d\n",monitorSet,sizeof(monitorData));

    sprintf(hostInfo.monset,"%s",monitorSet);  

    // setup services, initial parameters...
    setupCommon(logOption,&monitorData, sizeof(monitorData));

    //setup up monitor specific stuff
    setup();

    // start the data collector 
    sprintf(aux,"%s_%s_Collector",hname,monitorSet);
    dis_start_serving(aux);
    // send the hostInfo information to the monitoring station, so it can
    // set things up over there
    // need the statusFlag = -1 condition for time being...
    monitorData.statusFlag = -1;
    dis_update_service(kStartCollecting);            
    sprintf(aux,"%s_%s",hname,monitorSet);
    dic_cmnd_service("MonAffair/newHost",&aux,sizeof(aux));
    sprintf(gTextString,"Initialization done. DIM MonAffair/newHost command sent to AFFAIR_MONITOR. Waiting for response \n");
    writeOutput(gTextString);

    // wait for monitor to acknowledge that it sees this node/service
    while(!startFlag) dim_wait();
    sprintf(gTextString,"Received response from AFFAIR_MONITOR. Start collecting performance data \n");
    writeOutput(gTextString);

    dtq_sleep(timeDelay);		

    monitorData.statusFlag = 1;


    ///////////////////////////////////////////////////////////////////////////////////////////////////
    // do an endless loop with provided delay, get current data and send data to monitor in each cycle
    ///////////////////////////////////////////////////////////////////////////////////////////////////
    while(1){	
	monitorData.statusFlag  = (double) time(0);    			
	if (gDebugLevel == 1) printf(" MY_MONVALUE_COUNT is %d \n",MY_MONVALUE_COUNT);
	if (MY_MONVALUE_COUNT > 0) {
	  for ( i =0; i < MY_MONVALUE_COUNT; i++) {
	    monitorData.myMonitoredValues[i] = GetMyMonitoredValues(i);
	    if (gDebugLevel == 1) printf("myMonitoredValues=%i value = %f  \n",i,monitorData.myMonitoredValues[i]);
	  }
	}

	// data sent to monitor
	dis_update_service(kUpdateData);	 
	if (gDebugLevel == 1) {
	  sprintf(gTextString,"new data sent. iteration=%i \n",iter);
	  writeOutput(gTextString);
	}
	iter++;
	// wait for time delay
	dtq_sleep(timeDelay);		

    }
}









