/* AffairCollector
 * gathers system data and sends to AffairMonitor
 *
 * Start Date    : 1-8-2001
 * Written by    : tome.anticic@cern.ch
 */

#include <stdio.h>
#include <signal.h>

#include <stdlib.h>
#include <unistd.h>

#include <dic.h>
#include <dis.h>
#include "hostInfo.h"
#include "collectorlib.h"

#include <netdb.h>

FILE* logFile;

double getLoginSessions(void)
{
    FILE* read_parameter;
    int chars_read;
    int loginSessions = 0;
    char buffer[80];
    char strCommand[256];
    
    sprintf(strCommand,"%s/support/getLoginSessions.pl",affairPath);
    read_parameter = popen(strCommand,"r");
    if(read_parameter !=NULL){
	chars_read = fread(buffer,sizeof(char),256,read_parameter);
	if (chars_read > 0) loginSessions =  (double) atoi(buffer);
    }
    pclose(read_parameter);
    return(loginSessions);
}

void getProcessorInfo(void)
{
    FILE* read_parameter;
    int chars_read;
    char buffer[256];
    char strCommand[256];
    float cpuf;

    sprintf(strCommand,"%s/support/getProcessorNumber.pl",affairPath);
    read_parameter = popen(strCommand,"r");
    if(read_parameter !=NULL){
	chars_read = fread(buffer,sizeof(char),256,read_parameter);
	if (chars_read > 0) sscanf(buffer,"%i %f %s",&hostInfo.processorNumber,
				   &cpuf,&hostInfo.processorName);      
	hostInfo.cpuf = cpuf;
    }
    pclose(read_parameter);
    return;
}

double getDiskUsage(diskName)
    char * diskName;
{
    /* read disk 1 */	
    FILE* read_parameter;
    int chars_read;
    double diskUsage;
    char buffer[80];
    char strGetDisk1[256];
    
    sprintf(strGetDisk1,"%s/support/getDiskUsage.pl %s",affairPath,diskName);

    read_parameter = popen(strGetDisk1,"r");
    if(read_parameter !=NULL){
	chars_read = fread(buffer,sizeof(char),80,read_parameter);
	if (chars_read > 0) {
	    diskUsage = (double) atoi(buffer);
	}
    }
    pclose(read_parameter);
    return(diskUsage);
}

double getDiskFree(diskName)
    char * diskName;
{
    /* read disk 1 */	
    FILE* read_parameter;
    int chars_read;
    double diskUsage;
    char buffer[80];
    char strGetDisk1[256];
    
    sprintf(strGetDisk1,"%s/support/getDiskFree.pl %s",affairPath,diskName);
    read_parameter = popen(strGetDisk1,"r");
    if(read_parameter !=NULL){
	chars_read = fread(buffer,sizeof(char),80,read_parameter);
	if (chars_read > 0) {
	    diskUsage = (double) atoi(buffer);
	}
    }
    pclose(read_parameter);
    return(diskUsage);
}

double getMemInfo(char *memParameter)
{
    FILE* read_parameter;
    int chars_read;
    double memkb = 0;
    char buffer[80];
    char strCommand[256];
    
    sprintf(strCommand,"%s/support/getMemInfo.pl %s",affairPath,memParameter);
    read_parameter = popen(strCommand,"r");
    if(read_parameter !=NULL){
	chars_read = fread(buffer,sizeof(char),80,read_parameter);
	if (chars_read > 0) memkb =  (double) atoi(buffer);
    }
    pclose(read_parameter);
    return(memkb);
}
 

void getTmpValues(float *tmpValues)
{
    FILE* read_parameter;
    int chars_read;
    char buffer[80];
    char strCommand[256];
    
    sprintf(strCommand,"%s/support/getTmpValues.pl",affairPath);
    read_parameter = popen(strCommand,"r");
    if(read_parameter !=NULL){
	chars_read = fread(buffer,sizeof(char),80,read_parameter);
	if (chars_read > 0) sscanf(buffer,"%f %f %f",&tmpValues[0],&tmpValues[1],&tmpValues[2]);      
    }
    pclose(read_parameter);
    return;
}

double getRunQueue(char * rqFile)
{
    FILE* fp;
    char fullName[256]; 
    char line[256];
    float  runQueue = 0 ;

    sprintf(fullName,"%s/log/%s_%s.log",affairPath,rqFile,hname);

    fp = fopen(fullName,"r");
    if (fp) {
	while (fgets(line,256,fp)) 
	    sscanf(line,"%f",&runQueue);
	fclose(fp);   
    }
    return(runQueue);
}


void getPagingRate(char * pgFile,float *pagingValues)
{
    FILE* fp;
    char fullName[256]; 
    char line[256];
    float  inPage = 0, outPage = 0, totPage = 0 ;

    sprintf(fullName,"%s/log/%s_%s.log",affairPath,pgFile,hname);

    fp = fopen(fullName,"r");
    if (fp) {
	while (fgets(line,256,fp)) 
	    sscanf(line,"%f %f",&inPage,&outPage);
	fclose(fp);   
    }
    totPage = inPage + outPage;
    pagingValues[0] = inPage;
    pagingValues[1] = outPage;
    pagingValues[2] = totPage;
    return;
}

void getHostType(void)
{
    FILE* read_parameter;
    int chars_read;
    char buffer[128];
    char strCommand[256];
    char type[80];
    char kernel[80];

    sprintf(strCommand,"%s/support/getHostType.pl",affairPath);
    read_parameter = popen(strCommand,"r");
    if(read_parameter !=NULL){
	chars_read = fread(buffer,sizeof(char),256,read_parameter);
	if (chars_read > 0) sscanf(buffer,"%s %s",&type,&kernel);
	sprintf(hostInfo.type,"%s",type);
	sprintf(hostInfo.kernel,"%s",kernel);
	
    }
    pclose(read_parameter);
    return;
}

void getMyHostName(void)
{
    FILE* read_parameter;
    int chars_read;
    char buffer[80];
    char strCommand[256];
    char hnameTemp[80];
    char fullHnameTemp[80];
    //char domainName[80];

    gethostname(hnameTemp,100);

    if (1 > 0) {
      sprintf(strCommand,"%s/support/getMyHostName.pl %s",affairPath,hnameTemp);
      read_parameter = popen(strCommand,"r");
      if(read_parameter !=NULL){
	chars_read =  fread(buffer,sizeof(char),80,read_parameter);
	if (chars_read > 0) sscanf(buffer,"%s",&fullHnameTemp);      
      }
      pclose(read_parameter);
      // make sure node not disconnected from line
      if ( strcmp(fullHnameTemp,"disconnected")== 0 ) {
	sprintf(hname,"%s",hnameTemp);
	}else {
	  sprintf(hname,"%s",fullHnameTemp);
	}
    } else {
      sprintf(hname,"%s",hnameTemp);
    }

    if (strcmp(gUserHname,"DUMMY")  !=0) {
      sprintf(hname,"%s",gUserHname);
    }
    printf(" hname is %s \n",hname);
    return;
}

void setupHostinfo() {
    // setup host name, type 
    sprintf(hostInfo.hname,"%s",hname);
    sprintf(hostInfo.parameterLine," ");    
    sprintf(hostInfo.statusText,"OK");    
    hostInfo.maxmem = getMemInfo("MemTotal");
    hostInfo.statusFlag = 1;
}


FILE* getLogfile(int logOptionX) {

   char logFileName[256];

    if (logOptionX == 0) {
      //	logFile = stderr;
	logFile = stdout;
    }
    else if (logOptionX == 1) { 
	logFile = fopen("/dev/null","a");
    }
    else if (logOptionX == 2) {
        sprintf(logFileName,"%s/log/DataCollector_%s",affairPath,hname);
	logFile = fopen(logFileName,"a");
    }
    return(logFile);
}


void startServices(int addressX, int sizeX) {    
    char aux[256];
    /* here are the services provided by data collector */
    dis_add_client_exit_handler(client_exited);        

    // service giving host info to monitor, provided at beginning of data collecting session
    sprintf(aux,"Affair/%s_%s/StartFlag",hname,monitorSet);
    kStartCollecting = dis_add_service(aux, "I:1;I:1;D:1;D:1;D:1;c:80;c:80;c:80;c:80;c:80;c:80;c:512", &hostInfo, sizeof(hostInfo), (void *)0, 0 );


    // service updating the status of the host, like disk full, ... , ...
    sprintf(aux,"Affair/%s_%s/UpdateHostStatus",hname,monitorSet);
    kUpdateHostStatus = dis_add_service(aux, "I:1;I:1;c:80;", &hostStatus, sizeof(hostStatus), (void *)0, 0);
        
    // the startCollecting function gets executed when the  monitor sends the StartCommand here
    sprintf(aux,"Affair/%s_%s/StartCommand",hname,monitorSet);
    dis_add_cmnd( aux,"C",startCollecting, 0);

    // service which sends data to the monitor after a time interval. The format is always double values(for time being)
    // and the values are in the monitorData structure
    sprintf(aux,"Affair/%s_%s/Data",hname,monitorSet);
    kUpdateData = dis_add_service( aux,"D",addressX, sizeX, (void *)0, 0 );

    // service to send the final parameter line to mon, once the par line has been updated
    sprintf(aux,"Affair/%s_%s/ParameterLine",hname,monitorSet); 
    kParameterLine = dis_add_service(aux, "I:1;I:1;D:1;D:1;D:1;c:80;c:80;c:80;c:80;c:80;c:80;c:512",&hostInfo, sizeof(hostInfo), (void *)0, 0 );

    if (gDebugLevel == 1) {      
      sprintf(gTextString,"Started services: StartFlag, UpdateHostStatus, StartCommand, Data, ParameterLine\n");
      writeOutput(gTextString);
    }

}

void client_exited(tag)
    int *tag;
{
    char name[84];

    
    if(dis_get_client(name)) {
	sprintf(gTextString,"Monitor %s (%d) exited\n", name, *tag);
	writeOutput(gTextString);
    } else{
	sprintf(gTextString,"Monitor %d exited\n", *tag);
	writeOutput(gTextString);
    }
}


void ouch(int sig) {
    sprintf(gTextString,"Affair. Being killed. sig=%d \n", sig);
    writeOutput(gTextString);
    hostInfo.statusFlag = 0;
    //dis_update_service(kStartCollecting);
    if (logFile !=0 ) {
	fclose(logFile);
    }
    exit(0);
}
void setupInterrupt(void) {
    //make sure exit gracefully
    struct sigaction act;
    act.sa_handler = ouch;
    sigemptyset(&act.sa_mask);
    act.sa_flags =0;
    sigaction(SIGINT, &act,0);
}

void writeOutput(char * textString){
    time_t the_time;
    struct tm *tm_ptr;
    char timeLabel[256];
    (void) time(&the_time);
    tm_ptr = localtime(&the_time);    
    strftime(timeLabel,74,"%H:%M %d/%b/%y",tm_ptr);
    fprintf(logFile,"Affair:%s:%s:%s: %s",timeLabel,hname,monitorSet,textString);
}

void setupCommon(int logOptionX,int addressX, int sizeX) {

    char* affairPathPtr;
    FILE* read_parameter;
    int chars_read;
    char buffer[256];
    char strCommand[256];

    //make sure exit gracefully
    setupInterrupt();
    // check if there is AFFAIR environment
    affairPathPtr=getenv("AFFAIR");
    if(affairPathPtr) {
	strcpy(affairPath,getenv("AFFAIR"));
    }
    else { 
      printf("Affair. No AFFAIR environment variable! Exit \n ");
      exit(0);
    }
    getMyHostName();
    // setup logfile
    // it can be stdout if logOption ==0, /dev/null if logOption ==1, and in log dir if logoption = 2
    logFile = getLogfile(logOptionX);
    // get some system parameters
    getHostType();
    getProcessorInfo();
    setupHostinfo();
    /* here are the services provided by data collector */    
    startServices(addressX, sizeX); 
    sprintf(gTextString,"setup. host name = %s  dimdnsnode is %s. Services started\n",hostInfo.hname,getenv("DIM_DNS_NODE"));
    writeOutput(gTextString);
}


double getPool(char * disk1,char * disk2,char * disk3,char * disk4,char * disk5)
{
    double pool = 0;

    if(strcmp(disk1,"DUMMY")!=0)  pool += getDiskUsage(disk1);
    if(strcmp(disk2,"DUMMY")!=0)  pool += getDiskUsage(disk2);
    if(strcmp(disk3,"DUMMY")!=0)  pool += getDiskUsage(disk3);
    if(strcmp(disk4,"DUMMY")!=0)  pool += getDiskUsage(disk4);
    if(strcmp(disk5,"DUMMY")!=0)  pool += getDiskUsage(disk5);
    
    return(pool);

}


double getDiskNumber(char * disk1,char * disk2,char * disk3,char * disk4,char * disk5)
{
    double diskNumber = 0;

    if(strcmp(disk1,"DUMMY")!=0)  diskNumber += 1;
    if(strcmp(disk2,"DUMMY")!=0)  diskNumber += 1;
    if(strcmp(disk3,"DUMMY")!=0)  diskNumber += 1;
    if(strcmp(disk4,"DUMMY")!=0)  diskNumber += 1;
    if(strcmp(disk5,"DUMMY")!=0)  diskNumber += 1;
    
    return(diskNumber);

}


char** string_to_argv(char *argstring, int *argc)
{
  char inquotes = 0, *workstring, **argv;
  int i, nchars;
  
  if((nchars = strlen(argstring)) > 0) {
    workstring = (char*)calloc((nchars + 2), sizeof(char*));
    //	fill the array with space characters
    for(i=0; i < (nchars + 2); i++) workstring[i] = ' '; 	  
    //	copy the argstring into the workstring (padded with spaces on both ends)
    for(i=0; i < nchars; i++) workstring[i+1] = argstring[i];
    for((*argc) = 1, i=0; i < nchars + 2; i++) {
      //	count the number of arguements
      if(isgraph(workstring[i]) > 0) {
	//	if current character is not whitespace and previous 
	//      character is whitespace, increment (*argc)
	if((isgraph(workstring[i-1]) == 0) && (inquotes == 0)) (*argc)++;
	//	check for the quote character
	if(workstring[i] == '"') {
	  //	toggle inquotes flag
	  inquotes = (char)(!inquotes);
	}		
      } else {
	//	convert whitespace to null characters
	if(!inquotes) workstring[i] = '\0';
      }
    }
    
    //	no arguements in the string
    if((*argc) == 0){
      free(workstring);
      return NULL;
    } else {
      inquotes = 0;		  
      argv = (char**)calloc((*argc), sizeof(char**));	    
      argv[0] = &workstring[0];
      
      for((*argc) = 1, i=1; i < nchars + 2; i++) {
	// count the number of arguements
	if(isgraph(workstring[i]) > 0) {
	  // if current character is not whitespace and previous 
	  // character is whitespace, increment (*argc)
	  if((isgraph(workstring[i-1]) == 0) && (inquotes == 0)) {
	    argv[(*argc)] = &workstring[i];
	    (*argc)++;
	  }
	  //	check for the quote character
	  if(workstring[i] == '"') {
	    //	toggle inquotes flag
	    inquotes = (char)(!inquotes);
	  }
	}
      }	  
      return argv;
    }
  }
  else {
    (*argc) = 0;
    return NULL;
  }
}




