#include "myMonitoredValues.h"

char* GetMyParameters(int parid, char * par, int isParSetByAffairMonitor)
{
  // insert here code for your parameters
  // if isParSetByAffairMonitor == 1 then the variable is set 
  // by the monitoring station via the gui
  // else do them by hand in the code: this happens when the parameter is 
  // set via the guo to AUTO. This is useful to have correct labels on plots, such as disk names 
  // 

  if (isParSetByAffairMonitor == 1) {
    sprintf(fParameterList[parid],par);
  } else {
    /*
    // example code 
    // the first parameter is set by the moniotring station, while the other
    // two are set by hand to eth0 and hda2
    if (parid == 1) sprintf(fParameterList[parid],"eth0");
    if (parid == 2) sprintf(fParameterList[parid],"hda2");
  */

  }

  return fParameterList[parid];
}

double GetMyMonitoredValues(int i)
{
  //insert here code for your own monitored values
  //i is the variable index, from 0 until the numbero f monitored values -1
  // example below is when have two monitored variables.
  // the first one returns 999.
  // the 2nd one returns 111.
  // modify these to suit your needs
  // the number of variables is defined in myMonitoredValues.h file
  // with MY_MONVALUE_COUNT 

  double myValue;
  if (i==0) myValue = 999.; 
  if (i==1) myValue = 111.; 
  if (i==2)  myValue = 222.; 
  
  if (i==3) {
    //sample code where the monitored value is set based on the parameter set by the gui on the monitoring station
    if (MY_PARAMETERS_COUNT >0 && strcmp(fParameterList[0],"PUT333") == 0   ) {
      myValue = 333.;     
    } else {
      myValue = 444.;     
    }
  }

  return(myValue);
}




