#include <TROOT.h>
#include <TSystem.h>
#include <time.h>
#include <stdio.h>
#include <iostream>
#include <TFile.h>
#include <TApplication.h>  
#include "TDataProcess.h"
#include "TAffairSql.h"
#include "affairGlobals.h"
// shared memory stuff 
#include <sys/types.h>
#include <sys/ipc.h>
#define  USE_TIME_STAMP  1
#define  USE_TIME_STRING 2


Char_t gAffairPath[256];
TDataProcess cc;
Char_t gMonitorSet[256];
Char_t gUser[256];
Char_t gRunOption[256];
Char_t gPeriodOption[256];
Char_t gBeginTime[256];
Char_t gEndTime[256];
string *gRootFileList;
Int_t  gEntries;
Char_t gRootfileListInputFile[256];
Char_t gDirectoryOfRootFiles[256];
Char_t gComputerList[256];
Int_t  gXBinNumber;
Int_t  gSumOrSuperimposedOption;
Int_t  gSelectionVariable;
Int_t  gSelectionLowCut;
Int_t  gSelectionHighCut;
Int_t  gOnlineRunControl;
Int_t  gEachPlotsOption;
Int_t gUseMysql;
TAffairSql * gAffairSql;


void doPlots();
void doGlobalPlotsRrdBoxLoop();
void doGlobalPlotsRrdLoop();
void doGlobalPlotsRrdLastRunLoop();
void doEachPlotsRrdLoop();
void doEachPlotsRrd();
int  doEachPlotsFromTo(Int_t timeEnd, Int_t timePerBin);
int doGlobalPlotsFromTo(Int_t timeEnd,Int_t timePerBin);
Int_t CheckIfDirExists(Char_t * mydir);

int main( int argc, char **argv ) {

Char_t sumOrSuperimposedOption[256];


    if ( argc <= 2) {
	cout << " need parameters to run\n";
	cout  <<" for example: ./AffairPlots -m GDC -r ANA_GLOBAL  "
	      << " (-x 120 -b 3:9:2002/15:56:00 -e 6:9:2002/15:56:00 -i ~/config/inputfileList.conf"
	      << endl << " m= monitorSet (GDC, LDC, DATEMON, SYSMON, no default)"
	      << endl << " x= XBinNumber (deafult 120)"
	      << endl << " p= period option (separate procees for last hour, 20min, day, hourday,rest,all) "
	      << endl << "                   used with RRD_XXXX option. Default is all "
	      << endl << " r= runOption (ANA_GLOBAL,ANA_EACH,RRD_GLOBAL,RRD_EACH,RRD_ONE_COMPUTER) "
	      << endl << " s= sum or superimpose option (SUPERIMPOSE,SUM_AND_SUPERIMPOSE,SUM,BOX,ALL_PLOT_TYPES). Dwfault is ALL_PLOT_TYPES "
	      << endl << " b= beginDate (format is Day:Month:Year/Hour:Min:Second). Used with -e. Only used with ANA_XXX option " 
	      << endl << " e=  endDate(same format as BeginDate)"
	      << endl << " i=  filename for root file list. default is config/rootfilelist.conf "
	      << endl << " c=  filename for computer list. default is to use the rrds in the $AFFAIR/rrd directory"
	      << endl << "     or, this is the actual computer name when used with the -r RRD_ONE_COMPUTER flag"
	      << endl << " v=  index of variable for which time perod selected "
	      << endl << "            (eg. if want runNumber then 0 if first entry in  monset.conf is runNumber."
	      << endl << "             the next two variables are used only if tihs is >=0 "
	      << endl << "             this variable takes precedence over a time period chosen with the =b and =e flags "
	      << endl << " l=  low cut, used  if v >= 0 "
	      << endl << " h=  high cut, used  if v >= 0 "
	      << endl << " u=  user. For offline analyis "
	      << endl << " o=  online. used if want run control to receive graph via messages directly. experimental as of version 1.6.2"
	      << endl << " n=  nodesIndividuallyAlso. To do an offline analysis for all individual plots also."
	      <<endl;
	exit( -1 );
    }
    gROOT->SetBatch();
    sprintf(gAffairPath,"%s",getenv("AFFAIR_MONITOR"));

    cout << " gAffairPath is " << gAffairPath << " mon is " << getenv("AFFAIR_MONITOR")<<endl;
 
    //    gDebugLevel = AFFAIR_DEBUG_LEVEL;
    
    // some default values
    gSumOrSuperimposedOption = -1;
    gXBinNumber        = -1;
    gSelectionVariable = -1;
    gSelectionLowCut   = -1;
    gSelectionHighCut  = -1;
    gOnlineRunControl  = -1;
    gEachPlotsOption   = -1;

    sprintf(gMonitorSet,"%s","DUMMY");
    sprintf(gUser,"%s","DUMMY");
    sprintf(gRunOption,"%s","DUMMY");
    sprintf(gBeginTime,"%s","DUMMY");
    sprintf(gEndTime,"%s","DUMMY");
    sprintf(sumOrSuperimposedOption,"%s","DUMMY");
    sprintf(gRootfileListInputFile,"%s","DUMMY");
    sprintf(gComputerList,"%s","DUMMY");
    sprintf(gPeriodOption,"%s","DUMMY");
    sprintf(gDirectoryOfRootFiles,"%s","DUMMY");


    for(Int_t i=1; i<argc; i++) {
        if ( strncmp(argv[i],"-monitorSet", 2 ) == 0 ) {
	    sprintf(gMonitorSet,"%s",argv[i+1]);
        }
        if ( strncmp(argv[i],"-user", 2 ) == 0 ) {
	    sprintf(gUser,"%s",argv[i+1]);
        }
        else if ( strncmp(argv[i],"-runOption", 2 )  == 0 ) {
	    sprintf(gRunOption,"%s",argv[i+1]);
        }
        else if ( strncmp(argv[i],"-sumOrSuperimposedOption", 2 )  == 0 ) {
	    sprintf(sumOrSuperimposedOption,"%s",argv[i+1]);
	    if (strcmp(sumOrSuperimposedOption,SUM_AND_SUPERIMPOSE) == 0) {
		gSumOrSuperimposedOption = k_SUM_AND_SUPERIMPOSE;
	    } else if (strcmp(sumOrSuperimposedOption,SUM) == 0) {
		gSumOrSuperimposedOption = k_SUM;
	    } else if (strcmp(sumOrSuperimposedOption,SUPERIMPOSE) == 0) {
		gSumOrSuperimposedOption = k_SUPERIMPOSE;
	    } else if (strcmp(sumOrSuperimposedOption,BOX) == 0) {
		gSumOrSuperimposedOption = k_BOX;
	    } else if (strcmp(sumOrSuperimposedOption,ALL_PLOT_TYPES) == 0) {
		gSumOrSuperimposedOption = k_ALL_PLOT_TYPES;
	    } else {
		cout << " invalid sum and/or superimposed option. Exiting " << endl;
		exit(2);
	    }
        } else if ( strncmp(argv[i],"-periodOption", 2 )  == 0 ) {
	    sprintf(gPeriodOption,"%s",argv[i+1]);
        } else if ( strncmp(argv[i],"-xBinNumber", 2 )  == 0 ) {
	       gXBinNumber = atoi(argv[i+1]);
        } else if ( strncmp(argv[i],"-beginTime", 2 )  == 0 ) {
	    sprintf(gBeginTime,"%s",argv[i+1]);
        } else if ( strncmp(argv[i],"-endTime", 2 )  == 0 ) {
	    sprintf(gEndTime,"%s",argv[i+1]);
        } else if ( strncmp(argv[i],"-inputFile", 2 )  == 0 ) {
	    sprintf(gRootfileListInputFile,"%s",argv[i+1]);	    
        } else if ( strncmp(argv[i],"-directoryOfRootFiles", 2 )  == 0 ) {
	    sprintf(gDirectoryOfRootFiles,"%s",argv[i+1]);	    
        } else if ( strncmp(argv[i],"-computerFile", 2 )  == 0 ) {
	    sprintf(gComputerList,"%s",argv[i+1]);	    
        } else if ( strncmp(argv[i],"-Verbose", 2 )  == 0 ) {
	      gDebug = 1;
        } else if ( strncmp(argv[i],"-variable", 2 )  == 0 ) {
	      gSelectionVariable = atoi(argv[i+1]);
        } else if ( strncmp(argv[i],"-highCut", 2 )  == 0 ) {
	      gSelectionHighCut = atoi(argv[i+1]);
        } else if ( strncmp(argv[i],"-lowCut", 2 )  == 0 ) {
	      gSelectionLowCut = atoi(argv[i+1]);
	} else if ( strncmp(argv[i],"-online", 2 )  == 0 ) {
	      gOnlineRunControl = atoi(argv[i+1]);
	} else if ( strncmp(argv[i],"-nodesIndividuallyAlso", 2 )  == 0 ) {
	      gEachPlotsOption  = atoi(argv[i+1]);;
        }
    }

    //


    gAffairSql = 0;
    if (gAffairSql != 0) delete gAffairSql;
    gAffairSql = new TAffairSql;
    gUseMysql = 0;
    gUseMysql = gAffairSql->IsConfiguredMysql();
    
    if (gDebug) cout <<"AffairDataProcess. gUseMysql" << gUseMysql <<endl ;
    if (gUseMysql) {
      gUseMysql = gAffairSql->OpenDatabase();      
      gAffairSql->FillRrdListDefaultValues();
    }

    if (gDebug) cout <<"AffairDataProcess.2 gUseMysql" << gUseMysql <<endl ;

    //

    //consistency check
    if ( strcmp(gMonitorSet,"DUMMY") == 0 ) {
	cout << " Warning. Did not select a monitor set (GDC, LDC, DATEMON,..). Will exit " << endl;
	exit (2);
    }

    if ( strcmp(gRunOption,"DUMMY") == 0 ) {
	cout << " Warning. Did not select a runOption (ANA_GLOBAL,RRD_GLOBAL,..). Will exit " << endl;
	exit (2);
    }

    // now do the appropriate plotting/storing scheme
    doPlots();
}

void doPlots(){
    if ( strcmp(gComputerList,"DUMMY") == 0) {
      sprintf(gComputerList,"%s","ONLINE_RRD_LIST");
    }     
    if (strcmp(gRunOption,RRD_GLOBAL_OPTION) == 0) {
      if ( gSumOrSuperimposedOption == k_BOX) {
	doGlobalPlotsRrdBoxLoop();
      } else {
	doGlobalPlotsRrdLoop();
      }
    } else if (strcmp(gRunOption,RRD_GLOBAL_LASTRUN_OPTION) == 0) {
	doGlobalPlotsRrdLastRunLoop();
    } else if (strcmp(gRunOption,RRD_EACH_OPTION)== 0) {
	doEachPlotsRrdLoop();
    } else if (strcmp(gRunOption,RRD_ONE_COMPUTER_OPTION)== 0) {
	doEachPlotsRrd();
    } else if ( strcmp(gRunOption,ANALYSIS_GLOBAL_OPTION) == 0 || strcmp(gRunOption,ANALYSIS_EACH_OPTION) == 0 
	      || strcmp(gRunOption,ANALYSIS_GLOBAL_EACH_OPTION) == 0 || strcmp(gRunOption,ANALYSIS_ONE_COMPUTER_OPTION) == 0 ) {
	
      Int_t timeFormatOption = USE_TIME_STAMP;
      gEntries        = 0;
      gRootFileList   = 0;	      
      Char_t startTimeSqlFormat[128];
      Char_t endTimeSqlFormat[128];

      if ( gRootFileList != 0) delete [] gRootFileList ;gRootFileList = 0;

      if ( strcmp(gUser,"DUMMY") == 0 ) {
	cout << " user not provided. Assume it is user " << endl;
	sprintf(gUser,"user");
      }
      
      if (gXBinNumber <= 0 ) {
	cout << " bin number <=0. Must be > 0 if have start/end time option. Assume there are 120 bins" << endl;
	gXBinNumber = 120;
      }

      Int_t  startTime  = 0;
      Int_t  endTime    = 0;	
      Int_t  timePerBin = 0;
      Int_t  returnValue;
      time_t the_time;
      (void) time(&the_time);
      struct tm *tm_ptr;
      
      if (strcmp(gBeginTime,"DUMMY") != 0 && strcmp(gEndTime,"DUMMY") != 0 ) {
	Int_t sSecond,sMinute,sHour,sDay,sMonth,sYear;
	Int_t eSecond,eMinute,eHour,eDay,eMonth,eYear;

	tm_ptr  = localtime(&the_time);
	
	cout << " startTimeString=" << gBeginTime << " endTimeString=" << gEndTime << endl; 
	
	if (timeFormatOption == USE_TIME_STRING) {
	  sscanf(gBeginTime,"%i:%i:%i/%i:%i:%i",&sDay,&sMonth,&sYear,&sHour,&sMinute,&sSecond);
	  sscanf(gEndTime,"%i:%i:%i/%i:%i:%i ",&eDay,&eMonth,&eYear,&eHour,&eMinute,&eSecond);
	  cout << " sDay="<<sDay<< " sMonth="<<sMonth<<" sYear="<<sYear<<"sHour="<<sHour<<" sMinute="<<sMinute<<" sSecond="<<sSecond<<endl;  
	  cout << " eDay="<<eDay<< " eMonth="<<eMonth<<" eYear="<<eYear<<"eHour="<<eHour<<" eMinute="<<eMinute<<" eSecond="<<eSecond<<endl;  
	  printf(" gbegin time is %s day mon year hour min sec is %i %i %i %i %i %i \n",gBeginTime,sDay,sMonth,sYear,sHour,sMinute,sSecond);
	  tm_ptr->tm_year = (Int_t) (sYear)-1900;
	  tm_ptr->tm_mon  = (Int_t) (sMonth)-1;
	  tm_ptr->tm_mday = (Int_t) sDay;
	  tm_ptr->tm_hour = (Int_t) sHour;
	  tm_ptr->tm_min  = (Int_t) sMinute;
	  tm_ptr->tm_sec  = (Int_t) sSecond;

	  
	  startTime = mktime(tm_ptr);	  
	  strftime(startTimeSqlFormat,64,"%Y-%m-%d %H:%M:%S",tm_ptr);
	  if (gDebug) cout << "startTime=" << startTime << " year=" << tm_ptr->tm_year << "tm_mon=" << tm_ptr->tm_mon  << "tm_day=" << tm_ptr->tm_mday
	       << "tm_sec=" << tm_ptr->tm_sec <<endl; 
	  
	  tm_ptr->tm_year = (Int_t) eYear-1900;
	  tm_ptr->tm_mon  = (Int_t) (eMonth)-1;
	  tm_ptr->tm_mday = (Int_t) eDay;
	  tm_ptr->tm_hour = (Int_t) eHour;
	  tm_ptr->tm_min  = (Int_t) eMinute;
	  tm_ptr->tm_sec  = (Int_t) eSecond;
	  
	  endTime = mktime(tm_ptr);
	  
	  strftime(endTimeSqlFormat,64,"%Y-%m-%d %H:%M:%S",tm_ptr);
	   if (gDebug)cout << "endTime=" << endTime << " year=" << tm_ptr->tm_year << "tm_mon=" << tm_ptr->tm_mon 
	       << "tm_day=" << tm_ptr->tm_mday << "tm_sec=" << tm_ptr->tm_sec <<endl; 
	} else {
	  sscanf(gBeginTime,"%i",&startTime);
	  sscanf(gEndTime,"%i",&endTime);


          Int_t beginTimeInt = atoi (gBeginTime);
          Int_t endTimeInt   = atoi (gEndTime);
          tm_ptr = localtime((const time_t *) &beginTimeInt);
          strftime(startTimeSqlFormat,64,"%Y-%m-%d %H:%M:%S",tm_ptr);


          tm_ptr = localtime((const time_t *) &endTimeInt);
          strftime(endTimeSqlFormat,64,"%Y-%m-%d %H:%M:%S",tm_ptr);
	   if (gDebug) printf(" starttime is %s end time is %s gBeginTime is %s gEndTime is %s startTim e is %i endTime is %i \n",startTimeSqlFormat,endTimeSqlFormat,gBeginTime,gEndTime,startTime,endTime) ;
 

	}

	Int_t deltaTime = (Int_t) difftime(endTime,startTime);
	
	// take care if delta time < 20 min
	// now kludge make more elwegant in future
	if (deltaTime <= 1200 && deltaTime > 800 ) gXBinNumber = 80;
	if (deltaTime <= 800 && deltaTime > 400 ) gXBinNumber = 40;
	if (deltaTime <= 400) gXBinNumber = 20;

	timePerBin = deltaTime/gXBinNumber;
	if (gDebug) printf(" delta time is %d\n",deltaTime );
	if (gDebug) cout << " endTime = " <<endTime << " startTime = " << startTime << "  gXBinNumber = " 
			 << gXBinNumber<< " deltaTime = " << deltaTime << "  timePerBin = " << timePerBin << endl;
	
	if ( strcmp(gRootfileListInputFile,"DUMMY") == 0 ) {	      
	  if (!gUseMysql) {
	    // create rootfilelist from directory only if rootfilelist not set, and place the values 
	    // in default rootfilelist
	    if ( strcmp(gDirectoryOfRootFiles,"DUMMY") == 0  ) {
	      cout << " input file directory not provided. Assume it is $AFFAIR_MONITOR/backup " << endl;
	      sprintf(gDirectoryOfRootFiles,"%s/backup",gAffairPath);
	    }
	    
	    if (strcmp(gRunOption,ANALYSIS_ONE_COMPUTER_OPTION) == 0 ) {
	      sprintf(gRootfileListInputFile,"%s/config/rootfilelist_%s_%s.conf",gAffairPath,gComputerList,gUser);	  
	    } else {
	      sprintf(gRootfileListInputFile,"%s/config/rootfilelist_%s.conf",gAffairPath,gUser);
	    }
	    	    
	    Char_t sysCommand[256];
	    sprintf(sysCommand,"%s/support/listRootfiles.pl %s %s %s %i %i %s",gAffairPath,gMonitorSet,gDirectoryOfRootFiles,gRootfileListInputFile,startTime,endTime,gComputerList);	
	    FILE* read_parameter;
	    int chars_read;
	    char buffer[80];
	    read_parameter = popen(sysCommand,"r");
	    if(read_parameter !=NULL){
	      chars_read =  fread(buffer,sizeof(char),80,read_parameter);
	      if (chars_read > 0) gEntries = (int) atoi(buffer);      
	    }
	    pclose(read_parameter);

	    if ( gEntries > 0 ) {
	      FILE     *table_fp;    
	      char      line[512]; 
	      char      fileName[512]; 
	      Int_t     ncols;
	      Char_t   *ptr;

	      gRootFileList = new  string[gEntries] ;    
	      table_fp = fopen(gRootfileListInputFile,"r");    
	      gEntries = 0;
	      while (fgets(line,512,table_fp)) {
		for(ptr=line;;ptr++){
		  if (*ptr==0) break;
		  if (!isspace(*ptr)) break;
		}       
		if (*ptr=='#') continue;
		if (strlen(line) < 2) continue;

		ncols = sscanf(line,"%s",&fileName);       
		gRootFileList[gEntries] = fileName;
		gEntries++;
	      }    
	      fclose(table_fp);
	    }
	  }  else {
	    // USE MYSQL
	    Char_t compname[256];
	    sprintf(compname,"");
	    if (strcmp(gRunOption,ANALYSIS_ONE_COMPUTER_OPTION) == 0) sprintf(compname,"%s",gComputerList);
	    gRootFileList = gAffairSql->GetRootFileList(startTimeSqlFormat,endTimeSqlFormat,compname,gMonitorSet,&gEntries);
	  }
	}
      }	    
      
      if (gEntries > 0 ) {
	if (strcmp(gRunOption,ANALYSIS_GLOBAL_OPTION) == 0) {
	  returnValue = doGlobalPlotsFromTo(endTime,timePerBin);
	} else if (strcmp(gRunOption,ANALYSIS_EACH_OPTION) == 0) {
	  returnValue = doEachPlotsFromTo(endTime,timePerBin);
	} else if (strcmp(gRunOption,ANALYSIS_ONE_COMPUTER_OPTION) == 0) {
	  returnValue = doEachPlotsFromTo(endTime,timePerBin);
	}
      }else {
	cout << " no appropriate root files for this time period, or monitoring set or choice of nodes. exiting."  << endl;
	exit(2);
      }

    } else  {
      cout << " forgot to have start or end time. exiting."  << endl;
      exit(2);
    }
}    


void doGlobalPlotsRrdLoop(){
    Int_t returnInitValue;    
    Int_t loopCount     = 0;
    Int_t dirExistsFlag = 0;
    time_t     the_time;
    struct tm *tm_ptr;
    struct tm *tm_ptr_onedayago;
    char newDir[256];
    char newDirFullPath[256];
    Char_t sysCommand[512];

    
    if (  gSumOrSuperimposedOption < 0 ) {
	cout << " Warning. Did not select a sumOrSuperimposedOption (SUM_AND_SUPERIMPOSE,SUM,SUPERIMPOSE,BOX_ALL_PLOT_TYPES) " << endl << "Will assume all plottypes " << endl;
	gSumOrSuperimposedOption = k_ALL_PLOT_TYPES;
    }

    if ( gXBinNumber <= 0 ) {
	cout << " Warning. xbin number is <=0. Will set it to 120" << endl;       
	gXBinNumber = 120;
    }

    if ( strcmp(gPeriodOption,"DUMMY") == 0) {
	cout << " period option not provided. Assume it is for all periods " << endl;
	sprintf(gPeriodOption,"%s","all");
    } 

    // create rrdlist file
    if (!gUseMysql) {
      sprintf(sysCommand,"%s/support/listRRD.pl",gAffairPath);	
      gSystem->Exec(sysCommand);
    }

    Int_t binDeltaTimeHour = (Int_t) 3600/gXBinNumber; 

    if (gUseMysql) cc.SetMysql(gAffairSql);
    returnInitValue = cc.Init(gMonitorSet,gXBinNumber,gRunOption,gComputerList,NO_ROOTFILE_STORAGE,"global");    
     if (gDebug) cout << " doGlobalPlotsRrdLoop " << endl;

    if (returnInitValue) {	      
      while(1){
	Int_t TimeNow  = (Int_t) (time(0)-10.0);
	(void) time(&the_time);
	if (strcmp(gPeriodOption,"hour") == 0) {		
	  cc.GlobalPlotsRrd("hour",binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 1 hour 
	}
	else if (strcmp(gPeriodOption,"6hour") == 0) {		
	  cc.GlobalPlotsRrd("6hour",6*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 1 hour 
	}
	else if (strcmp(gPeriodOption,"day") == 0) {
	  cc.GlobalPlotsRrd("day",24*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 24 hour 
	}
	else if (strcmp(gPeriodOption,"20min") == 0) {
	  cc.GlobalPlotsRrd("20min",Int_t(binDeltaTimeHour/3),12,TimeNow,gSumOrSuperimposedOption); // 10 min 
	}
	else if (strcmp(gPeriodOption,"hourday") == 0) {
	  cc.GlobalPlotsRrd("hour",binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 1 hour 
	  cc.GlobalPlotsRrd("day",24*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 24 hour 
	}
	else if (strcmp(gPeriodOption,"20minhourday") == 0) {
	  cc.GlobalPlotsRrd("20min",Int_t(binDeltaTimeHour/3),12,TimeNow,gSumOrSuperimposedOption); // 10 min 
	  cc.GlobalPlotsRrd("hour",binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 1 hour 
	  cc.GlobalPlotsRrd("day",24*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 24 hour 
	}
	else if (strcmp(gPeriodOption,"20min6hour7daysmonth") == 0) {
	  cc.GlobalPlotsRrd("20min",Int_t(binDeltaTimeHour/3),12,TimeNow,gSumOrSuperimposedOption); // 10 min 
	  cc.GlobalPlotsRrd("6hour",6*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 6 hour
	  cc.GlobalPlotsRrd("7days",168*binDeltaTimeHour,15,TimeNow,gSumOrSuperimposedOption); // 7 days
	  cc.GlobalPlotsRrd("month",720*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 30 days
	}
	else if (strcmp(gPeriodOption,"6hour7daysmonth") == 0) {
	  cc.GlobalPlotsRrd("6hour",6*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 6 hour
	  cc.GlobalPlotsRrd("7days",168*binDeltaTimeHour,15,TimeNow,gSumOrSuperimposedOption); // 7 days
	  cc.GlobalPlotsRrd("month",720*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 30 days
	}
	else if (strcmp(gPeriodOption,"rest") == 0) {
	  cc.GlobalPlotsRrd("6hour",6*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 6 hour
	  cc.GlobalPlotsRrd("7days",168*binDeltaTimeHour,15,TimeNow,gSumOrSuperimposedOption); // 7 days
	  cc.GlobalPlotsRrd("month",720*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 30 days
	}
	else if (strcmp(gPeriodOption,"all") == 0) {
	  cc.GlobalPlotsRrd("month",720*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 30 days
	  cc.GlobalPlotsRrd("20min",Int_t(binDeltaTimeHour/3),12,TimeNow,gSumOrSuperimposedOption); // 20 min 
	  cc.GlobalPlotsRrd("hour",binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 1 hour 
	  cc.GlobalPlotsRrd("6hour",6*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 6 hour
	  cc.GlobalPlotsRrd("day",24*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 24 hour
	  cc.GlobalPlotsRrd("7days",168*binDeltaTimeHour,15,TimeNow,gSumOrSuperimposedOption); // 7 days
	}
	else {
	  if (loopCount%4 == 0 ) cc.GlobalPlotsRrd("month",720*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 30 days
	  cc.GlobalPlotsRrd("20min",Int_t(binDeltaTimeHour/3),12,TimeNow,gSumOrSuperimposedOption); // 20 min 
	  cc.GlobalPlotsRrd("hour",binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 1 hour 
	  cc.GlobalPlotsRrd("6hour",6*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 6 hour
	  cc.GlobalPlotsRrd("day",24*binDeltaTimeHour,12,TimeNow,gSumOrSuperimposedOption); // 24 hour 
	  if (loopCount%3 == 0 ) cc.GlobalPlotsRrd("7days",168*binDeltaTimeHour,15,TimeNow,gSumOrSuperimposedOption); // 7 days
	  loopCount++;
	}
	// check now if midnight has just passed. If so, make a directory with the old date (SYSMON_21012005), and put the "day"
	// eps files in there, and convert them to png
	

	//	 (void) time(&the_time);

	Int_t oldTime  = (Int_t) (time(0)-24.*60.*60.);    		
	Int_t nowTime  = (Int_t) (time(0));    		

	tm_ptr_onedayago = localtime((const time_t *)&oldTime);    
	strftime(newDir,256,"%d%m%Y",tm_ptr_onedayago);

	tm_ptr           = localtime((const time_t *)&nowTime);  

	// find also number of seconds from midnight. Only consider if less than 10? minutes
	
	Int_t nowHour    = tm_ptr->tm_hour;
	Int_t nowMinutes = tm_ptr->tm_min;

	if (nowHour == 0 && nowMinutes < 20 ) {
	  // need to subtract one day
	  //	  strftime(newDir,256,"%d%m%Y",tm_ptr_onedayago);
	  sprintf(newDirFullPath,"%s/plots/%s",gAffairPath,newDir);
	  dirExistsFlag = CheckIfDirExists(newDirFullPath);
	  if (dirExistsFlag != 1) {
	    sprintf(sysCommand,"if [ ! -d %s ]; then mkdir %s; cp  %s/plots/*.eps  %s; chmod a+w %s/.; fi",newDirFullPath,newDirFullPath,gAffairPath,newDirFullPath,newDirFullPath);	
	    gSystem->Exec(sysCommand);
	    cout << " create new dir = " << newDirFullPath << endl; 
	  }	  
	}		
	(Int_t) cc.InitQuick(gComputerList,"global");	
	gSystem->Sleep(kCycleDelay);
      }
    } else {
      //      cout << " could not load rrd file. exiting." << endl;
      cout << " could not load rrd file. try again in 2 min" << endl;
	gSystem->Sleep(120000);
	doGlobalPlotsRrdLoop();
    }	    
}

void doGlobalPlotsRrdBoxLoop(){
    Int_t returnInitValue;    

    if ( gXBinNumber <= 0 ) {
	cout << " Warning. xbin number is <=0. Will set it to 120" << endl;       
	gXBinNumber = 120;
    }

    if ( strcmp(gPeriodOption,"DUMMY") == 0) {
	cout << " period option not provided. Assume it is for all periods " << endl;
	sprintf(gPeriodOption,"%s","all");
    } 


    // create rrdlist file
    if (!gUseMysql) {
      Char_t sysCommand[256];
      sprintf(sysCommand,"%s/support/listRRD.pl",gAffairPath);	
      gSystem->Exec(sysCommand);
    }
    Int_t binDeltaTimeHour = (Int_t) 3600/gXBinNumber; 

    cc.SetCanvasYFactor(0.5);
    if (gUseMysql) cc.SetMysql(gAffairSql);
    returnInitValue = cc.Init(gMonitorSet,gXBinNumber,gRunOption,gComputerList,NO_ROOTFILE_STORAGE,"global");    

    if (returnInitValue) {	      
      while(1){
	Int_t TimeNow  = (Int_t) (time(0)-10.0);    		
	cc.GlobalPlotsRrd("20min",Int_t(binDeltaTimeHour/3),12,TimeNow,gSumOrSuperimposedOption); // 20 min 
	(Int_t) cc.InitQuick(gComputerList,"global");
	gSystem->Sleep(kCycleDelay);
      }
    } 
    else {
      cout << " could not load root file. exiting." << endl;
    }	    
}


void doGlobalPlotsRrdLastRunLoop(){
}

void doEachPlotsRrdLoop(){
    Int_t returnInitValue;
    Int_t loopCount = 0;
    
    if ( gSumOrSuperimposedOption < 0 ) {
	cout << " Warning. Did not select a sumOrSuperimposedOption (SUM_AND_SUPERIMPOSE,SUM,SUPERIMPOSE)"
	     << endl << "Will assume both " << endl;
	gSumOrSuperimposedOption = k_SUM_AND_SUPERIMPOSE;
    }
    
    if ( gXBinNumber <= 0 ) {
	cout << " Warning. xbin number is <=0. Will set it to 120" << endl;       
	gXBinNumber = 120;
    }

    if ( strcmp(gPeriodOption,"DUMMY") == 0) {
	cout << " period option not provided. Assume it is for all periods " << endl;
	sprintf(gPeriodOption,"%s","all");
    } 



    // create rrdlist file
    if (!gUseMysql) {
      Char_t sysCommand[256];
      sprintf(sysCommand,"%s/support/listRRD.pl",gAffairPath);	
      gSystem->Exec(sysCommand);
    }
    Int_t binDeltaTimeHour = (Int_t) 3600/gXBinNumber; 

    if (gUseMysql) cc.SetMysql(gAffairSql);
    returnInitValue = cc.Init(gMonitorSet,gXBinNumber,gRunOption,gComputerList,NO_ROOTFILE_STORAGE,"each");
    if (returnInitValue) {
	while(1){      
	  //	  Int_t TimeNow  = time(0);
	  Int_t TimeNow  = (Int_t) (time(0)-10.0);    		    		
	  cc.EachPlotsRrd("20min",Int_t(binDeltaTimeHour/3),12,TimeNow); // 20 min 
	  cc.EachPlotsRrd("hour",binDeltaTimeHour,12,TimeNow); // 1 hour 
	  cc.EachPlotsRrd("6hour",6*binDeltaTimeHour,12,TimeNow); // 6 hour
	  cc.EachPlotsRrd("day",24*binDeltaTimeHour,12,TimeNow); // 24 hour 
	  if (loopCount%3 == 0 ) cc.EachPlotsRrd("7days",168*binDeltaTimeHour,15,TimeNow); // 7 days
	  if (loopCount%4 == 0 ) cc.EachPlotsRrd("month",720*binDeltaTimeHour,12,TimeNow); // 30 days
	  loopCount++;
	  (Int_t) cc.InitQuick(gComputerList,"each");
	}
    }
    else {
	cout << " could not load root file. exiting." << endl;
    }	    
    gSystem->Sleep(kCycleDelay);
}


void doEachPlotsRrd(){
    Int_t returnInitValue;

    if ( gSumOrSuperimposedOption < 0 ) {
	cout << " Warning. Did not select a sumOrSuperimposedOption (SUM_AND_SUPERIMPOSE,SUM,SUPERIMPOSE)"
	     << endl << "Will assume both " << endl;
	gSumOrSuperimposedOption = k_SUM_AND_SUPERIMPOSE;
    }

    if ( gXBinNumber <= 0 ) {
	cout << " Warning. xbin number is <=0. Will set it to 120" << endl;       
	gXBinNumber = 120;
    }

    if ( strcmp(gPeriodOption,"DUMMY") == 0) {
	cout << " period option not provided. Assume it is for all periods " << endl;
	sprintf(gPeriodOption,"%s","all");
    } 


    Int_t binDeltaTimeHour = (Int_t) 3600/gXBinNumber; 

    if (gUseMysql) cc.SetMysql(gAffairSql);
    returnInitValue = cc.Init(gMonitorSet,gXBinNumber,gRunOption,gComputerList,NO_ROOTFILE_STORAGE,"each");
    if (returnInitValue) {
      //	Int_t TimeNow  = time(0);    		
      Int_t TimeNow  = (Int_t) (time(0)-10.0);    		
      cc.EachPlotsRrd("day",24*binDeltaTimeHour,12,TimeNow); // 24 hour 
      cc.EachPlotsRrd("20min",Int_t(binDeltaTimeHour/3),12,TimeNow); // 1 hour
      cc.EachPlotsRrd("hour",binDeltaTimeHour,12,TimeNow); // 1 hour 
      cc.EachPlotsRrd("6hour",6*binDeltaTimeHour,12,TimeNow); // 6 hour
      cc.EachPlotsRrd("7days",168*binDeltaTimeHour,15,TimeNow); // 7 days
      cc.EachPlotsRrd("month",720*binDeltaTimeHour,12,TimeNow); // 30 days
    }
    else {
	cout << " could not load root file. exiting." << endl;
    }	    
}


int doEachPlotsFromTo(Int_t timeEnd,Int_t timePerBin){
    Int_t returnInitValue;
    Char_t sysCommand[256];

    if ( gSumOrSuperimposedOption < 0 ) {
	cout << " Warning. Did not select a sumOrSuperimposedOption (SUM_AND_SUPERIMPOSE,SUM,SUPERIMPOSE)"
	     << endl << "Will assume both " << endl;
	gSumOrSuperimposedOption = k_SUM_AND_SUPERIMPOSE;
    }
    // create rrdlist file
    if (!gUseMysql) {
      sprintf(sysCommand,"%s/support/listRRD.pl",gAffairPath);	
      gSystem->Exec(sysCommand);
    }
    Char_t rootFileName[256];
    sprintf(rootFileName,"%s.root",gUser);	

   
    Char_t affairPlotPath[256];
    sprintf(affairPlotPath,"%s/plots/%s",getenv("AFFAIR_MONITOR"),gUser);
    sprintf(sysCommand,"mkdir -p %s;chmod a+w %s; chmod a+w %s/.; ",affairPlotPath,affairPlotPath,affairPlotPath);	
    gSystem->Exec(sysCommand);
    cc.SetPlotDir(affairPlotPath);

    if (gUseMysql) cc.SetMysql(gAffairSql);
    returnInitValue = cc.Init(gMonitorSet,gXBinNumber,gRunOption,gComputerList,NO_ROOTFILE_STORAGE,"each");
    if (returnInitValue) {
	cc.SetRootFileList(gRootFileList,gEntries);
	cc.EachPlotsOffline(gUser,timePerBin,12,timeEnd,gSelectionVariable,gSelectionLowCut,gSelectionHighCut); //		
	cc.CloseFile();
    }
    else {
	cout << " could not load root file. exiting." << endl;
	exit(0);
    }
    exit(0);
}


int doGlobalPlotsFromTo(Int_t timeEnd,Int_t timePerBin){
    Int_t returnInitValue;
    Char_t sysCommand[256];

    if ( gSumOrSuperimposedOption < 0 ) {
	cout << " Warning. Did not select a sumOrSuperimposedOption (SUM_AND_SUPERIMPOSE,SUM,SUPERIMPOSE)"
	     << endl << "Will assume both " << endl;
	gSumOrSuperimposedOption = k_SUM_AND_SUPERIMPOSE;
    }


    // create rrdlist file
    if (!gUseMysql) {
      sprintf(sysCommand,"%s/support/listRRD.pl",gAffairPath);	
      gSystem->Exec(sysCommand);
    }
    Char_t rootFileName[256];
    sprintf(rootFileName,"%s.root",gUser);	
    //sprintf(sysCommand,"rm -f %s/plots/%s",gAffairPath,rootFileName);	

    Char_t affairPlotPath[256];
    sprintf(affairPlotPath,"%s/plots/%s",getenv("AFFAIR_MONITOR"),gUser);
    sprintf(sysCommand,"mkdir  -p %s;chmod a+w %s; chmod a+w %s/.; ",affairPlotPath,affairPlotPath,affairPlotPath);	
    gSystem->Exec(sysCommand);
    cc.SetPlotDir(affairPlotPath);

 
    if (gUseMysql) cc.SetMysql(gAffairSql);
    returnInitValue = cc.Init(gMonitorSet,gXBinNumber,gRunOption,gComputerList,NO_ROOTFILE_STORAGE,"global");
    if (returnInitValue) {
       cc.SetRootFileList(gRootFileList,gEntries);
      if (gEachPlotsOption >=0) cc.SetEachPlotsOption(gEachPlotsOption);
      cc.GlobalPlotsOffline(gUser,timePerBin,12,timeEnd,gSumOrSuperimposedOption,gSelectionVariable,gSelectionLowCut,gSelectionHighCut); //	
      cc.CloseFile();
    }
    else {
      cout << " could not load root file. exiting." << endl;
      exit(0);
    }
    exit(0);
}




Int_t CheckIfDirExists(Char_t * mydir)
{
  Char_t line[256];
  Char_t aux[256];    
  Int_t dirExistsStatus = -1;
  sprintf(aux,"source %s/support/isDir.sh %s",gAffairPath,mydir);	
  FILE *fp = gSystem->OpenPipe(aux,"r");
  if(fp != NULL) {
    // consistency check. Should get -1 if not exists, and 1 if exists
    fgets(line,256,fp);
  } else {		
    cout  << " fp is null. This should not happen " << endl;
  }
  gSystem->ClosePipe(fp);
  dirExistsStatus = atoi(line);	    	
  return(dirExistsStatus);
}














