#include <stdio.h>
#include <stdlib.h> 
#include "hostInfo.h"
#include <map> 
#include <sys/types.h>
#include <sys/ipc.h>

#include <signal.h>
#include "TAffairDim.h"

#include "AffairMonitor.h"

//Int_t gDebug;

DimData **   gDimDataServices;

void ouch(int sig) {
  cout << "Received interrupt. About to exit AffairMonitor.Will close gracefully all " << gServiceNumber << " files.Do not interupt. " <<endl;
  for (Int_t i=0; i <gServiceNumber ;i++) { 
    if (gDebug) cout << "  CloseFile i="<<i <<endl; 
    if ( gDimDataServices[i] != 0) {
      gDimDataServices[i]->Shutdown();
    }      
  }
  cout << "All files closed " <<endl;
  exit(0);
}

void setupInterrupt(void) {  
    //make sure exit gracefully
    struct sigaction act;
    act.sa_handler = ouch;
    sigemptyset(&act.sa_mask);
    act.sa_flags =0;
    sigaction(SIGINT, &act,0);

}

int main( int argc, char **argv ) 
{ 

  DimBrowser dbr;
  DimData *theService;

  
  char fullServiceName[256];
  char hnameAndMonset[256];

  char tbedName[128];
  char aux[256];
  char monsetDefault[64];
  char line[256]; 
  Int_t offlineStorageFlag;

  Int_t     ncols;
  string   *nodeList = 0;
  Int_t     fileNumber;
  
  Int_t        monitoringStationTimeOrRemoteNodeTimeOption;
  Int_t        useMysql;
  TAffairSql  *affairSql;


  sprintf(gAffairPath,"%s",getenv("AFFAIR_MONITOR"));

  //sprintf(aux,"%s/log/monitor.log",gAffairPath);
  //fout.open(aux,ios::out | ios::app );
  monitoringStationTimeOrRemoteNodeTimeOption = USE_REMOTE_NODE_TIME_OPTION;
  //  localOrRemoteTimeOption = USE_LOCAL_NODE_OPTION;
  gDebug    = 0;

  affairSql = 0;
  if (affairSql != 0) delete affairSql;
  affairSql = new TAffairSql;
 
  useMysql = affairSql->IsConfiguredMysql();
  
  /*
  if ( (useMysql == 0 && argc != 4 && argc != 5) ||  (useMysql == 0 && argc != 3 && argc != 4) ) {
    cout << getTime() <<" Affair Monitor not started properly.  Format is  nodeListFile monitorSet offlineStorageFlag. For example: " << endl
	 << "$AFFAIR_MONITOR/src/root/AffairMonitor  $AFFAIR_MONITOR/config/computerlist.conf   GDC 1 " << endl 
	 <<"  offlineStorageFlag = 0 for no offline root storage file (only round robin) and 1 otherwise (both of them). " <<endl
	 <<"  if mysql is used, then the nodelist file is not entered, as it comes from the computerlist mysql table " <<endl;
    exit( -1 );
  }
  */


  if (  argc != 4 && argc != 5 ) {
    cout << getTime() <<" Affair Monitor not started properly.  Format is  nodeListFile monitorSet offlineStorageFlag. For example: " << endl
	 << "$AFFAIR_MONITOR/src/root/AffairMonitor  $AFFAIR_MONITOR/config/computerlist.conf   GDC 1 " << endl 
	 <<"  offlineStorageFlag = 0 for no offline root storage file (only round robin) and 1 otherwise (both of them). " <<endl;
    exit( -1 );
  }


  sprintf(aux,argv[1]); 
  sprintf(monsetDefault,argv[2]);
  offlineStorageFlag = atoi(argv[3]);

  if ( argc == 5 ) {
    if ( strncmp(argv[4],"-V", 2 )  == 0 ||  strcmp(argv[4],"verbose")  == 0 ) gDebug = 1;
  }

  setupInterrupt();

  if (useMysql) useMysql = affairSql->OpenDatabase();
  if (gDebug)  cout << "AffairMonitor.useMysql= " << useMysql << endl;

  FILE *table_fp;    
  Char_t *ptr;

  if (useMysql) {
    nodeList = affairSql->GetColumn("AFFAIR_COMPUTERLIST",&fileNumber,0, " ");

    if (fileNumber <= 0) {
      printf("no nodes specified.Exit. \n");
      return 0;
    }
    // now update rrd list values. This is to make sure all rrds are in mysql tables, to prevent
    // Ssome rrds not listed when mysql is down.
    affairSql->FillRrdListDefaultValues();

    if (gDebug) {
      cout <<"affaircontrol.fileNumber= " <<fileNumber<<endl;
      if (fileNumber > 0) {
	for (Int_t i = 0; i < fileNumber; i++) {
	  cout << " testtstr = " << nodeList[i] << " .Data = " << nodeList[i].c_str() << endl;
	}  
      }
    }
    //get option if use local time or global time, from database
    monitoringStationTimeOrRemoteNodeTimeOption = atoi(affairSql->GetAffairParameter(kMonitoringStationTimeOrRemoteNodeTimeOptionIndex)); 
    if (gDebug)  printf(" localOrRemoteTimeOption =%d \n",monitoringStationTimeOrRemoteNodeTimeOption);
  } else {    
    table_fp = fopen(aux,"r");    
    fileNumber = 0;
    while (fgets(line,256,table_fp)) {
      for(ptr=line;;ptr++){
	if (*ptr==0) break;
	if (!isspace(*ptr)) break;
      }       
      if (*ptr=='#') continue;
      if (strlen(line) < 2) continue;

      ncols = sscanf(line,"%s",&tbedName);       
      fileNumber++;
    }    
    fclose(table_fp);

    if ( nodeList != 0) delete [] nodeList ;nodeList = 0;
    nodeList = new  string[fileNumber] ;    
    table_fp = fopen(aux,"r");    
    fileNumber = 0;
    while (fgets(line,256,table_fp)) {
      for(ptr=line;;ptr++){
	if (*ptr==0) break;
	if (!isspace(*ptr)) break;
      }       
      if (*ptr=='#') continue;
      if (strlen(line) < 2) continue;
      ncols = sscanf(line,"%s",&tbedName);       
      nodeList[fileNumber] = tbedName;
      fileNumber++;
    }    
    fclose(table_fp);
  }
 
  gDimDataServices  = 0;
  gDimDataServices  = new DimData*[fileNumber];
  gServiceNumber    = 0;
  
  for (Int_t ii = 0; ii < fileNumber; ii++) {
    sprintf(hnameAndMonset,"%s_%s",nodeList[ii].c_str(),monsetDefault);
    if (gDebug)  cout << "AffairMonitor. nodeList[ii].c_str()= " << nodeList[ii].c_str() << endl;
    if (gDebug)  cout << "AffairMonitor. monsetDefault= " << monsetDefault << endl;
    if (gDebug)  cout << "AffairMonitor. hnameAndMonset= " << hnameAndMonset << endl;

    sprintf(fullServiceName,"Affair/%s/UpdateHostStatus",hnameAndMonset);
   
    if (gDebug)  cout << "AffairMonitor.fullServiceName= " << fullServiceName << endl;


    theService = new DimData(fullServiceName,-1);
    if (useMysql) theService->UseMysql(affairSql);  

    sprintf(fullServiceName,"Affair/%s/StartFlag",hnameAndMonset);
    theService = new DimData(fullServiceName,-1);
    if (useMysql) theService->UseMysql(affairSql);  

    sprintf(fullServiceName,"Affair/%s/Data",hnameAndMonset);

  
    gDimDataServices[gServiceNumber]  = new DimData(fullServiceName,-1);  
    //    gDimDataServices[gServiceNumber]->SetUseLocalNodeTime(USE_LOCAL_NODE_OPTION);  
    gDimDataServices[gServiceNumber]->SetUseRemoteNodeTime(monitoringStationTimeOrRemoteNodeTimeOption);  
    if (useMysql) gDimDataServices[gServiceNumber]->UseMysql(affairSql);  
    gDimDataServices[gServiceNumber]->OpenFile(hnameAndMonset,offlineStorageFlag);  

    gServiceNumber++;

    sprintf(fullServiceName,"Affair/%s/ParameterLine",hnameAndMonset);
    theService = new DimData(fullServiceName,-1);  
    if (useMysql) theService->UseMysql(affairSql);  
  }


  while(1) {
       pause();
  }    
} 

 
 



