#define TPlotMaker_cxx
#include "TPlotMaker.h"

/// ClassImp(TPlotMaker)

void TPlotMaker::CreateRootFile(Char_t * fileName, Char_t headerName[128]) 
{
    Char_t fileNameFull[256];
    Char_t dirName[256];
    TKey* key;

    sprintf(fileNameFull,"%s/%s",fAffairPlotPath,fileName);
    gRootFile = new TFile(fileNameFull,"UPDATE");
    gRootFile->cd();
    
 
    fDirTop      = new TDirectory;
    fDirTopGraph = new TDirectory;
    fDirTopHisto = new TDirectory;
    fDirTopComp  = new TDirectory;

    sprintf(dirName,"%s",headerName);
    key = gRootFile->GetKey(dirName);
    if (!key){
      fDirTop = gRootFile->mkdir(dirName); 
    }else {
      gRootFile->cd(dirName); 
      fDirTop = gDirectory; 
    }
    fDirTop->cd();

    sprintf(dirName,"%s_%s",headerName,"graphs");
    key = fDirTop->GetKey(dirName);
    if (!key){
      fDirTopGraph = fDirTop->mkdir(dirName); 
    }else {
      fDirTop->cd(dirName); 
      fDirTopGraph = gDirectory; 
    }

    sprintf(dirName,"%s_%s",headerName,"histograms");
    key = fDirTop->GetKey(dirName);
    if (!key)  {
      fDirTopHisto = fDirTop->mkdir(dirName); 
    }else {
      fDirTop->cd(dirName); 
      fDirTopHisto = gDirectory; 
    }

    sprintf(dirName,"%s_%s",headerName,"computers");
    key = fDirTop->GetKey(dirName);
    if (!key) { 
      fDirTopComp = fDirTop->mkdir(dirName); 
    }else {
      fDirTop->cd(dirName); 
      fDirTopComp = gDirectory; 
    }

}



void TPlotMaker::MkDir(Int_t compNumber, Int_t lComp, Char_t * compName) 
{
    TKey* key;

    fCompNumber = compNumber;
    if ( fDirComp == 0 ) {
	fDirComp = new TDirectory*[fCompNumber];
	for (Int_t i = 0; i < fCompNumber; i++ ) {
	    fDirComp[i] = new TDirectory;
	}
    }

    fDirTopComp->cd();

    key = fDirTopComp->GetKey(compName);
    if (!key) { 
      fDirComp[lComp] = fDirTopComp->mkdir(compName);
    }
}



void TPlotMaker::CdDir(Int_t lComp,Char_t* dirName) 
{
    if (strcmp(dirName,"graph") == 0) {
	fDirTopGraph->cd();
    }
    else if (strcmp(dirName,"histo") == 0) {
	fDirTopHisto->cd();
    }
    else if (strcmp(dirName,"comp") == 0) {
	fDirComp[lComp]->cd();
    }
}



void TPlotMaker::WriteFile() { gRootFile->Write();}


void TPlotMaker::CloseRootFile() 
{
    gRootFile->Write();
    gRootFile->Save();
    gRootFile->Close();

    delete gRootFile; gRootFile = 0;

   /*
     cout << " closing root file4 " << endl;
     if ( fDirComp != 0 ) {	
     for (Int_t i = 0; i < fCompNumber; i++) {
     if ( fDirComp[i] != 0 ) delete fDirComp[i]; 
     fDirComp[i] = 0;
     } 
     if ( fDirComp != 0 ) delete [] fDirComp; fDirComp = 0;
     }
     cout << " closing root file5 " << endl;
     
     if ( fDirTop != 0 ) delete fDirTop; fDirTop = 0;
     if ( fDirTopGraph != 0 ) delete fDirTopGraph; fDirTopGraph = 0;
     cout << " closing root file6 fDirTopHisto= "<<fDirTopHisto << endl;
     if ( fDirTopHisto != 0 ) delete fDirTopHisto; 
     cout << " closing root file6.1 fDirTopHisto= "<<fDirTopHisto << endl;
     fDirTopHisto = 0;
     cout << " closing root file7 " << endl;
     if ( fDirTopComp != 0 ) delete fDirTopComp; fDirTopComp = 0;
   */
}


void TPlotMaker::Graph(Char_t *plotTitle,Char_t *YTitle, Int_t LineColor, Float_t graphMinimum, Float_t graphMaximum,
			     Char_t *labelName, Char_t *drawStyle, TGraph * grh)
{    
    Char_t label3[64];
    Char_t label4[64];
    Char_t label5[64];



    
    grh->SetLineStyle(1);
    grh->SetLineColor(LineColor);
    grh->SetLineWidth(2);


    grh->SetMarkerColor(LineColor);
    grh->SetMarkerStyle(22);
    grh->SetMarkerSize(0.7);

    grh->SetTitle();
    gPad->SetGrid();
    gStyle->SetNdivisions(fXDiv);
    

    if (strcmp(drawStyle,"ALB")==0){
      grh->SetFillColor(LineColor);
    } else {
      grh->SetFillColor(0);
    }

    grh->GetXaxis()->SetRangeUser(0.,(fTimeMax-fTimeMin));
       
    grh->Draw(drawStyle);    

    time_t the_time;
    struct tm *tm_ptr;
    (void) time(&the_time);
    tm_ptr = localtime(&the_time);    


    gStyle->SetTimeOffset(kTimeOffset+fTimeMin);

    //    printf(" kTimeOffset=%d fTimeMin=%d fTimeMax-fTimeMin = %d \n",kTimeOffset,fTimeMin,fTimeMax-fTimeMin);

    if ((graphMaximum-graphMinimum) < 0.0000001) graphMaximum = 1.0;

    //test
    //graphMaximum = 100.;

    grh->GetXaxis()->SetTimeDisplay(1);
    grh->GetXaxis()->SetTimeFormat(fTimeFormat);
    grh->GetXaxis()->SetTitleSize(0.06);
    grh->GetYaxis()->SetTitleSize(0.05);
    
    //
    grh->GetYaxis()->SetNdivisions(5);
    fText7->SetTextSize(0.06);
    fText7->SetTextColor(1);
    fText7->DrawTextNDC(0.5,0.04,fXTitle);

    //    grh->GetHistogram()->SetLineColor(3);
    grh->GetHistogram()->SetLineWidth(0);
    //    grh->GetHistogram()->SetLineStyle(2);


    grh->GetHistogram()->SetYTitle(YTitle);
    grh->GetHistogram()->SetMaximum(graphMaximum);
    // if(graphMinimum > -0.99 ) grh->GetHistogram()->SetMinimum(graphMinimum);
    grh->GetHistogram()->SetMinimum(graphMinimum);
    // check if this is OK...
    //    if(graphMinimum < 0. ) graphMinimum = 0.0;
    //    grh->GetHistogram()->SetMinimum(0.0);
    //printf(" graphMinimum is %f  plot is %s \n", graphMinimum,plotTitle);
    //grh->GetHistogram()->SetMinimum(graphMinimum);
    gGraphMinimum = graphMinimum;    

    fText1->SetTextColor(LineColor);
    fText1->SetTextSize(kLabelFontSize);
    fText1->SetTextAngle(0);
    fText1->DrawTextNDC(0.92,1-1.0/( (Float_t)  1.1*kMaxGraphsPerPlot ),labelName);

    // draw time of begining of plot
    tm_ptr = localtime((const time_t *)&fTimeMin);    
    strftime(label3,74,"%H:%M %d/%b/%y",tm_ptr);

    fText3->SetTextSize(0.085);
    fText3->SetTextColor(2);
    fText3->DrawTextNDC(0.05,0.02,label3);

    // draw time of end of plot
    tm_ptr = localtime((const time_t *)&fTimeMax);    
    strftime(label4,64,"%H:%M %d/%b/%y",tm_ptr);

    fText4->SetTextSize(0.085);
    fText4->SetTextColor(2);
    fText4->DrawTextNDC(0.8,0.02,label4);

    if (fCutVar >= 0) {
      fText5->SetTextColor(LineColor);
      if ((fCutLow < fCutHigh) > 0.001) {
	sprintf(label5," %i < run number < %i",(Int_t) fCutLow,(Int_t) fCutHigh);
	fText5->DrawTextNDC(0.7,0.93,label5);
      }
      else {
	sprintf(label5," run number = %i",(Int_t) fCutHigh);
	fText5->DrawTextNDC(0.8,0.93,label5);
      }
    }

    fText6->SetTextSize(0.08);
    fText6->SetTextColor(1);
    fText6->DrawTextNDC(0.3 ,0.93,plotTitle);

    // draw a white line at bottom to cover black axis

    /*
      fHorizontalAxisLine = new TLine(0.,graphMinimum,(fTimeMax-fTimeMin) * 1.1 ,graphMinimum);
      fHorizontalAxisLine->SetLineColor(kWhite);
      fHorizontalAxisLine->SetLineWidth(1);
      fHorizontalAxisLine->Draw();
    */

}


void TPlotMaker::GraphBox(Char_t *plotTitle,Char_t *yTitle,Float_t graphMinimum, Float_t * yValues, Int_t pointNumber)
{    
    
    Float_t graphMaximum;
    Float_t padLeft;
    Float_t padRight;
   
    if (gBox != 0 || gBoxNumber != 0 ) cout << " something wrong. gBox != 0 . this should not happen  in graphbox.  gBoxNumber = "<< gBoxNumber << " gBox="<<gBox << endl;    
    gBoxNumber = 0;
    graphMaximum = graphMinimum;

    padLeft = -0.5-(pointNumber)*0.05;
    padRight = pointNumber-0.5;

    for (Int_t i = 0; i < pointNumber; i++) {
      if ( yValues[i] > graphMaximum) graphMaximum = yValues[i];
    }
    if ((graphMaximum-graphMinimum) < 0.0000001) graphMaximum = 1.0;
    gPad->Range(padLeft,graphMinimum- 0.1*(graphMaximum-graphMinimum),padRight,graphMaximum + 0.20*(graphMaximum-graphMinimum));
    fC1->SetBorderSize(0);

    fText2->SetTextSize(0.1);
    fText2->SetTextAngle(90);
    fText2->DrawTextNDC(0.0 ,0.6,yTitle);

    fText3->DrawTextNDC(0.5 ,0.95,plotTitle);
    fText3->SetTextColor(1);

    
    if ( fAxis2 != 0) {
      delete fAxis2;
      fAxis2 = 0;
    }
    
    fAxis2 = new TGaxis(-0.5,graphMinimum,-0.5,graphMaximum,graphMinimum,graphMaximum,5,"R");
    fAxis2->SetLabelSize(0.1);
    fAxis2->SetTitleSize(0.1);
    fAxis2->SetName("axis2");
    fAxis2->SetLabelOffset(0.00);
   fAxis2->SetLineColor(4);
    fAxis2->Draw();
    
    
    Float_t halfWidth = 0.4;
    if (2*halfWidth > 0.2* pointNumber) halfWidth = 0.1* pointNumber; 

    
    gBox = new TWbox*[pointNumber];
    gBoxNumber = pointNumber;
    for (Int_t i = 0; i <pointNumber; i++) { 
      gBox[i] = new TWbox(i-halfWidth,0.,i+halfWidth, yValues[i],kColorCode[i%kMaxGraphsPerPlot],1,1);
      gBox[i]->Draw();
    }
    
    
    Char_t label4[64];
    time_t the_time;
    struct tm *tm_ptr;
    (void) time(&the_time);
    tm_ptr = localtime(&the_time);    
    gStyle->SetTimeOffset(kTimeOffset);

    // draw time of end of plot
    tm_ptr = localtime((const time_t *)&fTimeMax);    
    strftime(label4,64,"%H:%M %d/%b/%y",tm_ptr);

    fText1->SetTextSize(0.1);
    fText1->SetTextColor(2);
    fText1->DrawTextNDC(0.8,0.90,label4);
    
    gPad->Draw();
    gPad->cd();
}


Int_t TPlotMaker::GraphMultiBox(Char_t *plotTitle,Char_t *labels,Char_t *yTitle,Float_t graphMinimum, Float_t * yValues, Int_t compNumber, Int_t boxNumber,Int_t * yVarRef)
{    

    Float_t ySumTopValue;
    Float_t ySumBottomValue;
    Float_t graphMaximum;
    Float_t padLeft;
    Float_t padRight;
    Int_t   maxBoxNumberPerComp = 0;
    Int_t   boxNumberPerComp;
    Int_t   boxId     = 0;
    Int_t   lineId    = 0;
    Float_t halfWidth = 0.4;
    //Float_t leftEdgeFraction = 0.25; 
    Float_t leftEdgeFraction = 0.35; 
    const Int_t kMaxBoxPerPlot = 10;
    char    **argv;
    int     argc;
    Char_t fullTitle[256];

    if (gBox != 0 || gBoxNumber != 0 ) printf(" something wrong. gBox != 0 . this should not happen  in graphmultibox.  gBoxNumber = %d gBox=%d \n",gBoxNumber,gBox);
    
    gBoxNumber = 0;
    
    graphMaximum = graphMinimum;
    for (Int_t i = 0; i < compNumber; i++) { 
      ySumTopValue = 0.0;
      boxNumberPerComp = 0;
      for (Int_t j = 0; j <boxNumber; j++) {
	// condition if actually plot values. Shold be nonnegative.
	// in future have an actual array of on/off variables
	if (yVarRef[i+j*compNumber] > 0) {
	  ySumTopValue = ySumTopValue + yValues[i+j*compNumber];
	  gBoxNumber++;
	  boxNumberPerComp++;
	}
      }
      if (boxNumberPerComp > maxBoxNumberPerComp) maxBoxNumberPerComp = boxNumberPerComp;
      if (ySumTopValue > graphMaximum)                   graphMaximum = ySumTopValue; 
    }
    
    if (gBoxNumber == 0 ) {
      if (gDebug) printf(" gBoxNumber == 0. can't make multibox graph \n");
      return 0;
    }


    argv = string_to_argv(labels, &argc);

    padLeft  = -0.5-(compNumber)*0.05;
    padRight = compNumber-0.5;

    if ((graphMaximum-graphMinimum) < 0.0000001) graphMaximum = 1.0;
    gPad->Range(padLeft,graphMinimum- 0.1*(graphMaximum-graphMinimum),padRight,graphMaximum + 0.20*(graphMaximum-graphMinimum));


    fC1->SetBorderSize(0);
    /*
    fText2->SetTextSize(0.1);
    fText2->SetTextAngle(90);
    //fText2->DrawTextNDC(0.0 ,0.6,yTitle);
    fText2->DrawTextNDC(0.05 ,0.6,yTitle);
    */
    
    sprintf(fullTitle,"%s -%s",plotTitle,yTitle);
    fText3->SetTextAngle(0);
    fText3->SetTextSize(0.12);
    fText3->SetTextColor(1);
    //fText3->DrawTextNDC(0.1 ,0.93,plotTitle);
    fText3->DrawTextNDC(0.05 ,0.93,fullTitle);

   if ( fAxis2 != 0) {
     delete fAxis2;
     fAxis2 = 0;
   }

   fAxis2 = new TGaxis(-0.5,graphMinimum,-0.5,graphMaximum,graphMinimum,graphMaximum,5,"R");
   fAxis2->SetLabelSize(0.1);
   fAxis2->SetTitleSize(0.1);
   fAxis2->SetName("axis2");
   fAxis2->SetLabelOffset(0.00);
   fAxis2->SetLineColor(4);
   fAxis2->Draw();
   
   
   // label boxes only if max less than some reasonable number, say 10
   if ( maxBoxNumberPerComp  <= kMaxBoxPerPlot) gBoxNumber = gBoxNumber + maxBoxNumberPerComp;
   gBox       = new TWbox*[gBoxNumber];

   


   if (fLine != 0 ) {
     for (Int_t i = 0;i < compNumber; i++) {
       if (fLine[i] != 0)  delete  fLine[i];
       fLine[i] = 0;
     }
     delete [] fLine;		       
     fLine = 0;	   
   }
   
   
   fLine = new TLine*[compNumber];

   for (Int_t i = 0; i < compNumber; i++) { 
     ySumBottomValue = 0.0;
     ySumTopValue = 0.0;
     for (Int_t j = 0; j <boxNumber; j++) {
       //	  cout << " boxNumber= "<<boxNumber<<" j="<<j << " yVarRef[i+j*compNumber] " << yVarRef[i+j*compNumber] <<endl; 
       
       if (yVarRef[i+j*compNumber] > 0) {
	 ySumTopValue    = ySumTopValue + yValues[i+j*compNumber];
	 if (2*halfWidth > 0.2* compNumber) halfWidth = 0.1* compNumber; 
	 gBox[boxId]     = new TWbox(i-halfWidth,ySumBottomValue,i+halfWidth, ySumTopValue, kColorCodeEach[j%kMaxGraphsPerPlot],1,1);
	 ySumBottomValue = ySumTopValue;
	 gBox[boxId]->Draw();
	 boxId++;
       }
     }
     // line at bottom
     fLine[lineId] = new TLine(i-halfWidth*1.1,graphMinimum- 0.05*(graphMaximum-graphMinimum),i+halfWidth*1.1, graphMinimum- 0.05*(graphMaximum-graphMinimum));
     fLine[lineId]->SetLineColor(kColorCode[i%kMaxGraphsPerPlot]);
     fLine[lineId]->SetLineWidth(5);
     fLine[lineId]->Draw();
     lineId++;
   }
   
   // labels of what is plotted
   
   //    cout << " maxBoxNumberPerComp= "<<maxBoxNumberPerComp<<" kMaxBoxPerPlot="<<kMaxBoxPerPlot<<endl; 
   if ( maxBoxNumberPerComp  <= kMaxBoxPerPlot) {
     for (Int_t j = 0; j < maxBoxNumberPerComp; j++) {
       gBox[boxId] = new TWbox(padLeft+ (leftEdgeFraction+j*0.1)*(padRight-padLeft),graphMaximum + 0.05*(graphMaximum-graphMinimum) ,padLeft 
			       + (leftEdgeFraction+0.05+j*0.1)*(padRight-padLeft),
			       graphMaximum + 0.12*(graphMaximum-graphMinimum), kColorCodeEach[j%kMaxGraphsPerPlot],1,1);
       gBox[boxId]->Draw();
       boxId++;
       
       
       fText4->SetTextSize(0.08);
       fText4->DrawText(padLeft + (leftEdgeFraction + 0.06+j*0.1)*(padRight-padLeft) ,graphMaximum + 0.07*(graphMaximum-graphMinimum),argv[j+1]);
       
       //	cout << " text is " << argv[j+1] <<endl; 
       
     }
   }
   
   Char_t label4[64];
   time_t the_time;
   struct tm *tm_ptr;
   (void) time(&the_time);
   tm_ptr = localtime(&the_time);    
   gStyle->SetTimeOffset(kTimeOffset);

   // draw time of end of plot
   tm_ptr = localtime((const time_t *)&fTimeMax);    
   strftime(label4,64,"%H:%M %d/%b/%y",tm_ptr);
   
   fText1->SetTextSize(0.1);
   fText1->SetTextColor(2);
   fText1->DrawTextNDC(0.8,0.90,label4);
   
   gPad->Draw();
   gPad->cd();
   
   
   free(argv[0]);
   free(argv);
   return 1;
   
}


void TPlotMaker::GraphCompActiveStatusBox(Char_t *plotTitle,Char_t *yTitle,Float_t * yValues, Int_t compNumber,Int_t binNumber,Int_t varNumber)
{    


    Float_t graphMinimum;
    Float_t graphMaximum;
    Float_t padLeft;
    Float_t padRight;

    Int_t varUsed = 0;
    
    if (gBox != 0 || gBoxNumber != 0 ) cout << " something wrong. gBox != 0 . this should not happen  in graphmultibox.  gBoxNumber = "<< gBoxNumber << endl;
    
    gBoxNumber = 0;


    if (fLine != 0 ) {
      for (Int_t i = 0;i < compNumber; i++) {
	if (fLine[i] != 0)  delete  fLine[i];
	fLine[i] = 0;
      }
      delete [] fLine;		       
      fLine = 0;	   
    }
    fLine = new TLine*[compNumber];
    

    //get maximum
    graphMinimum = 0.0;
    graphMaximum = (Float_t) binNumber;
    padLeft = -0.5-(compNumber)*0.05;
    padRight = compNumber-0.5;


    gPad->Range(padLeft,graphMinimum- 0.1*(graphMaximum-graphMinimum),padRight,graphMaximum + 0.30*(graphMaximum-graphMinimum));



    fC1->SetBorderSize(0);
    fText1->SetTextSize(0.065);
    fText1->SetTextAngle(90);
    fText1->SetTextColor(kBlack);
    fText1->DrawTextNDC(0.0 ,0.6,yTitle);

    fText2->SetTextSize(0.07);
    fText2->SetTextColor(1);
    fText2->SetTextAngle(0);
    fText2->DrawTextNDC(0.05 ,0.93,plotTitle);

   if ( fAxis2 != 0) {
     delete fAxis2;
     fAxis2 = 0;
   }

   fAxis2 = new TGaxis(-0.5,graphMinimum,-0.5,graphMaximum,graphMinimum,graphMaximum,0,"R");
   fAxis2->SetLabelSize(0.5);
   fAxis2->SetTitleSize(0.5);
   fAxis2->SetName("axis2");
   fAxis2->SetLabelOffset(0.00);
   fAxis2->SetLineColor(4);
   fAxis2->Draw();
   
    Int_t   lineId    = 0;
    Float_t halfWidth = 0.4;
    Int_t   badPeriods;
    Bool_t  oldPeriodStatus;


    badPeriods  = 0;
    for (Int_t i = 0; i < compNumber; i++) { 
      // first get number of boxes needed.
      // a box is added only when have off ->on
      // init status
      Int_t firstBin = 0;
      if (yValues[(i*varNumber)*binNumber+varUsed*firstBin+firstBin] < 0.001) {
	oldPeriodStatus = false;
      } else {
	oldPeriodStatus = true;
      }

      //loop over all data for this comp
      for (Int_t bin = 1; bin < binNumber -1; bin++) { 

	//change from on to off
	if (yValues[(i*varNumber)*binNumber+varUsed*binNumber+bin] < 0.001 && oldPeriodStatus == true)  oldPeriodStatus = false;
	// change from off to on comp
	if (yValues[(i*varNumber)*binNumber+varUsed*binNumber+bin]  > 0.001 && oldPeriodStatus == false) {
	  oldPeriodStatus = true;
	  badPeriods++;
	}
	//cout << " " << yValues[(i*varNumber)*binNumber+0+bin]; 
      }
      // if status is false, then have one more red box till top
      if (oldPeriodStatus == false) badPeriods++;      
    }


    gBoxNumber =  compNumber + badPeriods + 2;
    gBox = new TWbox*[gBoxNumber];


    if (2*halfWidth > 0.2* compNumber) halfWidth = 0.1* compNumber; 

    Float_t badBegin = 0;
    Int_t   boxCount = 0;

    for (Int_t i = 0; i < compNumber; i++) { 
      // strategy: draw first a green box till top for each node, and overlay with red boxes for dead times.
      gBox[boxCount] = new TWbox(i-halfWidth,0.,i+halfWidth,graphMaximum,kGreen,1,1);
      gBox[boxCount]->Draw();
      boxCount++;
      // now get red boxes
      badPeriods  = 0;
      if (yValues[(i*varNumber)*binNumber+varUsed*0+0] < 0.001) {
	oldPeriodStatus = false;
	badBegin = 0.0;
      } else {
	oldPeriodStatus = true;
      }

      for (Int_t bin = 1; bin < binNumber -1; bin++) { 
	if (yValues[(i*varNumber)*binNumber+varUsed*binNumber+bin] < 0.001 && oldPeriodStatus == true) {
	  badBegin = (Float_t) bin;
	  oldPeriodStatus = false;
	}
	if (yValues[(i*varNumber)*binNumber+varUsed*binNumber+bin]  > 0.001 && oldPeriodStatus == false) {
	  oldPeriodStatus = true;
	  gBox[boxCount] = new TWbox(i-halfWidth,badBegin,i+halfWidth,(Float_t) bin,kRed,1,1);
	  gBox[boxCount]->Draw();
	  boxCount++;
	}
      }

      if (oldPeriodStatus == false) {
	gBox[boxCount] = new TWbox(i-halfWidth,badBegin,i+halfWidth, graphMaximum,kRed,1,1);
	gBox[boxCount]->Draw();
	boxCount++;
      }
      // line at bottom
      fLine[lineId] = new TLine(i-halfWidth*1.1,graphMinimum- 0.05*(graphMaximum-graphMinimum),i+halfWidth*1.1, graphMinimum- 0.05*(graphMaximum-graphMinimum));
      fLine[lineId]->SetLineColor(kColorCode[i%kMaxGraphsPerPlot]);
      fLine[lineId]->SetLineWidth(5);
      fLine[lineId]->Draw();
      lineId++;
    }


    Char_t label4[64];
    time_t the_time;
    struct tm *tm_ptr;
    (void) time(&the_time);
    tm_ptr = localtime(&the_time);    
    gStyle->SetTimeOffset(kTimeOffset);


    // labels of what is plotted
    Float_t leftEdgeFraction = 0.55; 
    gBox[boxCount] = new TWbox(padLeft+ (leftEdgeFraction+0*0.1)*(padRight-padLeft),graphMaximum + 0.05*(graphMaximum-graphMinimum) ,padLeft 
				    + (leftEdgeFraction+0.05+0*0.1)*(padRight-padLeft),
			       graphMaximum + 0.12*(graphMaximum-graphMinimum), kGreen,1,1);
    gBox[boxCount]->Draw();
    boxCount++;

    fText3->SetTextSize(0.06);
    fText3->SetTextColor(kBlack);
    fText3->DrawText(padLeft + (leftEdgeFraction + 0.06+0*0.1)*(padRight-padLeft) ,graphMaximum + 0.07*(graphMaximum-graphMinimum),"On");
    
    
    
    gBox[boxCount] = new TWbox(padLeft+ (leftEdgeFraction+1*0.1)*(padRight-padLeft),graphMaximum + 0.05*(graphMaximum-graphMinimum) ,padLeft 
			       + (leftEdgeFraction+0.05+1*0.1)*(padRight-padLeft),
			       graphMaximum + 0.12*(graphMaximum-graphMinimum), kRed,1,1);
    gBox[boxCount]->Draw();
    fText4->SetTextSize(0.06);
    fText4->SetTextColor(kBlack);
    fText4->DrawText(padLeft + (leftEdgeFraction + 0.06+1*0.1)*(padRight-padLeft) ,graphMaximum + 0.07*(graphMaximum-graphMinimum),"Off");


    // draw time of end of plot
    tm_ptr = localtime((const time_t *)&fTimeMax);    
    strftime(label4,64,"%H:%M %d/%b/%y",tm_ptr);

    fText5->SetTextSize(0.065);
    fText5->SetTextColor(2);
    fText5->DrawTextNDC(0.8,0.90,label4);



   gPad->Draw();
   gPad->cd();
}




void TPlotMaker::Histo(Char_t *plotTitle,Char_t *xUnit, Int_t LineColor, Char_t *labelName,TH1F * hst,Float_t histMaximum)
{    
    Double_t xMax;
    Double_t xMin;
    //Double_t yMax;

    Char_t label2[64];
    Char_t label3[64];
    Char_t label4[64];

    //yMax = hst->GetMaximum();
    if (histMaximum > 0.0) hst->SetMaximum(histMaximum);

    xMax = hst->GetXaxis()->GetXmax();
    xMin = hst->GetXaxis()->GetXmin();
    
    hst->SetTitle("");
    hst->SetStats(gStatOption);
    hst->SetLineWidth(2);
    
    time_t     the_time;
    struct tm *tm_ptr;
    (void)     time(&the_time);
    tm_ptr =   localtime(&the_time);    
    
    gStyle->SetTimeOffset(kTimeOffset+fTimeMin);

    hst->GetXaxis()->SetTitleSize(0.06);
    hst->GetYaxis()->SetTitleSize(0.05);
    hst->SetLineColor(LineColor);

    hst->GetYaxis()->SetNdivisions(5);

    hst->Draw();
    hst->SetXTitle(xUnit);

    hst->SetYTitle("count");    
    fText1->SetTextColor(LineColor);
    fText1->SetTextSize(kLabelFontSize);
    fText1->DrawTextNDC(0.92,1-1.0/( (Float_t)  1.1*kMaxGraphsPerPlot ),labelName);


    if (fCutVar >= 0) {
	fText2->SetTextColor(LineColor);
	if (fCutLow < fCutHigh) {
	    sprintf(label2," %i < run number < %i",(Int_t) fCutLow,(Int_t) fCutHigh);
	    fText2->DrawTextNDC(0.7,0.95,label2);
	}
	else {
	    sprintf(label2," run number = %i",(Int_t) fCutHigh);
	    fText2->DrawTextNDC(0.8,0.95,label2);
	}
    } else {
      // draw time of begining of plot
      tm_ptr = localtime((const time_t *)&fTimeMin);    
      strftime(label3,74,"%H:%M %d/%b/%y",tm_ptr);

      // draw time of end of plot
      tm_ptr = localtime((const time_t *)&fTimeMax);    
      strftime(label4,64,"%H:%M %d/%b/%y",tm_ptr);

      sprintf(label2," from %s to %s",label3,label4);
      fText2->SetTextSize(0.055);
      fText2->DrawTextNDC(0.05,0.02,label2);
    }

    fText3->SetTextSize(0.08);
    fText3->SetTextColor(1);
    fText3->DrawTextNDC(0.3 ,0.93,plotTitle);

}



void  TPlotMaker::SuperimposeGraph(Int_t LineColor,Char_t *labelName, Int_t plotCount, Int_t lineStyle, Char_t *drawStyle, TText *t, TGraph * grh2)
{  
    grh2->SetLineStyle(lineStyle);
    grh2->SetLineWidth(3);
    if (lineStyle == 2)  grh2->SetLineWidth(1); // make dashed lines thin
    grh2->SetLineColor(LineColor);

    if (strcmp(drawStyle,"LB")==0){
      grh2->SetFillColor(LineColor);
    } else {
      grh2->SetFillColor(0);
    }

    grh2->Draw(drawStyle);
    // plotCount used for labels of graphs
    if (plotCount > 0) {
      t->SetTextColor(LineColor);
      t->SetTextSize(kLabelFontSize);
      t->DrawTextNDC(0.92,1-(1.0+plotCount)/( (Float_t)  1.1* kMaxGraphsPerPlot ),labelName);
    } 
}



void  TPlotMaker::SuperimposeHisto(Int_t LineColor, Int_t plotCount, Char_t* labelName, TText *t, TH1F * hst)
{    

    Double_t xMax;
    Double_t xMin;
    Double_t yMax;

    yMax = hst->GetMaximum();
    xMax = hst->GetXaxis()->GetXmax();
    xMin = hst->GetXaxis()->GetXmin();

    hst->SetStats(gStatOption);

    hst->SetLineWidth(2);
    hst->SetLineColor(LineColor);
    hst->Draw("same");

    // plotCount used for labels of histo
    if (plotCount > 0) {
      t->SetTextColor(LineColor);
      t->SetTextSize(kLabelFontSize);
      t->DrawTextNDC(0.92,1-(1.0+plotCount)/( (Float_t)  1.1* kMaxGraphsPerPlot),labelName);   
    } 
}


void TPlotMaker::DoGif(Char_t *plotName, Int_t plotScope, Char_t * plotType)
{    
    Char_t  nameEps[256];
    Char_t  nameGif[256];
    char    strCommand[256];     
    Char_t  sql[2000];

    fP1->Modified();
    fC1->Update();  


    // add entry to log file of all plots produced
    // only update logfile if files changed, requiring init
    if ( gLogFlag ) {      
      // remove any leading directories, if there are
      Char_t plotNameNoTimePeriod[256];
      Char_t plotNameNoTimePeriodNoDir[256];
      Char_t * ptr;
      Int_t offsetDir        = 0;
      Int_t offsetTimePeriod = 0;
      for (ptr=plotName;;ptr++){
	if (*ptr==0) break;
	if (*ptr=='/')  offsetDir        = (ptr - plotName)/sizeof(Char_t);
	if (*ptr=='_')  offsetTimePeriod = (ptr - plotName)/sizeof(Char_t);
      }       	

      if (offsetTimePeriod && (plotScope != kCurrentTimeScope) ) {
	snprintf(plotNameNoTimePeriod,offsetTimePeriod + 1, "%s",plotName);      
      } else {
	sprintf(plotNameNoTimePeriod,"%s",plotName);
      }
      if (offsetDir) {
	sscanf(plotNameNoTimePeriod + offsetDir + 1, "%s",plotNameNoTimePeriodNoDir);
      } else {
      sprintf(plotNameNoTimePeriodNoDir,"%s",plotNameNoTimePeriod);
      }

      if (gDebug) cout <<" plotNameNoTimePeriod=" << plotNameNoTimePeriod<< " plotNameNoTimePeriodNoDir=" << plotNameNoTimePeriodNoDir <<endl; 	        

      if (fUser)  sprintf (fUser,"user");


      if (fAffairSql) {

	sprintf(sql,"REPLACE INTO %s.AFFAIR_PLOTLIST (NAME,USER,MONSET,PLOT_TYPE,PLOT_SCOPE,TS) VALUES('%s','%s','%s','%s',%i,CURRENT_TIMESTAMP)",fDatabase,plotNameNoTimePeriodNoDir,
		fUser,fMonitorSet,plotType,plotScope);
	fAffairSql->Exec(sql);
	// following only needed to setup file list for default values into plotlist in mysql tables
	// actually, this is a better solution for the flat file case also...
	// sprintf(strCommand,"%s/support/fillLogfile.pl  %s/config/PlotList.conf %s %s %s %i",fAffairPath,fAffairPath,plotNameNoTimePeriodNoDir,fMonitorSet,plotType,plotScope);
	// gSystem->Exec(strCommand);
      } else {
	if (plotScope == kGlobalScope || plotScope == kCurrentTimeScope) {
	    sprintf(strCommand,"%s/support/fillLogfile.pl  %s/log/%s%s_PlotList.log %s",fAffairPath,fAffairPath,fUser,fMonitorSet,plotNameNoTimePeriodNoDir);
	} else if  (plotScope == kOneNodeScope) {  
	  sprintf(strCommand,"%s/support/fillLogfile.pl %s/log/%s%s_EachPlotList.log %s",fAffairPath,fAffairPath,fUser,fMonitorSet,plotNameNoTimePeriodNoDir);	
	}
	if (gDebug) cout <<" strCommand=" << strCommand <<endl; 	  
	gSystem->Exec(strCommand);
      }
    }

    if (gOutputMode == k_YES_EPS) {
      sprintf(nameGif,"%s/%s.png",fAffairPlotPath,plotName);
      sprintf(nameEps,"%s/%s.eps",fAffairPlotPath,plotName);
      if (fRootVersion < 5.0 || !fUseRootToPlotGif ) {
	fC1->Print(nameEps);
      } else {
	fC1->Print(nameGif);
      }
      if (plotScope == kGlobalScope || plotScope == kCurrentTimeScope) {
	sprintf(strCommand,"touch  %s/log/%s_%i ",fAffairPath,fMonitorSet,plotScope);
	gSystem->Exec(strCommand);
      }
    }else if (gOutputMode == k_YES_EPS_AFFAIR_DIR) {
      sprintf(nameGif,"%s/%s.png",fAffairPath,plotName); 
      sprintf(nameEps,"%s/%s.eps",fAffairPath,plotName);
 
      if (fRootVersion < 5.0 || !fUseRootToPlotGif ) {
	fC1->Print(nameEps);
      } else {
	fC1->Print(nameGif);
      }
      if (plotScope == kGlobalScope || plotScope == kCurrentTimeScope) {
        sprintf(strCommand,"touch  %s/log/%s_%i ",fAffairPath,fMonitorSet,plotScope);
        gSystem->Exec(strCommand);
      }
    }else if (gOutputMode == k_YES_PNG) {
      sprintf(nameGif,"%s/%s.png",fAffairPlotPath,plotName);
      sprintf(nameEps,"%s/%s.eps",fAffairPlotPath,plotName);

      if (fRootVersion < 5.0 || !fUseRootToPlotGif ) {
	fC1->Print(nameEps);      
	sprintf(strCommand,"%s/support/convert %s %s",fAffairPath,nameEps,nameGif);
	gSystem->Exec(strCommand);
      } else {
	fC1->Print(nameGif);
      }
    }
    fP1->Clear(); 
   
    // delete from memory boxes

    if (gBoxNumber > 0 ) {
      if (gBox != 0 ) {
	for (Int_t i=0;i < gBoxNumber; i++) {
	  if (gBox[i] != 0)  delete  gBox[i];
	  gBox[i] = 0;
	}
	delete [] gBox;		       
	gBox = 0;	   
      }    
      gBoxNumber = 0;
    } else {
      if (gBox != 0 ) {
	cout << " gBox != 0 gBoxNumber = 0. should never happen. = " << gBox << endl;
      }
    }
}






