#!/bin/bash

cd $AFFAIR_MONITOR;
cd ../;

parNum=$#;

if [ $parNum -lt 2 ]; then
    echo " need at least two pars:1st is name of tar.gz file, 2nd is backup option(all,distribution,date,collector)";
    echo " if want to do a clean, then 3rd par is clean. Be careful with this option! "
    exit;
fi

if [ "$3" = "clean" ]; then
    cd $AFFAIR_MONITOR;
    make clean;
    cd ../;
fi

if [ "$2" = "all" ]; then
cd $AFFAIR_MONITOR;
$AFFAIR_MONITOR/support/build.sh affairMonitor$1 monitor;
$AFFAIR_MONITOR/support/build.sh affairDate$1 date;
$AFFAIR_MONITOR/support/build.sh affairCollector$1 collector;
elif [ "$2" = "date" ]; then
    cd $AFFAIR_MONITOR;
    tar cvzf $AFFAIR_MONITOR/$1.tar.gz \
	    src/dim  \
	    support/*.pl support/*.sh  \
	    Makefile \
	    setup* install* start* monitor* docs 
	    echo " We have a build for the  DATE run control "
elif [ "$2" = "monitor" ]; then
    cd $AFFAIR_MONITOR;
    cp -R config config.example;
    tar cvzf $1.tar.gz \
	    dim smixx \
	    support config.example \
	    Makefile  \
	    setup* install*   start*  monitor*  docs  affairControl.sh \
	    src web  \
	    rrdtool  log/*PlotList.log;
    rm -fR config.example;
    echo " We have a build of the monitor station code  "
elif [ "$2" = "collector" ]; then
    cd $AFFAIR_MONITOR;
    tar cvzf $1.tar.gz \
	    dim smixx \
	    src/dim   \
	    support/*.pl  support/*.sh  \
	    Makefile  \
	    setup* install*   start*  monitor* docs  
	    echo " We have a build of the collector code  "
else
    echo "We have no good option for backup. 2nd var needs to be either all or distribution or date or collector"
fi

cd $AFFAIR_MONITOR;



