#!/usr/bin/perl

if ( length ("$ENV{'AFFAIR_MONITOR'}") > 0 ) {
    $AffairDir     = "$ENV{'AFFAIR_MONITOR'}";
} elsif ( length ("$ENV{'AFFAIR'}") > 0 ) {
    $AffairDir     = "$ENV{'AFFAIR'}";
} else {
#    print " no AFFAIR OR AFFAIR_MONITOR variable. Can't log data \n";
};

open TEMP, ">>$AffairDir/log/restartedProcess.log";

$argCount = @ARGV;
$processArgCount = $argCount-2;

# 0th arg is directory where executable is, 1st is the name of executable
# all later args are parameters

$matchCount = 0;
$PsArgOffset = 1; # offset for arguments in ps -weo command


foreach $_ (`ps -weo command | grep $ARGV[1] `) 
{
   # only consider processes with executable 
    $line = $_;
    chomp($line);
    $line =~ s/.*grep.*//; #ignore own ps process 
    $line =~ s/.*checkProcess.*//; #ignore own  process 
    next unless length ($line);  #anything left
    @psParArray = split(/\s+/,$line);     
    $psParArrayCount = @psParArray;
    $beginPsArg = $psParArrayCount - $processArgCount;

    # first check if the TOTAL number of arguments is the same. If not, then the process
    # clearly does not exist
    if ( ( $psParArrayCount - $PsArgOffset)   == $processArgCount) {	 
	for ($i = $beginPsArg; $i < $psParArrayCount; $i++) {
	    if ( $psParArray[$i]  =~ /$ARGV[$i -$beginPsArg+2]/ ) {
		$matchCount++;		
	    }
	}
	# take care if same num of args and some matches. Don't want to count it if not all
	# matches. This can be a problem if several processes like that. can add up matches
	if ( $matchCount < $processArgCount ) {
	    $matchCount = 0;
	}

	# take care of case if no argument parameters. In that case if came to this point
	# then the process does exist
	if ($processArgCount == 0) {
	    $matchCount++;
	}
    }
    else { 

    }
}

# argcount -2 is the total number of parameters used
# need to match All of them for process to be considered alive
# the == 0 case is when there are no arguments, and is =1 if process exists

if ( $matchCount < $processArgCount || $matchCount == 0 ) {
    $argList ="";
    for ($i = 2; $i < $argCount; $i++) {
	$argList= $argList." ".$ARGV[$i];
    }
    $myTime = ` date +%T_%D`;
#    $| = 1;
    if ( $ARGV[1] =~ bash) {
	system("/bin/bash $argList  & ");
#	`/bin/bash $argList  >& /dev/null  `;
        print TEMP " /bin/bash $argList has been started at $myTime\n";
#        print  " /bin/bash $argList has been started at $myTime\n";
    }
    else {
#	`cd $ARGV[0];./$ARGV[1] $argList  >& /dev/null `;
	system("cd $ARGV[0];./$ARGV[1] $argList   & ");
        print TEMP " $ARGV[0]/$ARGV[1] $argList has been started at $myTime\n";
#        print " $ARGV[0]/$ARGV[1] $argList has been started at $myTime\n";
    }
}








