#! /usr/bin/perl

use POSIX;


my $AffairDir     = "$ENV{'AFFAIR_MONITOR'}"; 
my $runMode     = "$ENV{'RRD_MODE'}"; 
my $debugMode     = "DEBUG_YES"; 

# $maxFullInfoTime is in hours
my $maxFullInfoTime = 1.5; 

my $RRDFileName = $AffairDir."/rrd/".$ARGV[0];
print " RRDFileName= $RRDFileName \n";
if (!(-e ($RRDFileName)))  {
   my $Interval = $ARGV[1];
   my $Heartbeat   = $Interval*2.0;
   print " Heartbeat = $Heartbeat \n";

   my $StartTime = time();
   my $fileType = $ARGV[0];
   $fileType =~ s/\.rrd$//;
   my @names = split(/_/, $fileType);
   my $numElements = @names;
   $fileType = $names[$numElements - 1]; 

   my $fileName = "$AffairDir/config/" . $fileType . ".conf";
    my $command = "$AffairDir/rrdtool/bin/rrdtool create ".$RRDFileName." -b ".$StartTime." -s ".$Interval." "; 

   my $variableCount = $ARGV[2];

#   open (CONF, $fileName);
#   while (<CONF>) {
#       my $line = $_;     
#     $line =~ s/#.*//;             # No comments
#     $line =~ s/^\s+//;            # No leading white
#     $line =~  s/\s+$//;           # No trailing white
#     next unless length ($line);   # Anything left?
   
#     my @values = split (/\s+/, $line);
#     $command .= "DS:";
#     $command .= $values[1];
#     $command .= ":";
#     $command .= $values[3]; 
#     $command .= ":";     
#     $command .= $Heartbeat;
#     $command .= ":U:U "; 
#   };
#   close (CONF);   


for($i=0;$i<$variableCount;$i++) {    
     $command .= "DS:";
     $command .= "var".$i;
     $command .= ":";
     $command .= "GAUGE"; 
     $command .= ":";     
     $command .= $Heartbeat;
     $command .= ":U:U "; 
}
   
   # get correct depth based on interval, i.e. make sure store two day of data in full detail
   my $noavercount =  60 * 60 * $maxFullInfoTime;
   $noavercount =  $noavercount/$Interval;
   $noavercount = int $noavercount;
     $command .= "RRA:AVERAGE:0.5:1:$noavercount ";  # 1 unit (e.g. hour)
     $command .= "RRA:AVERAGE:0.5:6:$noavercount ";   # 6 hour
     $command .= "RRA:AVERAGE:0.5:24:$noavercount ";  # 24 hour
     $command .= "RRA:AVERAGE:0.5:148:$noavercount "; #  7 days
     $command .= "RRA:AVERAGE:0.5:720:$noavercount "; # month
     $command .= "RRA:AVERAGE:0.5:2180:$noavercount "; # 3 month
     $command .= "RRA:AVERAGE:0.5:8760:$noavercount "; # year
     $command .= "RRA:MAX:0.5:1:$noavercount ";   # 1 unit (e.g. hour)
     $command .= "RRA:MAX:0.5:6:$noavercount ";   # 6 hour
     $command .= "RRA:MAX:0.5:24:$noavercount ";  # 24 hour
     $command .= "RRA:MAX:0.5:148:$noavercount "; #  7 days
     $command .= "RRA:MAX:0.5:720:$noavercount "; # month
     $command .= "RRA:MAX:0.5:2180:$noavercount "; # month
     $command .= "RRA:MAX:0.5:8760:$noavercount "; # year

#   if ($debugMode =~ "DEBUG_YES") {
#     $command .= " >>/tmp/".$ARGV[0]; 
#   }

##--------------------------------------------------------
## Finally, create the RRD.
##--------------------------------------------------------

   print " command= $command";
   sleep(1);
   system(" $command ");
   sleep(2); 


##-----------------------------------------------------------
## Now update the rrdlist file
##-----------------------------------------------------------
system("$AffairDir/support/listRRD.pl & ");

}
else
{
   print "File $RRDFileName already exists!";
};










